#include <stdio.h>
#include "pcsgbd.h"
#include "cm_cm01.h"

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Retorna o valor da probabilidade da distribuio de qui-quadrado para um
	valor de qui-quadrado e o seu graus de liberdade.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/


Simbolo_t *xprob2(ww,vv)
Simbolo_t *ww;        /* chisquare */
Simbolo_t *vv;        /* graus de liberdade */
{
	Simbolo_t *sr=faztemp(1,1);
	double v;
	double w;

#ifdef EDIX
	double *dp;
#endif

	v = (double) DADOij(vv,0,0);
	w = (double) DADOij(ww,0,0);
	if (v <= 0.0 || w < 0.0)

/* *** Padroniz. msg erro - Luciana 21/12/94
		execerro("parametro tem que ser > que zero",(char *) 0);
*** */
		execerro(PegaMsg(3100),(char *) 0);
	if (NLINS(vv) > 1 || NCOLS(vv) > 1)

/* *** Padroniz. msg erro - Luciana 21/12/94
		execerro("parametro 1 tem que ser escalar",(char *) 0);
*** */
		execerro(PegaMsg(3101),(char *) 0);
	if (NLINS(ww) > 1 || NCOLS(ww) > 1)

/* *** Padroniz. msg erro - Luciana 21/12/94
		execerro("parametro 2 tem que ser escalar",(char *) 0);
*** */
		execerro(PegaMsg(3100),(char *) 0);


#ifdef EDIX
	dp = &(DADOij(sr,0,0));
	*dp = xprob(w, v); 
#else
	DADOij(sr,0,0) = xprob(w, v); 
#endif

	return (sr);
}
