
/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Conta o nmero de ocorrncia de um determinado valor na matriz

Desenvolvido por: 

	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <stdlib.h>

#include "pcsgbd.h"
#include "cm_cm01.h"


void contagem()
{
	Datum d1, d2;
	int i, j, l;
	int nc, nl;
#ifdef EDIX
	double *dp;
#endif
	Simbolo_t *sr;

	d2 = pop();
	d1 = pop();

	if (NLINS( (Simbolo_t *) d2) != 1) {

/* *** Padroniz. msg erro - Luciana 21/12/94
		execerro("CONTAGEM",
		"Segundo argumento tem que ser vetor linha");
*** */
		execerro(PegaMsg(3102),(char *) 0);
	}
	if (NCOLS( (Simbolo_t *) d1) != 2) {

/* *** Padroniz. msg erro - Luciana 21/12/94
		execerro("CONTAGEM",
		"Primeiro argumento deve conter apenas duas colunas");
*** */
		execerro(PegaMsg(3103),(char *) 0);
	}
	nl = (int) ( NLINS( (Simbolo_t *) d1));
	nc = (int) ( NCOLS( (Simbolo_t *) d2));
	
	if (nc <= 0)

/* *** Padroniz. msg erro - Luciana 21/12/94
		execerro("CONTAGEM","nao posso criar matriz desta dimensao");
*** */
		execerro(PegaMsg(5035),(char *) 0);

	sr = faztemp(nc, nc);	

	for(l=0; l < nc; l++) {	
		for(i=0; i < nc; i++) {	
#ifdef EDIX
			dp = &(DADOij(sr, l, i));
			*dp= 0.0;
#else	
			DADOij(sr, l, i) = 0.0;
#endif	
		}
	}


	for(l=0; l < nc; l++) {	
		for(i=0; i < nc; i++) {	
			for(j=0; j < nl; j++) {
				if ( (DADOij( (Simbolo_t *) d1, j, 0)  ==
				     DADOij( (Simbolo_t *) d2, 0, l))  &&
				     (DADOij( (Simbolo_t *) d1, j, 1)  ==
			             DADOij( (Simbolo_t *) d2, 0, i))) {
#ifdef EDIX
					dp = &(DADOij(sr, l, i));
					*dp= DADOij( sr, l, i) + 1.0;
#else	
					DADOij(sr, l, i) = 
						DADOij( sr, l, i) + 1.0;
#endif	
				}
			}
		}
	}
	push((Datum) sr);

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

