#include <stdio.h>
#include <string.h>
#ifdef MSDOS
# include <stdlib.h>
#endif

#include "cm_cm01.h"
#include "pcsgbd.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
	Procede alungs procedimentos internos do CM para indicar que arquivos esto fechados.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

extern	int	linhanum;
extern	char	*infile;	/* nome do arquivo de entrada */
extern	FILE	*fin;		/* ponteiro para arquivo de entrada */

struct guarda_arq {
	FILE	*arquivo;
	int	numlinha;
	char	*nomearq;
};
extern struct guarda_arq guarda_arq[30];

#ifdef MSDOS
# define TECLADO		"con"
#else
# define TECLADO		"/dev/tty"
#endif

extern	int	numero_arq;
extern	int	interativo;
extern	int	flagA;

void eofarq()
{
	dprintf(">>>> Estou saindo do arquivo <%s>\n", infile);

	if (numero_arq == 1) {
		if (!strcmp(infile, TECLADO)) {
			setOSstdin();
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
				printf("*** Lista de memoria nao esta' vazia *** \n");
				Mem_Store("cm");
				exit(0);
			}
#endif

			exit(0);
		}

		flagA = 0;

		if ((fin = fopen(TECLADO, "r")) == (FILE *) NULL) {

/* *** Padroniz. msg erro - Luciana 21/12/94
			fprintf(stderr, "Arquivo %s nao abre.\n", TECLADO);
*** */
			fprintf(stderr, PegaMsg(5020),TECLADO);
			setOSstdin();
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
				printf("*** Lista de memoria nao esta' vazia *** \n");
				Mem_Store("cm");
				exit(1);
			}
#endif
			exit(1);
		}

		infile = TECLADO;
		interativo = 0;
		pprompt();

		guarda_arq[0].arquivo = fin;
		guarda_arq[0].numlinha = 0;
		guarda_arq[0].nomearq = infile;
	}

	else {
		if (strcmpi(guarda_arq[numero_arq-1].nomearq,TECLADO) != 0) {
		    if (fclose(guarda_arq[--numero_arq].arquivo) == EOF) {
			    fprintf(stderr,PegaMsg(5005),"");
			    setOSstdin();
#ifdef MEM_DEBUG
			    if (Mem_Used() != 0) {
				    printf("*** Lista de memoria nao esta' vazia ***\n");
				    Mem_Store("cm");
				    exit(2);
			    }
#endif

			    exit(2);
		    }
		}
		else {
			--numero_arq;
		}

		efree(guarda_arq[numero_arq].nomearq);

		linhanum = guarda_arq[numero_arq].numlinha;
		fin = guarda_arq[numero_arq-1].arquivo;

		infile = guarda_arq[numero_arq-1].nomearq;

		--interativo;
	}

	dprintf(">>>> Estou voltando para o arquivo <%s>\n", infile);
}

