#include <stdio.h>
#include "cm_cm01.h"

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Gera indices (de 1 at n) e os armazena em um vetor coluna.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

Simbolo_t *genindex(sstart, sstop)
Simbolo_t *sstart;
Simbolo_t *sstop;
{
	Simbolo_t *sr;
	int start, stop, nc, inc, j;
	double fs;
#ifdef EDIX
	double *dp;
#endif

	if (NLINS(sstart) != 1 || NCOLS(sstart) != 1 || NLINS(sstop) != 1 ||
		NCOLS(sstop) != 1) 
		conferro(sstart, sstop, ":");

	start = (int) DADOij(sstart, 0, 0);
	stop = (int) DADOij(sstop, 0, 0);
	fs = (double) start;

	if ( start < stop ) {
		nc = stop - start + 1;
		inc = 1;
	}
	else {
		nc = start - stop + 1;
		inc = -1;
	}

	sr = faztemp(1,nc);

	for (j = 0; j < nc; j++, fs += (double) inc) {
#ifdef EDIX
		dp = &(DADOij(sr, 0, j));
		*dp = fs;
#else
		DADOij(sr, 0, j) = fs;
#endif
	}

	return sr;
}

