
/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Este mdulo possui todas as rotinas para interface com a mquina de execuo do CM.
	Um comando que foi inserido pelo usurio  ter a sua sintaxe avaliada e uma pilha de
	execuo ser montada. Durante o processamento da pilha de execuo, funes deste mdulos
	estaro sendo chamadas e executadas.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <ctype.h>
#include "pcsgbd.h"
#include "cm_cm01.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

#ifdef MSDOS
# include <stdlib.h>
# include "y_tab.h"
#else
# ifdef VAXVMS
#  include <stdlib.h>
#  include "y_tab.h"
# else
#  include "y.tab.h"
# endif
#endif

#if defined(MSDOS) & !defined(DJGPP)
#   define	MAXRAND		32767.
#else
# define	MAXRAND		2147483647.
#endif

#define NSTACK 550

static Datum stack[NSTACK];	/* A Pilha */
static Datum *stackp;		/* Proxima posicao livre na pilha */

#define NPROG 4400

extern int excprg;
extern int argumento;
extern int parametro;
extern int indef;		/* Indica o escopo */

int linerro[NPROG];
int *plinerro;
int n_inst=0;			/* Indica o numero de instrucoes */
Inst prog[NPROG];		/* A Maquina */
Inst *progp;			/* Proxima posicao livre para geracao do      
				   codigo */
Inst *pc;			/* Contador da Pilha */
Inst *progbase = prog;		/* Comeca o corrente subprograma */
int  returning;			/* 1 se return */

typedef struct Frame { /* proc/func call pilha */
	Simbolo_t *sp;		/* proxima entrada na tabela de simbolos */
	Inst	  *retpc; 	/* para onde voltar apos return */
	Datum	  *argn;	/* n-esimo argumento */
	int	  nargs;	/* numero de argumentos */
} Frame;

#define NFRAME 125

Frame frame[NFRAME];
Frame *fr;

extern double _toler_;
extern int _colunas;
extern char _diretorio[MAXDIR];
extern int nivel;
extern int linhanum;

/* 
** void tentaLibSim(d): codigo fonte passado para o arquivo init.c,
			para possibilitar montagem da libcm sem a
			inclusao do arquivo initcode.c
*/

Datum libpop()
{
	tentaLibSim((Simbolo_t *) pop());

	return (Datum) 0;
}

void initcode()
{
	stackp 	= stack;
	progp  	= progbase;
	plinerro = linerro;
	fr 	= frame;
	nivel 	= 0;
	returning = 0;

	if (debugflag) {
		printf("Initcode\n");
		printf("argumento 0\n\n");
	}

	argumento = 0;
	reset_parm();

	libtemp();
}

void push(d)
Datum d;
{
	if (stackp >= &stack[NSTACK])

/* *** Padroniz. msg erro - Luciana 22/12/94
		execerro("Estouro da pilha de execucao", (char *) 0);
*** */
		execerro(PegaMsg(5016), (char *) 0);

	*stackp++ = d;
}

Datum pop()
{
	if (stackp <= stack)

/* *** Padroniz. msg erro - Luciana 22/12/94
		execerro("Pilha 'underflow'", (char *) 0);
*** */
		execerro(PegaMsg(5017), (char *) 0);

	return *--stackp;
}

Inst *code(f) 	/* Instala Uma Instrucao ou operando */
Inst f;
{
	char	tmpbuf[128];

	Inst *oprogp = progp;

	if (progp >= &prog[NPROG]) {

/* *** Padroniz. msg erro - Luciana 22/12/94
		execerro("Programa muito longo", (char *) 0);
*** */
		sprintf(tmpbuf,PegaMsg(1001),"");
		execerro(tmpbuf, (char *) 0);
	}

	if (indef)	
		n_inst++;

	*progp++ = f;
	*plinerro++ = linhanum;

	return oprogp;
}

void execute(p)	/* Executa a maquina */	
Inst *p;
{
	for(pc = p; *pc != STOP && !returning; ) {
		excprg = (int) (pc - prog);
		(*(*pc++))();
	}
}

void varpsint()	/* Coloca um valor inteiro na Pilha */
{
	Datum d;

	d = (Datum) (*pc++);

	push(d);
}

void varpshn()	/* Coloca uma Variavel nova na Pilha */
{
	Datum d;

	d = (Datum) (*pc++);

	push(d);
}

void varpshs()	/* Coloca uma Variavel nova na Pilha */
{
	Datum d;

	d = (Datum) (*pc++);

	push(d);
}

void varnulo() /* Coloca uma variavel nula na pilha */
{
	push( (Datum) NULL);
}	

void varpush()	/* Coloca uma Variavel na Pilha */
{
	Datum d;
	char tmpbuf[128]; /* Luciana */

	d = (Datum) (*pc++);

	if (((Simbolo_t *) d) -> tipo == INDEF ||
	    ((Simbolo_t *) d) -> tipo == INDEFL ) {
		numerro = MATINDEFER;

		if (((Simbolo_t *) d) -> tipo == INDEF )
			libsim((Simbolo_t *) d);

/* *** Padroniz. msg erro - Luciana 22/12/94
		execerro("Matriz indefinida", ((Simbolo_t *) d)->nome);
*** */
		sprintf(tmpbuf,PegaMsg(1050),((Simbolo_t *) d)->nome);
		execerro(tmpbuf,(char *) 0);
	}

	push(d);
}	
 

void atribu1()	/* Atribui valor do topo para o proximo valor */
{
	Datum d1, d2;

	d1 = pop();
	d2 = pop();
	
	d1 = (Datum) atribua((Simbolo_t *) d1, (Simbolo_t *) d2);

	((Simbolo_t *) d1) -> tipo = ID;

	push(d2);
}


void toler()	/* Muda valor da tolerancia */
{
	Datum d;
	double y;
	double x;
	extern double _toleri;	/* Usado pelo liste */

	d = pop();

	y = (double) DADOij((Simbolo_t *) d,0,0);
	y = fabs(y);

	_toleri =  y;		

	if (y >= 1.0) {
		x = pow(10.0, -y); 
	}
	else
		x = DADOij((Simbolo_t *) d,0,0);

	_toler_ = x;

	tentaLibSim((Simbolo_t *) d);
}

void setcol()	/* Muda largura do formulario */
{
	Datum d;

	d = pop();

	_colunas = (int) DADOij((Simbolo_t *) d,0,0);

	tentaLibSim((Simbolo_t *) d);
}

void setdef()	/* Muda largura do formulario */
{
	extern FILE *fsaida;
	extern int   fvideo;
	extern char _nomesai[MAXDIR];
	char *pd;

	_toler_ = 1.e-12;

	pd = getenv("PWD");

	if (pd)
		strcpy(_diretorio, pd);
	else
		_diretorio[0] = '\0';

	_colunas  = 70;

	if (!fvideo) {
		if (fclose(fsaida) == EOF) {
			fprintf(stderr,PegaMsg(5005),"");
			setOSstdin();
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
				printf("*** Lista de memoria nao esta' vazia ***\n");
				Mem_Store("cm");
				exit(2);
			}
#endif

			exit(2);
		}
	}


	strcpy(_nomesai, "video");
	fsaida = stdout;
	fvideo = 1;
}

/* -------------------------------------------------------------------
** setimp:	configura impressora com parametros dados pelo usuario
** 	entrada:
**		STRING : "015,\AA,\04,0A5"
**			string: Impresso com printf(%s)
**				 . comecando com '\'
**				   ex: \aa \15
**				 . qualquer palavra com pelo menos
**				   uma letra.
**				   ex: aa, a15
**
**			Numeros: Impressos com putchar
**
**			parametros separados por ','
** -------------------------------------------------------------------
*/

void setimp()	/* Configura a impressora */
{
	Datum d;
	int   ret;
	int   i;
	int   j;
	int flag;
	char  num[64];
	char s1[256];
	extern FILE *fsaida;

	d = pop();

	(void) trim(((Simbolo_t *) d)->nome,s1);
	
	j = 0;
	flag = 0;

	for(i=0; i <= (int) strlen(s1); i++) {
		if (s1[i] == ',' || s1[i] == '\0') {
			if (i > 0) {
				num[j] = '\0';

				for(j = 0; j < (int) strlen(num); j++) {
					if (!isdigit(num[j]))
						break;
				}

				if (j < (int) strlen(num) || flag) {
					fprintf(fsaida,"%s",num);
				}

				else {
					j = atoi(num);
					ret = putc(j, fsaida);

					if (ret == EOF) {
						ret = ferror(fsaida);

						if (ret != 0) {

/* *** Padroniz. msg erro - Luciana 22/12/94
							execerro("Nao posso escrever no meio determinado para saida", (char *) 0);
*** */
							execerro(PegaMsg(1032), (char *) 0);
							(void) clearerr(fsaida);
						}
					}
				}
			}

			j = 0;

			flag = 0;
		}

		else {
		        if (s1[i] == '\\') 
				flag = 1;
			else
				num[j++] = s1[i];
		}
	}

	tentaLibSim((Simbolo_t *) d);
}

void setdir()	/* Redireciona a saida */
{
	Datum d;
	char s1[MAXDIR];

	d = pop();

	strncpy(s1,((Simbolo_t *) d)->nome,63);

	s1[63] = '\0';

	(void) trim(s1, _diretorio);

	tentaLibSim((Simbolo_t *) d);
}

void setsai()	/* Redireciona a saida */
{
	extern FILE *fsaida;
	extern int   fvideo;
	extern char _nomesai[MAXDIR];

	Datum d;
	char s[MAXDIR];
	char s1[MAXDIR];

	d = pop();

	strncpy(s1,((Simbolo_t *) d)->nome,63);

	s1[63] = '\0';

	(void) trim(s1, s);

	if (!fvideo) {
		if (fclose(fsaida) == EOF) {
			fprintf(stderr,PegaMsg(5005),"");
			setOSstdin();
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
				printf("*** Lista de memoria nao esta' vazia ***\n");
				Mem_Store("cm");
				exit(2);
			}
#endif

			exit(2);
		}
	}


	if (strcmpi(s,"video") == 0) {
		fsaida = stdout;
		fvideo = 1;
		strcpy(_nomesai, "video");
	}
	else {
		fsaida = fopen(s, "w");
		if (fsaida == (FILE *) NULL) {
			fprintf(stderr,PegaMsg(5006),s);
			setOSstdin();
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
				printf("*** Lista de memoria nao esta' vazia ***\n");
				Mem_Store("cm");
				exit(2);
			}
#endif

			exit(2);
		}

		strcpy(_nomesai, s);
		fvideo = 0;
	}

	tentaLibSim((Simbolo_t *) d);
}
		
void constpush()
{
	Datum d;
	
	d = (Datum) (*pc++);

	push(d);
}



void imprimr()	/* Imprimir o que esta no topo da pilha no formato default */
{
	Datum d;

	d = pop();

	matlista((Simbolo_t *) d, 14.0, 6.0, (char *) 0, 1, 0);

	tentaLibSim((Simbolo_t *) d);
}

void imprim1()
{
	Datum d;

	d = pop();

	matlista((Simbolo_t *) d, 14.0, 6.0, (char *) 0, 1, 1);

	tentaLibSim((Simbolo_t *) d);
}

void imprim2()	
{
	Datum d, d1;

	d1 = pop();
	d  = pop();

	matlista((Simbolo_t *) d, 14.0, 6.0, ((Simbolo_t *)d1)->nome , 2, 0);

	tentaLibSim((Simbolo_t *) d);
	tentaLibSim((Simbolo_t *) d1);
}

void imprim3()	
{
	Datum d, d1;

	d1 = pop();
	d  = pop();

	matlista((Simbolo_t *) d, 14.0, 6.0, ((Simbolo_t *)d1)->nome , 2, 1);

	tentaLibSim((Simbolo_t *) d);
	tentaLibSim((Simbolo_t *) d1);
}

void imprim4()	
{
	Datum  d, d2, d3;

	d2 = pop();
	d3 = pop();
	d  = pop();

	matlista((Simbolo_t *) d,DADOij((Simbolo_t *) d3,0,0),
		DADOij((Simbolo_t *) d2,0,0), (char *) 0 ,1,0);

	tentaLibSim((Simbolo_t *) d);
	tentaLibSim((Simbolo_t *) d2);
	tentaLibSim((Simbolo_t *) d3);
}

void imprim5()	
{
	Datum  d, d2, d3;

	d2 = pop();
	d3 = pop();
	d  = pop();

	matlista((Simbolo_t *) d,DADOij((Simbolo_t *) d3,0,0),
		DADOij((Simbolo_t *) d2,0,0),(char *) 0 ,1,1);

	tentaLibSim((Simbolo_t *) d);
	tentaLibSim((Simbolo_t *) d2);
	tentaLibSim((Simbolo_t *) d3);
}

void imprim6()	
{
	Datum d, d1, d2, d3;

	d1 = pop();
	d2 = pop();
	d3 = pop();
	d  = pop();

	matlista((Simbolo_t *) d,DADOij((Simbolo_t *) d3,0,0),
		DADOij((Simbolo_t *) d2,0,0),((Simbolo_t *) d1)->nome,2,0);

	tentaLibSim((Simbolo_t *) d);
	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
	tentaLibSim((Simbolo_t *) d3);
}

void imprim7()	
{
	Datum d, d1, d2, d3;

	d1 = pop();
	d2 = pop();
	d3 = pop();
	d  = pop();

	matlista((Simbolo_t *) d,DADOij((Simbolo_t *) d3,0,0),
		DADOij((Simbolo_t *) d2,0,0),((Simbolo_t *) d1)->nome,2,1);

	tentaLibSim((Simbolo_t *) d);
	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
	tentaLibSim((Simbolo_t *) d3);
}


void matsub1()
{
	Datum d1, d2, d3;

	d3 = pop();
	d2 = pop();
	d1 = pop();

	push((Datum) matsubs((Simbolo_t *) d1, (Simbolo_t *) d2,
		(Simbolo_t *) d3));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
	tentaLibSim((Simbolo_t *) d3);
}


void matsub2()
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();

	push((Datum) matsubs((Simbolo_t *) d1, (Simbolo_t *) 0,
		(Simbolo_t *) d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void matsub3()
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();

	push((Datum) matsubs((Simbolo_t *) d1, (Simbolo_t *) d2,
		(Simbolo_t *) 0));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void setsub1()
{
	Datum d1, d2, d3, d4;
	char tmpbuf[128]; /* Luciana */

	d1 = pop();
	d4 = pop();
	d3 = pop();
	d2 = pop();

	if (((Simbolo_t *) d1) -> tipo == INDEF ||
	    ((Simbolo_t *) d1) -> tipo == INDEFL ) {
		numerro = MATINDEFER;

		if (((Simbolo_t *) d1) -> tipo == INDEF )
			libsim((Simbolo_t *) d1);


/* *** Padroniz. msg erro - Luciana 22/12/94
		execerro("Matriz indefinida", ((Simbolo_t *) d1)->nome);
*** */
		sprintf(tmpbuf,PegaMsg(1050),((Simbolo_t *) d1)->nome);
		execerro(tmpbuf,(char *) 0);
	}

	setsubs((Simbolo_t *) d1, (Simbolo_t *) d2 , (Simbolo_t *) d3,
		(Simbolo_t *) d4);

	push(d1);

	tentaLibSim((Simbolo_t *) d2);
	tentaLibSim((Simbolo_t *) d3);
	tentaLibSim((Simbolo_t *) d4);
}

void setsub2()
{
	Datum d1, d2, d3;
	char tmpbuf[128]; /* Luciana */

	d1 = pop();
	d3 = pop();
	d2 = pop();

	if (((Simbolo_t *) d1) -> tipo == INDEF ||
	    ((Simbolo_t *) d1) -> tipo == INDEFL ) {
		numerro = MATINDEFER;

		if (((Simbolo_t *) d1) -> tipo == INDEF )
			libsim((Simbolo_t *) d1);

/* *** Padroniz. msg erro - Luciana 22/12/94
		execerro("Matriz indefinida", ((Simbolo_t *) d1)->nome);
*** */
		sprintf(tmpbuf,PegaMsg(1050),((Simbolo_t *) d1)->nome);
		execerro(tmpbuf,(char *) 0);
	}

	setsubs((Simbolo_t *) d1, (Simbolo_t *) 0, (Simbolo_t *) d2,
		(Simbolo_t *) d3);

	push(d1);

	tentaLibSim((Simbolo_t *) d2);
	tentaLibSim((Simbolo_t *) d3);
}

void setsub3()
{
	Datum d1, d2, d3;
	char tmpbuf[128]; /* Luciana */

	d1 = pop();
	d3 = pop();
	d2 = pop();

	if (((Simbolo_t *) d1) -> tipo == INDEF ||
	    ((Simbolo_t *) d1) -> tipo == INDEFL ) {
		numerro = MATINDEFER;

		if (((Simbolo_t *) d1) -> tipo == INDEF )
			libsim((Simbolo_t *) d1);

/* *** Padroniz. msg erro - Luciana 22/12/94
		execerro("Matriz indefinida", ((Simbolo_t *) d1)->nome);
*** */
		sprintf(tmpbuf,PegaMsg(1050),((Simbolo_t *) d1)->nome);
		execerro(tmpbuf,(char *) 0);
	}

	setsubs((Simbolo_t *) d1, (Simbolo_t *) d2,  (Simbolo_t *) 0,
		(Simbolo_t *) d3);

	push(d1);

	tentaLibSim((Simbolo_t *) d2);
	tentaLibSim((Simbolo_t *) d3);
}

void hconca1()
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();

	push((Datum) hconcat((Simbolo_t *) d1, (Simbolo_t *) d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void vconca1()
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();

	push((Datum) vconcat((Simbolo_t *) d1, (Simbolo_t *) d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}


void add()	
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();
	
	push((Datum) matsoma((Simbolo_t *) d1, (Simbolo_t *) d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}


void sub()	
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();
	
	push((Datum) matdif((Simbolo_t *) d1,(Simbolo_t *) d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void mult()	
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();
	
	push((Datum) matemul((Simbolo_t *) d1, (Simbolo_t *) d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void divv()	
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();
	
	push((Datum) matediv((Simbolo_t *) d1, (Simbolo_t *) d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void divi()	
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();
	
	push((Datum) matediv((Simbolo_t *) d2, (Simbolo_t *) d1));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}


void multp()	
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();
	
	push((Datum) matmult((Simbolo_t *) d1, (Simbolo_t *) d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void multc()	
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();
	
	push((Datum) mmulcol((Simbolo_t *) d1, (Simbolo_t *) d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}


void dive()	
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();
	
	push((Datum) matdive((Simbolo_t *) d1, (Simbolo_t *) d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void divd()	
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();
	
	push((Datum) matdivd((Simbolo_t *) d2, (Simbolo_t *) d1));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}


void kron()	
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();
	
	push((Datum) matkron((Simbolo_t *) d1, (Simbolo_t *) d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}


void epot()	
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();
	
	push((Datum) matepot((Simbolo_t *) d1, (Simbolo_t *) d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);

}

void pot()	
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();

	push((Datum) matpot((Simbolo_t *) d1, (Simbolo_t *) d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void tran()	
{
	Datum d1;

	d1 = pop();

	push((Datum) mattran((Simbolo_t *) d1));

	tentaLibSim((Simbolo_t *) d1);
}

void multran()	
{
	Datum d1, d2;
	Datum d3;

	d2 = pop();
	d1 = pop();
	d3 = (Datum) mattran((Simbolo_t *) d1);

	push((Datum) matmult((Simbolo_t *) d3, (Simbolo_t *) d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
	tentaLibSim((Simbolo_t *) d3);
}

void matneg1()	
{
	Datum d1;

	d1 = pop();

	push((Datum) matneg((Simbolo_t *) d1));

	tentaLibSim((Simbolo_t *) d1);
}

void bltin()
{
	Datum d;

	d = pop();
	push((Datum) ((*(Simbolo_t * (*) ()) (*pc++)) ((Simbolo_t *) d)));

	tentaLibSim((Simbolo_t *) d);
}

void mfprob1()
{
	Datum d1, d2, d3;

	d3 = pop();
	d2 = pop();
	d1 = pop();	

	push((Datum) mfprob((Simbolo_t *) d1, (Simbolo_t *) d2,
		(Simbolo_t *) d3));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
	tentaLibSim((Simbolo_t *) d3);
}

void mfinv1()
{
	Datum d1, d2, d3;
	double p1, p2, p3;
	Simbolo_t *sr = faztemp(1,1);
#ifdef EDIX
	double *dp;
#endif

	d3 = pop();
	d2 = pop();
	d1 = pop();	

	if (NLINS((Simbolo_t *)  d1) > 1 || NCOLS((Simbolo_t *) d1) > 1)

/* *** Padroniz. msg erro - Luciana 22/12/94
		execerro("parametro 1 tem que ser escalar", (char *) 0);
*** */
		execerro(PegaMsg(3106), (char *) 0);

	if (NLINS((Simbolo_t *)  d2) > 1 || NCOLS((Simbolo_t *) d2) > 1)

/* *** Padroniz. msg erro - Luciana 22/12/94
		execerro("parametro 2 tem que ser escalar", (char *) 0);
*** */
		execerro(PegaMsg(3100), (char *) 0);

	if (NLINS((Simbolo_t *)  d3) > 1 || NCOLS((Simbolo_t *) d3) > 1)

/* *** Padroniz. msg erro - Luciana 22/12/94
		execerro("parametro 3 tem que ser escalar", (char *) 0);
*** */
		execerro(PegaMsg(3107), (char *) 0);

	p1 = DADOij((Simbolo_t *) d1,0,0);
	p2 = DADOij((Simbolo_t *) d2,0,0);
	p3 = DADOij((Simbolo_t *) d3,0,0);

	if (p1 < 0.0 || p2 <= 0.0 || p3 <= 0.0 || p1 > 1.0)

/* *** Padroniz. msg erro - Luciana 22/12/94
		execerro("parametro invalido ", (char *) 0);
*** */
		execerro(PegaMsg(3108), (char *) 0);

#ifdef EDIX
	dp = &(DADOij(sr,0,0));
	*dp = finv(p1, p2, p3); 
#else
	DADOij(sr,0,0) = finv(p1, p2, p3); 
#endif

	push ((Datum) sr);

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
	tentaLibSim((Simbolo_t *) d3);
}

void mxinv1()
{
	Datum d1, d2;
	double p1, p2;
	Simbolo_t *sr = faztemp(1,1);
#ifdef EDIX
	double *dp;
#endif


	d2 = pop();
	d1 = pop();	

	if (NLINS((Simbolo_t *)  d1) > 1 || NCOLS((Simbolo_t *) d1) > 1)

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("parametro 1 tem que ser escalar", (char *) 0);
*** */
		execerro(PegaMsg(3106), (char *) 0);

	if (NLINS((Simbolo_t *)  d2) > 1 || NCOLS((Simbolo_t *) d2) > 1)

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("parametro 2 tem que ser escalar", (char *) 0);
*** */
		execerro(PegaMsg(3100), (char *) 0);

	p1 = DADOij((Simbolo_t *) d1,0,0);
	p2 = DADOij((Simbolo_t *) d2,0,0);

	if (p1 < 0.0 || p2 <= 0.0 || p1 > 1.0 )

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("parametro invalido ", (char *) 0);
*** */
		execerro(PegaMsg(3108), (char *) 0);

#ifdef EDIX
	dp = &(DADOij(sr,0,0));
	*dp = xinv(p1, p2); 
#else
	DADOij(sr,0,0) = xinv(p1, p2); 
#endif

	push ((Datum)  sr);

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void mxprob1()
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();	

	push((Datum) xprob2((Simbolo_t *) d1, (Simbolo_t *) d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void mtinv1()
{
	Datum d1, d2;
	double p1, p2;
	Simbolo_t *sr = faztemp(1,1);
#ifdef EDIX
	double *dp;
#endif

	d2 = pop();
	d1 = pop();	

	if (NLINS((Simbolo_t *)  d1) > 1 || NCOLS((Simbolo_t *) d1) > 1)

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("parametro 1 tem que ser escalar", (char *) 0);
*** */
		execerro(PegaMsg(3106), (char *) 0);

	if (NLINS((Simbolo_t *)  d2) > 1 || NCOLS((Simbolo_t *) d2) > 1)

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("parametro 2 tem que ser escalar", (char *) 0);
*** */
		execerro(PegaMsg(3100), (char *) 0);

	p1 = DADOij((Simbolo_t *) d1,0,0);
	p2 = DADOij((Simbolo_t *) d2,0,0);

	if (p2 <= 0.0 || p1 < 0.0 || p1 > 1.0)

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("parametro 2 invalido ", (char *) 0);
*** */
		execerro(PegaMsg(3108), (char *) 0);

#ifdef EDIX
	dp = &(DADOij(sr,0,0));
	*dp = tinv(p1, p2); 
#else
	DADOij(sr,0,0) = tinv(p1, p2); 
#endif

	push((Datum) sr);

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);

}

void mtprob1()
{
	Datum d1, d2;
	double p1, p2;
	Simbolo_t *sr = faztemp(1,1);
#ifdef EDIX
	double *dp;
#endif

	d2 = pop();
	d1 = pop();	

	if (NLINS((Simbolo_t *)  d1) > 1 || NCOLS((Simbolo_t *) d1) > 1)

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("parametro 1 tem que ser escalar", (char *) 0);
*** */
		execerro(PegaMsg(3109), (char *) 0);

	if (NLINS((Simbolo_t *)  d2) > 1 || NCOLS((Simbolo_t *) d2) > 1)

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("parametro 2 tem que ser escalar", (char *) 0);
*** */
		execerro(PegaMsg(3100), (char *) 0);

	p1 = DADOij((Simbolo_t *) d1,0,0);
	p2 = DADOij((Simbolo_t *) d2,0,0);

	if (p2 <= 0.0)

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("parametro 2 invalido ", (char *) 0);
*** */
		execerro(PegaMsg(3100), (char *) 0);

#ifdef EDIX
	dp = &(DADOij(sr,0,0));
	*dp = tprob(p1, p2); 
#else
	DADOij(sr,0,0) = tprob(p1, p2); 
#endif

	push((Datum) sr);

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);

}

/* 
** ninv1(): codigo fonte passado para o arquivo init.c, para possibilitar 
	     montagem da libcm sem a inclusao do arquivo initcode.c
*/

/* 
** nprob1(): codigo fonte passado para o arquivo init.c, para possibilitar 
	     montagem da libcm sem a inclusao do arquivo initcode.c
*/

void grave1() 		/* Tipo: GRAVE expr */
{
	Datum d;	/* Matriz */

	d = pop();

	grave((Simbolo_t *) d, (char *) 0, (char *) 0, 1);

	tentaLibSim((Simbolo_t *) d);
}

void grave2()		/* Tipo: GRAVE expr ( STRING ) */
{
	Datum d;	/* Matriz */
	Datum d2;	/* Nome Colunas */

	d2= pop();
	d = pop();

	grave((Simbolo_t *) d,(char *) 0, ((Simbolo_t *) d2)->nome, 2); 

	tentaLibSim((Simbolo_t *) d);
	tentaLibSim((Simbolo_t *) d2);
}

void grave3()		/* Tipo: GRAVE expr STRING */
{
	Datum d;	/* Matriz */
	Datum d1;	/* Diretorio */

	d1= pop();
	d = pop();

	grave((Simbolo_t *) d,((Simbolo_t *) d1)->nome, (char *) 0, 3); 

	tentaLibSim((Simbolo_t *) d);
	tentaLibSim((Simbolo_t *) d1);
}

void grave4()		/* Tipo: GRAVE expr STRING ( STRING ) */
{
	Datum d;	/* Matriz */
	Datum d1;	/* Diretorio */
	Datum d2;	/* Nome Colunas */
	
	d2= pop();
	d1= pop();
	d = pop();

	grave((Simbolo_t *)d,((Simbolo_t *)d1)->nome,((Simbolo_t *)d2)->nome,4);

	tentaLibSim((Simbolo_t *) d);
	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void leia1()
{
	Datum d, d1, d2;
	Simbolo_t *temp;

	d = pop();
	d1= pop();

	d2 = (Datum) atribua((Simbolo_t *) d1,
			(temp = leia(((Simbolo_t *) d) -> nome,
			(char *) NULL, 0, (char *) NULL, 0.0)));

	libsim(temp);

	tentaLibSim((Simbolo_t *) d);
	tentaLibSim((Simbolo_t *) d1);

	((Simbolo_t *) d2) -> tipo = ID;

	push(d2);
}

void leia2()
{
	Datum d, d1, d2, d3, d4, d5;

	d = pop();
	d1= pop();
	d2= pop();
	d3= pop();
	d4= pop();

	d5 = (Datum) atribua((Simbolo_t *) d4, 
	     leia(((Simbolo_t *) d3) -> nome, ((Simbolo_t *) d2)-> nome,
		     (int) ((long) d1), ((Simbolo_t *) d) -> nome, 0.0));

	((Simbolo_t *) d5) -> tipo = ID;

	push(d5);

	tentaLibSim((Simbolo_t *) d);
	tentaLibSim((Simbolo_t *) d2);
	tentaLibSim((Simbolo_t *) d3);
	tentaLibSim((Simbolo_t *) d4);
}

void leia3()
{
	Datum d, d1, d2, d3, d4, d5;

	d = pop();
	d1= pop();
	d2= pop();
	d3= pop();
	d4= pop();


	d5 = (Datum) atribua((Simbolo_t *) d4, 
	     leia(((Simbolo_t *) d3) -> nome, ((Simbolo_t *) d2)-> nome,
	     (int) ((long) d1), (char *) NULL, DADOij((Simbolo_t *) d, 0, 0)));

	((Simbolo_t *) d5) -> tipo = ID;

	push(d5);

	tentaLibSim((Simbolo_t *) d);
	tentaLibSim((Simbolo_t *) d2);
	tentaLibSim((Simbolo_t *) d3);
	tentaLibSim((Simbolo_t *) d4);
}

void genind1()
{
	Datum d1, d2;

	d2= pop();
	d1= pop();

	push((Datum) genindex((Simbolo_t *) d1, (Simbolo_t *) d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void execar1()
{
	Datum d;

	d = pop();

/*
	execarq(((Simbolo_t *) d)->nome);
*/
	system(((Simbolo_t *) d)->nome);
}

void anote1()
{
	extern FILE *fsaida;
	Datum d;

	d = pop();

	fprintf(fsaida,"%s\n",((Simbolo_t *) d)->nome);

	fflush(fsaida);

	tentaLibSim((Simbolo_t *) d);
}

void anote2()
{
	extern FILE *fsaida;
	Datum d;

	d = pop();

	fprintf(fsaida,"%c",12);
	fprintf(fsaida,"%s\n",((Simbolo_t *) d)->nome);

	fflush(fsaida);

	tentaLibSim((Simbolo_t *) d);
}

void whilecod()
{
	Datum d;
	Inst *savepc = pc;
	
	execute(savepc+2);

	d = pop();

	while(DADOij((Simbolo_t *) d,0,0) != 0.0 ) {
		tentaLibSim((Simbolo_t *) d);

		execute(* ((Inst **) (savepc)));	

		if (returning) {
			d = (Datum) 0;
			break;
		}

		execute(savepc+2);

		d = pop(); 
	}

	if (d)
		tentaLibSim((Simbolo_t *) d);

	if (!returning)
		pc = *((Inst **) (savepc+1));
}

void ifcode()
{
	Datum d;
	Inst *savepc = pc;
	
	execute(savepc+3);

	d = pop();

	if (DADOij((Simbolo_t *) d,0,0) != 0.0) {
		tentaLibSim((Simbolo_t *) d);

		execute(*((Inst **) (savepc)));
	}
	else if (*((Inst **) (savepc+1))) {
		tentaLibSim((Simbolo_t *) d);

		execute(*((Inst **) (savepc+1)));	
	}

	if (!returning)
		pc = *((Inst **) (savepc+2));
}

void define(sp)	/* put func/proc in symbol table */
Simbolo_t *sp;
{
	sp->u.defn = (Inst) progbase;

	progbase = progp;
}

void call()		/* call a function */
{
	Simbolo_t *sp = (Simbolo_t *) pc[0];

	if (fr++ >= &frame[NFRAME-1])

/* *** Padroniz. msg erro - Luciana 21/12/94
		execerro("Hierarquia muito profunda ", sp->nome);
*** */
		execerro(PegaMsg(1051), (char *) 0);

	fr->sp = sp;
	fr->nargs= (int) ((long) pc[1]);
	fr->retpc= pc + 2;
	fr->argn = stackp - 1;

	if (fr->sp->tipo == FUNCTION) {
		argumento++;

		if (debugflag)
			printf("argumento 1\n");
	}

	execute((Inst *) sp->u.defn);

	returning = 0;
}

void ret() 
{
	int i;

	Datum d;

	for(i = 0; i < fr->nargs; i++)  {
		d = pop();
		tentaLibSim((Simbolo_t *) d);
	}

	pc = (Inst *) fr->retpc;

	--fr;

	returning = 1;
}

void funcret()
{
	Datum d;
	Simbolo_t *sr;

	if (fr->sp->tipo == PROCEDURE)

/* *** Padroniz. msg erro - Luciana 09/03/95
		execerro("Proc nao retorna valor",(char *) 0);
*** */

		execerro(PegaMsg(3221), (char *) 0);

	d = pop();

	ret();

	sr = faztemp(NLINS((Simbolo_t *) d),NCOLS((Simbolo_t *) d));
	copmat(MATRIZ(sr), MATRIZ((Simbolo_t *) d));

	push((Datum) sr);

	tentaLibSim((Simbolo_t *) d);

	argumento--;

	if (fr == frame)
		libtmp2();

	if (debugflag) {
		printf("argumento 0");
	}
}

void procret()
{
	if (fr->sp->tipo == FUNCTION)

/* *** Padroniz. msg erro - Luciana 09/03/95
		execerro("Funcao tem que retornar valor",(char *) 0);
*** */

		execerro(PegaMsg(3222), (char *) 0);

	ret();

	if (fr == frame)
		libtmp2();
}

void arg()
{
	int nargs = (int) ((long) *pc++);
	Datum d;

	if (nargs > fr->nargs)

/* *** Padroniz. msg erro - Luciana 09/03/95
		execerro("Numero errado de argumentos",(char *) 0);
*** */

		execerro(PegaMsg(3220), (char *) 0);

	d = (Datum) fr->argn[nargs - fr->nargs];

	push(d);
}

void argsub1()
{
	Datum  d2, d3, d4;
	int nargs = (int) ((long) *pc++);

	if (nargs > fr->nargs)

/* *** Padroniz. msg erro - Luciana 09/03/95
		execerro("Numero errado de argumentos",(char *) 0);
*** */

		execerro(PegaMsg(3220), (char *) 0);

	d4 = pop();
	d3 = pop();
	d2 = pop();

	setsubs((Simbolo_t *) fr->argn[nargs - fr->nargs] , (Simbolo_t *) d2 ,
		(Simbolo_t *) d3, (Simbolo_t *) d4);

	push(d4);

	tentaLibSim((Simbolo_t *) d2);
	tentaLibSim((Simbolo_t *) d3);
}

void argsub2()
{
	Datum d2, d3;
	int nargs = (int) ((long) *pc++);

	if (nargs > fr->nargs)

/* *** Padroniz. msg erro - Luciana 09/03/95
		execerro("Numero errado de argumentos",(char *) 0);
*** */

		execerro(PegaMsg(3220), (char *) 0);

	d3 = pop();
	d2 = pop();

	setsubs((Simbolo_t *) fr->argn[nargs - fr->nargs] , (Simbolo_t *) 0,
		(Simbolo_t *) d2, (Simbolo_t *) d3);

	push(d3);

	tentaLibSim((Simbolo_t *) d2);
}

void argsub3()
{
	Datum  d2, d3;
	int nargs = (int) ((long) *pc++);

	if (nargs > fr->nargs)

/* *** Padroniz. msg erro - Luciana 09/03/95
		execerro("Numero errado de argumentos",(char *) 0);
*** */

		execerro(PegaMsg(3220), (char *) 0);

	d3 = pop();
	d2 = pop();

	setsubs((Simbolo_t *) fr->argn[nargs - fr->nargs] ,(Simbolo_t *) d2,  
		(Simbolo_t *) 0, (Simbolo_t *) d3);

	push(d3);

	tentaLibSim((Simbolo_t *) d2);
}

void argassign()
{
	Datum d;
	int nargs = (int) ((long) *pc++);

	if (nargs > fr->nargs)

/* *** Padroniz. msg erro - Luciana 09/03/95
		execerro("Numero errado de argumentos",(char *) 0);
*** */

		execerro(PegaMsg(3220), (char *) 0);

	d = pop();
	push(d);

	fr->argn[nargs - fr->nargs] = d;

}


Simbolo_t * igual(d1, d2)
Datum d1;
Datum d2;
{
	int i, n;
	int j, n1;
	Simbolo_t *sr = faztemp(1,1);
#ifdef EDIX
	double *dp;
#endif

	if (((n=NLINS((Simbolo_t *) d1))!=NLINS((Simbolo_t *) d2))||
		((n1=NCOLS((Simbolo_t *) d1))!=NCOLS((Simbolo_t *) d2)))

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("Matrizes nao possuem as mesmas dimensoes",(char *) 0);
*** */
		execerro(PegaMsg(3112),(char *) 0);
	
	for(i=0; i < n; ++i) {
		for(j=0; j < n1; ++j) {
			if (fuzz(DADOij((Simbolo_t *) d1,i,j),
				 DADOij((Simbolo_t *) d2,i,j)) != 0) {

#ifdef EDIX
				dp = &DADOij(sr,0,0);
				*dp = 0.0;
#else
				DADOij(sr,0,0) = 0.0;
#endif
				return (sr);
			}
		}
	}

#ifdef EDIX
	dp = &DADOij(sr,0,0);
	*dp = 1.0;
#else
	DADOij(sr,0,0) = 1.0;
#endif

	return (sr);
}

Simbolo_t * diff(d1, d2)
Datum d1;
Datum d2;
{
	int i, n;
	int j, n1;
	Simbolo_t *sr = faztemp(1,1);
#ifdef EDIX
	double *dp;
#endif

	if (((n=NLINS((Simbolo_t *) d1))!=NLINS((Simbolo_t *) d2))||
		((n1=NCOLS((Simbolo_t *) d1))!=NCOLS((Simbolo_t *) d2)))

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("Matrizes nao possuem as mesmas dimensoes",(char *) 0);
*** */
		execerro(PegaMsg(3112),(char *) 0);

	for(i=0; i < n; ++i) {
		for(j=0; j < n1; ++j) {
			if (fuzz(DADOij((Simbolo_t *) d1,i,j),
				 DADOij((Simbolo_t *) d2,i,j))!=0) {

#ifdef EDIX
				dp = &DADOij(sr,0,0);
				*dp = 1.0;		
#else
				DADOij(sr,0,0) = 1.0;		
#endif
				return (sr);
			}
		}
	}

#ifdef EDIX
	dp = &DADOij(sr,0,0);
	*dp = 0.0;		
#else
	DADOij(sr,0,0) = 0.0;		
#endif

	return (sr);
}

Simbolo_t * maior(d1, d2)
Datum d1;
Datum d2;
{
	int i, n;
	int j, n1;
	Simbolo_t *sr = faztemp(1,1);
#ifdef EDIX
	double *dp;
#endif

	if (((n=NLINS((Simbolo_t *) d1))!=NLINS((Simbolo_t *) d2))||
		((n1=NCOLS((Simbolo_t *) d1))!=NCOLS((Simbolo_t *) d2)))

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("Matrizes nao possuem as mesmas dimensoes",(char *) 0);
*** */
		execerro(PegaMsg(3112),(char *) 0);

	for(i=0; i < n; ++i) {
		for(j=0; j < n1; ++j) {
			if (fuzz(DADOij((Simbolo_t *) d1,i,j),
				 DADOij((Simbolo_t *) d2,i,j)) <= 0) {
#ifdef EDIX
				dp = &DADOij(sr,0,0);
				*dp = 0.0;		
#else
				DADOij(sr,0,0) = 0.0;		
#endif
				return (sr);
			}
		}
	}

#ifdef EDIX
	dp = &DADOij(sr,0,0);
	*dp = 1.0;
#else
	DADOij(sr,0,0) = 1.0;
#endif

	return (sr);
}

Simbolo_t * maioreq(d1, d2)
Datum d1;
Datum d2;
{
	int i, n;
	int j, n1;
	Simbolo_t *sr = faztemp(1,1);
#ifdef EDIX
	double *dp;
#endif

	if (((n=NLINS((Simbolo_t *) d1))!=NLINS((Simbolo_t *) d2))||
		((n1=NCOLS((Simbolo_t *) d1))!=NCOLS((Simbolo_t *) d2)))

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("Matrizes nao possuem as mesmas dimensoes",(char *) 0);
*** */
		execerro(PegaMsg(3112),(char *) 0);

	for(i=0; i < n; ++i) {
		for(j=0; j < n1; ++j) {
			if (fuzz(DADOij((Simbolo_t *) d1,i,j),
				 DADOij((Simbolo_t *) d2,i,j)) < 0) {
#ifdef EDIX
				dp = &DADOij(sr,0,0);
				*dp = 0.0;		
#else
				DADOij(sr,0,0) = 0.0;		
#endif
				return (sr);
			}
		}
	}

#ifdef EDIX
	dp = &DADOij(sr,0,0);
	*dp = 1.0;		
#else
	DADOij(sr,0,0) = 1.0;		
#endif

	return (sr);
}

Simbolo_t * menor(d1, d2)
Datum d1;
Datum d2;
{
	int i, n;
	int j, n1;
	Simbolo_t *sr = faztemp(1,1);
#ifdef EDIX
	double *dp;
#endif

	if (((n = NLINS((Simbolo_t *) d1)) != NLINS((Simbolo_t *) d2)) ||
		((n1=NCOLS((Simbolo_t *) d1)) != NCOLS((Simbolo_t *) d2)))

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("Matrizes nao possuem as mesmas dimensoes",(char *) 0);
*** */
		execerro(PegaMsg(3112),(char *) 0);

	for(i=0; i < n; ++i) {
		for(j=0; j < n1; ++j) {
			if (fuzz(DADOij((Simbolo_t *) d1,i,j),
				 DADOij((Simbolo_t *) d2,i,j)) >= 0) {
#ifdef EDIX
				dp = &DADOij(sr,0,0);
				*dp = 0.0;
#else
				DADOij(sr,0,0) = 0.0;
#endif
				return (sr);
			}
		}
	}

#ifdef EDIX
	dp = &DADOij(sr,0,0);
	*dp = 1.0;
#else
	DADOij(sr,0,0) = 1.0;
#endif

	return (sr);
}

Simbolo_t * menoreq(d1, d2)
Datum d1;
Datum d2;
{
	int i, n;
	int j, n1;
	Simbolo_t *sr = faztemp(1,1);
#ifdef EDIX
	double *dp;
#endif

	if (((n = NLINS((Simbolo_t *) d1)) != NLINS((Simbolo_t *) d2)) ||
		((n1 = NCOLS((Simbolo_t *) d1)) != NCOLS((Simbolo_t *) d2)))

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("Matrizes nao possuem as mesmas dimensoes",(char *) 0);
*** */
		execerro(PegaMsg(3112),(char *) 0);

	for(i=0; i < n; ++i) {
		for(j=0; j < n1; ++j) {
			if (fuzz(DADOij((Simbolo_t *)d1,i,j),
				 DADOij((Simbolo_t *)d2,i,j)) > 0) {
#ifdef EDIX
				dp = &DADOij(sr,0,0);
				*dp = 0.0;
#else
				DADOij(sr,0,0) = 0.0;
#endif
				return (sr);
			}
		}
	}

#ifdef EDIX
	dp = &DADOij(sr,0,0);
	*dp = 1.0;
#else
	DADOij(sr,0,0) = 1.0;
#endif

	return (sr);
}

void gt()
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();

	push((Datum) maior(d1,d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void lt()
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();

	push((Datum) menor(d1,d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void ge()
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();

	push((Datum) maioreq(d1,d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void le()
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();

	push((Datum) menoreq(d1,d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void eq()
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();

	push((Datum) igual(d1,d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void ne()
{
	Datum d1, d2;

	d2 = pop();
	d1 = pop();

	push((Datum) diff(d1,d2));

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void and()
{
	Datum d1, d2;
	Simbolo_t *sr = faztemp(1,1);
#ifdef EDIX
	double *dp;
#endif

	d2 = pop();
	d1 = pop();

	if (DADOij((Simbolo_t *) d1,0,0) != 0.0 &&
			DADOij((Simbolo_t *) d2,0,0) != 0.0) {
#ifdef EDIX
		dp = &DADOij(sr,0,0);
		*dp = 1.0;
#else
		DADOij(sr,0,0) = 1.0;
#endif
	}

	else {
#ifdef EDIX
		dp = &DADOij(sr,0,0);
		*dp = 0.0;
#else
		DADOij(sr,0,0) = 0.0;
#endif
	}

	push((Datum) sr);

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void or()
{
	Datum d1, d2;
	Simbolo_t *sr = faztemp(1,1);
#ifdef EDIX
	double *dp;
#endif

	d2 = pop();
	d1 = pop();

	if (DADOij((Simbolo_t *) d1,0,0) != 0.0 ||
			DADOij((Simbolo_t *) d2,0,0) != 0.0) {
#ifdef EDIX
		dp = &DADOij(sr,0,0);
		*dp = 1.0;
#else
		DADOij(sr,0,0) = 1.0;
#endif
	}

	else {
#ifdef EDIX
		dp = &DADOij(sr,0,0);
		*dp = 0.0;
#else
		DADOij(sr,0,0) = 0.0;
#endif
	}

	push((Datum) sr);

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}

void not()
{
	Datum d;
	Simbolo_t *sr = faztemp(1,1);
#ifdef EDIX
	double *dp;
#endif

	d = pop();

	if (DADOij((Simbolo_t *) d,0,0) != 0.0 ) {
#ifdef EDIX
		dp = &DADOij(sr,0,0);
		*dp = 0.0;
#else
		DADOij(sr,0,0) = 0.0;
#endif
	}

	else {
#ifdef EDIX
		dp = &DADOij(sr,0,0);
		*dp = 1.0;
#else
		DADOij(sr,0,0) = 1.0;
#endif
	}

	push((Datum) sr);

	tentaLibSim((Simbolo_t *) d);
}

void existe()
{
	Simbolo_t *d;
	Simbolo_t *sr = faztemp(1,1);
#ifdef EDIX
	double *dp;
#endif

	d = (Simbolo_t *) (*pc++);

	if (d -> tipo == INDEF || d -> tipo == INDEFL) {
#ifdef EDIX
		dp = &DADOij(sr,0,0);
		*dp = 0.0;
#else
		DADOij(sr,0,0) = 0.0;
#endif
	}

	else {
#ifdef EDIX
		dp = &DADOij(sr,0,0);
		*dp = 1.0;
#else
		DADOij(sr,0,0) = 1.0;
#endif
	}

	push((Datum) sr);
}


void gs1()
{
	Datum d1, d2, d3;

	d3 = pop();
	d2 = pop();
	d1 = pop();

	if (MATRIZ((Simbolo_t *)d3) != (Matriz_t *) 0) {
		if (NLINS((Simbolo_t *)d3) != NLINS((Simbolo_t *)d1) ||
			NCOLS((Simbolo_t *)d3) != NCOLS((Simbolo_t *)d1)) {
			efree((char *) DADOS((Simbolo_t *)d3));
			efree((char *) MATRIZ((Simbolo_t *)d3));
			MATRIZ((Simbolo_t *)d3) = fazmat(NLINS((Simbolo_t *)d1),
				NCOLS((Simbolo_t *)d1));
		}
	}

	else {
		MATRIZ((Simbolo_t *)d3) = fazmat(NLINS((Simbolo_t *)d1),
			NCOLS((Simbolo_t *)d1));
		((Simbolo_t *)d3) -> tipo = ID;
	}

	if (NLINS((Simbolo_t *)d1) >= NCOLS((Simbolo_t *)d1)) {
		if (MATRIZ((Simbolo_t *)d2) != (Matriz_t *) 0) {
			if (NLINS((Simbolo_t *)d2) != NCOLS((Simbolo_t *)d1) ||
				NCOLS((Simbolo_t *)d2)!=NCOLS((Simbolo_t *)d1)){
				efree((char *) DADOS((Simbolo_t *)d2));
				efree((char *) MATRIZ((Simbolo_t *)d2));
				MATRIZ((Simbolo_t *)d2) =
					fazmat(NCOLS((Simbolo_t *)d1),
					NCOLS((Simbolo_t *)d1));
			}
		}

		else {
			MATRIZ((Simbolo_t *)d2) = fazmat(NCOLS((Simbolo_t *)d1),
				NCOLS((Simbolo_t *)d1));
			((Simbolo_t *)d2) -> tipo = ID;
		}

		mgs1((Simbolo_t *)d1, (Simbolo_t *)d2, (Simbolo_t *)d3);
	}

	else {
		if (MATRIZ((Simbolo_t *)d2) != (Matriz_t *) 0) {
			if (NLINS((Simbolo_t *)d2) != NLINS((Simbolo_t *)d1) ||
				NCOLS((Simbolo_t *)d2)!=NLINS((Simbolo_t *)d1)){
				efree((char *) DADOS((Simbolo_t *)d2));
				efree((char *) MATRIZ((Simbolo_t *)d2));
				MATRIZ((Simbolo_t *)d2) =
					fazmat(NLINS((Simbolo_t *)d1),
					NLINS((Simbolo_t *)d1));
			}
		}

		else {
			MATRIZ((Simbolo_t *)d2) = fazmat(NLINS((Simbolo_t *)d1),
				NLINS((Simbolo_t *)d1));
			((Simbolo_t *)d2) -> tipo = ID;
		}

		mgs((Simbolo_t *)d1, (Simbolo_t *)d2, (Simbolo_t *)d3);
	}
}

void mdvs1()
{
	Datum d1, d2, d3, d4;

	d4 = pop();
	d3 = pop();
	d2 = pop();
	d1 = pop();

	MATRIZ((Simbolo_t *)d2) = fazmat(NCOLS((Simbolo_t *)d1),1);

	MATRIZ((Simbolo_t *)d3) = fazmat(NLINS((Simbolo_t *)d1),
		NCOLS((Simbolo_t *)d1));

	MATRIZ((Simbolo_t *)d4) = fazmat(NCOLS((Simbolo_t *)d1),
		NCOLS((Simbolo_t *)d1));

	mdvs((Simbolo_t *)d1, (Simbolo_t *)d2, (Simbolo_t *)d3,
		(Simbolo_t *)d4);

	((Simbolo_t *)d2) -> tipo = ID;
	((Simbolo_t *)d3) -> tipo = ID;
	((Simbolo_t *)d4) -> tipo = ID;
}

void mcata1()
{
	Datum d1, d2, d3, d4;
	Simbolo_t *sr;

	d4 = pop();
	d3 = pop();
	d2 = pop();
	d1 = pop();

	sr = faztemp((int) (mcata((Simbolo_t *)d1,
		(Simbolo_t *) 0, (Simbolo_t *)d2, (Simbolo_t *)d3, 0,
		((Simbolo_t *)d4)->nome)+1), NCOLS((Simbolo_t *)d1)); 

	mcata((Simbolo_t *)d1,sr,(Simbolo_t *)d2,(Simbolo_t *)d3,1,
	     ((Simbolo_t *)d4)->nome);

	push((Datum) sr);

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
	tentaLibSim((Simbolo_t *) d3);
	tentaLibSim((Simbolo_t *) d4);
}

void criamat()
{
	Datum d1, d2, d3;
	int i, j;
	int nc, nl;
#ifdef EDIX
	double *dp;
#endif
	Simbolo_t *sr;

	d3 = pop();
	d2 = pop();
	d1 = pop();

	if (((NLINS( (Simbolo_t *) d1) *NCOLS( (Simbolo_t *) d1) ) > 1) ||
	    ((NLINS( (Simbolo_t *) d2) *NCOLS( (Simbolo_t *) d2) ) > 1) ||
	    ((NLINS( (Simbolo_t *) d3) *NCOLS( (Simbolo_t *) d3) ) > 1)) {

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("CRIAMAT","argumento nao e' escalar");
*** */
		execerro(PegaMsg(3113),(char *) 0);
	}

	nl = (int) ( DADOij( (Simbolo_t *) d1, 0, 0));

	nc = (int) ( DADOij( (Simbolo_t *) d2, 0, 0));
	
	if (nl <= 0 || nc <= 0)

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("CRIAMAT","nao posso criar matriz desta dimensao");
*** */
		execerro(PegaMsg(3114),(char *) 0);

	sr = faztemp(nl, nc);	

	for(i=0; i < nl; i++) {	
		for(j=0; j < nc; j++) {	
#ifdef EDIX
			dp = &(DADOij(sr, i, j));
			*dp= DADOij( (Simbolo_t *) d3, 0, 0);
#else	
			DADOij(sr,i,j) = DADOij( (Simbolo_t *) d3, 0, 0);
#endif	
		}
	}	

	push((Datum) sr);

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
	tentaLibSim((Simbolo_t *) d3);
}

/*
void contagem()
{
	Datum d1, d2;
	int i, j, l;
	int nc, nl;
#ifdef EDIX
	double *dp;
#endif
	Simbolo_t *sr;

	d2 = pop();
	d1 = pop();

	if (NLINS( (Simbolo_t *) d2) != 1) {

/# *** Padroniz. msg erro - Luciana 23/12/94
		execerro("CONTAGEM",
			"Segundo argumento tem que ser vetor linha");
*** #/
		execerro(PegaMsg(3102),(char *) 0);
	}

	if (NCOLS( (Simbolo_t *) d1) != 2) {

/# *** Padroniz. msg erro - Luciana 23/12/94
		execerro("CONTAGEM",
		"Primeiro argumento deve conter apenas duas colunas");
*** #/
		execerro(PegaMsg(3103),(char *) 0);
	}

	nl = (int) ( NLINS( (Simbolo_t *) d1));

	nc = (int) ( NCOLS( (Simbolo_t *) d2));
	
	if (nc <= 0)

/# *** Padroniz. msg erro - Luciana 23/12/94
		execerro("CONTAGEM","nao posso criar matriz desta dimensao");
*** #/
		execerro(PegaMsg(5035),(char *) 0);

	sr = faztemp(nc, nc);	

	for(l=0; l < nc; l++) {	
		for(i=0; i < nc; i++) {	
#ifdef EDIX
			dp = &(DADOij(sr, l, i));
			*dp= 0.0;
#else	
			DADOij(sr, l, i) = 0.0;
#endif	
		}
	}


	for(l=0; l < nc; l++) {	
		for(i=0; i < nc; i++) {	
			for(j=0; j < nl; j++) {
				if ( (DADOij( (Simbolo_t *) d1, j, 0)  ==
				     DADOij( (Simbolo_t *) d2, 0, l))  &&
				     (DADOij( (Simbolo_t *) d1, j, 1)  ==
			             DADOij( (Simbolo_t *) d2, 0, i))) {
#ifdef EDIX
					dp = &(DADOij(sr, l, i));
					*dp= DADOij( sr, l, i) + 1.0;
#else	
					DADOij(sr, l, i) = 
						DADOij( sr, l, i) + 1.0;
#endif	
				}
			}
		}
	}

	push((Datum) sr);
}
*/


void mbdiag()
{
	Datum d3[15];
	Datum d;
	int i, j, k, nl, nc, nci, nli;
	Simbolo_t *sr;
#ifdef EDIX
	double *dp;
#endif

	i = nl = nc = 0;

	while(1) {
		if (i >= 15)

/* *** Padroniz. msg erro - Luciana 23/12/94
			execerro("BDIAG","Numero de argumentos maior do que 15"); 
*** */
			execerro(PegaMsg(1108),(char *) 0);
		d3[i] = pop();
		d = d3[i];

		if (d3[i] == (Datum) NULL)
			break;

		nl += (NLINS( (Simbolo_t *) d));
		nc += (NCOLS( (Simbolo_t *) d));

		i++;
	}

	sr = faztemp(nl, nc);	

	for(j=0; j < nl; j++) {	
		for(k=0; k < nc; k++) {	
#ifdef EDIX
			dp = &(DADOij(sr, j, k));
			*dp= 0.0;
#else	
			DADOij(sr,j,k) = 0.0;
#endif	
		}
	}	

	nci = 0;
	nli = 0;

	for(i=i-1; i >= 0; i--) {	
		d = d3[i];

		for(k=0; k < NLINS((Simbolo_t *) d)	; k++) {	
			for(j=0	; j < NCOLS((Simbolo_t *) d); j++) {	
#ifdef EDIX
				dp = &(DADOij( sr,nli+k,nci+j));
				*dp= DADOij((Simbolo_t *) d,k,j);
#else	
				DADOij(sr,nli+k,nci+j) = DADOij((Simbolo_t *) d,k,j);
#endif		
			}
		}

		nci = (nci + NCOLS((Simbolo_t *)d)); 
		nli = (nli + NLINS((Simbolo_t *)d)); 
	}

	push((Datum) sr);
}

/* 
** fuzz(): codigo fonte passado para o arquivo init.c, para possibilitar 
	   montagem da libcm sem a inclusao do arquivo initcode.c
*/

/* ------------------------------------------------------
** Funcao:  LIBTMP2
**	   Forca a liberacao das matrizes paraemtros
**	   resetando temporariamente o valor de argumento
** ------------------------------------------------------
*/

void libtmp2() 
{
	extern Simbolo_t *tabsimb;	/* tabela de simbolos */

	Simbolo_t *sp, *spp;

	if (debugflag)
		printf("LIBTEMP2\n");

	for (sp = tabsimb; TIPO(sp) != 9999 ; sp = PROXIMO(sp))
		if (TIPO(sp) == LOCAL) {
			if (PREVIO(sp) == (Simbolo_t *) 0)
				spp = tabsimb;
			else
				spp = PREVIO(sp);

			libsim(sp);

			sp = spp;
		}
}


/* -------------------------------------------------------------------
** Funcoes: Set_parm e reset_parm
** Objetivo: Indicar que parametros devem ser instalados como locais
** -------------------------------------------------------------------
*/

void set_parm() 
{
	if (debugflag)
		printf("parm 1\n");

	parametro = 1;
}

void reset_parm() 
{
	if (debugflag)
		printf("parm 0\n");

	parametro = 0;
}


/*
** Muda Semente
*/

void setsem()
{
#ifndef VAXVMS
	extern void	srand();
#endif
	Datum		d;
	double		op2;
	unsigned	irand;
	int		l;

	d = pop();

	op2 = DADOij( (Simbolo_t *) d, 0, 0);

	if (op2 < 0.0)
		op2 = -op2;

	if (op2 > 1.0) {
		l = (int) log10(op2) + 1;
		op2 = op2 / pow(10., (double) l);
	}

	/*
	irand = (unsigned) (op2 * MAXRAND);
	*/
	irand = (unsigned) (op2);
	srand(irand);
}

void meigen1()
{
	Datum	d1, d2, d3;
	int	i, j;
	int	n;
	int	nm;
	int	matz;

	d3 = pop();
	d2 = pop();
	d1 = pop();

	nm = (int) NLINS((Simbolo_t *) d1);
	n  = nm;

	if (NLINS((Simbolo_t *) d1) != NCOLS((Simbolo_t *) d1))

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("Auto","Matriz nao e' quadrada.");
*** */
		execerro(PegaMsg(3115),(char *) 0);

	matz = 0;

	for(i=0; i < n; ++i) {
		for(j=i; j < n; ++j) {
			if (fuzz(DADOij((Simbolo_t *) d1,i,j),
					DADOij((Simbolo_t *) d1,j,i)) != 0) {
				matz = 1;

				break;
			}
		}
	}

	if (MATRIZ((Simbolo_t *)d2) != (Matriz_t *) 0) {
		efree((char *) DADOS((Simbolo_t *)d2));
		efree((char *) MATRIZ((Simbolo_t *)d2));
	}

	MATRIZ((Simbolo_t *)d2) = fazmat(NLINS((Simbolo_t *)d1),matz+1);

	((Simbolo_t *)d2) -> tipo = ID;

	if (MATRIZ((Simbolo_t *) d3) != (Matriz_t *) 0) {
		efree((char *) DADOS((Simbolo_t *) d3));
		efree((char *) MATRIZ((Simbolo_t *) d3));
	}

	MATRIZ((Simbolo_t *)d3) = fazmat(NLINS((Simbolo_t *)d1),
		NCOLS((Simbolo_t *)d1));

	((Simbolo_t *) d3) -> tipo = ID;

	if (matz) {
		int	 ierr;
		int	*iv1;
		double	*fv1;
		double	*A;
		double	*wr;
		double	*wi;
		double	*z;

		if ((iv1 = (int *) malloc(nm*sizeof(int))) == (int *) NULL) 

/* *** Padroniz. msg erro - Luciana 23/12/94
			execerro("","Memoria disponivel esgotada");
*** */
			execerro(PegaMsg(1039),(char *) 0);

		fv1 = (double *) malloc(nm*sizeof(double));

		if (fv1 == (double *) NULL)

/* *** Padroniz. msg erro - Luciana 23/12/94
			execerro("","Memoria disponivel esgotada");
*** */
			execerro(PegaMsg(1039),(char *) 0);

		z = (double *) malloc(nm*nm*sizeof(double));

		if (z == (double *) NULL)

/* *** Padroniz. msg erro - Luciana 23/12/94
			execerro("","Memoria disponivel esgotada");
*** */
			execerro(PegaMsg(1039),(char *) 0);

		A = (double *) malloc(nm*nm*sizeof(double));

		if (A == (double *) NULL)

/* *** Padroniz. msg erro - Luciana 23/12/94
			execerro("","Memoria disponivel esgotada");
*** */
			execerro(PegaMsg(1039),(char *) 0);

		wr = (double *) malloc(nm*sizeof(double));

		if (wr == (double *) NULL)

/* *** Padroniz. msg erro - Luciana 23/12/94
			execerro("","Memoria disponivel esgotada");
*** */
			execerro(PegaMsg(1039),(char *) 0);
	
		wi = (double *) malloc(nm*sizeof(double));

		if (wi == (double *) NULL)

/* *** Padroniz. msg erro - Luciana 23/12/94
			execerro("","Memoria disponivel esgotada");
*** */
			execerro(PegaMsg(1039),(char *) 0);

		for(i=0; i < NLINS((Simbolo_t *) d1); i++) {
			iv1[i] = 0;
			fv1[i] = 0.0;

			for(j=0; j < NLINS((Simbolo_t *) d1); j++) {
				A[i*NCOLS((Simbolo_t *) d1)+j] =
					(double) DADOij((Simbolo_t *) d1,j,i);
				z[i*NCOLS((Simbolo_t *) d1)+j] = 0.0;
			}
		}

		rg_(nm,n,A,wr,wi,&matz, z, iv1, fv1, &ierr);

		for(i=0; i <  NLINS((Simbolo_t *) d1); i++) {
			DADOij((Simbolo_t *) d2,i,0) = (double) wr[i];
			DADOij((Simbolo_t *) d2,i,1) = (double) wi[i];
		}

		for(i=0; i < NLINS((Simbolo_t *) d1); i++) {
			for(j=0; j < NLINS((Simbolo_t *) d1); j++) {
				DADOij((Simbolo_t *) d3,j,i) =
					(double) z[i*NCOLS((Simbolo_t *) d1)+j];
			}
		}

		free( (char *) z);
		free( (char *) wr);
		free( (char *) wi);
		free( (char *) iv1);
		free( (char *) fv1);
		free( (char *) A);
	}
	else
		meigen((Simbolo_t *)d1, (Simbolo_t *)d2, (Simbolo_t *)d3);

	tentaLibSim((Simbolo_t *) d1);
}

