#include <stdio.h>
#include "cm_cm01.h"

#ifdef MSDOS
#include "y_tab.h"
#else
#ifdef VAXVMS
#include "y_tab.h"
#else
#include "y.tab.h"
#endif
#endif

#ifdef MEM_DEBUG
#include "mshell.h"
#endif


/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Libera item da tabela de smbolos.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

extern Simbolo_t falso_no;
extern Simbolo_t *tabsimb;	/* tabela de simbolos */

void libsim(sp)			/* remove simbolo apontado por sp */
Simbolo_t *sp;
{

	int t;
	t = TIPO(sp);

	/* remova sp da tabela de simbolos */
	/* faca o previo do que agora e' o proximo de sp ser o que agora */
	/* e' o previo de sp (nota: sp sempre tem proximo: falso_no) */

	PREVIO(PROXIMO(sp)) = PREVIO(sp);

	/* faca o proximo do que agora e' o previo de sp  ser o que agora */
	/* e' o proximo de sp */

	if (PREVIO(sp) == (Simbolo_t *) 0)
		tabsimb = PROXIMO(sp);
	else
		PROXIMO(PREVIO(sp)) = PROXIMO(sp); 


	/* libere espacos ocupados por sp */
	/* libere o espaco ocupado pelo nome do simbolo apontado por sp */

	efree(NOME(sp));

	if (t != FUNCTION && t != PROCEDURE) {
		/* libere o espaco ocupado pela matriz apontada por sp */
		/* libere o espaco ocupado pelo no' descritor da matriz */

		if (MATRIZ(sp) != (Matriz_t *) 0) {
			if (DADOS(sp) != (double *) 0) {
				efree((char *) DADOS(sp));
			}
			efree((char *) MATRIZ(sp));
		}
	}

	/* libere o espaco ocupado pelo no' sp propriamente dito */

	efree((char *) sp);
}

