#include <stdio.h>
#include "cm_cm01.h"

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	produto de kronecker das matrizes associadas aos simbolos x e y



Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/


Simbolo_t *matkron(x,y)
Simbolo_t *x, *y;
{

	Simbolo_t *sr = faztemp(NLINS(x)*NLINS(y),NCOLS(x)*NCOLS(y));
	int i, j, k, l, baselin, lin, basecol;
	double elx;
#ifdef EDIX
	double *dp;
#endif

	for (i = 0; i < NLINS(x); i++) {
		baselin = i * NLINS(y);

		for (j = 0; j < NCOLS(x); j++) {
			basecol = j * NCOLS(y);
			elx = DADOij(x, i, j);

			for (k = 0; k < NLINS(y); k++) {
				lin = baselin + k;

				for (l = 0; l < NCOLS(y); l++) {
#ifdef EDIX
					dp = &(DADOij(sr, lin, basecol+l));
					*dp = elx * DADOij(y, k, l);
#else
					DADOij(sr, lin, basecol+l) = elx * 
						DADOij(y, k, l);
#endif
				}
			}
		}
	}

	return sr;

}

