#include <stdio.h>
#include "cm_cm01.h"

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Multiplicao de duas matrizes



Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/


Simbolo_t *matmult(x,y)			/* multiplica x * y */
Simbolo_t *x, *y;
{
	Simbolo_t *sr; 
#ifdef EDIX
	double *dp;
#endif

	switch (verdim(x,y)) {

	/*
	** matriz x e' um escalar
	*/

	case 1:
		{
			int  numelem = NLINS(y) * NCOLS(y);
			double d = DADOij(x, 0, 0);
			int i;

			sr = faztemp(NLINS(y),NCOLS(y)); 

			for (i=0; i < numelem; i++) {
#ifdef EDIX
				dp = &(DADOS(sr)[i]);
				*dp = d * DADOS(y)[i];
#else
				DADOS(sr)[i] = d * DADOS(y)[i];
#endif
			}

			break;
		}

	/*
	** matriz y e' um escalar
	*/

	case 2:
		{
			int  numelem = NLINS(x) * NCOLS(x);
			double d = DADOij(y, 0, 0);
			int i;

			sr = faztemp(NLINS(x),NCOLS(x)); 

			for (i=0; i < numelem; i++) {
#ifdef EDIX
				dp = &(DADOS(sr)[i]);
				*dp = d * DADOS(x)[i];
#else
				DADOS(sr)[i] = d * DADOS(x)[i];
#endif
			}

			break;
		}

	/*
	** multiplicacao matricial; verifique dimensoes
	*/

	case 0:
	case 3:
		if (NCOLS(x) != NLINS(y)) {
			/*
			** matrizes sao incompativeis
			*/

			numerro = MATMULTER;

			conferro(x, y, "*");
		}

		sr = faztemp(NLINS(x),NCOLS(y)); 
       
		multmat(DADOS(x), DADOS(y), DADOS(sr), NLINS(x),
			NCOLS(x), NCOLS(y));

		break;

	}

	return sr;
}

