#include <stdio.h>
#include <math.h>
#include "cm_cm01.h"
#include "pcsgbd.h" /* Luciana */

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
Calcula o determinante de uma matriz quadrada.



Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

extern double _toler_;
#define TOL _toler_

#ifdef MSDOS
# define  EPS 1.0e-291
#else
# define  EPS 1.0e-15
#endif
   
Simbolo_t *mdet(a)
Simbolo_t *a;
{
	int i;
	int j;
	int k;
	int n;
	int teste;
	double det;
	double r;

	Simbolo_t *s = faztemp(1,1);
	Simbolo_t *t = faztemp(NLINS(a),NLINS(a));
	Simbolo_t *p = faztemp(NLINS(a),1);
/*	Simbolo_t *b = faztemp(NLINS(a),1); */
#ifdef EDIX
	double *dp;
#endif
	if ((n=NLINS(a)) != NCOLS(a))

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("matriz nao e quadrada",(char *) 0);
*** */
		execerro(PegaMsg(3115), (char *) 0);

	teste = 1;

	for(i=0; i < n; ++i) {
		for(j=0; j < n; ++j) {
#ifdef EDIX
			dp = &(DADOij(t,i,j));
			*dp = DADOij(a,i,j);
#else
			DADOij(t,i,j) = DADOij(a,i,j);
#endif
		}
	}
	det = 1.0;
	if (fabs(DADOij(t,0,0)) < TOL) {
		teste = ptroca(0,t);
		det = - det;
	}

	if (teste == 0) {
#ifdef EDIX
		dp = &(DADOij(s,0,0));
		*dp = 0.0;
#else
		DADOij(s,0,0) = 0.0;
#endif

		tentaLibSim(t);
		tentaLibSim(p);

		return s;
	}
		
	k = 0;

	while( k < (n - 1)) {
		i = k + 1;
		if ( k > 0) {
			if (fabs(DADOij(t,k,k)) < TOL) {
				teste = ptroca(k,t);
				det = -det;
				if (teste == 0) {
#ifdef EDIX
					dp = &(DADOij(s,0,0));
					*dp = 0.0;
#else
					DADOij(s,0,0) = 0.0;
#endif

					tentaLibSim(t);
					tentaLibSim(p);

					return s;
				}
			}	
		}

#ifdef EDIX
		dp = &(DADOij(p,k,0));
		*dp = 1.0 / DADOij(t,k,k);
#else
		DADOij(p,k,0) = 1.0 / DADOij(t,k,k);
#endif
		while(i < n) {
			r = DADOij(t,i,k)* DADOij(p,k,0);
#ifdef EDIX
			dp = &(DADOij(t,i,k));
			*dp = 0.0;
#else
			DADOij(t,i,k) = 0.0;
#endif

			for(j=k+1; j < n ; ++j) {
#ifdef EDIX
				dp = &(DADOij(t,i,j));
				*dp = DADOij(t,i,j)-r*DADOij(t,k,j);
#else
				DADOij(t,i,j) = DADOij(t,i,j)-r*DADOij(t,k,j);
#endif
			}
			
		/*	DADOij(b,i,0) = DADOij(b,i,0) - r* DADOij(b,k,0);*/
			++i;
	 	}
		det = det*DADOij(t,k,k);
		++k;
	}
	det = det*DADOij(t,k,k);
#ifdef EDIX
	dp = &(DADOij(s,0,0));
	*dp = det;
#else
	DADOij(s,0,0) = det;
#endif

	tentaLibSim(t);
	tentaLibSim(p);

	return s;
}

int	ptroca(i, t)
int	i;
Simbolo_t *t;
{
	int j;
	int k;

	for(k=i+1; k < NLINS(t); ++k) {
		if(fabs(DADOij(t,k,i))  > TOL) {
			for(j=0; j < NLINS(t); ++j) {
				swap(&DADOij(t,i,j),&DADOij(t,k,j));
			}
			return 1;
		}
	}
	return 0;
}

