#include <stdio.h>
#include <math.h>
#include "cm_cm01.h"
#include "pcsgbd.h" /* Luciana */

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
Constri uma matriz diagonal a partir de um vetor ou de uma matriz quadrada. A diagonal principal desta matriz  
formada pelo vetor ou pela diagonal principal da matriz quadrada.
Exemplos:

B = DIAG(A1[,3]);
C = DIAG(A1'A1);

B       Col1   Col2   Col3   Col4   Col5
Lin1     1         0         0          0       0
Lin2     0         4         0          0       0
Lin3     0         0         9          0       0
Lin4     0         0         0        16       0
Lin5     0         0         0          0      25

C      Col1   Col2   Col3
Lin1    5        0           0
Lin2    0       55          0
Lin3    0        0        979



Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

Simbolo_t *mDiag(x)
Simbolo_t *x;
{
	Simbolo_t *sr;
	int i, j, n, inci, incj;
#ifdef EDIX
	double *dp;
#endif

	if (NLINS(x) == NCOLS(x)) {
		n = NLINS(x);
		inci = 1;
		incj = 1;
	}
	else
		if (NLINS(x) == 1) {
			n = NCOLS(x);
			inci = 0;
			incj = 1;
		}
		else
			if (NCOLS(x) == 1) {
				n = NLINS(x);
				inci = 1;
				incj = 0;
			}
			else

/* *** Padroniz. msg erro - Luciana 23/12/94
				execerro("diag: ","argumento nao e'matriz quadrada nem vetor");
*** */
				execerro(PegaMsg(3124), (char *) 0);

	sr  = faztemp(n,n);

	for (i = 0; i < NLINS(sr); i++) {
		for (j = 0; j < NCOLS(sr); j++) {
#ifdef EDIX
			dp = &(DADOij(sr, i, j));
			*dp = 0.0;
#else
			DADOij(sr, i, j) = 0.0;
#endif
		}
		DADOij(sr, i, i) = DADOij(x, i*inci, i*incj);
	}

	return sr;
}

