#include <stdio.h>
#include "pcsgbd.h"
#include "cm_cm01.h"

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
Calcula Prob( Y > arg1 ) onde Y  uma varivel aleatria  com distribuio F com arg2 e arg3 graus de liberdade.
Os argumentos devem ser nmeros reais, com arg1 >= 0 e arg2,arg3 > 0.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

Simbolo_t *mfprob(f, d11, d22)
Simbolo_t *f;
Simbolo_t *d11;
Simbolo_t *d22;
{
	Simbolo_t *sr = faztemp(1,1);
	double f1;
	double d1, d2;
#ifdef EDIX
	double *dp;
#endif

	if (NLINS(f) > 1 || NCOLS(f) > 1)

/* *** Padroniz. msg erro - Luciana 02/01/95
		execerro("parametro 1 tem que ser escalar", (char *) 0);
*** */
		execerro(PegaMsg(3126), (char *) 0);
	if (NLINS(d11) > 1 || NCOLS(d11) > 1)

/* *** Padroniz. msg erro - Luciana 02/01/95
		execerro("parametro 2 tem que ser escalar", (char *) 0);
*** */
		execerro(PegaMsg(3100), (char *) 0);
	if (NLINS(d22) > 1 || NCOLS(d22) > 1)

/* *** Padroniz. msg erro - Luciana 02/01/95
		execerro("parametro 3 tem que ser escalar", (char *) 0);
*** */
		execerro(PegaMsg(3107), (char *) 0);

	
	d1 = (DADOij(d11,0,0));
	d2 = (DADOij(d22,0,0));
	f1 = DADOij(f,0,0);
	if (f1 < 0.0 || d1 <= 0.0 || d2 <= 0.0)

/* *** Padroniz. msg erro - Luciana 02/01/95
		execerro("parametro invalido ", (char *) 0);
*** */
		execerro(PegaMsg(3127), (char *) 0);

#ifdef EDIX
	dp = &(DADOij(sr,0,0));
	*dp = fprob(f1, d1, d2); 
#else
	DADOij(sr,0,0) = fprob(f1, d1, d2); 
#endif

	return (sr);
}

