#include <stdio.h>
#include <math.h>
#include "cm_cm01.h"

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
Calcula a decomposio ortonormal de Gram-Smith de uma matriz retangular (mxn) com m >= n. Esta funo retorna duas variveis.
Ela s pode ser usada com o comando de atribuio (=).  necessrio atribuir duas variveis de uma s vez, separando-as por vrgula (,). 
A primeira  uma matriz triangular superior e a segunda uma matriz ortonormal.
Se B e C representam, respectivamente, estas  variveis, com dimenses (nxn) e (mxn), ento arg = C * B.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

extern double _toler_;

#define TOL	_toler_
   
void mgs(a1,t,p1)
Simbolo_t *a1;
Simbolo_t *t;
Simbolo_t *p1;
{
	int i,k,j,l,l1,lin,col;
	Simbolo_t *q;
	Simbolo_t *s;
	Simbolo_t *a;
	Simbolo_t *p;
#ifdef EDIX
	double *dp;
#endif
 
	if (NLINS(a1) >= NCOLS(a1)) {
		p = faztemp(NLINS(a1),NCOLS(a1));
		a = faztemp(NLINS(a1),NCOLS(a1));
	}
	else {
		p = faztemp(NCOLS(a1),NLINS(a1));
		a = faztemp(NCOLS(a1),NLINS(a1));
	}

	for(i=0; i < NLINS(a1); ++i)
		for(j=0; j < NCOLS(a1); ++j)
			if (NLINS(a1) >= NCOLS(a1)) {
#ifdef EDIX
				dp = &(DADOij(a,i,j));
				*dp = DADOij(a1,i,j);
#else
				DADOij(a,i,j) = DADOij(a1,i,j);
#endif
			}
			else {
#ifdef EDIX
				dp = &(DADOij(a,j,i));
				*dp = DADOij(a1,i,j);
#else
				DADOij(a,j,i) = DADOij(a1,i,j);
#endif
			}

	lin = NLINS(a);
	col = NCOLS(a); 
	s = faztemp(lin,1);
	q = faztemp(lin,1);

#ifdef EDIX
	dp = &(DADOij(t,0,0));
	*dp = 0.;
#else
	DADOij(t,0,0) = 0.;
#endif

	for(i=0; i < lin; i++) {
#ifdef EDIX
		dp = &(DADOij(t,0,0));
		*dp += DADOij(a,i,0)* DADOij(a,i,0);
#else
		DADOij(t,0,0) += DADOij(a,i,0)* DADOij(a,i,0);
#endif
	}
#ifdef EDIX
	dp = &(DADOij(t,0,0));
	*dp = sqrt( DADOij(t,0,0));
#else
	DADOij(t,0,0) = sqrt( DADOij(t,0,0));
#endif

	for(i=0; i < lin; i++) {
		if ( fabs(DADOij(t,0,0)) < TOL) {
#ifdef EDIX
			dp = &(DADOij(p,i,0));
			*dp = 0.;
#else
			DADOij(p,i,0) = 0.;
#endif
		}
		else {
#ifdef EDIX
			dp = &(DADOij(p,i,0));
			*dp = DADOij(a,i,0)/ DADOij(t,0,0);
#else
			DADOij(p,i,0) = DADOij(a,i,0)/ DADOij(t,0,0);
#endif
		}
 	}
	   
	for(k=1; k < col; ++k) {
#ifdef EDIX
		dp = &(DADOij(t,k,k));
		*dp = 0.;
#else
		DADOij(t,k,k) = 0.;
#endif
		for(i=0; i < k; ++i) {
#ifdef EDIX
			dp = &(DADOij(t,i,k));
			*dp = 0.;
#else
			DADOij(t,i,k) = 0.;
#endif
			for(j=0; j < lin; ++j) {
#ifdef EDIX
				dp = &(DADOij(s,j,0));
				*dp = 0.;
				dp = &(DADOij(t,i,k));
				*dp += DADOij(p,j,i)* DADOij(a,j,k);
#else
				DADOij(s,j,0) = 0.;
				DADOij(t,i,k) += DADOij(p,j,i)* DADOij(a,j,k);
#endif
			}
	 	}
		for(l=0; l < k; ++l) 
			for(l1=0; l1 < lin; ++l1) {
#ifdef EDIX
				dp = &(DADOij(s,l1,0));
				*dp += DADOij(t,l,k)*DADOij(p,l1,l);
#else
				DADOij(s,l1,0)+=DADOij(t,l,k)*DADOij(p,l1,l);
#endif
			}
		for(j=0; j < lin; ++j) {
#ifdef EDIX
			dp = &(DADOij(q,j,0));
			*dp = DADOij(a,j,k) - DADOij(s,j,0);
			dp = &(DADOij(t,k,k));
			*dp += DADOij(q,j,0)* DADOij(q,j,0);
#else
			DADOij(q,j,0) = DADOij(a,j,k) - DADOij(s,j,0);
			DADOij(t,k,k) += DADOij(q,j,0)* DADOij(q,j,0);
#endif
		}
#ifdef EDIX
		dp = &(DADOij(t,k,k));
		*dp = sqrt(DADOij(t,k,k));
#else
		DADOij(t,k,k) = sqrt(DADOij(t,k,k));
#endif

		for(j=0; j < lin; j++) {
			if ( fabs(DADOij(t,k,k)) < TOL) {
#ifdef EDIX
				dp = &(DADOij(p,j,k));
				*dp = 0.;
#else
				DADOij(p,j,k) = 0.;
#endif
			}
			else {
#ifdef EDIX
				dp = &(DADOij(p,j,k));
				*dp = DADOij(q,j,0)/DADOij(t,k,k);
#else
				DADOij(p,j,k)=DADOij(q,j,0)/DADOij(t,k,k);
#endif
			}
		}
	}

	for(i=0; i < lin; ++i)
		for(j=0; j < col; ++j)
			if (NLINS(a1) < NCOLS(a1)) {
#ifdef EDIX
				dp = &(DADOij(p1,j,i));
				*dp = DADOij(p,i,j);
#else
				DADOij(p1,j,i) = DADOij(p,i,j);
#endif
			}
			else {
#ifdef EDIX
				dp = &(DADOij(p1,i,j));
				*dp = DADOij(p,i,j);
#else
				DADOij(p1,i,j) = DADOij(p,i,j);
#endif
			}
	for(i=0; i < col; ++i)
		for(j=0; j < col; ++j)
			if(NLINS(a1) < NCOLS(a1)) {
#ifdef EDIX
				dp = &(DADOij(t,j,i));
				*dp = DADOij(t,i,j);
#else
				DADOij(t,j,i) = DADOij(t,i,j);
#endif
			}
			else
				break;
	for(i=1; i < col; ++i)
		for(k=0; k < i; ++k)
			if (NLINS(a1) < NCOLS(a1)) {
#ifdef EDIX
				dp = &(DADOij(t,k,i));
				*dp = 0.;
#else
				DADOij(t,k,i) = 0.;
#endif
			}
			else {
#ifdef EDIX
				dp = &(DADOij(t,i,k));
				*dp = 0.;
#else
				DADOij(t,i,k) = 0.;
#endif
			}

	tentaLibSim(q);
	tentaLibSim(s);
	tentaLibSim(a);
	tentaLibSim(p);
}

