#include <stdio.h>
#include <math.h>
#include "cm_cm01.h"

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	 
	Calcula a inversa generalizada de uma matriz quadrada.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

extern double _toler_;

#define TOL	_toler_

Simbolo_t *minvp(a)
Simbolo_t *a;
{
	int i,j,k,m,n;
	double d;
	Simbolo_t *s = faztemp(NCOLS(a),NLINS(a));
	Simbolo_t *q = faztemp(NCOLS(a),1);
	Simbolo_t *u = faztemp(NLINS(a),NCOLS(a));
	Simbolo_t *v = faztemp(NCOLS(a),NCOLS(a));
#ifdef EDIX
	double *dp;
#endif
	m = NLINS(a);
	n = NCOLS(a);

	mdvs(a,q,u,v);

	for(i=0; i < n; ++i) {
		for(k=0; k < n; ++k) {
			if ( fabs(DADOij(q,k,0)) > TOL) {
#ifdef EDIX
				dp = &(DADOij(v,i,k));
				*dp = DADOij(v,i,k)*(1/DADOij(q,k,0));
#else
				DADOij(v,i,k) = DADOij(v,i,k)*(1/DADOij(q,k,0));
#endif
			}
			else {
#ifdef EDIX
				dp = &(DADOij(v,i,k));
				*dp = 0.;
#else
				DADOij(v,i,k) = 0.;
#endif
			}
		}
	}

	for (i = 0; i < n; i++) 
	      for (j = 0; j < m; j++){
			d = 0.;
			for (k = 0; k < n; k++)
		        	d += DADOij(v,i,k)*DADOij(u,j,k);
#ifdef EDIX
			dp = &(DADOij(s,i,j));
			*dp = d;
#else
			DADOij(s,i,j) = d;
#endif
	       }

	tentaLibSim(q);
	tentaLibSim(u);
	tentaLibSim(v);

	return s;
}

