#include <stdio.h>
#include <math.h>
#include "cm_cm01.h"
#include "pcsgbd.h" /* Luciana */



/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	 
	Multiplica os elementos de cada uma das colunas do operando1 pelos correspondentes elementos de todas as colunas do operando2.
 	Os dois operandos devem ter necessariamente o mesmo nmero de linhas.
	Se A tem dimenso (mxn) e B tem dimenso (mxl), ento A *% B tem dimenso (mxnl).  

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/
   
Simbolo_t *mmulcol(x,y)		/* Multiplicacao de colunas */
Simbolo_t *x;
Simbolo_t *y;
{
	int i, j, n, nx, ny;
	int l, k;
	Simbolo_t *s;
#ifdef EDIX
	double *dp;
#endif

	if ( NLINS(y) != (n=NLINS(x)) ) {

/* *** Padroniz. msg erro - Luciana 02/01/95
		execerro("*%: ","Argumentos com diferentes numeros de linhas");
*** */
		execerro(PegaMsg(3130), (char *) 0);
	}
	nx = NCOLS(x);
	ny = NCOLS(y);

	s = faztemp(n,nx*ny); 

	k = 0;
	for(i=0; i < nx; i++) {
		for(j=0; j < ny; j++) {
			for(l=0; l < n; l++) {
#ifdef EDIX
				dp = &(DADOij(s,l,k));
				*dp = DADOij(x,l,i)*DADOij(y,l,j);
#else
				DADOij(s,l,k) = DADOij(x,l,i)*DADOij(y,l,j);
#endif
			}
			k++;
		}
	}
	return s;
}
