#include <stdio.h>
#include <math.h>

#include "cm_cm01.h"
#ifdef MSDOS
# define	EPS	1.0e-15
#else
# define	EPS	1.0e-15
#endif


/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	 
Gera um vetor coluna a partir dos elementos das linhas da parte triangular superior da matriz quadrada
 especificada como argumento. Se A  de ordem n ento UVEC(A) tem dimenso ((n(n+1)/2)x1).

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

void mtri(a,e,d,z)
Simbolo_t *a;
Simbolo_t *e;
Simbolo_t *d;
Simbolo_t *z;
{
	int i,j,k,l,n;
	double f,g,h,hh;
#ifdef EDIX
	double *dp;
#endif

	n = NCOLS(a);

	for(i=0; i < n; ++i) {
		for(j=0; j <= i; ++j) {
#ifdef EDIX
			dp = &(DADOij(z,i,j));
			*dp = DADOij(a,i,j);
#else
			DADOij(z,i,j) = DADOij(a,i,j);
#endif
		}
	}

	for(i=n-1; i >=1; --i) {
		l = i - 2;
		f = DADOij(z,i,i-1);
		g = 0.0;
		for(k=0; k <= l; ++k) {
			g += (DADOij(z,i,k) * DADOij(z,i,k));
		}
		h = g + f * f;
		if (g <= EPS) {
#ifdef EDIX
			dp = &(DADOij(e,i,0));
			*dp = f;
#else
			DADOij(e,i,0) = f;
#endif
			h = 0.0;
			goto skip;
	 	}
		++l;
		if(f >= 0.0) {
#ifdef EDIX
			dp = &(DADOij(e,i,0));
			*dp = - sqrt(h);
#else
			DADOij(e,i,0) = - sqrt(h);
#endif
		}
		else {
#ifdef EDIX
			dp = &(DADOij(e,i,0));
			*dp = sqrt(h);
#else
			DADOij(e,i,0) = sqrt(h);
#endif
		}
		g = DADOij(e,i,0);
		h = h - f*g;
#ifdef EDIX
		dp = &(DADOij(z,i,i-1));
		*dp = f - g;
#else
		DADOij(z,i,i-1) = f - g;
#endif
		f = 0.0;
		for(j=0; j <= l; ++j) {
#ifdef EDIX
			dp = &(DADOij(z,j,i));
			*dp = DADOij(z,i,j)/h;
#else
			DADOij(z,j,i) = DADOij(z,i,j)/h;
#endif
			g = 0.0;
			for(k=0; k <= j; ++k) {
				g += (DADOij(z,j,k)* DADOij(z,i,k));
			}
			for(k=j+1; k <= l; ++k) {
				g += (DADOij(z,k,j)* DADOij(z,i,k));
			}
#ifdef EDIX
			dp = &(DADOij(e,j,0));
			*dp = g/h;
#else
			DADOij(e,j,0) = g/h;
#endif
			f += (g* DADOij(z,j,i));
		}
		hh = f /(h+h);
		for(j=0; j <=l; ++j) {
			f = DADOij(z,i,j);
			g = DADOij(e,j,0) = DADOij(e,j,0) - hh*f;

			for(k=0; k <= j; ++k) {
#ifdef EDIX
				dp = &(DADOij(z,j,k));
				*dp = DADOij(z,j,k) - f * DADOij(e,k,0) -
					g * DADOij(z,i,k);
#else
				DADOij(z,j,k) = DADOij(z,j,k) -
					f * DADOij(e,k,0)-g* DADOij(z,i,k);
#endif
			}
		}
skip:
#ifdef EDIX
		dp = &(DADOij(d,i,0));
		*dp = h;
#else
		DADOij(d,i,0) = h;
#endif
	 }
#ifdef EDIX
	 dp = &(DADOij(e,0,0));
	 *dp = 0.0;
	 dp = &(DADOij(d,0,0));
	 *dp = 0.0;
#else
	 DADOij(d,0,0) = DADOij(e,0,0) = 0.0;
#endif
	 for(i=0; i < n; ++i) {
		l = i - 1; 
		if ( DADOij(d,i,0) != 0.0) {
			for(j=0; j <= l; ++j) {
				g = 0.0;
				for(k=0; k <= l; ++k) {
					g += (DADOij(z,i,k)* DADOij(z,k,j));
				}
				for(k=0; k <= l; ++k) {
#ifdef EDIX
					dp = &(DADOij(z,k,j));
					*dp = DADOij(z,k,j)-g* DADOij(z,k,i);
#else
					DADOij(z,k,j) = DADOij(z,k,j) -
						g* DADOij(z,k,i);
#endif
				}

			}
		}
#ifdef EDIX
		dp = &(DADOij(d,i,0));
		*dp = DADOij(z,i,i);
		dp = &(DADOij(z,i,i));
		*dp = 1.0;
#else
		DADOij(d,i,0) = DADOij(z,i,i);
		DADOij(z,i,i) = 1.0;
#endif
		for(j=0; j <= l; ++j) {
#ifdef EDIX
			 dp = &(DADOij(z,j,i));
			 *dp = 0.0;
			 dp = &(DADOij(z,i,j));
			 *dp = 0.0;
#else
			 DADOij(z,i,j) = DADOij(z,j,i) = 0.0;
#endif
		}

	}
}

