#include <stdio.h>

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	 
Calcula o produto matricial entre matrizes compatveis, ou seja, o nmero de colunas da primeira deve ser igual ao nmero 
de linhas da segunda matriz. Se  A = (a(i,j)) (m x n)  e  B = (b(j,k)) (n x l), ento A * B = (a(i,1) *  b(1,k) + ... + a(i,n) * b(n,k))  
tem dimenso (m x l). Quando uma das matrizes for um escalar, cada elemento da outra matriz   multiplicado pelo escalar.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

#define ind(n,i,j)	((n)*(i)+(j))

void multmat(ma, mb, mc, nla, nab, ncb)	/* multiplica matrizes a*b */
double	ma[];				/* matriz nla por nab */
double	mb[];				/* matriz nab por ncb */
double	mc[];				/* matriz resultante  nla por nbc */
int	nla, nab, ncb;			/* dimensoes */
{
	double d;
	int i, j, k;

	for (i = 0; i < nla; i++) {
		for (j = 0; j < ncb; j++){
			d = 0.0;
			for (k = 0; k < nab; k++)
			       d += ma[ind(nab,i,k)] * mb[ind(ncb,k,j)]; 
			k = ind(ncb,i,j);
			mc[k] = d;
		}
	}
}

