#include <stdio.h>
#include <math.h>
#include <string.h>

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	 
	Imprime uma matriz.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

extern int  _colunas;
extern FILE *fsaida;

#define ind(n,i,j)	((n)*(i)+(j))
#define eps		1.0e-10
#define MAXCOL		((int) (_colunas / ii))

void printmat(mat, nl, nc, nome, lnome, coluna, job,ii,jj,form)
			/* imprime matriz */
double	mat[];		/* matriz armazenada por linha */
int	nl;		/* numero de linhas */
int	nc;		/* numero de colunas */
char	*nome;		/* nome da matriz */
char	*lnome[];	/* nomes das linhas */
char	*coluna;	/* nomes das colunas */
int	job;		/* opcoes de nomes: 0 ==> sem nomes de col. */
			/*                  1 ==> gere nomes COL1...*/
			/*                  2 ==> use cnome como nome de col. */
			/*                  3 ==> use lcome como nome de lin. */
			/*                  4 ==> use lnome e cnome */
			/*                  5 ==> 0 com 16 casas    */
			/*                  6 ==> 1 com 16 casas    */
			/*                  7 ==> 2 com 16 casas    */
			/*                  8 ==> 4 e use lnome como cnome */
int 	ii;		/* numero de casas para impressao */
int 	jj;		/* precisao */
int     form;		/* 0 - formato 'g' ;  1 - formato 'f' */
{
	int nblocos, b, colinicial, colfinal, i, j, k, l;
	char lcnome[15];                        /* nome de linha ou coluna */
	double d;
	int t;
	char cnome[15];			       /* nome das colunas */
	char pbuff[512];
	double MaxFr;
	int espacos;

#ifdef VAXVMS
	char bufaux[64];
	char *pp;
	char *pe;
	int car;

#endif

	espacos = ((job >= 5) && (job != 8))? 16 : 8;

	MaxFr = pow(10., - (double) jj);

	nblocos = (nc / MAXCOL) + ((nc % MAXCOL) != 0);

	/* nblocos blocos de MAXCOL colunas serao impressos (exceto, talvez, */
	/* o ultimo bloco que pode ser menor) */

	k = 0;
	for (b = 1; b <= nblocos; b++) {
		colinicial = (b - 1) * MAXCOL;
		colfinal = colinicial + MAXCOL - 1;
		colfinal = (colfinal >= nc) ? (nc-1) : colfinal;
		/* escreve o cabecalho do bloco */
		fprintf(fsaida,"\n%-*.*s ",espacos, espacos, nome);
		l = 0;
		for (j=colinicial; j <= colfinal; j++) { 
			switch (job) {
			case 1:
			case 6:
				if (ii > 4)
					sprintf(lcnome, "Col%d", j+1);
				if (ii == 4)
					sprintf(lcnome, "Co%d",j+1);
				if (ii == 3)
					sprintf(lcnome, "C%d",j+1);
				if (ii == 2)
					sprintf(lcnome, "%d",j+1);

				fprintf(fsaida,"%*.*s",ii,(ii-1),lcnome);
				break;

			case 2:
			case 4:
			case 7:
						
				for(i=k;i<(int)strlen(coluna)&&j<=colfinal;i++){
					if ((coluna[i] != ',') && l < 14) {
						cnome[l++] = coluna[i];
					}
					else 
						if (coluna[i] == ',') 
							break;
						
				}
				cnome[l] = '\0';
				k = i + 1;
				l = 0;
				fprintf(fsaida,"%*.*s",ii,(ii-1),cnome);
				break;
			case 8: /* Usar Lnome como cnome */
				fprintf(fsaida,"%*.*s",ii,(ii-1),lnome[j]);
				break;

			}
		}
               
		fprintf(fsaida,"\n");
		fprintf(fsaida,"\n");
               
		for (i = 0; i < nl; i++) {
			switch (job) {
			case 1:
			case 2:
				sprintf(lcnome, "Lin%d", i+1);
				fprintf(fsaida,"%-*.*s ",espacos, espacos,
					lcnome);
				break;

			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
				fprintf(fsaida,"%-*.*s ", espacos, espacos, lnome[i]);
				break;

			default:
				fprintf(fsaida,"         ");
				break;
			}

			for (j = colinicial; j <= colfinal; j++) {
				d = (fabs(mat[ind(nc,i,j)]) < eps) ? 0.0 :
				mat[ind(nc,i,j)];
				sprintf(pbuff,"%*.*lf",ii-1,jj,d);
				for (t = strlen(pbuff)-1; t; --t) {
					if (pbuff[t] == '0')
						pbuff[t] = '\0';
					else if (pbuff[t] == '.') {
						pbuff[t] = '\0';
						break;
					}
					else
						break;
				}
				if (form)
#ifdef MSDOS
					fprintf(fsaida,"%*.*lf",ii,jj,d);

				else if (((int) strlen(pbuff) < ii &&
						fabs(d) > MaxFr) || d == 0.)
					fprintf(fsaida,"%*.*s",ii,ii,pbuff);
				else
					fprintf(fsaida,"%*.*le",ii,ii-8,d);
#else
					fprintf(fsaida,"%*.*f",ii,jj,d);

				else if ((strlen(pbuff) < ii &&
						fabs(d) > MaxFr) || d == 0.)
					fprintf(fsaida,"%*.*s",ii,ii,pbuff);
				else
#ifdef VAXVMS
					{
					ftoa(d, ii-1, bufaux);
					pp = strchr(bufaux, '.');
					pe = strchr(bufaux, 'e');
					if (d == 0.)
						car = 1;
					else
						car = (int) log10(fabs(d));
					if (pe == (char *) NULL) {
						if (pp != (char *) NULL)
							*(pp+jj-car) = '\0';
					}
					else {
						if (pe-pp > jj-car) {
							*(pp+jj-car) = '\0';
							strcat(bufaux, pe);
						}
					}
		  			fprintf(fsaida,"%*s", ii, bufaux);
				}
#else                                    
					fprintf(fsaida,"%*.*e",ii,ii-8,d);
#endif
#endif
			}
			fprintf(fsaida,"\n");
		}
	}
	fprintf(fsaida,"\n");
	fflush(fsaida);
}

