#include <stdio.h>

#include "cm_cm01.h"

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	 
	Resolve os sistemas:
		a * X = b  ou
		a' * X = b


Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

#define ind(n,i,j)	((n)*(i)+(j))

void sgesl(a, n, ipvt, b, job)
int	n, ipvt[], job;
double	a[], b[];
{
	double t;
	int k, l;

	if (job == 0) {
		/*
		**  job = 0 : resolva a * X = b 
		**  primeiro resolva L * Y = b
		*/

		for (k = 0; k < n-1; k++) {
			l = ipvt[k];

			t = b[l];

			if (l != k)
				swap(&b[l], &b[k]);

			saxpy(n-k-1, t, &a[ind(n,k+1,k)], n, &b[k+1], 1);
		}

		/* 
		**  agora resolva U * X = Y
		*/

		for (k = n-1; k >= 0; k--) {
			b[k] = b[k] / a[ind(n,k,k)];
			saxpy(k, -b[k], &a[ind(n,0,k)], n, &b[0], 1); 
		}
	}

	else {
		/*
		**  job != 0 : resolva a' * X = b
		**  primeiro resolva  U' * Y = b
		*/

		for (k = 0; k < n; k++) {
			t = sdot(k, &a[ind(n,0,k)], n, &b[0], 1);
			b[k] = (b[k] - t) / a[ind(n,k,k)];
		}

		/*
		**  agora resolva L' * X = Y
		*/

		for (k = n-2; k >= 0; k--) {
			b[k] += sdot(n-k-1, &a[ind(n,k+1,k)], n, &b[k+1], 1);

			l = ipvt[k];

			if (l != k)
				swap(&b[l], &b[k]);
		}
	}
}

