#include <stdio.h>
#include "cm_cm01.h"

static char *sccsid = "@(#)vconcat.c	3.1	(NTIA/cm)	94/10/24";

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	 
	Procede a concatenao vertical de duas matrizes.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

Simbolo_t *vconcat(x,y)		/* concatenacao vertical de matrizes */
Simbolo_t *x, *y;
{
	Simbolo_t *sr;
	int i, j;
#ifdef EDIX
	double *dp;
#endif

	if (NCOLS(x) != NCOLS(y)) {
		numerro = VCONCER;
		conferro(x, y, "concatenacao vertical");
	}

	sr = faztemp(NLINS(x)+NLINS(y), NCOLS(x));

	for (i = 0; i < NLINS(x); i++)
		for (j = 0; j < NCOLS(x); j++) {
#ifdef EDIX
			dp = &(DADOij(sr, i, j));
			*dp = DADOij(x, i, j);
#else
			DADOij(sr, i, j) = DADOij(x, i, j);
#endif
		}

	for (i = 0; i < NLINS(y); i++)
		for (j = 0; j < NCOLS(y); j++) {
#ifdef EDIX
			dp = &(DADOij(sr, i + NLINS(x), j));
			*dp = DADOij(y, i, j);
#else
			DADOij(sr, i + NLINS(x), j) = DADOij(y, i, j);
#endif
		}

	return sr;
}

