#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include "cm_cm01.h"
#ifdef MSDOS
# include "y_tab.h"
#else
#ifdef VAXVMS
#include "y_tab.h"
#else
# include "y.tab.h"
#endif
#endif

#include "pcsgbd.h"

extern YYSTYPE yylval;
extern int valret, retlex;
extern YYSTYPE valyyl;

extern FILE *fin;	/* ponteiro para arquivo de entrada */
extern int c;			/* global para uso por aviso() */

int  indef=0;

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	 
	Analisador lxido do CM.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

yylex()   
{
#define isalpha_(x)	((isalpha(x)) || ( x == '_'))
#define isalnum_(x)	((isalnum(x)) || ( x == '_'))

	int t;
#ifdef EDIX
	double *dp;
#endif

	if (valret != -1 || valyyl.simb != (Simbolo_t *) NULL) {
		yylval = valyyl;
		retlex = valret;
		valyyl.simb = (Simbolo_t *) NULL;
		valret = -1;

		return retlex;
	}

Denovo:
	while((c=xgetc(fin)) == ' ' || c == '\t')
		;

	if ( (c == '\n') ||  (c == '\r' ) ) {
		pprompt();

		goto Denovo;
	}

	if (c == EOF) {
		retlex = MYEOF;

		return MYEOF;
	}

	if (c == '/') {			/* comentario? */
		int t;

		t = xgetc(fin);

		if (t == '*') {		/* e' comentario */
Emcomentario:
			while (((c=xgetc(fin)) != EOF) && (c != '*')) {
				if ((c == '\n')||  (c == '\r') ) 
					pprompt();
			}

			if (c == EOF) {
				numerro = EOFEMCOMER;

/* *** Padroniz. msg erro - Luciana 02/01/95
				execerro("termino prematuro de comentario", 
					(char *) 0);
*** */
				execerro(PegaMsg(3132), (char *) 0);
			}

			do {
				if ((c=xgetc(fin)) == '/')
					goto Denovo; /* comentario processado */

				if ((c == '\n')||  (c == '\r') ) 
					pprompt();
			} while (c == '*');

			goto Emcomentario;	/* ainda nao acabou */
		}

		else		/* nao e' comentario */
			unxgetc(t,fin);
	}

	if (isdigit(c) || c == '.') {	/* numero */
		int ne, np, pos;
		char sbuf[254], *p = sbuf;

		ne = 0;
		np = 0;
		pos = 0;

		do {
			if (pos) 
				pos = 0;

			*p++ = (char) c;

			if (c == '.')
				++np;

			if (c == 'e' || c == 'E') {
				++pos;
				++ne;
			}
		} while (isdigit((c = xgetc(fin))) || (c == '.' && np == 0) ||
			((c == 'e' || c == 'E') && ne == 0) ||
			(c == '-' && ne == 1 && pos == 1));

		unxgetc(c, fin);

		*p = '\0';
	       
		if (indef)
			yylval.simb = instale("",NUMEROL,(Matriz_t *) 0); 
		else
			yylval.simb = instale("",NUMERO,(Matriz_t *) 0); 

		MATRIZ(yylval.simb) = fazmat(1,1); 

#ifdef EDIX
		dp = &(DADOij(yylval.simb,0,0));
		*dp = atof(sbuf);
#else
		DADOij(yylval.simb,0,0) = atof(sbuf);
#endif

		retlex = NUMERO;

		return NUMERO;
	}

	if (isalpha_(c)) {	/* identificador, intrinsico, ou comando */
		Simbolo_t *s;
		char sbuf[100], *p = sbuf;

		do {
			if (p >= sbuf + sizeof(sbuf) - 2) {
				*p = '\0';
				numerro = NOMEGDEER;

/* *** Padroniz. msg erro - Luciana 02/01/95
				execerro("nome muito grande",sbuf);
*** */
				execerro(PegaMsg(3133), (char *) 0);
			}

			*p++ = (char) c;
		} while ((c=xgetc(fin)) != EOF && isalnum_(c));

		unxgetc(c,fin);

		*p = '\0';

		if ((s=procure(sbuf)) == 0)  {
			if (indef)
				s=instale(sbuf, INDEFL, (Matriz_t *) 0);
			else
				s=instale(sbuf, INDEF , (Matriz_t *) 0);
		}

		yylval.simb = s;

		retlex = (TIPO(s) == INDEFL || TIPO(s) == INDEF)? ID : TIPO(s);

		return   (TIPO(s) == INDEFL || TIPO(s) == INDEF)? ID : TIPO(s);
	}

	if (c == '&') {		/* argumento? */
		int n = 0;

		while(isdigit( c = xgetc(fin)))
			n = 10 * n + c - '0';

		unxgetc(c, fin);

		if (n > 0) { 
			yylval.narg = n;
			retlex = ARG;

			return ARG;
		}
	}
				

	if (c == '"') {		/* string */
		Simbolo_t *s;
		char sbuf[254], *p = sbuf;

		while ((c=xgetc(fin)) != EOF && c != '"') {
			if ((c == '\n')||  (c == '\r') ) 
				pprompt();

			if (p >= sbuf + sizeof(sbuf) - 2) {
				*p = '\0';

/* *** Padroniz. msg erro - Luciana 02/01/95
				execerro("nome muito grande", sbuf);
*** */
				execerro(PegaMsg(3133), (char *) 0);
			}

			*p++ = (char) c;
		}

		*p = '\0';

		if (indef) {
			s = instale(sbuf, STRINGL, (Matriz_t *) 0);
		}
		else {
			s = instale(sbuf, STRING, (Matriz_t *) 0);
		}

		yylval.simb = s;
		retlex = STRING;

		return STRING;
	}

	switch (c) {

	case '*' :

		if ( (t = xgetc(fin)) == '!') {
			retlex = EMULT;
			return EMULT;
		}

		else {
			if ( t == '%') {
				retlex = CMULT;
				return CMULT;
			}
			unxgetc(t, fin);
			retlex = '*';
			return '*';
		}

	case '/' :

		if ( (t = xgetc(fin)) == '!') {
			retlex = EDIVD;

			return EDIVD;
		}

		else {
			unxgetc(t, fin);
			retlex = '/';

			return '/';
		}

	case '\\' :

		if ( (t = xgetc(fin)) == '!') {
			retlex = EDIVE;

			return EDIVE;
		}

		else {
			unxgetc(t, fin);
			retlex = '\\';

			return '\\';
		}

	case '>':

		retlex = follow('=',GE,GT);

		return retlex;

	case '<':

		retlex = follow('=',LE,LT);

		return retlex;

	case '=':

		retlex = follow('=',EQ,'=');

		return retlex;

	case '!':

		retlex = follow('=',NE,NOT);

		return retlex;

	case '|':

		retlex = follow('|',OR,'|');

		return retlex;

	case '&':

		retlex = follow('&',AND,'&');

		return retlex;
	}

	retlex = c;
	return c;

}

int follow(expect, ifyes, ifno)
int expect;
int ifyes;
int ifno;
{
	int c = xgetc(fin);

	if (c == expect)
		return ifyes;

	unxgetc(c, fin);

	return ifno;
}

void defnonly(s)
char *s;
{
	if (!indef)
		execerro("Erro no uso de definicao", s);
}
