/***********************************************************************************
 ESTAT - Clculo de Estatsticas Descritivas
 
 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Mdulo integrante do software ESTAT, que  calcula estatsticas descritivas 
    de variveis  numricas. As  estatsticas  que  podem  ser requeridas so: nmero 
    de observaes, valor mnimo, valor mximo, total, mdia, varincia, desvio padro, 
    erro padro, coeficiente de variao, assimetria, curtose, mediana, estatstica D 
    de Kolmogorov, percentis e modas.
    Neste mdulo encontram-se as rotinas para alocar os vetores que serao utilizados 
    para guardar os clculos. As alocacoes sao feitas para "nvar" variaveis, logo apos 
    a anlise semantica (veja semantic.c) dos comandos. Todas as variaveis sao globais, 
    veja "estat.h"  

 Desenvolvido por:

	  Dalton Francisco Andrade
	  Maria Fernanda Moura
	  Maurcio Noronha Festa

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include "estat.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

void aloc_ests()
{
    missing = (int *) calloc(nvar, sizeof(int));
    inicio = (int *) calloc(nvar, sizeof(int));
    soma = (double *) calloc(nvar, sizeof(double));
    xmean = (double *) calloc(nvar, sizeof(double));
    xmean2 = (double *) calloc(nvar, sizeof(double));
    wsum = (double *) calloc(nvar, sizeof(double));
    wfreq = (double *) calloc(nvar, sizeof(double));
    s2 = (double *) calloc(nvar, sizeof(double));
    s22 = (double *) calloc(nvar, sizeof(double));
    if (pert(est, "mediana"))
	mediana = (double *) calloc(nvar, sizeof(double));
    if (pert(est, "curtose"))
	s4 = (double *) calloc(nvar, sizeof(double));
    if (pert(est, "curtose") || pert(est, "assimetria"))
	s3 = (double *) calloc(nvar, sizeof(double));
    if (pert(est, "D_Kolmog."))
	kolmogorov = (double *) calloc(nvar, sizeof(double));
    if (pert(est, "minimo") || pert(est, "maximo")) {
	xmin = (double *) calloc(nvar, sizeof(double));
	xmax = (double *) calloc(nvar, sizeof(double));
    }
    if (pert(est, "moda"))
	moda = (Lista *) calloc(nvar, sizeof(Lista));
    if (pert(est, "p05") || pert(est, "p10") || pert(est, "p15") ||
	pert(est, "p20") || pert(est, "p25") || pert(est, "p30") ||
	pert(est, "p35") || pert(est, "p40") || pert(est, "p45") ||
	pert(est, "p50") || pert(est, "p55") || pert(est, "p60") ||
	pert(est, "p65") || pert(est, "p70") || pert(est, "p75") ||
	pert(est, "p80") || pert(est, "p85") || pert(est, "p90") ||
	pert(est, "p95"))
	percentis = (Lista *) calloc(nvar, sizeof(Lista));
}

char *alocqt(qtd, tipo)
int qtd;
int tipo;
{
    char *p;

    p = (char *) calloc((unsigned) qtd, (unsigned) tipo);

    if (p == NULL) {
	fprintf(stderr, PegaMsg(1039));
	fprintf(stderr,
		"Tente reduzir o numero de variaveis e/ou estatisticas\n");
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("estat");
	    exit(1);
	}
#endif

	exit(1);
    }
    return (p);
}
