/***********************************************************************************
 ESTAT - Clculo de Estatsticas Descritivas
 
 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Mdulo integrante do software ESTAT, que  calcula estatsticas descritivas 
    de variveis  numricas. As  estatsticas  que  podem  ser requeridas so: nmero 
    de observaes, valor mnimo, valor mximo, total, mdia, varincia, desvio padro, 
    erro padro, coeficiente de variao, assimetria, curtose, mediana, estatstica D 
    de Kolmogorov, percentis e modas.
    Neste mdulo encontram-se as rotinas de tratamento de erro para um tipo abstrato de 
    dados - desde que configurado. Para cada tipo implementado no software pode-se in-
    corporar uma rotina de print do tipo. Basta convencionar um %? para o tipo i incor-
    porar esta rotina no case '%'.	

 Desenvolvido por:

	  Luis Antonio Peloso

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#ifdef MSDOS
#include <stdlib.h>
#endif

#include	<stdio.h>
#include	<ctype.h>

#include	"pcsgbd.h"
#include	"erro.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif


int Er_Msg[] = {
    9999,			/* nao usado */
    1039,
    0
};

/*
// Metodos
*/

void Er_Error(tipo, fmt, args)
int tipo;
char *fmt;
int args;
{
    char c;
    char *p = fmt;
    int **prt = (int **) &args;
    int par = 0;

    for (p = fmt; *p; ++p) {
	switch (*p) {
	case '%':
	    c = *++p;
	    switch (c) {
	    case 'e':
	    case 'E':
		printf(PegaMsg(Er_Msg[atoi(++p)]));
		while (isdigit(*p++));
		--p;
		--p;		/* volta o branco e fica */
		break;		/* no ultimo digito */
	    case 'd':
	    case 'D':
		printf("%d", prt[par++]);
		break;
	    case 's':
	    case 'S':
		printf("%s", (char *) prt[par++]);
		break;
	    case '%':
		putchar('%');
		break;
	    }
	    break;
	default:
	    putc(*p & 0177, stdout);
	}
    }

    if (tipo == ER_EXIT) {
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("estat");
	    exit(1);
	}
#endif

	exit(1);
    }
}
