/***********************************************************************************
 ESTAT - Clculo de Estatsticas Descritivas
 
 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Mdulo integrante do software ESTAT, que  calcula estatsticas descritivas 
    de variveis  numricas. As  estatsticas  que  podem  ser requeridas so: nmero 
    de observaes, valor mnimo, valor mximo, total, mdia, varincia, desvio padro, 
    erro padro, coeficiente de variao, assimetria, curtose, mediana, estatstica D 
    de Kolmogorov, percentis e modas.
    Este  o mdulo de declaraes globais. 
    
 Desenvolvido por:

	  Dalton Francisco Andrade
	  Maria Fernanda Moura
	  Maurcio Noronha Festa
	  Slvio roberto Medeiros Evangelista
	  
 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#ifndef VAR1
# define	VAR1	extern
#endif
 
#define NRO_OBS(parq) (parq->proxobs)

#include <stdlib.h>

#include "atomic.h"
#include "lista.h"
#include "conjunto.h"
#include <stdio.h>
#include <math.h>
#include <signal.h>
#include <string.h>
#include <malloc.h>
#include "pcsgbd.h"

#ifdef RS6000
#define class cclass
#endif

/* ......... Declaracoes constantes globais          .............*/

#define    MAXDEC  3		/* numero maximo de casas decimais */
#define    ESC     27		/* Simbolo ESC */
#define    NPAR    7		/* Numero de Colunas */

#define    MAXBY    8
#define    MAXMEM 100
#define    MAXTIT  10
#define    MAXMODA  5
#define    MAXNOME 16
#define    TAMTIT  78
#define    NIVELBY 4
#define    LARGURA 78		/* Largura do formulario */
#define    NLINHAS 18		/* Numero de linhas para Video */

/* ......... Declaracoes referentes a tabela de hashing .............*/

#define	   TAMINI 100		/* tamanho inicial do vetor nomes   */
#define	   TAMTAB 111		/* tamanho para a tabela de Hashing */
#define    MAXDIM   1		/* maximo de niveis da tabela       */
#define    TIPO_H  double       /* campo def de tabhash */

VAR1 struct simb {
	char   *nome;
	TIPO_H def;
	struct simb *proximo;
};
VAR1	struct simb **tabhash[1];
VAR1	char	**nomes[1];
VAR1	int	apnome;		/* indice para o vetor de nomes */

/*............ Declaracao dos tipos de NULL Utilizados ...............*/

#define CNULL ((char *) NULL)             /* strings */
#define SNULL ((struct simb *) NULL)      /* tabela de hashing */
#define DNULL ( (Dado) NULL)              /* elemento de conjunto */

/*............Declaracoes Referentes aos arquivos utilizados .........*/

VAR1 ARQ    *fd;		/* apontador para o arquivo de dados  */
VAR1 ARQ    *fout;		/* apontador para o arquivo_ntia_saida */
VAR1 char   *obs[OBSSIZE];	/* ponteiro para a observacao */ 

/*..................Estatisticas Calculadas ........................*/

VAR1 double qfreq;		/* variavel com a frequencia */
VAR1 double wt;			/* variavel com o peso */
VAR1 double x[MAXVAR];		/* vetor de valores da observacao */
VAR1 double *s2;		/* vetor com o segundo momento (com peso) */
VAR1 double *s22;		/* vetor com o segundo momento (sem peso) */
VAR1 double *s3;		/* vetor com o terceiro momento */
VAR1 double *s4;		/* vetor com o quarto momento */
VAR1 double *soma;		/* vetor com o total */
VAR1 double *xmean;		/* vetor com a media (com peso) */
VAR1 double *xmean2;		/* vetor com a media (sem peso) */
VAR1 double *wsum;		/* vetor com a soma dos pesos */
VAR1 double *wfreq;		/* vetor com a soma das frequencias */
VAR1 double *xmin;       	/* vetor com o minimo */
VAR1 double *xmax;		/* vetor com o maximo */
VAR1 Lista  *moda;		/* Lista com as modas   */
VAR1 double *mediana;		/* vetor com a mediana */
VAR1 Lista  *percentis;  	/* lista de percentis para cada variavel */
VAR1 double *kolmogorov;	/* valor da estatistica de kolmogorov */
VAR1 int    *missing;    	/* vetor de flag de missing */
VAR1 int    *inicio;		/* vetor de flag de inicial. */   
VAR1 char   by[MAXBY][80];	/* variavel by */
VAR1 char   ant[MAXBY][80];	/* variavel que tem o valor anterior da obs */
VAR1 char   tipby[MAXBY];	/* tipos das variaveis de cada classe */
VAR1 char   tip_ord;		/* tipo de ordenacao das variaveis do class */

/*.....................TITULO UTILIZADO ...............................*/

VAR1 char   titulo[MAXTIT][TAMTIT]; 

/*.................. Conjuntos Utilizados .............................*/

VAR1 Lista  var;		/* <listvar> do comando VAR     */
VAR1 Lista  class;		/* <listvar> do comando CLASS   */
VAR1 Lista  peso;		/* <listvar> do comando PESO    */
VAR1 Lista  freq;		/* <listvar> do comando FREQ    */
VAR1 Lista  vars;		/* <listvar> do comando VARS    */
VAR1 Lista  rf;			/* <listvar> do comando RF      */
VAR1 Lista  bp;			/* <listvar> do comando BP      */
VAR1 Lista  np;			/* <listvar> do comando NP      */
VAR1 int    posvar[MAXVAR];	/* associado ao conjunto "var", contendo
				   a posicao relativa no arquivo_ntia  */
VAR1 int    posclass[MAXVAR];   /* associado ao conjunto "class", contendo
 				   a posicao relativa no arquivo_ntia */
VAR1 int    pospeso;		/* associado ao conjunto "peso", contendo
 				   a posicao relativa no arquivo_ntia */
VAR1 int    posfreq;		/* associado ao conjunto "freq", contendo
 				   a posicao relativa no arquivo_ntia */
VAR1 int    pvar_s[MAXVAR];	/* associado ao conjunto "vars", contendo
				   a posicao relativa no arquivo_ntia  */
VAR1 int    posrf[1];		/* associado ao conjunto "rf", contendo
				   a posicao relativa no arquivo_ntia  */
VAR1 int    posbp[1];		/* associado ao conjunto "bp", contendo
				   a posicao relativa no arquivo_ntia  */
VAR1 int    posnp[1];		/* associado ao conjunto "np", contendo
				   a posicao relativa no arquivo_ntia  */

VAR1 Lista  est;		/* <listest> do comando EST  */
VAR1 Lista  ests;		/* <listest> do comando ESTS */

/*................... Variaveis globais de controle ..................*/

VAR1 int   nvar;		/* numero de variaveis VAR */
VAR1 int   ntit;		/* numero de titulos  */
VAR1 int   nby;			/* numero de variaveis by */
VAR1 int   pondera;		/* flag de tem variavel de ponderacao */
VAR1 int   nest;		/* numero de estatisticas a calcular */
VAR1 int   nests;		/* numero de estatisticas para saida */
VAR1 int   nvars;		/* numero de variaveis VARS */
VAR1 int   nrf;			/* numero de variaveis RF   */
VAR1 int   nbp;			/* numero de variaveis BP   */
VAR1 int   nnp;			/* numero de variaveis NP   */
VAR1 int   nfreq;		/* numero de variaveis FREQ   */

/*.................... Rotinas .......................................*/

#ifdef MSDOS
 extern void	getpar(int ,char * *, int *, int *, int *, int *, int *,
							   int *);
 extern void	number(int *,char * *,int *);
 extern void	semantica(void);
 extern void 	idemvar(Lista,int *,int *,int *,Lista);
 extern Lista	listvar(ARQ *,int *,char ,int *);
 extern Lista	listclass(ARQ *,int *,char ,int *);
 extern Lista	umavar (ARQ *,int *,char ,int *);
 extern Lista	listest(int *);
 extern void	tk_titulo(void);
 extern int	descobre(char *,char *);
 extern void	erroc(int);
 extern void    aloc_ests(void);
 extern char    *alocqt(int,int);
 extern void 	decide(int *,int *,int *,int *);
 extern void	ini_by(void);
 extern void	ini_flag(void);
 extern void	aminmax(double ,int);
 extern void	momentos(double,double ,double ,int);
 extern void	ini_var(int);
 extern void 	estourou(int);
 extern void 	veri_class(void);
 extern void	imprime(void);
 extern int	imptl(int,int);
 extern void 	impby(int,int,int,int,int);
 extern void	relatorio(int);
 extern char	*center(char *,int);
 extern char	*char_str(int ,char);
 extern int	ins_modas(void);
 extern void	observacoes(int);
 extern void	mensagem(int,int);
 extern double  calculo(int,int);
 extern void	outhdr(void);
 extern void	grava_ntia(void);
 extern void	ini_hash(void);
 extern void	aloc_hash(void);
 extern void	hashcalc(int *);
 extern int	compn(void *,void *);
 extern void 	le_proxima(int ,unsigned int,unsigned int);
 extern void	libera(void);
 extern void	t_hashing(int);
 extern void	trata_outras(unsigned int *,int *,unsigned int *);
 extern void	var_hash(int *);
 extern Lista	calc_moda(int);
 extern double	calc_percentil(int,double);
 extern double	calc_kolmogorov(int);
 extern char	*guardacad(char *);
 extern char	*realoca(char **,int , int);
 extern char	*aloc(int , int);
 extern int	hash(char *);
 extern struct simb *pesquisa(char *, struct simb **);
 extern struct simb *instala(char *, TIPO_H, struct simb **);
 extern void libera_est();

#else

 extern void	getpar();
 extern void	number();
 extern void	semantica();
 extern void 	idemvar();
 extern Lista	listvar();
 extern Lista	listclass();
 extern Lista	umavar ();
 extern Lista	listest();
 extern void	tk_titulo();
 extern int	descobre();
 extern void	erroc();
 extern void    aloc_ests();
 extern char    *alocqt();
 extern void 	decide();
 extern void	ini_by();
 extern void	ini_flag();
 extern void	aminmax();
 extern void	momentos();
 extern void	ini_var();
 extern void 	estourou();
 extern void 	veri_class();
 extern void	imprime();
 extern int	imptl();
 extern void 	impby();
 extern void	relatorio();
 extern char	*center();
 extern char	*char_str();
 extern double  calculo();
 extern int	ins_modas();
 extern void	observacoes();
 extern void	mensagem();
 extern void	outhdr();
 extern void	grava_ntia();
 extern void	aloc_hash();
 extern void	ini_hash();
 extern void	hashcalc();
 extern int	compn();
 extern void 	le_proxima();
 extern void	libera();
 extern void	t_hashing();
 extern void	trata_outras();
 extern void	var_hash();
 extern Lista	calc_moda();
 extern double	calc_percentil();
 extern double	calc_kolmogorov();
 extern char	*guardacad();
 extern char	*realoca();
 extern char	*aloc();
 extern int	hash();
 extern struct simb *pesquisa();
 extern struct simb *instala();
 extern void libera_est();
#endif

