/***********************************************************************************
 ESTAT - Clculo de Estatsticas Descritivas
 
 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Mdulo integrante do software ESTAT, que  calcula estatsticas descritivas 
    de variveis  numricas. As  estatsticas  que  podem  ser requeridas so: nmero 
    de observaes, valor mnimo, valor mximo, total, mdia, varincia, desvio padro, 
    erro padro, coeficiente de variao, assimetria, curtose, mediana, estatstica D 
    de Kolmogorov, percentis e modas.
    Este  o mdulo que le as opcoes de execucao. 

 Desenvolvido por:

	  Dalton Francisco Andrade
	  Maria Fernanda Moura
	  Maurcio Noronha Festa
	  Slvio Roberto Medeiros Evangelista
	  
 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <string.h>
#include <signal.h>


#ifdef MSDOS
#include <io.h>
#endif

#ifdef RS6000
#include <sys/io.h>
#endif

#include "estat.h"
#include "pcsgbd.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

static int flag_exec = 0;
extern void controlC();

extern int descarq[2];

extern char 	exretstd[]; /* Contem o nome do arquivo exretstd */
extern int	flagstd;

void getpar(argc,argv,flagP,flag_imp,flagX,output,linhas,colunas)
int argc;
char *argv[];
int *flagP;
int *flag_imp;
int *flagX;
int *output;
int *linhas;
int *colunas;
{
	extern int atoi();
	int i;	  
	int flag_vazio;	  
	char *pdir;
	long ret;

	flag_vazio = 1; /* Habilita teste de arquivo vazio */
	++argv;		/* aponta para o primeiro parametro */
	--argc;		/* decrementa o apontador */
	while (argc--) {
		if (argv[0][0] == '-') {
			for (i=1; argv[0][i]; ++i) {
				switch (argv[0][i]) {
				case 'P':
					*flagP = 1;
					break;
				case 'n':
					*flag_imp = 0;
					break;
				case 'l':  
					*linhas = 0;
					number(linhas,argv,&i);
					if ((*linhas > 88) || (*linhas <= 6)) 
							*linhas = NLINHAS;
					break;	
				case 'c':
					*colunas = 0;
					number(colunas,argv,&i);
					if ((*colunas > 256)||(*colunas <= 24)) 
							*colunas = LARGURA;
					break;	
				case 'A': 
					flag_exec = 1;
#ifdef RS6000
					flagstd = 1;

					if(*strchr(&argv[0][i+1], '|'))
						*strchr(&argv[0][i+1], '|') = '\0';

					if (freopen(&argv[0][i+1], "r", stdin)==
							(FILE *) NULL) {

                                                i += (strlen(&argv[0][i+1]) + 1);
                                                *strchr(&argv[0][i+1], '|') = '\0';
                                                i += (strlen(&argv[0][i+1]) + 1);
                                                strcpy(exretstd, &argv[0][i+1]);

/* *** Padroniz. msg erro - Luciana 02/01/1995
						fprintf(stderr,
						"Arquivo stdin nao abre.\n");
*** */
						fprintf(stderr,PegaMsg(1034),"stdin");
						setOSstdin();
#ifdef MEM_DEBUG
						if(Mem_Used() != 0){
							printf("***Lista de memoria nao esta vazia ***\n");
							Mem_Store("estat");
							exit(5);
						}
#endif

						exit(5);
					}
					i += (strlen(&argv[0][i+1]) + 1);
					*strchr(&argv[0][i+1], '|') = '\0';
					fseek(stdin, atol(&argv[0][i+1]), 0);
					i += (strlen(&argv[0][i+1]) + 1);
					strcpy(exretstd, &argv[0][i+1]);
					i += strlen(&argv[0][i+1]);
#endif
					setbuf(stdin, CNULL);
					break;
                                case 'M':   /* Habilita impressao de mensagens */
                                        break;
                                case 't': /* Habilita impressao de tempo */
                                        break;
				case 'X':
					if (strcmp(&argv[0][i+1],"ntia") == 0) {
						*flagX = 1;
						i += 4;
					}
					break;
                                case 'k': /* Desabilita teste de arquivo vazio*/
					flag_vazio = 0;
                                        break;
				default:

/* *** Padroniz. msg erro - Luciana 02/01/1995
					fprintf(stderr,
						"Opcao <%c> invalida\n",
						argv[0][1]);
*** */
					fprintf(stderr,PegaMsg(3086),argv[0][1]);
					setOSstdin();
#ifdef MEM_DEBUG
					if(Mem_Used() != 0){
						printf("***Lista de memoria nao esta vazia ***\n");
						Mem_Store("estat");
						exit(1);
					}
#endif
					exit(1);
				}
			}
		}
		else
			break;
		++argv;
	}

	if (!*flagX) {

/* *** Padroniz. msg erro - Luciana 02/01/1995
		fprintf(stderr, "Execucao nao permitida\n");
*** */
		fprintf(stderr, PegaMsg(1000));
		setOSstdin();
#ifdef MEM_DEBUG
		if(Mem_Used() != 0){
			printf("***Lista de memoria nao esta vazia ***\n");
			Mem_Store("estat");
			exit(1);
		}
#endif
		exit(1);
	}

	if (argc < 0) {

/* *** Padroniz. msg erro - Luciana 02/01/1995
		fprintf(stderr,"Falta nome de arquivo\n");
*** */
		fprintf(stderr,PegaMsg(3000));
		setOSstdin();
#ifdef MEM_DEBUG
		if(Mem_Used() != 0){
			printf("***Lista de memoria nao esta vazia ***\n");
			Mem_Store("estat");
			exit(1);
		}
#endif
		exit(1);
	}

	pdir = pega_env(argv[0], ".hdr");


        /* Abertura do arquivo de entrada */


	if ((ret = (long) (fd = abre_arq(pdir,0, flag_vazio))) < 0L && ret > -5L) {

		if ( flag_vazio ) {
		    fprintf(stderr, PegaMsg(1034), pdir);
		    setOSstdin();
#ifdef MEM_DEBUG
		    if(Mem_Used() != 0){
			    printf("***Lista de memoria nao esta vazia ***\n");
			    Mem_Store("estat");
			    exit(2);
		    }
#endif

		    exit(2);
		}
	}

	if (argc) {	
		*output = 1;

                /* Abertura do arquivo de saida */

		if ((ret=(long) (fout = cria_arq(argv[1]))) < 0L && ret > -4L) {

/* *** Padroniz. msg erro - Luciana 02/01/1995
			fprintf(stderr, "Nao consegui abrir <%s> %ld\n", argv[1],
				ret);
*** */
			fprintf(stderr, PegaMsg(5006), argv[1]);
			setOSstdin();
#ifdef MEM_DEBUG
			if(Mem_Used() != 0){
				printf("***Lista de memoria nao esta vazia ***\n");
				Mem_Store("estat");
				exit(2);
			}
#endif

			exit(2);
		}
	}
	signal(SIGINT,controlC);
}

void	 number(alfa,argv,k)
int	*alfa;
char	*argv[];
int	*k;
{
	int		j;
	int		i;
	int		t;
	char		s[15];
	extern int	atoi();
	
	j = 0;
	t = 0;
	i = *k;
	for (i=i+1;;++i) {
		switch (argv[0][i]) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
				s[j++] = argv[0][i];
				break;
			default:
				t = 1;
				s[j++]='\0';
				*alfa = atoi(s);
				--i;
				*k = i;
				break;
		}
		if (t) break;
	}

}

void controlC(sig)
int sig;
{
	/*
	** Apagar, se necessario, arquivos temporarios
	*/
	
        if (!flag_exec)
                fprintf(stderr,"\n********  Interrompido pelo usuario\n");


	setOSstdin();

#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
		printf("***Lista de memoria nao esta vazia ***\n");
		Mem_Store("estat");
		exit(1);
	}
#endif
	exit(sig);
}

