/***********************************************************************************
 ESTAT - Clculo de Estatsticas Descritivas
 
 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Mdulo integrante do software ESTAT, que  calcula estatsticas descritivas 
    de variveis  numricas. As  estatsticas  que  podem  ser requeridas so: nmero 
    de observaes, valor mnimo, valor mximo, total, mdia, varincia, desvio padro, 
    erro padro, coeficiente de variao, assimetria, curtose, mediana, estatstica D 
    de Kolmogorov, percentis e modas.
    Este  o mdulo que implementa os operadores usados pelo tipo Memoria
    
 Desenvolvido por:

 	  Antonio Luis Peloso
	  
 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include	<stdio.h>
#include	"atomic.h"
#include	"erro.h"
#include	"memoria.h"
#include	"pcsgbd.h"	/* Luciana */

/*
//	Variaveis do Modulo Memoria
*/

#define	MAX_AREA (4096)
#define	LIVRE	((Bool)0)
#define	OCUPADO	((Bool)-1)

typedef struct M_Area {
    Memoria memo;
    int modulo;
    int area;
    Bool status;
} M_Area;

static M_Area D_Area[MAX_AREA];

static long M_Total = 0l;
static long M_Atual = 0l;

/*
// 	Operadores do tipo
*/

Memoria M_Aloca(total, tipo, modulo)
unsigned int total;
unsigned int tipo;
int modulo;
{
#ifdef	ULTRIX
    extern char *calloc();
#endif
#ifdef	SUN
    extern char *calloc();
#endif
    Memoria M;
    Bool Livre;
    int i = 0;

    M = calloc(total, tipo);
    if (M == (Memoria) NULL) {
	Er_Error(ER_EXIT, "%e1", 0);
    }

    Livre = TRUE;
    for (i = 0; i < MAX_AREA; ++i) {
	if (D_Area[i].status == LIVRE) {
	    D_Area[i].memo = M;
	    D_Area[i].modulo = modulo;
	    D_Area[i].area = total * tipo;
	    D_Area[i].status = OCUPADO;
	    Livre = FALSE;
	    M_Total += D_Area[i].area;
	    break;
	}
    }
    if (Livre)
	Er_Error(ER_EXIT, PegaMsg(5037), 0);
    return (M);
}


void M_Libera(M, modulo)
Memoria M;
int modulo;
{
    int Livre;
    int i;
    char tmpbuf[128];

    Livre = TRUE;
    for (i = 0; i < MAX_AREA; ++i) {
	if (D_Area[i].memo == M && D_Area[i].status == OCUPADO) {
	    free(M);
	    D_Area[i].memo = (Memoria) NULL;
	    D_Area[i].status = LIVRE;
	    M_Total -= D_Area[i].area;
	    Livre = FALSE;
	    break;
	}
    }
    if (Livre) {
	sprintf(tmpbuf, PegaMsg(1040), "");
	Er_Error(ER_EXIT, PegaMsg(1040), 0);
    }
}

void M_Print()
{
    int i;

    for (i = 0; i < MAX_AREA; ++i) {
	if (D_Area[i].status == OCUPADO) {
	    printf("<%3d> Endereco [%08x] ", i, D_Area[i].memo);
	    printf("Modulo [%3d] Area [%6d]\n",
		   D_Area[i].modulo, D_Area[i].area);
	}
    }
    printf("\n\tTotal de memoria em uso = %ld Kbytes\n",
	   (long) (M_Total / 1024));
}

/*
//	Final de memoria.c
*/
