/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Contm funcao constant que identifica a constante utilizada como parametro da instrucao 
	que se encontra no topo da pilha de dados, obtendo seu valor numerico
	e colocando-o nesta pilha.

 Desenvolvido por:

      Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>
#include "socasm.h"
#include "pcsgbd.h"
#include "genese.h"


/* ----------------------------------------------------------------------------
**
**	
**
**  Funcao para verificar o tipo de constante, colocando seu valor 
**  correspondente na pilha de dados
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
** Data da ultima alteracao:
**
**		94/10/17 12:50:40
**
** ----------------------------------------------------------------------------
*/

#ifdef DEBUG
extern int	f_1;
#endif

extern	unsigned int	ins[]; /* vetor de instrucoes */
extern	double	pilha[];  /* pilha de dados */
extern	int	idpilha;  /* indice da pilha de dados */
extern unsigned int inst; /* instrucao do vetor de instrucoes  */

void constant()
{
	int i;

	i = OPER1;  /* Pega o parametro da instrucao  a ser executada  */

	/*
	** Testa o valor o parametro para saber que constante e', 
	** colocando na pilha seu valor numerico correspondente
	*/
	switch (i) {
	case OEOF:
#ifdef DEBUG
		D1print("EOF\n");
#endif
		pilha[idpilha++] = (double) EOF;
		break;
	case OPI:
#ifdef DEBUG
		D1print("PI\n");
#endif
		pilha[idpilha++] = 3.14159265358979;
		break;
	case OE:
#ifdef DEBUG
		D1print("E\n");
#endif
		pilha[idpilha++] = 2.71828182845905;
		break;
	case OEULER:
#ifdef DEBUG
		D1print("EULER\n");
#endif
		pilha[idpilha++] = 0.57721566490153;
		break;
	}
}
