/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Contm a funao dclsend que prepara a saida do programa genese, de acordo 
	com as variaveis a serem mantidas ou excluidas


 Desenvolvido por:

      Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>
#include <malloc.h>

#ifdef MSDOS
#include <stdlib.h>
#endif

#include "pcsgbd.h"
#include "genese.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif


/* ----------------------------------------------------------------------------
**
**	
**
** Prepara a saida do programa genese, de acordo com as variaveis a 
** serem mantidas ou excluidas
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
** Data da ultima alteracao:
**
**		95/01/09 08:31:50
**
** ----------------------------------------------------------------------------
*/

extern struct arquivos arquivos[]; /* estrutura com informacoes dos arquivos */

extern struct variavel variavel[]; /* estrutura com informacoes das variaveis */

extern	int	nvarc; 	/* no. de variaveis existentes ate o momento */
extern	int	nvar; 	/* numero total de variaveis */
extern	int	pervar; /* identifica o tipo da variavel */
extern	int	iskeep; /* flag - existe variavel a ser mantida ou excluida */
extern	int	nkd; 	/* total de variaveis a serem mantidas ou excluidas  */
extern	int	narqs; 	/* no. de arquivos existentes */
extern	int	keepdrop[]; /* vetor com os indices de variaveis a serem 
				mantidas ou excluidas  */

void dclsend()
{
	ARQ	*parq;
	int	i;
	int	j;
	int	k;
	int	*pv;	/* vetor com indices da variaveis */
	unsigned ubytes;

	pervar = 0;
	nvar = nvarc;

	/*
	**  Pega o indice 0 da tabela de arquivos, onde serao armazenadas
	**  as informacoes do padrao dos arquivos de saida
	*/
	parq = arquivos[0].arq.ptraa;

	/*------------------------------------------------- */
	/* Ver com Oscar(?):				    */
	/* 	Nao estou entendendo o motivo de se alocar  */
	/* 	nvar variaveis.				    */
	/*	Pois na pratica apenas nvar-(num.de.arquivos*/
	/*	serao utilizadas			    */
	/*	(Silvio e Fernanda)			    */
	/*------------------------------------------------- */

	/*
	** Nao tem variaveis a serem mantidas ou excluidas
	*/
	if (nkd == 0) {
		ubytes = (unsigned) (nvar * sizeof(int));
		if ((pv = (int *) malloc(ubytes)) == (int *) NULL) {

/* *** Padroniz. msg erro - Adriana 06/01/95
			fprintf(stderr, "Falta memoria.");
*** */

			fprintf(stderr, PegaMsg (1039) ); 
			termina(2);
		}
		j = 0;

		/*
		** Armazena os indices das variaveis que nao sao do tipo 
		** arquivo, concatenacao horizontal ou concatenacao vertical
		*/
		for (i = 0; i < nvar; ++i) {
			if ((variavel[i].tipo != 'a') && (variavel[i].tipo != 'v')  &&
			   (variavel[i].tipo != 'h')) {
				/*
				** Verifica se a variavel existe
				*/
				if (def_var(parq, variavel[i].nome, variavel[i].tipo) < 0)

/* *** Padroniz. msg erro - Adriana 06/01/95
					execerror("Variavel nao existe", "");
*** */

					execerror( PegaMsg (1062), "");
				/*
				** Armazena o indice da variavel
				*/
				pv[j++] = i;
			}
		}
		arquivos[0].nvar = j; 	/* numero de vars. do arquivo  */

		arquivos[0].pos = pv;	/* aponta para o vetor de indices das
					   variaveis  */
	}

	/*
	** Tem variaveis a serem mantidas
	*/
	else {
		if (iskeep) {
			ubytes = (unsigned) (nkd * sizeof(int));
			if ((pv = (int *) malloc(ubytes)) == (int *) NULL) {

/* *** Padroniz. msg erro - Adriana 06/01/95
				fprintf(stderr, "Falta memoria.");
*** */

				fprintf(stderr, PegaMsg (1039) );
				termina(2);
			}
			for (i = 0; i < nkd; ++i) {
				j = keepdrop[i];
				/*
				** Testa se a variavel existe
				*/
				if (def_var(parq, variavel[j].nome, variavel[j].tipo) < 0)

/* *** Padroniz. msg erro - Adriana 06/01/95
					execerror("Variavel nao existe", "");
*** */

					execerror( PegaMsg (1062), "");
				/*
				** Armazena o indice da variavel
				*/
				pv[i] = j;
			}
			arquivos[0].nvar = nkd; /* numero de variaveis do 
						 arquivo vai ser o numero
						 de variaveis a se manter */

			arquivos[0].pos = pv;	/* aponta para o vetor de 
						indices das variaveis */
		}

		/*
		** Tem variaveis a serem excluidas
		*/
		else {
			ubytes = (unsigned) ((nvar - nkd) * sizeof(int));
			if ((pv = (int *) malloc(ubytes)) == (int *) NULL) {

/* *** Padroniz. msg erro - Adriana 06/01/95
				fprintf(stderr, "Falta memoria.");
*** */

				fprintf(stderr, PegaMsg (1039) );
				termina(2);
			}
			/*
			** Desconsidera as variaveis que devem ser excluidas 
			** colocando em pv apenas os indices das variaveis
			** que nao estao em keepdrop[]
			*/
			for (i=0; i < nvar; ++i) {
				if ((variavel[i].tipo != 'a') &&
				    (variavel[i].tipo != 'h') &&
				    (variavel[i].tipo != 'v')) {
					for (j = 0; j < nkd; ++j) {
						if (keepdrop[j] == i)
							break;
					}
					if (j == nkd) {
						def_var(parq, variavel[i].nome,
							variavel[i].tipo);
						pv[arquivos[0].nvar++] = i;
					}
				}
			}
			arquivos[0].pos = pv; /* aponta para o vetor de indices
						das variaveis */
		}
	}

	k = 1;

	/*
	** Testa se e' arquivo do sistema e de saida, para definir suas 
	** variaveis, caso ele nao as tenha 
	*/
	while (k < narqs) {
		if (arquivos[k].arqfile == 0 && arquivos[k].modo == 1) {
			parq = arquivos[k].arq.ptraa;
			/*
			** Se o arquivo nao tem variaveis, estas ficam sendo 
			** as definidas em arquivos[0].
			*/
			if (arquivos[k].nvar == 0) {
				arquivos[k].nvar = arquivos[0].nvar;
				arquivos[k].pos = arquivos[0].pos;
			}
			/*
			** Testa se as variaveis existem
			*/
			for (i = 0; i < arquivos[k].nvar; ++i) {
				j = arquivos[k].pos[i];
				if (def_var(parq, variavel[j].nome,
						variavel[j].tipo) < 0)

/* *** Padroniz. msg erro - Adriana 06/01/95
					execerror("Variavel nao existe", "");
*** */

					execerror( PegaMsg (1062), "");
			}
		}
		++k;
	}
}

