/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Funcao ffopen para abrir arquivos externos ao genese, 
	segundo o modo indicado: entrada ou sada

 Desenvolvido por:

      Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>

#ifdef MSDOS
#include <io.h>
#endif

#ifdef RS6000
#include <sys/io.h>
#endif

#include <string.h>
#include "pcsgbd.h"
#include "genese.h"


/* ----------------------------------------------------------------------------
**
**	
**
** Funcao para abrir arquivos externos 
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
**
** Data da ultima alteracao:
**
**		95/01/11 11:28:04
**
** ----------------------------------------------------------------------------
*/

extern struct arquivos arquivos[];	/* informacoes dos arquivos existentes */	
extern	int	narqs;	/* numero de arquivos existentes  */

void ffopen(modo)
int modo; 	/* indica o modo do arquivo: entrada ou saida  */
{
	char modopen[2];
	char buf[TAMSTR];
	FILE *fo;

	if (modo == SAIDA)
		modopen[0] = 'w';
	else
		modopen[0] = 'r';

	modopen[1] = '\0';

	if (modopen[0] == 'r') {
		if (!(strcmp(arquivos[narqs].nome, "con"))) {
#ifndef	MSDOS
			strcpy(buf, "/dev/tty");
#else
			strcpy(buf, arquivos[narqs].nome);
#endif
		} else

			strcpy(buf, pega_env(arquivos[narqs].nome, ""));
	} else
		strcpy(buf, arquivos[narqs].nome);

	/*
	** Manda abrir o arquivo para leitura ou gravacao, testando se 
	** ele existe ou nao
	*/
	if ((fo = fopen(buf , modopen)) == (FILE *) NULL)
		if (modo == ENTRADA) {
		  	char	tmpbuf [128]; /* Adriana */

/* *** Padroniz. msg erro - Adriana 09/01/95
			execerror("Arquivo externo nao encontrado ou numero maximo de arquivos atingido: ",
				arquivos[narqs].nome);
*** */

			sprintf (tmpbuf, PegaMsg (1008), arquivos[narqs].nome);
			execerror( tmpbuf, "");
		}
		else {
		  	char	tmpbuf [128]; /* Adriana */

/* *** Padroniz. msg erro - Adriana 09/01/95
			execerror("Arquivo externo nao abre ou numero maximo de arquivos atingido: ",
				arquivos[narqs].nome);
*** */

			sprintf (tmpbuf, PegaMsg (1038), arquivos[narqs].nome);
			execerror(tmpbuf, "");
		}

	arquivos[narqs].arq.ptraf = fo;	/* apontador para o arquivo fisico */	
	arquivos[narqs].arqfile = 1;	/* arquivo do tipo externo  */
	arquivos[narqs].obs = 0L;	/* posiciona na primeira observacao
			    		   do arquivo */	
	arquivos[narqs].modo = modo;	/* seta o modo do arquivo  */
}

