/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Arquivo que contem adefinicao das estruturas de dados e constantes numericas
	utilizadas no genese

 Desenvolvido por:

      Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
      Carla Geovana do N. Macario
	Maria Fernanda Moura
	Adriana Delfino dos Santos
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

/* ----------------------------------------------------------------------------
**
**	
**
** Arquivo para definicao das estruturas de dados utilizadas no genese
** e constantes numericas
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
** Data da ultima alteracao:
**
**		95/08/14 10:51:11
**
** ----------------------------------------------------------------------------
*/

#define	MAXCHAVES  8
#define	TAMCAMPO  80

#if defined(MSDOS) & !defined(DJGPP)
# define MAXGENARQ		20
# define AXGENARQ		30
# define MAXGENVAR		1590
# define MAXGENINS		20000
# define MAXFORM		100
# define VARNULL		1589
#else
# ifdef EDIX
#  define MAXGENARQ		30
#  define MAXGENVAR		1590
#  define MAXGENINS		20000
#  define MAXFORM		100
#  define VARNULL		1589
# else
#  ifdef DJGPP
#   define MAXGENARQ		30
#   define AXGENARQ		30
#   define MAXGENVAR		10000
#   define MAXGENINS		200000
#   define MAXFORM		100
#   define VARNULL		9999
#  else
#   define MAXGENARQ		50
#   define MAXGENVAR		10000
#   define MAXGENINS		200000
#   define MAXFORM		1000
#   define VARNULL		9999
#  endif
# endif
#endif


#define	ENTRADA			0
#define	SAIDA			1

/*********
**** O tamanho maximo de um campo passou a ser NOVO_MAXSTR. 
**** Para leitura de arquivos externos formatados, o controle 
**** do tamanho e' feito no parser.
**** Para leitura de arquivo externo nao-formatado, o controle
**** e' feito pela rotina lerumcampo e truncando o conteudo do
**** campo se ele for maior.
****#define	RDRBUF			2048
****#define	PRTBUF			10240
**********/
#define	RDRBUF			NOVO_MAXSTR
#define	PRTBUF			NOVO_MAXSTR

/*
** Macros para verificar tipo de funcao.
*/

#if defined(MSDOS) & !defined(DJGPP)

# define CODIGO1	((inst >> 13) & 07)	/* Instrucoes de 3 bits.  */
# define CODIGO2	((inst >> 12) & 017)	/* Instrucoes de 4 bits.  */

#else

# ifdef EDIX

#  define CODIGO1	((inst >> 13) & 07)	/* Instrucoes de 3 bits.  */
#  define CODIGO2	((inst >> 12) & 017)	/* Instrucoes de 4 bits.  */

# else

#  define CODIGO1	((inst >> 29) & 07)	/* Instrucoes de 3 bits.  */
#  define CODIGO2	((inst >> 28) & 017)	/* Instrucoes de 4 bits.  */

# endif
#endif


/*
** Macro para verificar os bits que identificam o subtipo de uma funcao.
*/ 

#if defined(MSDOS) & !defined(DJGPP)

# define SCOD		((inst >> 11) & 03)

#else

# ifdef EDIX

#  define SCOD		((inst >> 11) & 03)

# else

#  define SCOD		((inst >> 27) & 03)

# endif
#endif

/*
** Macros para pegar parametros de funcoes.
*/ 

#if defined(MSDOS) & !defined(DJGPP)

# define OPER1		(inst & 0x07ff)		/* 11 bits de parametros. */
# define OPER2		(inst & 0x0fff)		/* 12 bits de parametros. */

#else

# ifdef EDIX

#  define OPER1		(inst & 0x07ff)
#  define OPER2		(inst & 0x0fff)

# else

#  define OPER1		(inst & 0x07ffffff)
#  define OPER2		(inst & 0x0fffffff)

# endif
#endif

#define	D1print		if (f_1) printf
#define	D16print	if (f_16) printf


/*
** Estrutura utilizada na concatenacao horizontal de arquivos.
*/

struct Ch_Lista {	
	long	apnivel;  /* Observacao do arquivo sendo utilizado  */
	long	approx;   /* Observacao do proximo arquivo a ser utilizado  */
};

/*
** Estrutura utilizada na concatencao horizontal de arquivos.
*/

struct Ch_Area {
	int	mestre;	   /* indice do arquivo mestre na tabela de arquivos */
	long	apmestre;  /* ultima observacao lida no arquivo mestre  */
	long 	obscorr;   /* observacao corrente */
	int	numLista;  /* numero de arquivos existentes */
	int	Lista[MAXGENARQ];  /* vetor com os indices dos arquivos 
				      na tabela */
	char	chave[MAXCHAVES][TAMCAMPO];  /* chaves existentes para 
						a concatencao */
	char	tip_ord;	/* tipo de ordenacao : 'a' ascendente,
						       'd' descendente */
	struct	Ch_Lista	ARQS[MAXGENARQ]; /* estrutura para controle 
						das observacoes dos arquivos 
						quando for feita a concatenacao
						horizontal  */
};

#define ChNULL	(struct Ch_Area *) NULL

/*
** Estrutura utilizada na concatencao vertical de arquivos.
*/

struct WorkArea {
	int 	mestre;				/* mestre corrente */
	char 	chave[MAXCHAVES][TAMCAMPO];	/* chave corrente  */
	char	tip_ord;	/* tipo de ordenacao : 'a' ascendente,
						       'd' descendente */
	long 	obscorr;			/* observacao corrente */
	long 	apmestre;/* apontador para ultima observacao lida no mestre */
};

#define WNULL	(struct WorkArea *) NULL

/*
** Contem informacoes dos arquivos utilizados no programa genese.
*/

struct	arquivos {
	char	*nome;   /* nome do arquivo  */
	char	arqfile; /* tipo do arquivo:
				0 - do sistema genese	1 - externo   */
	int	fim;     /* arquivo final para concatencao */
	int	*ch;	 /* indice das variaveis que formam a chave  */
	int	nch;	 /* numero de variaveis que formam a chave   */
	union	qarea {	 /* area utilizada para a concatenacao */
		struct  Ch_Area         *pch;   /* area de chaves */
		struct  WorkArea        *pcv;   /* area de variaveis */
	}	qarea;
	union	arq { 	 /* apontador para o arquivo */
		ARQ     *ptraa; /* arquivo do sistema   */
		FILE    *ptraf; /* arquivo externo      */
	}	arq;
	int	*pos;	 /* aponta para a area de variaveis do arquivo, onde 
			    estao seus indices na tabela  */
	int	nvar;	 /* numero de variaveis do arquivo  */
	long	obs;	 /* observacao corrente do arquivo  */
	int	modo;	 /* 0 leitura, 1 gravacao	*/
};

/*
** Contem informacoes das variaveis definidas no programa genese.
*/

struct	variavel {
	char	*nome;		/* nome da variavel  */
	char	tipo;		/* tipo da variavel
					1 - numerica            2 - string
					3 - arquivo             4 - data
					5 - var. a ser excluida ou mantida
					6 - lista de variaveis de arquivo
					7 - arquivo externo     8- chave   */
	union	endereco {	/* indica o conteudo das variaveis */
		double  ptrf;	/* conteudo numerico */
		char    *ptrs;	/* apontador para string  */
		int     ptra;	/* indice do arquivo na tabela*/
	}	ptrval;
};

/*
** Contem informacoes das palavras reservadas e constantes.
*/

struct	keywords {
	char	*name;	/* nome da palavra  */
	int	kval;	/* valor */
};

/*
** Contem informacoes das funcoes do genese.
*/

struct	funcwords {
	char	*name;		/* nome da funcao  */
	int	kval;		/* valor  */
	int	nparm;		/* numero de parametros */
	char	tipo_par[4];	/* tipo dos parametros na mesma ordem */
};


/*
** Prototipos das funcoes.
*/

#ifdef MSDOS

extern int	backslash(int);
extern void	concv(int,int,int *,int,struct WorkArea *);
extern void   	CvEscolheMestre(int *, char[MAXCHAVES][TAMCAMPO], int,
			int *, int, int, char);
extern void	ChErro(void);
extern long	CvLeCopiaChave(int, char[MAXCHAVES][TAMCAMPO], int *, int);
extern int 	CvCompara(char[MAXCHAVES][TAMCAMPO], char[MAXCHAVES][TAMCAMPO],
			int, int *);
extern void 	conch(int, int, int *, int, struct Ch_Area *);
extern void	ConcHor(int, int, struct Ch_Area *);
extern long 	ChSLe(int);
extern void	ChaveEscolheMestre(int,int,int *,int,struct Ch_Area *);
extern void 	ChChave(int,int,int *,int,struct Ch_Area *);
extern void	MontaObs(int,int *,int *,int *,int *,struct Ch_Area *,int *);
extern void     Pausa_de_Advertencia (void);
extern void	PoemMissing(int,int);
extern void	constant(void);
extern void	dclsend(void);
extern void	debug(int);
extern void	especial(int);
extern void	genpause(char *);
extern void	execerror(char *, char *);
extern void	execins(void);
extern void	ffopen(int);
extern int	follow(int, int, int);
extern void	func(void);
extern void	repete(char *, int, char *);
extern char	*word_k(char *, int, char *);
extern void	trim(char *, char *);
extern void	substr(char *,char *,char *,char *);
extern void	supper(char *, char *);
extern void	slower(char *, char *);
extern int	scan(char *, char *);
extern void	funcs(void);
extern int	yyparse(void);
extern void	grvint(int);
extern int	gtarggen(int, char **);
extern void	lerextf(int);
extern int	number(char *, long);
extern void	lerextnf(int);
extern void	lerint(int);
extern int	lerumcampo(char *, int, FILE *);
extern void	listadevar(int);
extern void	operacao(void);
extern void	operfun(void);
extern void	operlog(void);
extern void	opermat(void);
extern void	pgm(void);
extern void	printabela(void);
extern void	printpilha(void);
extern void	ssopen(int);
extern void	termina(int);
extern void	termina_ctrl_c(int);
extern void	termina_segfault(int);
extern void	termina_buserror(int);
extern int	veriarq(void);
extern int	verivar(char *);
extern int	vmissing(double, double);
extern void	warning(char *, char *);
extern void	yyerror(char *);
extern int	yylex(void);

#else

extern int	backslash();
extern void	concv();
extern void   	CvEscolheMestre();
extern void	ChErro();
extern long	CvLeCopiaChave();
extern int 	CvCompara();
extern void 	conch();
extern void	ConcHor();
extern long 	ChSLe();
extern void	ChaveEscolheMestre();
extern void 	ChChave();
extern void	MontaObs();
extern void     Pausa_de_Advertencia ();
extern void	PoemMissing();
extern void	constant();
extern void	dclsend();
extern void	debug();
extern void	especial();
extern void	genpause();
extern void	execerror();
extern void	execins();
extern void	ffopen();
extern int	follow();
extern void	func();
extern void	repete();
extern char	*word_k();
extern void	trim();
extern void	substr();
extern void	supper();
extern void	slower();
extern int	scan();
extern void	funcs();
extern int	yyparse();
extern void	grvint();
extern void	lerextf();
extern int	number();
extern void	lerextnf();
extern void	lerint();
extern int	lerumcampo();
extern void	listadevar();
extern void	operacao();
extern void	operfun();
extern void	operlog();
extern void	opermat();
extern void	pgm();
extern void	printabela();
extern void	printpilha();
extern void	ssopen();
extern void	termina();
extern void	termina_ctrl_c();
extern void	termina_segfault();
extern void	termina_buserror();
extern int	veriarq();
extern int	verivar();
extern int	vmissing();
extern void	warning();
extern void	yyerror();
extern int	yylex();

#endif
