#ifndef lint
/*static char yysccsid[] = "from: @(#)yaccpar	1.9 (Berkeley) 02/21/93";*/
static char yyrcsid[] = "$Id: skeleton.c,v 1.4 1993/12/21 18:45:32 jtc Exp $";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 1 "genparse.y"

/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Arquivo que a gramtica da linguagem GENESE

 Desenvolvido por:

      Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
      Carla Geovana do N. Macario
	Maria Fernanda Moura

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <string.h>
#ifdef MSDOS
# include <stdlib.h>
# include "y_tab.h"
#else
#ifdef VAXVMS
#include <stdlib.h>
#include "ytab.h"
#else
#include <malloc.h>
# include "y.tab.h"
#endif
#endif

#ifdef	MEM_DEBUG
#include "mshell.h"
#endif

#include "socasm.h"
#include "pcsgbd.h"
#include "genese.h"
#include "pilha.h"

#ifdef DEBUG
#define	YYDEBUG			1
#endif

/* ----------------------------------------------------------------------------
**
**	
**
** Define a gramatica do modulo genese
**
**
** Programado por:
**
**		Oscar Ivan Palma Pacheco
**		Carlos Fernando Assis Paniago
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**		Oscar Ivan Palma Pacheco
**
**
** Data da ultima alteracao:
**
**		97/02/28 15:44:02
**
** ----------------------------------------------------------------------------
*/


#ifdef DEBUG
extern	int	f_16;
#endif

#define YYMAXDEPTH 500

extern struct funcwords funcwords[]; 	/* Informacoes de funcoes matematicas e
					   funcoes que tratam datas numericas.*/

extern struct funcwords funcswords[]; 	/* Informcaoes de funcoes que tratam
					   strings.  */

extern struct funcwords funcdwords[]; 	/* Informacoes de funcoes de datas. */

extern struct funcwords funcvwords[];	/* informacoes de funcoes void */

extern struct keywords cnstwords[]; 	/* Informacoes de constantes. */

extern struct variavel variavel[];	/* Informacoes das vars. do genese. */

extern struct arquivos arquivos[];	/* Informacoes dos arqs. do genese. */

extern	int	pc;		/* Contador do programa. */
extern	int	output;		/* Flag - e' arquivo de saida. */
extern	int	pervar;		/* Contem o tipo da variavel. */
extern	int	iskeep;		/* Flag - variavel a ser mantida. */
extern	int	isdrop;		/* Flag - variavel a ser excluida. */
extern	int	narqs;		/* Numero de arquivos existentes. */
extern	int	prtvar;		/* Caracter especial de formatacao:
				   \L, \T ou \P */
extern	int	nform;		/* Numero de arquivos externos com formatos. */
extern	int	indvar;		/* Indice de variaveis de um arquivo. */
extern	int	posnum;		/* Numero de coluna a partir da qual deve ser
				   Iniciada a leitura formatada. */
extern	int	formnum;	/* Indice de variavel com formato numerico
				   para sua leitura. */
extern	unsigned int	ins[];	/* Vetor de instrucoes do programa. */
extern	int	nomeflag;	/* Flag - e' nome de arquivo. */
extern	int	debflag;	/* Flag - permite a depuracao do programa. */
extern	int	setmodo;	/* Flag - modo. */
extern	char	printbuf[];	/* Armazena a formatacao do arq. */
extern	char	*formatos[];	/* Formatacao de cada arquivo formatado. */
extern	int	*listas[];	/* Lista de vars. de cada arquivo externo. */
extern	int	numvar[];	/* Numero de vars. de cada arquivo externo. */
extern	int	pareeof;	/* Constante de final de arquivo. */

/*
** Variaveis globais neste arquivo.
*/

int	arq;
char	tabpos;			/* Tabulacao da posicao de impressao. */
char	*pp;			/* Buffer com a formatacao do arquivo. */
int	i, j, ct_break = 0;	/* indices auxiliares */
int	pcread;			/* variavel auxiliar para guardar o valor de 
				   pc */
int	indfmt;			/* Indice de formatacao de arquivo formatado. */
int	*pv;			/* Apontador para os indices das vars do
				   arquivo. */
int	eform;			/* Flag - e' formatado. */
int	nformv;			/* Numero de formatacoes. */
int	tarqs;			/* Total de arquivos lidos sem considerar os
				   que serao utilizados para concatenacao. */
int	varfil[MAXGENARQ];	/* Indice das variaveis arquivo. */
char	tipofil[MAXGENARQ];	/* Tipo do arquivo:
					1 - Arquivo do sistema
					2 - Arquivo externo
					3 - Arquivo para concatenacao vertical
					4 - Arquivo para concatenacao horizontal
				*/
int	yynch;
int	vetchave[MAXCHAVES];	
int	vars[MAXVAR];		/* Indices das variaveis de arquivo externo. */
int	flag_dcls = 0;		/* Flag de declaracao. */
char	tipordenacao;		/* Tipo de ordenacao. */
int	flagord=0;		/* Flag de ordenacao. */
int	end_break[200];		/* contem os enderecos dos breaks de cada 
				   while */
int	num_while = 0;		/* contem o no. do while que o parse esta' 
				   analisando  */
static	int	*vet;
int	nparam[100];		/* Indices dos parametros. */
int	npr = 0;	
unsigned ubytes;


T_Pilha		TipoParametro;			/* Tipo de parametros recebidos em listas de 
							argumentos de funcoes */
char	tmpbuf [128]; 

/*
** Mensagens de ERRO.
*/


static int Msg[] = {
	3182, /* Nao se pode usar MANTER e EXCLUIR no mesmo programa */
	3183, /* Estourado o numero maximo de arquivos */
	3184, /* ABRES(SOPEN): Lista de variaveis so' para criacao de arquivo */
	1039, /* Memoria disponivel esgotada */
	3185, /* ABREF(EOPEN): Lista de variaveis so' para leitura de arquivo */
	1039, /* Memoria disponivel esgotada */
	3186, /* Declaracao do nome e/ou tipo do arquivo incorreta */
	3183, /* Estourado o numero maximo de arquivos */
	3187, /* Especificacao da lista de arquivos incorreta */
	9999  /* (char *) NULL */
};


#line 218 "y.tab.c"
#define KEEP 257
#define DROP 258
#define NUMBER 259
#define IF 260
#define WHILE 261
#define ELSE 262
#define SREAD 263
#define EREAD 264
#define FUNCAO 265
#define FTOA 266
#define ATOF 267
#define STOP 268
#define MNT 269
#define MYFILE 270
#define SOPEN 271
#define EOPEN 272
#define VALSTR 273
#define FLOAT 274
#define PRINT 275
#define VARSTR 276
#define VARNUM 277
#define DATE 278
#define VARFIL 279
#define RDEBUG 280
#define EQ 281
#define NEQ 282
#define LT 283
#define LE 284
#define GT 285
#define GE 286
#define NOT 287
#define AND 288
#define OR 289
#define STRING 290
#define NOMEARQ 291
#define CONTINUE 292
#define OUTPUT 293
#define CONST 294
#define FUNCAOS 295
#define MODO 296
#define ABORT 297
#define CONCV 298
#define CONCH 299
#define CHAVE 300
#define ORD 301
#define ASC 302
#define DESC 303
#define VARDATA 304
#define VALDATA 305
#define FUNCAOD 306
#define FUNCAOV 307
#define MISSNUM 308
#define REWIND 309
#define BREAK 310
#define DTOA 311
#define ATOD 312
#define DTOF 313
#define FTOD 314
#define WHERE 315
#define PAUSE 316
#define UNARYMINUS 317
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    5,    0,    0,    3,    1,    1,    6,    6,    6,
    6,    6,    6,    6,   17,    7,   15,    2,    9,   11,
   13,   18,   18,    8,    8,    8,   19,   19,   19,   12,
   12,   10,   10,   14,   14,   16,   16,   24,   16,   26,
   16,   20,   22,   21,   27,   28,   21,   21,   23,   23,
   23,   25,   29,   31,   25,   25,   30,   32,   30,   30,
   33,   33,   33,    4,   34,   34,   35,   35,   35,   35,
   35,   35,   35,   46,   35,   35,   35,   35,   35,   35,
   47,   35,   35,   35,   35,   35,   44,   44,   41,   41,
   36,   36,   37,   37,   38,   38,   38,   40,   49,   39,
   42,   52,   52,   52,   54,   52,   52,   52,   52,   51,
   51,   51,   51,   55,   51,   51,   51,   51,   51,   50,
   50,   50,   50,   50,   56,   50,   50,   50,   50,   50,
   50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
   50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
   50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
   50,   50,   50,   53,   45,   45,   45,   45,   45,   45,
   45,   45,   58,   57,   57,   57,   57,   57,   57,   57,
   57,   59,   59,   59,   62,   62,   64,   64,   63,   63,
   61,   60,   48,   48,   48,   48,   48,   48,   48,   66,
   43,   43,   43,   43,   43,   65,   69,   65,   67,   68,
   68,   68,   68,   68,   71,   70,   70,   70,   70,   72,
   72,   74,   74,   73,   73,
};
short yylen[] = {                                         2,
    4,    0,    3,    1,    0,    2,    3,    3,    3,    3,
    3,    3,    5,    3,    0,    0,    0,    0,    0,    0,
    0,    0,    1,    1,    2,    1,    1,    1,    1,    1,
    2,    1,    2,    1,    2,    7,    7,    0,    7,    0,
    7,    0,    0,    1,    0,    0,    5,    1,    1,    2,
    1,    0,    0,    0,    5,    1,    0,    0,    4,    1,
    1,    1,    1,    3,    1,    2,    2,    2,    2,    5,
    5,    2,    2,    0,    5,    5,    5,    2,    2,    2,
    0,    5,    1,    4,    1,    1,    0,    3,    0,    3,
    3,    3,    3,    3,    3,    3,    3,    0,    0,    3,
    0,    1,    1,    3,    0,    5,    4,    4,    3,    1,
    1,    3,    3,    0,    5,    4,    4,    4,    3,    1,
    1,    1,    1,    3,    0,    5,    1,    4,    4,    3,
    3,    2,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    2,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    1,    1,    1,    3,    3,    3,    2,    4,
    4,    4,    0,    3,    3,    3,    3,    3,    3,    3,
    3,    0,    7,    5,    0,    1,    0,    2,    0,    1,
    0,    0,    0,    1,    1,    1,    3,    3,    3,    0,
    6,    4,    5,    1,    4,    0,    0,    5,    1,    1,
    3,    2,    4,    1,    1,    3,    3,    3,    3,    5,
    3,    0,    2,    0,    1,
};
short yydefred[] = {                                      0,
    4,   16,   16,   17,   19,   20,   15,   21,    0,    0,
    5,    0,    0,    0,    0,    0,    0,    0,    0,    5,
    0,    0,    6,   26,   28,   27,   29,    0,   24,    0,
    0,   32,    0,   30,    0,   14,   34,    0,    0,    7,
    0,    3,   25,    0,   33,   31,   35,    1,   86,    0,
  101,    0,    0,    0,    0,    0,    0,   15,    0,    0,
    0,    0,   81,    0,    0,    0,   85,   83,    0,   65,
    0,    0,    0,    0,   42,   42,   42,   42,   13,    0,
   98,    0,    0,    0,   79,    0,   74,    0,    0,    0,
   78,    0,   80,    0,    0,    0,   72,    0,   64,   66,
   67,   68,   69,   73,    0,    0,    0,    0,  163,  120,
  125,    0,    0,    0,  110,  111,  122,    0,  121,  114,
  103,  102,  105,  164,    0,    0,    0,    0,    0,    0,
  127,    0,    0,    0,    0,    0,   98,    0,  209,    0,
    0,    0,    0,    0,   94,    0,    0,   92,    0,    0,
    0,    0,    0,   97,   95,   96,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  100,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  200,    0,   88,  192,  192,  191,    0,
    0,    0,    0,  165,    0,   84,  205,    0,    0,    0,
    0,    0,    0,    0,   48,    0,    0,    0,   51,   49,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  124,  112,  104,  146,  119,  109,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  113,  147,
  148,  150,  151,  153,  154,  155,  156,  149,  152,   99,
   70,   71,    0,  214,  192,  192,  191,    0,    0,  210,
    0,    0,    0,   75,    0,    0,    0,  169,    0,    0,
    0,   82,    0,   77,   76,    0,   43,   43,   50,    0,
    0,    0,  116,  128,  118,    0,    0,  117,  107,  129,
  108,    0,  207,  201,    0,    0,    0,  215,    0,    0,
  212,  174,  175,  176,  177,  178,  179,  180,  181,    0,
    0,    0,    0,  168,  167,  166,    0,    0,    0,   46,
    0,    0,    0,    0,  126,  115,  106,   90,    0,  216,
  217,  218,  219,    0,  211,    0,  172,  171,  170,  186,
    0,    0,    0,   36,   37,   56,   53,   39,   41,    0,
    0,    0,    0,  213,    0,   47,    0,    0,    0,  223,
  221,    0,    0,    0,    0,  208,  225,    0,    0,  188,
  184,    0,  220,  190,    0,   60,   58,   55,  183,    0,
    0,   63,   61,   62,   59,
};
short yydgoto[] = {                                       9,
   10,   20,   22,   68,   11,   12,   13,  383,   16,   33,
   17,   35,   19,   38,   15,   79,   18,  384,   29,  105,
  237,  361,  241,  320,  388,  321,  316,  382,  397,  418,
  412,  420,  425,   69,   70,   71,   72,   73,   81,  136,
  291,   82,  131,   87,  220,  142,   95,  229,  332,  230,
  133,  134,  135,  170,  169,  164,  224,  309,  354,  301,
  303,  381,  415,  404,  334,  293,  140,  299,  369,  300,
  339,  375,  408,  393,
};
short yysindex[] = {                                    371,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -70,
    0,   -9, -247, -247, -186, -226, -177, -123, -117,    0,
  102,   46,    0,    0,    0,    0,    0, -240,    0, -240,
  118,    0,  -93,    0, -119,    0,    0,  -85,   46,    0,
 3276,    0,    0, -134,    0,    0,    0,    0,    0,  157,
    0,  161,  167,  153,  173,  163,  168,    0,  171,  194,
  178,  183,    0,  206,  188,  211,    0,    0, 2984,    0,
  195,  209,  213,  215,    0,    0,    0,    0,    0, 1631,
    0,  157,   -4,   12,    0,   20,    0,  208, 1691,    8,
    0,   21,    0,  115,  253,   28,    0,   41,    0,    0,
    0,    0,    0,    0,  278,  289,  291,  302,    0,    0,
    0,  308,  309,  314,    0,    0,    0, 1631,    0,    0,
    0,    0,    0,    0,  315,  325,  332,  334, 1751, 1631,
    0, 3392,  243,  306, -125, 3276,    0,  305,    0,  318,
  335, 2921,  163,  208,    0,  339,  168,    0,  319,  316,
  337,  183,    5,    0,    0,    0, 1631,  342,  359, -230,
 -230, -228, -228,  361, 1631,  236, 1631,  311,  363,  366,
   90,  236,   90, 1631,  370,  373,  381, 3414,  251,  300,
  311, 1631, 1631, 1631, 1631, 1631, 1631, 1631, 1631,    0,
 1631, 1631, 1631, 1631, 1631, 1631,  236,  236,  236,  236,
  236,  236,  236,  120,  120,   90,   90,   90,   90,   90,
   90,  145, 3276,    0,  266,    0,    0,    0,    0, 2725,
  319,  243,  306,    0,   44,    0,    0,  390,   14,  319,
  243,  306,  376,  377,    0,    0,  401,  403,    0,    0,
  175,  175, 1631, 3460,   91, 3472, 1631, 1631,  404,   99,
  408, 3518,    0,    0,    0,    0,    0,    0,   30,   30,
   30,   30,   30,   30,  589,  529,    2,    2,  311,  311,
  311,  311,  339,  339,  339,  339,  339,  339,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  138,    0,    0,    0,    0,  329,  -21,    0,
  212,  214,   74,    0,  319,  243,  306,    0,  331,  331,
  331,    0, 1631,    0,    0,  421,    0,    0,    0,  429,
  431,   84,    0,    0,    0,   85,  129,    0,    0,    0,
    0, 3276,    0,    0,  216,  217,  -49,    0,  224,  329,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  331,
  331,  331,  445,    0,    0,    0,  319,  243,  306,    0,
 -247, -247, -231, -231,    0,    0,    0,    0,  452,    0,
    0,    0,    0,  -12,    0,  224,    0,    0,    0,    0,
  234,  204, -240,    0,    0,    0,    0,    0,    0, 1631,
  245,  247,  382,    0,   77,    0, -247, 3534,  249,    0,
    0,  252,  255,  385, -240,    0,    0,  391,  256,    0,
    0, -241,    0,    0,  392,    0,    0,    0,    0,  459,
 -224,    0,    0,    0,    0,
};
short yyrindex[] = {                                    398,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  400,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  471,    0,  479,
    0,    0,  480,    0,  481,    0,    0,  482,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 2510,    0,    0,    0,    0,   39,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1494,    0,    0,    0,    0,    0,
    0,    0,  405,    0,    0,   -3, 3029,    0,   63,    0,
    0,   54,    0,    0,    0,    0,  137,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  104,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  174,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 3219,    0,    0, 3159,    0,    0,    0,    0,    0,
 2792, 2581, 2581,    0,    0,    0,    0,    0,    0,  139,
  154,  158,    0,    0,    0,  162,    0,    0,    0,    0,
  503,  504,  137,    0,    0,    0,  137,  137,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1870, 1930,
 1990, 2246, 2306, 2366, 2426, 2665, 1554, 1810,  454,  514,
  574,  634,  914,  974, 1034, 1094, 1374, 1434,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  -24,    0,    0,    0,    0,    0, 3099,    0,
    0,    0,    0,    0, 2792, 2581, 2581,    0, 2861, 2861,
 2861,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2861,
 2861, 2861,  293,    0,    0,    0,  181,  182,  187,    0,
  489,  489,  491,  491,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  428,    0,    0,    0,    0,    0,    0,
    0,    0,   -9,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  435,    0,    0,    0,  437,    0,
    0,    0,    0,    0,  -51,    0,    0,    0,  438,    0,
    0,  505,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
    0,    0,  545,    9,    0,  557,  565,  -13,    0,    0,
    0,    0,    0,    0,    0,    0,  511,  218,  -26,  201,
  414,  261,  430,    0,  230,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -47,  -35,  -82,  -87,  513,  460,
    0,    0,  -36,    0,    0,    0,    0,  -76,    0,  -77,
 1376,  839,  -84,    0,    0,    0,  378, -131, -158, -194,
  299,    0,    0,    0,    0,    0,    0,    0,    0,  313,
  259,  237,    0,    0,
};
#define YYTABLESIZE 3823
short yytable[] = {                                      28,
   30,   43,  132,   43,   74,  145,  154,   54,   24,  156,
  206,  149,  206,  295,  416,  206,  206,  206,  206,  206,
  206,  100,  206,  302,  386,  235,  372,  239,   25,   26,
   42,  422,   74,  392,  206,   25,   26,   93,  195,  206,
  168,  177,  296,  193,  153,  391,  176,   48,  194,   23,
   32,  178,  181,  148,  312,   93,   27,  313,  373,  417,
  236,  176,  240,   27,  221,  177,  195,  206,  387,  206,
  297,  193,  191,  204,  192,  204,  194,  423,  424,  204,
  204,  204,  204,  204,  257,  204,  203,  244,  212,  246,
  310,  311,   31,  175,  103,  196,  252,  204,  206,   74,
  335,  336,  204,   91,  259,  260,  261,  262,  263,  264,
  265,  266,  103,  267,  268,  269,  270,  271,  272,  281,
  283,   91,  403,  196,  365,  366,   34,  313,  313,  153,
  204,  324,  204,  203,  402,   36,   75,   76,  145,  329,
  145,  203,  305,  145,  145,  145,  145,  145,  145,  344,
  145,  355,  356,  348,  153,  210,  211,  346,   37,  153,
   40,  204,  145,   77,   78,  292,  322,  145,   41,  367,
  326,  327,  313,  350,  351,  352,   74,  193,   44,  196,
  193,  345,  196,   45,   46,  349,    2,    3,  298,  347,
   47,  377,  378,  379,  195,  145,   80,  195,  194,    4,
   83,  194,   44,    5,   54,   45,   84,    6,  132,    7,
  132,   85,   86,  132,  132,  132,  132,  132,  132,    8,
  132,  199,  198,   88,  199,  198,  145,  197,   89,   91,
  197,  206,  132,   92,  206,  357,   93,  132,  206,  206,
  206,  206,  206,   94,  206,   96,   97,  144,  206,   54,
   98,  206,  206,  101,   25,   26,  206,  206,  206,  206,
  206,  206,  206,  206,  206,  132,  150,  102,  206,  206,
  206,  103,  340,  104,  138,  144,  106,  107,  108,  206,
  206,  206,   27,  206,  368,  203,  206,  206,  206,  206,
  139,  257,  157,  203,  204,   74,  132,  204,  141,  151,
  295,  204,  204,  204,  204,  204,  158,  204,  152,  122,
  123,  204,  398,  159,  204,  204,  126,  160,  128,  204,
  204,  204,  204,  204,  204,  204,  204,  204,  161,  296,
  162,  204,  204,  204,  103,  103,  103,  103,  103,  103,
  258,  163,  204,  204,  204,  214,  204,  165,  166,  204,
  204,  204,  204,  167,  171,  195,   43,  297,  215,  145,
  193,  191,  145,  192,  172,  194,  145,  145,  145,  145,
  145,  173,  145,  174,  226,  216,  145,  227,   43,  145,
  145,  203,  233,  405,  145,  145,  145,  145,  145,  145,
  145,  145,  145,  121,  122,  123,  145,  145,  145,  234,
  243,  126,  247,  128,  196,  248,  290,  145,  145,  145,
  253,  145,  196,  254,  145,  145,  145,  145,  152,  122,
  123,  255,  124,  121,  122,  123,  126,  124,  128,  132,
  258,  126,  132,  128,  314,  315,  132,  132,  132,  132,
  132,  317,  132,  318,  328,  111,  132,  111,  330,  132,
  132,  338,  333,  353,  132,  132,  132,  132,  132,  132,
  132,  132,  132,  111,  360,  319,  132,  132,  132,  363,
  342,  364,  343,  112,  370,  371,  114,  132,  132,  132,
  115,  132,  374,  143,  132,  132,  132,  132,  133,  380,
  133,  390,  395,  133,  133,  133,  133,  133,  133,  396,
  133,  112,  120,  399,  114,  400,  401,  407,  115,  411,
  409,  116,  133,  410,  414,  413,  419,  133,  125,  421,
    2,  294,   18,  197,  198,  199,  200,  201,  202,    8,
  120,  197,  198,  199,  200,  201,  202,    9,   10,   11,
   12,   25,   26,   38,   40,  133,  125,   22,  134,   52,
  134,  185,  222,  134,  134,  134,  134,  134,  134,  187,
  134,  224,  189,   57,   39,  195,   21,   14,   90,   27,
  193,  191,  134,  192,  238,  194,  133,  134,  362,  385,
  204,  205,  206,  207,  208,  209,  204,  205,  206,  207,
  208,  209,  242,  389,  137,  337,  213,  308,  376,  182,
  183,  184,  185,  186,  187,  134,  188,  189,  135,    0,
  135,  341,  394,  135,  135,  135,  135,  135,  135,    0,
  135,    0,  196,    0,    0,  195,    1,    2,    3,    0,
  193,  191,  135,  192,    0,  194,  134,  135,    0,    0,
    4,    0,    0,    0,    5,    0,    0,    0,    6,    0,
    7,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    8,    0,    0,    0,    0,  135,    0,    0,  136,    0,
  136,    0,    0,  136,  136,  136,  136,  136,  136,    0,
  136,    0,  196,    0,    0,  111,  111,  111,  111,  111,
  111,    0,  136,    0,    0,    0,  135,  136,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  133,
    0,    0,  133,    0,    0,    0,  133,  133,  133,  133,
  133,    0,  133,    0,    0,  136,  133,    0,    0,  133,
  133,    0,    0,    0,  133,  133,  133,  133,  133,  133,
  133,  133,  133,    0,    0,    0,  133,  133,  133,    0,
    0,    0,    0,    0,    0,    0,  136,  133,  133,  133,
    0,  133,    0,    0,  133,  133,  133,  133,    0,  134,
    0,    0,  134,    0,    0,    0,  134,  134,  134,  134,
  134,    0,  134,    0,    0,    0,  134,    0,    0,  134,
  134,    0,    0,    0,  134,  134,  134,  134,  134,  134,
  134,  134,  134,    0,    0,    0,  134,  134,  134,  182,
  183,  184,  185,  186,  187,    0,  188,  134,  134,  134,
    0,  134,    0,    0,  134,  134,  134,  134,    0,  135,
    0,    0,  135,    0,    0,    0,  135,  135,  135,  135,
  135,    0,  135,    0,    0,    0,  135,    0,    0,  135,
  135,    0,    0,    0,  135,  135,  135,  135,  135,  135,
  135,  135,  135,    0,    0,    0,  135,  135,  135,  182,
  183,  184,  185,  186,  187,    0,    0,  135,  135,  135,
    0,  135,    0,    0,  135,  135,  135,  135,    0,  136,
    0,    0,  136,    0,    0,    0,  136,  136,  136,  136,
  136,    0,  136,    0,    0,    0,  136,    0,    0,  136,
  136,    0,    0,    0,  136,  136,  136,  136,  136,  136,
  136,  136,  136,    0,    0,    0,  136,  136,  136,    0,
    0,    0,  155,    0,    0,    0,    0,  136,  136,  136,
    0,  136,    0,    0,  136,  136,  136,  136,  157,    0,
  157,    0,    0,  157,  157,  157,    0,  157,  157,    0,
  157,    0,    0,    0,    0,    0,    0,  180,    0,    0,
    0,    0,  157,    0,    0,    0,    0,  157,    0,    0,
  223,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  228,    0,    0,    0,  232,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  157,    0,  157,  158,  249,
  158,  251,    0,  158,  158,  158,    0,  158,  158,    0,
  158,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  158,    0,    0,    0,  157,  158,    0,    0,
    0,    0,  280,  282,  284,  285,  286,  287,  288,  289,
    0,    0,    0,    0,    0,    0,    0,    0,  307,    0,
    0,    0,    0,    0,    0,  158,    0,  158,  159,    0,
  159,    0,    0,  159,  159,  159,    0,  159,  159,    0,
  159,  232,    0,    0,    0,  232,  232,    0,    0,    0,
    0,    0,  159,    0,    0,    0,  158,  159,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  159,    0,  159,  160,    0,
  160,    0,    0,  160,  160,  160,    0,  160,  160,    0,
  160,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  359,  160,    0,    0,    0,  159,  160,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  157,
    0,    0,  157,    0,    0,    0,  157,  157,  157,  157,
  157,    0,  157,    0,    0,  160,  157,  160,    0,  157,
  157,    0,    0,    0,  157,  157,  157,  157,  157,  157,
  157,  157,  157,    0,    0,    0,  157,  157,  157,    0,
    0,    0,    0,    0,    0,    0,  160,  157,  157,  157,
    0,  157,    0,    0,  157,  157,  157,  157,    0,  158,
    0,    0,  158,    0,    0,    0,  158,  158,  158,  158,
  158,    0,  158,    0,    0,    0,  158,    0,    0,  158,
  158,    0,    0,    0,  158,  158,  158,  158,  158,  158,
  158,  158,  158,    0,    0,    0,  158,  158,  158,    0,
    0,    0,    0,    0,    0,    0,    0,  158,  158,  158,
    0,  158,    0,    0,  158,  158,  158,  158,    0,  159,
    0,    0,  159,    0,    0,    0,  159,  159,  159,  159,
  159,    0,  159,    0,    0,    0,  159,    0,    0,  159,
  159,    0,    0,    0,  159,  159,  159,  159,  159,  159,
  159,  159,  159,    0,    0,    0,  159,  159,  159,    0,
    0,    0,    0,    0,    0,    0,    0,  159,  159,  159,
    0,  159,    0,    0,  159,  159,  159,  159,    0,  160,
    0,    0,  160,    0,    0,    0,  160,  160,  160,  160,
  160,    0,  160,    0,    0,    0,  160,    0,    0,  160,
  160,    0,    0,    0,  160,  160,  160,  160,  160,  160,
  160,  160,  160,    0,    0,    0,  160,  160,  160,    0,
    0,    0,    0,    0,    0,    0,    0,  160,  160,  160,
    0,  160,    0,    0,  160,  160,  160,  160,  161,    0,
  161,    0,    0,  161,  161,  161,    0,  161,  161,    0,
  161,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  161,    0,    0,    0,    0,  161,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  146,    0,  161,    0,  161,  162,    0,
  162,    0,    0,  162,  162,  162,    0,  162,  162,    0,
  162,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  162,    0,    0,    0,  161,  162,    0,    0,
    0,    0,    0,    0,  179,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  222,    0,  225,
    0,    0,    0,    0,    0,  162,    0,  162,  123,    0,
  123,    0,  231,  123,  123,  123,  123,  123,  123,    0,
  123,  245,    0,    0,    0,    0,    0,  250,    0,    0,
    0,    0,  123,    0,    0,    0,  162,  123,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  273,  274,  275,  276,  277,  278,  279,    0,
    0,    0,    0,    0,    0,  123,    0,  123,  130,    0,
    0,    0,    0,  130,  130,  306,  130,  130,  130,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  130,    0,    0,    0,  123,  130,  231,    0,
    0,    0,  231,  231,    0,    0,    0,    0,    0,  161,
    0,    0,  161,    0,    0,    0,  161,  161,  161,  161,
  161,    0,  161,    0,    0,  130,  161,    0,    0,  161,
  161,    0,    0,    0,  161,  161,  161,  161,  161,  161,
  161,  161,  161,    0,    0,    0,  161,  161,  161,    0,
  129,    0,    0,    0,    0,  130,  130,  161,  161,  161,
    0,  161,    0,    0,  161,  161,  161,  161,  358,  162,
    0,    0,  162,    0,    0,    0,  162,  162,  162,  162,
  162,    0,  162,    0,    0,    0,  162,    0,    0,  162,
  162,    0,    0,    0,  162,  162,  162,  162,  162,  162,
  162,  162,  162,    0,    0,    0,  162,  162,  162,    0,
  129,    0,    0,    0,    0,  130,    0,  162,  162,  162,
    0,  162,    0,    0,  162,  162,  162,  162,    0,  123,
    0,    0,  123,    0,    0,    0,  123,  123,  123,  123,
  123,    0,  123,    0,    0,    0,  123,    0,    0,  123,
  123,    0,    0,    0,    0,    0,  123,  123,  123,  123,
  123,  123,  123,    0,    0,    0,  123,  123,  123,    0,
  129,    0,    0,    0,    0,  130,    0,  123,  123,  123,
    0,  123,    0,    0,  123,  123,  123,  123,    0,  130,
    0,    0,  130,    0,    0,    0,  130,  130,  130,  130,
  130,    0,  130,    0,    0,    0,  130,    0,    0,  130,
  130,    0,    0,    0,  130,  130,  130,  130,  130,  130,
  130,  130,  130,    0,  131,    0,  130,  130,  130,  131,
  131,    0,  131,  131,  131,    0,    0,  130,  130,  130,
    0,  130,    0,    0,  130,  130,  130,  130,  131,    0,
    0,    0,    0,  131,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  109,    0,    0,  110,
    0,    0,    0,   52,   53,  111,  112,  113,    0,  114,
    0,  131,    0,  115,  137,    0,  116,  117,    0,  137,
  137,    0,    0,  137,    0,    0,    0,  118,    0,    0,
    0,    0,    0,   60,  119,  120,    0,    0,  137,    0,
    0,    0,  131,  137,  121,  122,  123,    0,  124,    0,
    0,  125,  126,  127,  128,    0,  109,    0,    0,  110,
    0,    0,    0,   52,   53,  111,  112,  113,    0,  114,
    0,  137,    0,  115,  138,    0,  116,  147,    0,  138,
  138,    0,    0,  138,    0,    0,    0,  118,    0,    0,
    0,    0,    0,   60,  119,  120,    0,    0,  138,    0,
    0,    0,  137,  138,  121,  122,  123,    0,  124,    0,
    0,  125,  126,  127,  128,    0,  109,    0,    0,  110,
    0,    0,    0,   52,   53,  111,  112,  113,    0,  114,
    0,  138,    0,  115,  139,    0,  143,  147,    0,  139,
  139,    0,    0,  139,    0,    0,    0,  118,    0,    0,
    0,    0,    0,   60,  119,  120,    0,    0,  139,    0,
    0,    0,  138,  139,  152,  122,  123,    0,  124,    0,
    0,  125,  126,  127,  128,  131,    0,    0,  131,    0,
    0,    0,  131,  131,  131,  131,  131,    0,  131,    0,
    0,  139,  131,    0,    0,  131,  131,    0,    0,    0,
  131,  131,  131,  131,  131,  131,  131,  131,  131,    0,
    0,    0,  131,  131,  131,    0,    0,    0,    0,    0,
    0,    0,  139,  131,  131,  131,    0,  131,    0,    0,
  131,  131,  131,  131,    0,  137,    0,    0,  137,    0,
    0,    0,  137,  137,  137,  137,  137,    0,  137,    0,
    0,    0,  137,    0,    0,  137,  137,    0,    0,    0,
  137,  137,  137,  137,  137,  137,  137,  137,  137,    0,
    0,    0,  137,  137,  137,    0,    0,    0,    0,    0,
    0,    0,    0,  137,  137,  137,    0,  137,    0,    0,
  137,  137,  137,  137,    0,  138,    0,    0,  138,    0,
    0,    0,  138,  138,  138,  138,  138,    0,  138,    0,
    0,    0,  138,    0,    0,  138,  138,    0,    0,    0,
  138,  138,  138,  138,  138,  138,  138,  138,  138,    0,
    0,    0,  138,  138,  138,    0,    0,    0,    0,    0,
    0,    0,    0,  138,  138,  138,    0,  138,    0,    0,
  138,  138,  138,  138,    0,  139,    0,    0,  139,    0,
    0,    0,  139,  139,  139,  139,  139,    0,  139,    0,
    0,    0,  139,    0,    0,  139,  139,    0,    0,    0,
  139,  139,  139,  139,  139,  139,  139,  139,  139,    0,
  140,    0,  139,  139,  139,  140,  140,    0,    0,  140,
    0,    0,    0,  139,  139,  139,    0,  139,    0,    0,
  139,  139,  139,  139,  140,    0,    0,    0,    0,  140,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  140,    0,    0,
  141,    0,    0,    0,    0,  141,  141,    0,    0,  141,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  141,    0,    0,    0,  140,  141,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  141,    0,    0,
  142,    0,    0,    0,    0,  142,  142,    0,    0,  142,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  142,    0,    0,    0,  141,  142,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  142,    0,    0,
  143,    0,    0,    0,    0,  143,  143,    0,    0,  143,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  143,    0,    0,    0,  142,  143,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  140,    0,    0,  140,    0,    0,    0,  140,  140,
  140,  140,  140,    0,  140,    0,    0,  143,  140,    0,
    0,  140,  140,    0,    0,    0,  140,  140,  140,  140,
  140,  140,  140,  140,  140,    0,    0,    0,  140,  140,
  140,    0,    0,    0,   87,    0,    0,    0,  143,  140,
  140,  140,    0,  140,   87,    0,  140,  140,  140,  140,
    0,  141,    0,    0,  141,    0,    0,    0,  141,  141,
  141,  141,  141,   87,  141,    0,    0,    0,  141,    0,
    0,  141,  141,    0,    0,    0,  141,  141,  141,  141,
  141,  141,  141,  141,  141,    0,    0,    0,  141,  141,
  141,   87,    0,    0,    0,    0,    0,    0,    0,  141,
  141,  141,    0,  141,    0,  173,  141,  141,  141,  141,
  173,  142,    0,    0,  142,  173,    0,    0,  142,  142,
  142,  142,  142,    0,  142,    0,    0,    0,  142,  173,
    0,  142,  142,    0,  173,    0,  142,  142,  142,  142,
  142,  142,  142,  142,  142,    0,    0,    0,  142,  142,
  142,    0,    0,    0,    0,    0,    0,    0,    0,  142,
  142,  142,  173,  142,    0,    0,  142,  142,  142,  142,
    0,  143,    0,    0,  143,    0,    0,    0,  143,  143,
  143,  143,  143,    0,  143,    0,    0,    0,  143,  144,
    0,  143,  143,  173,  144,  144,    0,    0,  144,    0,
    0,    0,  143,  143,  143,    0,    0,    0,  143,  143,
  143,    0,    0,  144,    0,    0,    0,    0,  144,  143,
  143,  143,    0,  143,    0,    0,  143,  143,  143,  143,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  144,    0,    0,  217,
    0,    0,    0,    0,  129,   87,    0,    0,   87,  130,
    0,    0,   87,   87,   87,   87,   87,    0,   87,    0,
    0,    0,   87,  304,    0,   87,   87,  144,  218,    0,
    0,    0,    0,    0,    0,    0,   87,    0,    0,    0,
    0,    0,   87,   87,   87,    0,    0,    0,    0,    0,
    0,    0,    0,   87,   87,   87,  219,   87,    0,    0,
   87,   87,   87,   87,    0,    0,  173,    0,    0,    0,
    0,  173,    0,    0,    0,    0,  173,    0,    0,  173,
    0,    0,    0,  173,  173,  173,  173,  173,    0,  173,
  173,    0,    0,  173,    0,  173,  173,  173,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  173,    0,    0,
    0,    0,    0,  173,  173,  173,    0,    0,    0,    0,
    0,    0,    0,  173,  173,  173,  173,    0,  173,    0,
    0,  173,  173,  173,  173,  182,    0,    0,    0,    0,
  182,    0,    0,    0,    0,  182,    0,    0,    0,    0,
    0,    0,    0,    0,  173,    0,    0,    0,    0,  182,
  144,    0,    0,  144,  182,    0,    0,  144,  144,  144,
  144,  144,    0,  144,    0,    0,    0,  144,    0,    0,
  144,  144,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  144,  182,  144,    0,  217,    0,  144,  144,  144,
  129,    0,    0,    0,    0,  130,    0,    0,  144,  144,
  144,    0,  144,    0,    0,  144,  144,  144,  144,    0,
  109,    0,    0,  110,  218,    0,    0,   52,   53,  111,
  112,  113,    0,  114,    0,    0,    0,  115,    0,    0,
  116,  117,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  118,  219,    0,    0,    0,    0,   60,  119,  120,
    0,    0,    0,    0,    0,    0,    0,    0,  121,  122,
  123,    0,  124,    0,    0,  125,  126,  127,  128,    0,
    0,    0,   67,    0,    0,    0,    0,  173,    0,    0,
  173,    0,    0,    0,  173,  173,  173,  173,  173,    0,
  173,    0,    0,    0,  173,  122,    0,  173,  173,  122,
  122,  122,    0,  122,    0,  122,    0,    0,  173,    0,
    0,    0,    0,    0,  173,  173,  173,  122,    0,    0,
    0,    0,    0,    0,    0,  173,  173,  173,    0,  173,
    0,    0,  173,  173,  173,  173,   41,    0,   99,    0,
    0,    0,    0,    0,    0,    0,  182,    0,    0,  182,
    0,    0,  122,  182,  182,  182,  182,  182,    0,  182,
    0,    0,    0,  182,    0,  203,  182,  182,  203,  203,
  203,  203,  203,  203,    0,  203,    0,  182,    0,    0,
    0,    0,    0,  182,  182,  182,    0,  203,    0,    0,
    0,    0,    0,    0,  182,  182,  182,    0,  182,    0,
    0,  182,  182,  182,  182,    0,  109,    0,    0,  110,
    0,    0,    0,   52,   53,  111,  112,  113,    0,  114,
    0,    0,  203,  115,    0,  202,  116,  117,  202,  202,
  202,  202,  202,  202,    0,  202,    0,  118,    0,    0,
    0,    0,    0,   60,  119,  120,    0,  202,    0,    0,
    0,  203,    0,    0,  121,  122,  123,    0,  124,    0,
    0,  125,  126,  127,  128,    0,    0,    0,    0,   49,
    0,    0,    0,   50,   51,    0,   52,   53,    0,    0,
    0,   54,  202,    0,    0,    0,    0,    0,   55,   56,
   57,    0,    0,   58,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   59,   60,   89,    0,    0,
   61,  202,    0,    0,    0,    0,    0,   62,    0,    0,
   63,    0,   64,   65,    0,    0,    0,    0,    0,   66,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  122,
  122,  122,  122,  122,  122,    0,  122,  122,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   67,    0,    0,    0,    0,    0,
    0,   89,    0,   89,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  203,    0,    0,  203,    0,    0,
    0,  203,  203,  203,  203,  203,    0,  203,    0,    0,
    0,  203,    0,    0,    0,    0,    0,    0,    0,  203,
  203,  203,  203,  203,  203,  203,  203,  203,    0,    0,
    0,  203,  203,  203,    0,    0,    0,    0,   41,    0,
    0,    0,    0,  203,  203,    0,  203,    0,    0,  203,
  203,  203,  203,    0,    0,    0,    0,  202,    0,    0,
    0,  202,  202,  202,  202,  202,    0,  202,  195,    0,
    0,  202,  190,  193,  191,    0,  192,    0,  194,  202,
  202,  202,  202,  202,  202,  202,  202,  202,    0,    0,
  195,  202,  202,  202,  256,  193,  191,    0,  192,    0,
  194,    0,    0,  202,  202,    0,  202,    0,    0,  202,
  202,  202,  202,    0,   89,    0,    0,    0,   89,   89,
    0,   89,   89,    0,    0,  196,   89,    0,    0,    0,
    0,    0,    0,   89,   89,   89,  195,    0,   89,    0,
  323,  193,  191,    0,  192,    0,  194,  196,  195,    0,
   89,   89,  325,  193,  191,   89,  192,    0,  194,    0,
    0,    0,   89,    0,    0,   89,    0,   89,   89,    0,
    0,   49,    0,    0,   89,   50,   51,    0,   52,   53,
    0,    0,    0,   54,    0,    0,    0,    0,    0,    0,
   55,   56,   57,  196,  195,   58,    0,    0,  331,  193,
  191,    0,  192,    0,  194,  196,    0,   59,   60,    0,
  195,    0,   61,    0,  406,  193,  191,    0,  192,   62,
  194,    0,   63,    0,   64,   65,    0,    0,    0,    0,
    0,   66,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  196,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  196,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  182,  183,  184,  185,  186,  187,    0,  188,
  189,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  182,  183,  184,  185,  186,  187,
    0,  188,  189,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  182,  183,  184,  185,  186,  187,    0,  188,  189,    0,
    0,    0,  182,  183,  184,  185,  186,  187,    0,  188,
  189,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  182,  183,
  184,  185,  186,  187,    0,  188,  189,    0,    0,    0,
    0,    0,    0,    0,  182,  183,  184,  185,  186,  187,
    0,  188,  189,
};
short yycheck[] = {                                      13,
   14,   28,   80,   30,   41,   88,   94,   59,  256,   94,
   35,   89,   37,   35,  256,   40,   41,   42,   43,   44,
   45,   69,   47,  218,  256,  256,   76,  256,  276,  277,
   22,  256,   69,   46,   59,  276,  277,   41,   37,   64,
  118,  129,   64,   42,   40,   58,  129,   39,   47,   59,
  277,  129,  130,   89,   41,   59,  304,   44,  108,  301,
  291,  144,  291,  304,  142,  153,   37,   92,  300,   94,
   92,   42,   43,   35,   45,   37,   47,  302,  303,   41,
   42,   43,   44,   45,   41,   47,   43,  165,  136,  167,
  222,  223,  279,  129,   41,   94,  174,   59,  123,  136,
  295,  296,   64,   41,  182,  183,  184,  185,  186,  187,
  188,  189,   59,  191,  192,  193,  194,  195,  196,  204,
  205,   59,   46,   94,   41,   41,  304,   44,   44,   40,
   92,   41,   94,   43,   58,  259,  271,  272,   35,   41,
   37,   43,  220,   40,   41,   42,   43,   44,   45,   76,
   47,  310,  311,   80,   40,  281,  282,   84,  276,   40,
   59,  123,   59,  298,  299,  213,  243,   64,  123,   41,
  247,  248,   44,  305,  306,  307,  213,   41,   61,   41,
   44,  108,   44,  277,  304,  112,  257,  258,  215,  116,
  276,  350,  351,  352,   41,   92,   40,   44,   41,  270,
   40,   44,   41,  274,  256,   44,   40,  278,   35,  280,
   37,   59,   40,   40,   41,   42,   43,   44,   45,  290,
   47,   41,   41,   61,   44,   44,  123,   41,   61,   59,
   44,  256,   59,   40,  259,  313,   59,   64,  263,  264,
  265,  266,  267,   61,  269,   40,   59,   40,  273,  301,
   40,  276,  277,   59,  276,  277,  281,  282,  283,  284,
  285,  286,  287,  288,  289,   92,  259,   59,  293,  294,
  295,   59,  299,   59,  279,   40,   76,   77,   78,  304,
  305,  306,  304,  308,  332,   43,  311,  312,  313,  314,
  279,   41,   40,   43,  256,  332,  123,  259,  279,  279,
   35,  263,  264,  265,  266,  267,  279,  269,  304,  305,
  306,  273,  390,  273,  276,  277,  312,   40,  314,  281,
  282,  283,  284,  285,  286,  287,  288,  289,   40,   64,
   40,  293,  294,  295,  281,  282,  283,  284,  285,  286,
   41,   40,  304,  305,  306,   41,  308,   40,   40,  311,
  312,  313,  314,   40,   40,   37,  383,   92,   41,  256,
   42,   43,  259,   45,   40,   47,  263,  264,  265,  266,
  267,   40,  269,   40,   59,   41,  273,   41,  405,  276,
  277,   43,   41,  397,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  304,  305,  306,  293,  294,  295,   41,
   40,  312,   40,  314,   94,   40,  262,  304,  305,  306,
   41,  308,   94,   41,  311,  312,  313,  314,  304,  305,
  306,   41,  308,  304,  305,  306,  312,  308,  314,  256,
   41,  312,  259,  314,   59,   59,  263,  264,  265,  266,
  267,   41,  269,   41,   41,   41,  273,   43,   41,  276,
  277,  123,  315,  123,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   59,   44,  291,  293,  294,  295,   41,
  259,   41,  259,  266,  259,  259,  269,  304,  305,  306,
  273,  308,  259,  276,  311,  312,  313,  314,   35,   45,
   37,   40,  259,   40,   41,   42,   43,   44,   45,  296,
   47,  266,  295,  259,  269,  259,  125,  259,  273,  125,
  259,  276,   59,  259,  259,  125,  125,   64,  311,   61,
  123,  256,  123,  281,  282,  283,  284,  285,  286,   59,
  295,  281,  282,  283,  284,  285,  286,   59,   59,   59,
   59,  276,  277,   41,   41,   92,  311,   59,   35,   59,
   37,  259,  125,   40,   41,   42,   43,   44,   45,  125,
   47,  125,  125,   59,   20,   37,   10,    3,   58,  304,
   42,   43,   59,   45,  161,   47,  123,   64,  318,  362,
  281,  282,  283,  284,  285,  286,  281,  282,  283,  284,
  285,  286,  163,  364,   82,  297,  137,  220,  340,  281,
  282,  283,  284,  285,  286,   92,  288,  289,   35,   -1,
   37,  299,  376,   40,   41,   42,   43,   44,   45,   -1,
   47,   -1,   94,   -1,   -1,   37,  256,  257,  258,   -1,
   42,   43,   59,   45,   -1,   47,  123,   64,   -1,   -1,
  270,   -1,   -1,   -1,  274,   -1,   -1,   -1,  278,   -1,
  280,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  290,   -1,   -1,   -1,   -1,   92,   -1,   -1,   35,   -1,
   37,   -1,   -1,   40,   41,   42,   43,   44,   45,   -1,
   47,   -1,   94,   -1,   -1,  281,  282,  283,  284,  285,
  286,   -1,   59,   -1,   -1,   -1,  123,   64,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,
   -1,   -1,  259,   -1,   -1,   -1,  263,  264,  265,  266,
  267,   -1,  269,   -1,   -1,   92,  273,   -1,   -1,  276,
  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,  293,  294,  295,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  123,  304,  305,  306,
   -1,  308,   -1,   -1,  311,  312,  313,  314,   -1,  256,
   -1,   -1,  259,   -1,   -1,   -1,  263,  264,  265,  266,
  267,   -1,  269,   -1,   -1,   -1,  273,   -1,   -1,  276,
  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,  293,  294,  295,  281,
  282,  283,  284,  285,  286,   -1,  288,  304,  305,  306,
   -1,  308,   -1,   -1,  311,  312,  313,  314,   -1,  256,
   -1,   -1,  259,   -1,   -1,   -1,  263,  264,  265,  266,
  267,   -1,  269,   -1,   -1,   -1,  273,   -1,   -1,  276,
  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,  293,  294,  295,  281,
  282,  283,  284,  285,  286,   -1,   -1,  304,  305,  306,
   -1,  308,   -1,   -1,  311,  312,  313,  314,   -1,  256,
   -1,   -1,  259,   -1,   -1,   -1,  263,  264,  265,  266,
  267,   -1,  269,   -1,   -1,   -1,  273,   -1,   -1,  276,
  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,  293,  294,  295,   -1,
   -1,   -1,   94,   -1,   -1,   -1,   -1,  304,  305,  306,
   -1,  308,   -1,   -1,  311,  312,  313,  314,   35,   -1,
   37,   -1,   -1,   40,   41,   42,   -1,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,  129,   -1,   -1,
   -1,   -1,   59,   -1,   -1,   -1,   -1,   64,   -1,   -1,
  142,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  153,   -1,   -1,   -1,  157,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   92,   -1,   94,   35,  171,
   37,  173,   -1,   40,   41,   42,   -1,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   -1,   -1,   -1,  123,   64,   -1,   -1,
   -1,   -1,  204,  205,  206,  207,  208,  209,  210,  211,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  220,   -1,
   -1,   -1,   -1,   -1,   -1,   92,   -1,   94,   35,   -1,
   37,   -1,   -1,   40,   41,   42,   -1,   44,   45,   -1,
   47,  243,   -1,   -1,   -1,  247,  248,   -1,   -1,   -1,
   -1,   -1,   59,   -1,   -1,   -1,  123,   64,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   92,   -1,   94,   35,   -1,
   37,   -1,   -1,   40,   41,   42,   -1,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  313,   59,   -1,   -1,   -1,  123,   64,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,
   -1,   -1,  259,   -1,   -1,   -1,  263,  264,  265,  266,
  267,   -1,  269,   -1,   -1,   92,  273,   94,   -1,  276,
  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,  293,  294,  295,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  123,  304,  305,  306,
   -1,  308,   -1,   -1,  311,  312,  313,  314,   -1,  256,
   -1,   -1,  259,   -1,   -1,   -1,  263,  264,  265,  266,
  267,   -1,  269,   -1,   -1,   -1,  273,   -1,   -1,  276,
  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,  293,  294,  295,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  304,  305,  306,
   -1,  308,   -1,   -1,  311,  312,  313,  314,   -1,  256,
   -1,   -1,  259,   -1,   -1,   -1,  263,  264,  265,  266,
  267,   -1,  269,   -1,   -1,   -1,  273,   -1,   -1,  276,
  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,  293,  294,  295,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  304,  305,  306,
   -1,  308,   -1,   -1,  311,  312,  313,  314,   -1,  256,
   -1,   -1,  259,   -1,   -1,   -1,  263,  264,  265,  266,
  267,   -1,  269,   -1,   -1,   -1,  273,   -1,   -1,  276,
  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,  293,  294,  295,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  304,  305,  306,
   -1,  308,   -1,   -1,  311,  312,  313,  314,   35,   -1,
   37,   -1,   -1,   40,   41,   42,   -1,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   -1,   -1,   -1,   -1,   64,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   88,   -1,   92,   -1,   94,   35,   -1,
   37,   -1,   -1,   40,   41,   42,   -1,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   -1,   -1,   -1,  123,   64,   -1,   -1,
   -1,   -1,   -1,   -1,  129,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  142,   -1,  144,
   -1,   -1,   -1,   -1,   -1,   92,   -1,   94,   35,   -1,
   37,   -1,  157,   40,   41,   42,   43,   44,   45,   -1,
   47,  166,   -1,   -1,   -1,   -1,   -1,  172,   -1,   -1,
   -1,   -1,   59,   -1,   -1,   -1,  123,   64,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  197,  198,  199,  200,  201,  202,  203,   -1,
   -1,   -1,   -1,   -1,   -1,   92,   -1,   94,   35,   -1,
   -1,   -1,   -1,   40,   41,  220,   43,   44,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   -1,   -1,   -1,  123,   64,  243,   -1,
   -1,   -1,  247,  248,   -1,   -1,   -1,   -1,   -1,  256,
   -1,   -1,  259,   -1,   -1,   -1,  263,  264,  265,  266,
  267,   -1,  269,   -1,   -1,   92,  273,   -1,   -1,  276,
  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,  293,  294,  295,   -1,
   40,   -1,   -1,   -1,   -1,   45,  123,  304,  305,  306,
   -1,  308,   -1,   -1,  311,  312,  313,  314,  313,  256,
   -1,   -1,  259,   -1,   -1,   -1,  263,  264,  265,  266,
  267,   -1,  269,   -1,   -1,   -1,  273,   -1,   -1,  276,
  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,  293,  294,  295,   -1,
   40,   -1,   -1,   -1,   -1,   45,   -1,  304,  305,  306,
   -1,  308,   -1,   -1,  311,  312,  313,  314,   -1,  256,
   -1,   -1,  259,   -1,   -1,   -1,  263,  264,  265,  266,
  267,   -1,  269,   -1,   -1,   -1,  273,   -1,   -1,  276,
  277,   -1,   -1,   -1,   -1,   -1,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,  293,  294,  295,   -1,
   40,   -1,   -1,   -1,   -1,   45,   -1,  304,  305,  306,
   -1,  308,   -1,   -1,  311,  312,  313,  314,   -1,  256,
   -1,   -1,  259,   -1,   -1,   -1,  263,  264,  265,  266,
  267,   -1,  269,   -1,   -1,   -1,  273,   -1,   -1,  276,
  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   -1,   35,   -1,  293,  294,  295,   40,
   41,   -1,   43,   44,   45,   -1,   -1,  304,  305,  306,
   -1,  308,   -1,   -1,  311,  312,  313,  314,   59,   -1,
   -1,   -1,   -1,   64,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,   -1,  259,
   -1,   -1,   -1,  263,  264,  265,  266,  267,   -1,  269,
   -1,   92,   -1,  273,   35,   -1,  276,  277,   -1,   40,
   41,   -1,   -1,   44,   -1,   -1,   -1,  287,   -1,   -1,
   -1,   -1,   -1,  293,  294,  295,   -1,   -1,   59,   -1,
   -1,   -1,  123,   64,  304,  305,  306,   -1,  308,   -1,
   -1,  311,  312,  313,  314,   -1,  256,   -1,   -1,  259,
   -1,   -1,   -1,  263,  264,  265,  266,  267,   -1,  269,
   -1,   92,   -1,  273,   35,   -1,  276,  277,   -1,   40,
   41,   -1,   -1,   44,   -1,   -1,   -1,  287,   -1,   -1,
   -1,   -1,   -1,  293,  294,  295,   -1,   -1,   59,   -1,
   -1,   -1,  123,   64,  304,  305,  306,   -1,  308,   -1,
   -1,  311,  312,  313,  314,   -1,  256,   -1,   -1,  259,
   -1,   -1,   -1,  263,  264,  265,  266,  267,   -1,  269,
   -1,   92,   -1,  273,   35,   -1,  276,  277,   -1,   40,
   41,   -1,   -1,   44,   -1,   -1,   -1,  287,   -1,   -1,
   -1,   -1,   -1,  293,  294,  295,   -1,   -1,   59,   -1,
   -1,   -1,  123,   64,  304,  305,  306,   -1,  308,   -1,
   -1,  311,  312,  313,  314,  256,   -1,   -1,  259,   -1,
   -1,   -1,  263,  264,  265,  266,  267,   -1,  269,   -1,
   -1,   92,  273,   -1,   -1,  276,  277,   -1,   -1,   -1,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,  293,  294,  295,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  123,  304,  305,  306,   -1,  308,   -1,   -1,
  311,  312,  313,  314,   -1,  256,   -1,   -1,  259,   -1,
   -1,   -1,  263,  264,  265,  266,  267,   -1,  269,   -1,
   -1,   -1,  273,   -1,   -1,  276,  277,   -1,   -1,   -1,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,  293,  294,  295,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  304,  305,  306,   -1,  308,   -1,   -1,
  311,  312,  313,  314,   -1,  256,   -1,   -1,  259,   -1,
   -1,   -1,  263,  264,  265,  266,  267,   -1,  269,   -1,
   -1,   -1,  273,   -1,   -1,  276,  277,   -1,   -1,   -1,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,  293,  294,  295,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  304,  305,  306,   -1,  308,   -1,   -1,
  311,  312,  313,  314,   -1,  256,   -1,   -1,  259,   -1,
   -1,   -1,  263,  264,  265,  266,  267,   -1,  269,   -1,
   -1,   -1,  273,   -1,   -1,  276,  277,   -1,   -1,   -1,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   35,   -1,  293,  294,  295,   40,   41,   -1,   -1,   44,
   -1,   -1,   -1,  304,  305,  306,   -1,  308,   -1,   -1,
  311,  312,  313,  314,   59,   -1,   -1,   -1,   -1,   64,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   92,   -1,   -1,
   35,   -1,   -1,   -1,   -1,   40,   41,   -1,   -1,   44,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,  123,   64,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   92,   -1,   -1,
   35,   -1,   -1,   -1,   -1,   40,   41,   -1,   -1,   44,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,  123,   64,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   92,   -1,   -1,
   35,   -1,   -1,   -1,   -1,   40,   41,   -1,   -1,   44,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,  123,   64,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  256,   -1,   -1,  259,   -1,   -1,   -1,  263,  264,
  265,  266,  267,   -1,  269,   -1,   -1,   92,  273,   -1,
   -1,  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,
  285,  286,  287,  288,  289,   -1,   -1,   -1,  293,  294,
  295,   -1,   -1,   -1,   35,   -1,   -1,   -1,  123,  304,
  305,  306,   -1,  308,   45,   -1,  311,  312,  313,  314,
   -1,  256,   -1,   -1,  259,   -1,   -1,   -1,  263,  264,
  265,  266,  267,   64,  269,   -1,   -1,   -1,  273,   -1,
   -1,  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,
  285,  286,  287,  288,  289,   -1,   -1,   -1,  293,  294,
  295,   92,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  304,
  305,  306,   -1,  308,   -1,   35,  311,  312,  313,  314,
   40,  256,   -1,   -1,  259,   45,   -1,   -1,  263,  264,
  265,  266,  267,   -1,  269,   -1,   -1,   -1,  273,   59,
   -1,  276,  277,   -1,   64,   -1,  281,  282,  283,  284,
  285,  286,  287,  288,  289,   -1,   -1,   -1,  293,  294,
  295,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  304,
  305,  306,   92,  308,   -1,   -1,  311,  312,  313,  314,
   -1,  256,   -1,   -1,  259,   -1,   -1,   -1,  263,  264,
  265,  266,  267,   -1,  269,   -1,   -1,   -1,  273,   35,
   -1,  276,  277,  123,   40,   41,   -1,   -1,   44,   -1,
   -1,   -1,  287,  288,  289,   -1,   -1,   -1,  293,  294,
  295,   -1,   -1,   59,   -1,   -1,   -1,   -1,   64,  304,
  305,  306,   -1,  308,   -1,   -1,  311,  312,  313,  314,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   92,   -1,   -1,   35,
   -1,   -1,   -1,   -1,   40,  256,   -1,   -1,  259,   45,
   -1,   -1,  263,  264,  265,  266,  267,   -1,  269,   -1,
   -1,   -1,  273,   59,   -1,  276,  277,  123,   64,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  287,   -1,   -1,   -1,
   -1,   -1,  293,  294,  295,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  304,  305,  306,   92,  308,   -1,   -1,
  311,  312,  313,  314,   -1,   -1,   35,   -1,   -1,   -1,
   -1,   40,   -1,   -1,   -1,   -1,  256,   -1,   -1,  259,
   -1,   -1,   -1,  263,  264,  265,  266,  267,   -1,  269,
   59,   -1,   -1,  273,   -1,   64,  276,  277,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  287,   -1,   -1,
   -1,   -1,   -1,  293,  294,  295,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   92,  304,  305,  306,   -1,  308,   -1,
   -1,  311,  312,  313,  314,   35,   -1,   -1,   -1,   -1,
   40,   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  123,   -1,   -1,   -1,   -1,   59,
  256,   -1,   -1,  259,   64,   -1,   -1,  263,  264,  265,
  266,  267,   -1,  269,   -1,   -1,   -1,  273,   -1,   -1,
  276,  277,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  287,   92,  289,   -1,   35,   -1,  293,  294,  295,
   40,   -1,   -1,   -1,   -1,   45,   -1,   -1,  304,  305,
  306,   -1,  308,   -1,   -1,  311,  312,  313,  314,   -1,
  256,   -1,   -1,  259,   64,   -1,   -1,  263,  264,  265,
  266,  267,   -1,  269,   -1,   -1,   -1,  273,   -1,   -1,
  276,  277,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  287,   92,   -1,   -1,   -1,   -1,  293,  294,  295,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  304,  305,
  306,   -1,  308,   -1,   -1,  311,  312,  313,  314,   -1,
   -1,   -1,   59,   -1,   -1,   -1,   -1,  256,   -1,   -1,
  259,   -1,   -1,   -1,  263,  264,  265,  266,  267,   -1,
  269,   -1,   -1,   -1,  273,   37,   -1,  276,  277,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,  287,   -1,
   -1,   -1,   -1,   -1,  293,  294,  295,   59,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  304,  305,  306,   -1,  308,
   -1,   -1,  311,  312,  313,  314,  123,   -1,  125,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,   -1,  259,
   -1,   -1,   94,  263,  264,  265,  266,  267,   -1,  269,
   -1,   -1,   -1,  273,   -1,   37,  276,  277,   40,   41,
   42,   43,   44,   45,   -1,   47,   -1,  287,   -1,   -1,
   -1,   -1,   -1,  293,  294,  295,   -1,   59,   -1,   -1,
   -1,   -1,   -1,   -1,  304,  305,  306,   -1,  308,   -1,
   -1,  311,  312,  313,  314,   -1,  256,   -1,   -1,  259,
   -1,   -1,   -1,  263,  264,  265,  266,  267,   -1,  269,
   -1,   -1,   94,  273,   -1,   37,  276,  277,   40,   41,
   42,   43,   44,   45,   -1,   47,   -1,  287,   -1,   -1,
   -1,   -1,   -1,  293,  294,  295,   -1,   59,   -1,   -1,
   -1,  123,   -1,   -1,  304,  305,  306,   -1,  308,   -1,
   -1,  311,  312,  313,  314,   -1,   -1,   -1,   -1,  256,
   -1,   -1,   -1,  260,  261,   -1,  263,  264,   -1,   -1,
   -1,  268,   94,   -1,   -1,   -1,   -1,   -1,  275,  276,
  277,   -1,   -1,  280,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  292,  293,   59,   -1,   -1,
  297,  123,   -1,   -1,   -1,   -1,   -1,  304,   -1,   -1,
  307,   -1,  309,  310,   -1,   -1,   -1,   -1,   -1,  316,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  281,
  282,  283,  284,  285,  286,   -1,  288,  289,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,
   -1,  123,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  256,   -1,   -1,  259,   -1,   -1,
   -1,  263,  264,  265,  266,  267,   -1,  269,   -1,   -1,
   -1,  273,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  281,
  282,  283,  284,  285,  286,  287,  288,  289,   -1,   -1,
   -1,  293,  294,  295,   -1,   -1,   -1,   -1,  123,   -1,
   -1,   -1,   -1,  305,  306,   -1,  308,   -1,   -1,  311,
  312,  313,  314,   -1,   -1,   -1,   -1,  259,   -1,   -1,
   -1,  263,  264,  265,  266,  267,   -1,  269,   37,   -1,
   -1,  273,   41,   42,   43,   -1,   45,   -1,   47,  281,
  282,  283,  284,  285,  286,  287,  288,  289,   -1,   -1,
   37,  293,  294,  295,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,  305,  306,   -1,  308,   -1,   -1,  311,
  312,  313,  314,   -1,  256,   -1,   -1,   -1,  260,  261,
   -1,  263,  264,   -1,   -1,   94,  268,   -1,   -1,   -1,
   -1,   -1,   -1,  275,  276,  277,   37,   -1,  280,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   94,   37,   -1,
  292,  293,   41,   42,   43,  297,   45,   -1,   47,   -1,
   -1,   -1,  304,   -1,   -1,  307,   -1,  309,  310,   -1,
   -1,  256,   -1,   -1,  316,  260,  261,   -1,  263,  264,
   -1,   -1,   -1,  268,   -1,   -1,   -1,   -1,   -1,   -1,
  275,  276,  277,   94,   37,  280,   -1,   -1,   41,   42,
   43,   -1,   45,   -1,   47,   94,   -1,  292,  293,   -1,
   37,   -1,  297,   -1,   41,   42,   43,   -1,   45,  304,
   47,   -1,  307,   -1,  309,  310,   -1,   -1,   -1,   -1,
   -1,  316,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  281,  282,  283,  284,  285,  286,   -1,  288,
  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  281,  282,  283,  284,  285,  286,
   -1,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  281,  282,  283,  284,  285,  286,   -1,  288,  289,   -1,
   -1,   -1,  281,  282,  283,  284,  285,  286,   -1,  288,
  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  281,  282,
  283,  284,  285,  286,   -1,  288,  289,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  281,  282,  283,  284,  285,  286,
   -1,  288,  289,
};
#define YYFINAL 9
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 317
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,"'#'",0,"'%'",0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,0,
0,0,0,0,"':'","';'",0,"'='",0,0,"'@'",0,0,0,0,0,0,0,0,0,0,0,"'L'",0,0,0,"'P'",0,
0,0,"'T'",0,0,0,0,0,0,0,"'\\\\'",0,"'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,"'l'",0,0,0,
"'p'",0,0,0,"'t'",0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"KEEP","DROP",
"NUMBER","IF","WHILE","ELSE","SREAD","EREAD","FUNCAO","FTOA","ATOF","STOP",
"MNT","MYFILE","SOPEN","EOPEN","VALSTR","FLOAT","PRINT","VARSTR","VARNUM",
"DATE","VARFIL","RDEBUG","EQ","NEQ","LT","LE","GT","GE","NOT","AND","OR",
"STRING","NOMEARQ","CONTINUE","OUTPUT","CONST","FUNCAOS","MODO","ABORT","CONCV",
"CONCH","CHAVE","ORD","ASC","DESC","VARDATA","VALDATA","FUNCAOD","FUNCAOV",
"MISSNUM","REWIND","BREAK","DTOA","ATOD","DTOF","FTOD","WHERE","PAUSE",
"UNARYMINUS",
};
char *yyrule[] = {
"$accept : pgm",
"pgm : dcls dclsend inicia bloco",
"$$1 :",
"pgm : $$1 inicia bloco",
"pgm : error",
"inicia :",
"dcls : dcl ';'",
"dcls : dcls dcl ';'",
"dcl : KEEP inikd lista_de_var",
"dcl : DROP inikd lista_de_var",
"dcl : FLOAT perf lista_de_var_n",
"dcl : DATE perd lista_de_var_d",
"dcl : STRING pers lista_de_var_s",
"dcl : MYFILE defil VARFIL '=' opcao",
"dcl : RDEBUG xdeb NUMBER",
"xdeb :",
"inikd :",
"defil :",
"dclsend :",
"perf :",
"perd :",
"pers :",
"lista_de_var_op :",
"lista_de_var_op : lista_de_var",
"lista_de_var : variavel",
"lista_de_var : lista_de_var variavel",
"lista_de_var : error",
"variavel : VARNUM",
"variavel : VARSTR",
"variavel : VARDATA",
"lista_de_var_d : VARDATA",
"lista_de_var_d : lista_de_var_d VARDATA",
"lista_de_var_n : VARNUM",
"lista_de_var_n : lista_de_var_n VARNUM",
"lista_de_var_s : VARSTR",
"lista_de_var_s : lista_de_var_s VARSTR",
"opcao : SOPEN nomarq '(' nome_do_arq ')' lvar lista_de_var_op",
"opcao : EOPEN nomarq '(' nome_do_arq ')' lvar lista_de_var_op",
"$$2 :",
"opcao : CONCV nomarq '(' lista_arq $$2 ')' chave",
"$$3 :",
"opcao : CONCH nomarq '(' lista_arq $$3 ')' chave",
"nomarq :",
"lvar :",
"nome_do_arq : NOMEARQ",
"$$4 :",
"$$5 :",
"nome_do_arq : NOMEARQ $$4 ',' $$5 MODO",
"nome_do_arq : error",
"lista_arq : NOMEARQ",
"lista_arq : lista_arq NOMEARQ",
"lista_arq : error",
"chave :",
"$$6 :",
"$$7 :",
"chave : CHAVE $$6 lista_de_var $$7 ord",
"chave : error",
"ord :",
"$$8 :",
"ord : ORD $$8 '=' tipoOrd",
"ord : error",
"tipoOrd : ASC",
"tipoOrd : DESC",
"tipoOrd : error",
"bloco : '{' cmds '}'",
"cmds : cmd",
"cmds : cmds cmd",
"cmd : atribnum ';'",
"cmd : atribstr ';'",
"cmd : atribdat ';'",
"cmd : IF cond start cmd else",
"cmd : WHILE end cond start cmd",
"cmd : BREAK ';'",
"cmd : entsai ';'",
"$$9 :",
"cmd : PRINT unidadep $$9 itens ';'",
"cmd : PAUSE '(' VALSTR ')' ';'",
"cmd : REWIND '(' VARFIL ')' ';'",
"cmd : CONTINUE ';'",
"cmd : STOP ';'",
"cmd : ABORT ';'",
"$$10 :",
"cmd : FUNCAOV $$10 '(' lista_de_exprs ')'",
"cmd : bloco",
"cmd : RDEBUG xdeb NUMBER ';'",
"cmd : ';'",
"cmd : error",
"unidadep :",
"unidadep : '(' VARFIL ')'",
"else :",
"else : ELSE starte cmd",
"atribnum : VARNUM '=' expr",
"atribnum : VARNUM '=' atribnum",
"atribstr : VARSTR '=' exprs",
"atribstr : VARSTR '=' atribstr",
"atribdat : VARDATA '=' exprd",
"atribdat : VARDATA '=' missval",
"atribdat : VARDATA '=' atribdat",
"start :",
"starte :",
"cond : '(' expr ')'",
"end :",
"exprd : VALDATA",
"exprd : VARDATA",
"exprd : '(' atribdat ')'",
"$$11 :",
"exprd : FUNCAOD $$11 '(' lista_de_exprs ')'",
"exprd : ATOD '(' exprs ')'",
"exprd : FTOD '(' expr ')'",
"exprd : '(' exprd ')'",
"exprs : VALSTR",
"exprs : VARSTR",
"exprs : '(' atribstr ')'",
"exprs : exprs '+' exprs",
"$$12 :",
"exprs : FUNCAOS $$12 '(' lista_de_exprs ')'",
"exprs : FTOA '(' expr ')'",
"exprs : DTOA '(' exprd ')'",
"exprs : MNT '(' expr ')'",
"exprs : '(' exprs ')'",
"expr : NUMBER",
"expr : CONST",
"expr : VARNUM",
"expr : missval",
"expr : '(' atribnum ')'",
"$$13 :",
"expr : FUNCAO $$13 '(' lista_de_exprs ')'",
"expr : entsai",
"expr : ATOF '(' exprs ')'",
"expr : DTOF '(' exprd ')'",
"expr : expr '+' expr",
"expr : expr '-' expr",
"expr : '-' expr",
"expr : expr '*' expr",
"expr : expr '/' expr",
"expr : expr '%' expr",
"expr : expr '^' expr",
"expr : expr EQ expr",
"expr : expr NEQ expr",
"expr : expr LT expr",
"expr : expr LE expr",
"expr : expr GT expr",
"expr : expr GE expr",
"expr : expr AND expr",
"expr : expr OR expr",
"expr : NOT expr",
"expr : '(' expr ')'",
"expr : exprd EQ exprd",
"expr : exprd EQ missval",
"expr : missval EQ exprd",
"expr : exprd NEQ exprd",
"expr : exprd NEQ missval",
"expr : missval NEQ exprd",
"expr : exprd LT exprd",
"expr : exprd LE exprd",
"expr : exprd GT exprd",
"expr : exprd GE exprd",
"expr : exprs EQ exprs",
"expr : exprs NEQ exprs",
"expr : exprs LT exprs",
"expr : exprs LE exprs",
"expr : exprs GT exprs",
"expr : exprs GE exprs",
"expr : error",
"missval : MISSNUM",
"itens : controle",
"itens : exprd formnum formato",
"itens : exprs formnum formato",
"itens : expr formnum formato",
"itens : itens controle",
"itens : itens exprd formnum formato",
"itens : itens exprs formnum formato",
"itens : itens expr formnum formato",
"formnum :",
"controle : '#' numero NUMBER",
"controle : '@' numero NUMBER",
"controle : '\\\\' prtchar 'L'",
"controle : '\\\\' prtchar 'l'",
"controle : '\\\\' prtchar 'T'",
"controle : '\\\\' prtchar 't'",
"controle : '\\\\' prtchar 'P'",
"controle : '\\\\' prtchar 'p'",
"formato :",
"formato : '{' alinhamento NUMBER ':' NUMBER numdec '}'",
"formato : '{' alinhamento NUMBER decs '}'",
"alinhamento :",
"alinhamento : '-'",
"decs :",
"decs : '.' NUMBER",
"numdec :",
"numdec : NUMBER",
"prtchar :",
"numero :",
"lista_de_exprs :",
"lista_de_exprs : exprd",
"lista_de_exprs : exprs",
"lista_de_exprs : expr",
"lista_de_exprs : lista_de_exprs ',' exprd",
"lista_de_exprs : lista_de_exprs ',' exprs",
"lista_de_exprs : lista_de_exprs ',' expr",
"$$14 :",
"entsai : SREAD '(' VARFIL ')' $$14 whereblk",
"entsai : EREAD '(' setarq ')'",
"entsai : EREAD '(' setarq ')' itensr",
"entsai : OUTPUT",
"entsai : OUTPUT '(' VARFIL ')'",
"whereblk :",
"$$15 :",
"whereblk : WHERE $$15 '(' expr ')'",
"setarq : VARFIL",
"itensr : controler",
"itensr : variavel formnumr formator",
"itensr : itensr controler",
"itensr : itensr variavel formnumr formator",
"itensr : error",
"formnumr : '{'",
"controler : '#' numero NUMBER",
"controler : '@' numero NUMBER",
"controler : '\\\\' prtchar 'L'",
"controler : '\\\\' prtchar 'l'",
"formator : NUMBER ':' NUMBER numdecr '}'",
"formator : NUMBER decsr '}'",
"decsr :",
"decsr : '.' NUMBER",
"numdecr :",
"numdecr : NUMBER",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 2992 "genparse.y"
 	/* end of grammar */

int			VerificaTipoParametro(estrutura,ind,n_par)
struct funcwords 	*estrutura;
int			ind;
int			n_par;
{
}

int 	IncrementaPC(pc)
int	*pc;
{

#if defined(MSDOS) & !defined(DJGPP)
	if ( (*pc) >= 2047 ) {
	    execerror (PegaMsg (1160), "");
	}
#endif

	return((*pc)++);
}

/* End of genparse.y */

#line 1559 "y.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
#if defined(__STDC__)
yyparse(void)
#else
yyparse()
#endif
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 231 "genparse.y"
{
				/*
				** Fim do programa genese.
				*/

				pgm();
				return 0;
			}
break;
case 2:
#line 244 "genparse.y"
{
				flag_dcls = 1;
			}
break;
case 3:
#line 250 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tJMP\t1\n", pc);
#endif
				/*
				** Instrucao para parar a execucao do programa.
				*/

				ins[pc] = PARE;
				IncrementaPC(&pc);
				return 0;
			}
break;
case 4:
#line 264 "genparse.y"
{
				execerror( PegaMsg (3159), "");
			}
break;
case 5:
#line 270 "genparse.y"
{

			TipoParametro = Pil_Create(128);
		}
break;
case 8:
#line 294 "genparse.y"
{
				if (isdrop)
					execerror(PegaMsg (Msg[0]), "");
				iskeep = 1;
			}
break;
case 9:
#line 305 "genparse.y"
{
				if (iskeep)
					execerror(PegaMsg (Msg[0]), "");
				isdrop = 1;
			}
break;
case 10:
#line 316 "genparse.y"
{
				pervar = 0;	/* reseta pervar */
			}
break;
case 11:
#line 325 "genparse.y"
{
				pervar = 0;	/* reseta pervar */
			}
break;
case 12:
#line 334 "genparse.y"
{
				pervar = 0;	/* reseta pervar */
			}
break;
case 13:
#line 343 "genparse.y"
{
				/*
				** Testa o numero de arquivos.
				*/

				if (narqs >= MAXGENARQ - 1)
					execerror(PegaMsg (Msg[1]), "");

				/*
				** Seta o indice deste arq. no vetor de vars. 
				** do arquivo.
				*/

				varfil[narqs] = yyvsp[-2]; 

				/* tipo do arq. */

				tipofil[narqs] = (char) (yyvsp[0]); 

				/*
				** Arquivo do sistema ou externo: tipo da
				** variavel e' "a" e indica o indice deste
				** arquivo na tabela de arquivos.
				*/

				if (yyvsp[0]==1 || yyvsp[0]==2) {
					variavel[yyvsp[-2]].tipo = 'a';
					variavel[yyvsp[-2]].ptrval.ptra = narqs++;
				}
				else {

					/*
					** Arquivo p/ concatenacao: variavel
					** do tipo v ou h.
					*/

					if (yyvsp[0]==3)
						variavel[yyvsp[-2]].tipo = 'v';
					else
						variavel[yyvsp[-2]].tipo = 'h';

					/*
					** Indica o indice deste arquivo na
					** tabela de variaveis.
					*/

					variavel[yyvsp[-2]].ptrval.ptra = tarqs;

					/*
					** Indica que os arquivos com indices
					** de tarqs ate (narqs-tarqs) serao
					** usados na concatenacao do arquivo $3
					** e define o tipo de concatenacao
					** (v ou h).
					*/

					for(; tarqs<narqs ; tarqs++) {
						varfil[tarqs] = yyvsp[-2];
						tipofil[tarqs] = (char) (yyvsp[0]);
					}
				}

				pervar = 0;	/* reseta pervar */
			}
break;
case 14:
#line 414 "genparse.y"
{
				debug(yyvsp[0]);
			}
break;
case 15:
#line 421 "genparse.y"
{
				debflag = -1;
			}
break;
case 16:
#line 432 "genparse.y"
{
				pervar = 5;
			}
break;
case 17:
#line 443 "genparse.y"
{
				pervar = 3;
				tarqs  = narqs;
				yynch  = 0;
			}
break;
case 18:
#line 456 "genparse.y"
{
				/*
				** Termina bloco de declaracoes.
				** Prepara para iniciar comandos.
				*/

				dclsend();
				flag_dcls = 1;
			}
break;
case 19:
#line 473 "genparse.y"
{
				pervar = 1;
			}
break;
case 20:
#line 484 "genparse.y"
{
				pervar = 4;
			}
break;
case 21:
#line 495 "genparse.y"
{
				pervar = 2;
			}
break;
case 22:
#line 507 "genparse.y"
{
				yyval = 0;
			}
break;
case 23:
#line 512 "genparse.y"
{
				yyval = -1;
			}
break;
case 26:
#line 527 "genparse.y"
{

/* *** Padroniz. msg erro - Adriana 09/01/95
				execerror(
				"Lista de variaveis nao especificada","");
*** */

				execerror( PegaMsg (3027), "");
			}
break;
case 27:
#line 543 "genparse.y"
{
				listadevar(yyvsp[0]);
			}
break;
case 28:
#line 548 "genparse.y"
{
				listadevar(yyvsp[0]);
			}
break;
case 29:
#line 553 "genparse.y"
{
				listadevar(yyvsp[0]);
			}
break;
case 30:
#line 564 "genparse.y"
{
				listadevar(yyvsp[0]);
			}
break;
case 31:
#line 569 "genparse.y"
{
				listadevar(yyvsp[0]);
			}
break;
case 32:
#line 580 "genparse.y"
{
				listadevar(yyvsp[0]);
			}
break;
case 33:
#line 585 "genparse.y"
{
				listadevar(yyvsp[0]);
			}
break;
case 34:
#line 596 "genparse.y"
{
				listadevar(yyvsp[0]);
			}
break;
case 35:
#line 601 "genparse.y"
{
				listadevar(yyvsp[0]);
			}
break;
case 36:
#line 616 "genparse.y"
{
				/*
				** Verifica as variaveis, se tiver.
				*/

				if (indvar) {
					arquivos[narqs].nvar = indvar;
					ubytes=(unsigned)(indvar*sizeof(int));

					/*
					** Aloca area para os indices das
					** variaveis.
					*/

					pv = (int *) malloc(ubytes);

					if (pv == (int *) NULL)
						execerror( PegaMsg (Msg[3]), "");

					/*
					** Coloca em pv os indices das
					** variaveis.
					*/

					for (i = 0; i < indvar; ++i)
						pv[i] = vars[i];

					/*
					** Coloca na estrutura de arquivos o
					** apontador para os indices das
					** variaveis.
					*/

					arquivos[narqs].pos = pv;
				}

				/*
				** Verifica se tem variaveis declaradas.
				*/

				if (yyvsp[0]) {
					/*
					** Tem variaveis declaradas.
					** Verifica se e' arquivo de saida.
					*/

					if (yyvsp[-3] != SAIDA)
						execerror(PegaMsg (Msg[2]), "");

					ssopen(SAIDA);
				}

				else {
					/*
					** Nao tem variaveis declaradas.
					** Verifica modo (entrada ou saida).
					** O default e' ENTRADA.
					*/

					if (yyvsp[-3] == -1)
						ssopen(ENTRADA);
					else
						ssopen(yyvsp[-3]);
				}

				/*
				** Nao e' arquivo a ser concatenado, logo 
				** os campos abaixo sao NULL ou 0.
				*/

				arquivos[narqs].fim = 0;
				arquivos[narqs].nch = 0;
				arquivos[narqs].ch  = NULL;
				arquivos[narqs].qarea.pch = NULL;

				yyval = 1;
			}
break;
case 37:
#line 699 "genparse.y"
{
				/*
				** Verifica as variaveis, se tiver.
				*/

				if (indvar) {
					arquivos[narqs].nvar = indvar;
					ubytes=(unsigned)(indvar*sizeof(int));

					/*
					** Aloca area para os indices das
					** variaveis.
					*/

					pv = (int *) malloc(ubytes);

					if (pv == (int *) NULL) {

/* *** Padroniz. msg erro - Adriana 09/01/95
						execerror(
						"Memoria disponivel esgotada",
						"");
*** */

						execerror( PegaMsg (1039), "");
					}

					/*
					** Coloca em pv os indices das
					** variaveis.
					*/

					for (i = 0; i < indvar; ++i)
						pv[i] = vars[i];

					/*
					** Coloca na estrutura de arquivos o
					** apontador para os indices das
					** variaveis.
					*/

					arquivos[narqs].pos = pv;
				}

				/*
				** Verifica se tem variaveis declaradas.
				*/

				if (yyvsp[0]) {
					/*
					** Tem variaveis declaradas.
					** Verifica se e' arquivo de saida.
					*/

					if (yyvsp[-3] == SAIDA)
						execerror(PegaMsg (Msg[4]), "");

					ffopen(ENTRADA);
				}

				else {
					/*
					** Nao tem variaveis declaradas.
					** Verifica modo (entrada ou saida).
					** O default e' ENTRADA.
					*/

					if (yyvsp[-3] == -1)
						ffopen(ENTRADA);
					else
						ffopen(yyvsp[-3]);
				}

				/*
				** Nao e' arquivo a ser concatenado, logo 
				** os campos abaixo sao NULL ou 0.
				*/

				arquivos[narqs].fim = 0;
				arquivos[narqs].nch = 0;
				arquivos[narqs].ch  = NULL;
				arquivos[narqs].qarea.pch = NULL;

				yyval = 2;
			}
break;
case 38:
#line 789 "genparse.y"
{ nomeflag = 0;}
break;
case 39:
#line 790 "genparse.y"
{
				/*
				** Indica o indice do ultimo arquivo a ser
				** concatenado.
				*/

				arquivos[tarqs].fim = narqs-1;
				arquivos[tarqs].nch  = yynch;

				if (yynch == 0)
					/*
					** Nao tem chaves p/ concatencao.
					*/ 

					arquivos[tarqs].ch = NULL;

				else {
					/*
					** Tem chaves p/ concatenacao.
					*/

					ubytes = (unsigned) (yynch*sizeof(int));

					/*
					** Aloca area para os inds. das chaves.
					*/

					vet = (int *) malloc(ubytes);

					if (vet == (int *) NULL) {

/* *** Padroniz. msg erro - Adriana 09/01/95
						execerror(
						"Memoria disponivel esgotada",
						"");
*** */

						execerror( PegaMsg (1039), "");
					}

					/*
					** Coloca em vet os indices das vars.
					*/

					for (i=0; i < yynch; i++)
						vet[i] = vetchave[i];

					/*
					** Coloca na estrutura arquivos o vetor
					** de indices das chaves.
					*/

					arquivos[tarqs].ch = vet;
				}

				/*
				** Aloca memoria para a area de trabalho da 
				** concatencao vertical.
				*/

				ubytes = (unsigned) sizeof(struct WorkArea);
				arquivos[tarqs].qarea.pcv =
					(struct WorkArea *) malloc(ubytes);

				if (arquivos[tarqs].qarea.pcv == WNULL)
					execerror(PegaMsg (Msg[5]), "");

				arquivos[tarqs].qarea.pcv->mestre = 0;
				arquivos[tarqs].qarea.pcv->tip_ord =
						tipordenacao;
				yyval = 3;
			}
break;
case 40:
#line 867 "genparse.y"
{ nomeflag = 0;}
break;
case 41:
#line 868 "genparse.y"
{
				/*
				** Indica o indice do ultimo arquivo a ser
				** concatenado.
				*/

				arquivos[tarqs].fim = narqs-1;
				arquivos[tarqs].nch  = yynch;

				if ( yynch == 0 )
					/*
					** Nao tem chaves p/ concatencao.
					*/

					arquivos[tarqs].ch = NULL;
				else {
					/*
					** Tem chaves p/ concatenacao.
					*/

					ubytes = (unsigned) (yynch*sizeof(int));

					/*
					** Aloca area para os inds. das chaves.
					*/

					vet = (int *) malloc(ubytes);

					if (vet == (int *) NULL)
						execerror(PegaMsg (Msg[5]), "");

					/*
					** Coloca em vet os indices das vars.
					*/

					for (i = 0; i < yynch; i++)
						vet[i] = vetchave[i];

					/*
					** Coloca na estrutura arquivos o
					** vetor de indices das chaves.
					*/

					arquivos[tarqs].ch = vet;
				}

				/*
				** Aloca memoria para a area de trabalho da
				** concatencao horizontal.
				*/

				ubytes = (unsigned) sizeof(struct Ch_Area);
				arquivos[tarqs].qarea.pch =
					(struct Ch_Area *) malloc(ubytes);

				if (arquivos[tarqs].qarea.pch == ChNULL)
					execerror( PegaMsg (Msg[5]), "");

				arquivos[tarqs].qarea.pch->mestre = 0;
				arquivos[tarqs].qarea.pch->tip_ord =
						tipordenacao;
				yyval = 4;
			}
break;
case 42:
#line 939 "genparse.y"
{
				nomeflag = -1;
			}
break;
case 43:
#line 950 "genparse.y"
{
				pervar = 6;
				indvar = 0;
			}
break;
case 44:
#line 962 "genparse.y"
{
				yyval = -1;
				nomeflag = 0;
			}
break;
case 45:
#line 967 "genparse.y"
{ nomeflag = 0; }
break;
case 46:
#line 967 "genparse.y"
{ setmodo = 1;}
break;
case 47:
#line 968 "genparse.y"
{
				yyval = yyvsp[0];
				setmodo = 0;
			}
break;
case 48:
#line 974 "genparse.y"
{
				execerror( PegaMsg (Msg[6]), "");
			}
break;
case 49:
#line 984 "genparse.y"
{
			if ( narqs >= MAXGENARQ - 1)
				execerror( PegaMsg (Msg[7]), "");

			ssopen(ENTRADA);
			arquivos[narqs].fim = 0;
			arquivos[narqs].nch = 0;
			arquivos[narqs].ch  = NULL;
			arquivos[narqs].qarea.pch = NULL;
			++narqs;
		  }
break;
case 50:
#line 997 "genparse.y"
{
			if ( narqs >= MAXGENARQ - 1)
				execerror(PegaMsg (Msg[7]), "");

			ssopen(ENTRADA);
			arquivos[narqs].fim = 0;
			arquivos[narqs].nch = 0;
			arquivos[narqs].ch  = NULL;
			arquivos[narqs].qarea.pch = NULL;
			++narqs;
		  }
break;
case 51:
#line 1010 "genparse.y"
{
			execerror( PegaMsg (Msg[8]), "");
		  }
break;
case 53:
#line 1021 "genparse.y"
{ pervar = 8; }
break;
case 54:
#line 1021 "genparse.y"
{pervar = 0;}
break;
case 55:
#line 1022 "genparse.y"
{
				tipordenacao = (char) yyvsp[0];
			}
break;
case 56:
#line 1027 "genparse.y"
{

/* *** Padroniz. msg erro - Adriana 09/01/95
			execerror("Especificacao de chave incorreta","");
*** */

			execerror( PegaMsg (3155),"");
			}
break;
case 57:
#line 1037 "genparse.y"
{ flagord = 0; yyval = 'a'; }
break;
case 58:
#line 1039 "genparse.y"
{ flagord = 1;}
break;
case 59:
#line 1040 "genparse.y"
{
				yyval = yyvsp[0];
			}
break;
case 60:
#line 1045 "genparse.y"
{
			flagord = 0; 

/* *** Padroniz. msg erro - Adriana 09/01/95
			execerror("Especificacao de ordenacao incorreta","");
*** */

			execerror( PegaMsg (3156), "");
			}
break;
case 61:
#line 1057 "genparse.y"
{
				flagord = 0;
				yyval = (int) 'a';
			}
break;
case 62:
#line 1063 "genparse.y"
{
				flagord = 0;
				yyval = (int) 'd';
			}
break;
case 63:
#line 1069 "genparse.y"
{
			flagord = 0; 

/* *** Padroniz. msg erro - Adriana 09/01/95
			execerror("Especificacao de ordenacao incorreta","");
*** */

			execerror( PegaMsg (3156),"");
			}
break;
case 70:
#line 1094 "genparse.y"
{
#ifdef DEBUG
				D16print("\tatualizar em %d para %d\n", yyvsp[-2],yyvsp[0]);
#endif
				/* Coloca o valor retornado por else como
				parametro da instrucao cujo indice no vetor de 
				instrucoes e' o valor retornado por start. No
				caso, a instrucao e' um JF e o parametro e'
				o endereco (pc) do comeco do else.*/
				ins[yyvsp[-2]] |= yyvsp[0];
			}
break;
case 71:
#line 1106 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tJMP\t%d\n",pc, yyvsp[-3]);
				D16print("\tatualizar em %d para %d\n",
					yyvsp[-1], pc+1);
#endif
				/* Ao final dos comandos, realiza um JMP para
				a posicao retornada por end. No caso, faz a
				execucao retornar para o comando inicial do 
				WHILE, que e' a condicao.  */

				ins[pc] = JMP | yyvsp[-3];
				IncrementaPC(&pc);

				/* Coloca o pc apos a execucao dos comandos  
				como parametro da instrucao cujo indice no 
				vetor de instrucoes e' o valor retornado por 
				start. No caso, a instrucao e' um JF e o 
				parametro e' o endereco (pc) ao final da 
				execucao dos comandos */

				ins[yyvsp[-1]] |= pc;

				/* Verifica a existencia de algum break dentro
				do while, atualizando o parametro da instrucao 
				correspondente ao break, no caso o comando JMP.
				O endereco do JMP passa a ser o endereco do 
				fim do while . Feito isso, decrementa o no. 
				de while's ja' tratados */

				if ( ct_break > 0 )
					--ct_break;
				while ( end_break[ct_break] > 0 && 
							ct_break >= 0 ) {
#ifdef DEBUG
					D16print("\tatualizar em %d para %d\n",
						end_break[ct_break], pc);
#endif
						ins[end_break[ct_break]] |= pc;
						--ct_break;
				}
				if ( end_break[ct_break] < 0 && ct_break > 0 )
					--ct_break;
				num_while--;
			}
break;
case 72:
#line 1152 "genparse.y"
{ 
#ifdef DEBUG
				D16print("\t%d\tJMP\t0\n",pc);
#endif
				if (!num_while )

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Comando BREAK usado fora do WHILE", "");
*** */

					execerror( PegaMsg (3157), "");
				else if ( ct_break == 200 )
				      {	
					sprintf (tmpbuf, PegaMsg (3161), 200);
					execerror( tmpbuf, "");
				      }
				else {

				/* Atualiza o no. de breaks referentes a esse
				while. Coloca o endereco da instrucao 
				correspondente ao break no vetor de enderecos 
				de breaks deste while. Coloca a instrucao para 
				desvio da execucao do programa
				no vetor de instrucoes */

					end_break[ct_break++] = pc;
					ins[pc] = JMP;
					IncrementaPC(&pc);
				}
			}
break;
case 73:
#line 1183 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tSTV\tnulo\n",pc);
#endif
				ins[pc] = STV | VARNULL;
				IncrementaPC(&pc);
			}
break;
case 74:
#line 1190 "genparse.y"
{ tabpos = 0; }
break;
case 75:
#line 1191 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\tnl\n",pc);
				D16print("\t%d\tPRT\tlinha\n",pc+1);
#endif
				ins[pc] = PRT | PNL;
				IncrementaPC(&pc);
				ins[pc] = PRT | PLIN;
				IncrementaPC(&pc);
			}
break;
case 76:
#line 1202 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tLDS\t%s\t%d\n", pc, 
					variavel[yyvsp[-2]].ptrval.ptrs, yyvsp[-2]);
				D16print("\t%d\tFSPC\tPSE\t\n",pc+1);
#endif
				/* Manda carregar valor string na pilha de 
				dados e executar a funcao especial PSE */
				ins[pc] = LDS | yyvsp[-2];
				IncrementaPC(&pc);
				ins[pc] = FSPC | PSE;
				IncrementaPC(&pc);
			}
break;
case 77:
#line 1216 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tLDI\t%s\t%d\n",pc,
					variavel[yyvsp[-2]].nome, yyvsp[-2]);
				D16print("\t%d\tFSPC\tRWND\t\n",pc+1);
#endif
				/* pega o indice do arquivo na tabela manda
				colocar na pilha. Manda executar a funcao 
				especial rewind  */
				arq = variavel[yyvsp[-2]].ptrval.ptra;
				ins[pc] = LDI | arq;
				IncrementaPC(&pc);
				ins[pc] = FSPC | RWND;
				IncrementaPC(&pc);
			}
break;
case 78:
#line 1232 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tJMP\t%d\n",pc, 0);
#endif
				ins[pc] = JMP;
				IncrementaPC(&pc);
			}
break;
case 79:
#line 1240 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tSTOP\n",pc);
#endif
				ins[pc] = PARE;
				IncrementaPC(&pc);
			}
break;
case 80:
#line 1248 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tABORT\n",pc);
#endif
				ins[pc] = PARE | 255;
				IncrementaPC(&pc);
			}
break;
case 81:
#line 1256 "genparse.y"
{
				nparam[npr++] = 0;
				if (npr > 99 || npr < 0)
				  {
					sprintf (tmpbuf, PegaMsg (3160), 99 );
					execerror( tmpbuf, "");
				  }
			}
break;
case 82:
#line 1265 "genparse.y"
{
				/* verifica se o no. de parms. da funcao esta'
				certo  */

				i = funcvwords[yyvsp[-4]].nparm;

				if (i != nparam[npr-1]) {
					if (funcvwords[yyvsp[-4]].kval == OSRAND
						&& nparam[npr-1] == 0) {
#ifdef DEBUG
						D16print("\t%d\tLDV\tnulo\n",
							pc);
#endif
						ins[pc] = LDV | VARNULL;
						IncrementaPC(&pc);
					}

					else if (i % 10 != nparam[npr-1] &&
						(i/100) != nparam[npr-1])
					       {
						sprintf (tmpbuf, PegaMsg (3165), funcwords[yyvsp[-4]].name);
						execerror( tmpbuf, "");
					       }
				}

				npr--;

				/* Verifica se os tipos de parametros estao corretos */

				for(j=i-1; j >= 0;	j--) {

				    if ( funcvwords[yyvsp[-4]].tipo_par[j] !=  P_Top(TipoParametro) ) {
					/*Tipo de Parametro Incorreto*/ 
					sprintf(tmpbuf,PegaMsg(3251));
					execerror(tmpbuf,"");
				    }
				    (void) P_Pop(TipoParametro);
				}

#ifdef DEBUG
				D16print("\t%d\tFUNC\t%s\n", pc,
					funcvwords[yyvsp[-4]].name);
#endif
				/* manda executar a funcao  */	
				ins[pc] = FUNC | funcvwords[yyvsp[-4]].kval;
				IncrementaPC(&pc);
			}
break;
case 84:
#line 1314 "genparse.y"
{
				debug(yyvsp[-1]);
			}
break;
case 86:
#line 1319 "genparse.y"
{

/* *** Padroniz. msg erro - Adriana 09/01/95
				execerror("Comando invalido ou fora de ordem","");
*** */

				execerror( PegaMsg (3005),"");
			}
break;
case 87:
#line 1331 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\tunidade padrao\n", pc);
#endif
				ins[pc]=PRT | (100 << 3 | PUNI);
				IncrementaPC(&pc);
			}
break;
case 88:
#line 1339 "genparse.y"
{
				for (i = 1; i < narqs; ++i) {
					if (varfil[i] == yyvsp[-1])
						if (tipofil[i] != 2)

/* *** Padroniz. msg erro - Adriana 09/01/95
							execerror(
							"Utilizar 'grave'", "");
*** */

							execerror(
							 PegaMsg (3162), "");
						else
							break;
				}	
				if (i >= narqs)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Variavel referencia de arquivo nao definida", "");
*** */

					execerror( PegaMsg (3163), "");
				arq = variavel[yyvsp[-1]].ptrval.ptra;
				if (arquivos[arq].modo != SAIDA)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Gravacao nao permitida. Arquivo foi aberto para leitura", "");
*** */

					execerror( PegaMsg (3164), "");
#ifdef DEBUG
				D16print("\t%d\tPRT\tunidade %s\n", pc,
				arquivos[variavel[yyvsp[-1]].ptrval.ptra].nome);
#endif
				/* Manda imprimir arquivo  */
				ins[pc] = PRT | ( arq << 3 | PUNI);
				IncrementaPC(&pc);
			}
break;
case 89:
#line 1381 "genparse.y"
{
				yyval = pc;
			}
break;
case 90:
#line 1385 "genparse.y"
{
#ifdef DEBUG
				D16print("\tatualizar em %d para %d\n",
					yyvsp[-1]-1, pc);
#endif
				/* Coloca o valor de pc como parametro 
				da instrucao cujo indice no vetor de
				instrucoes e' o valor retornado por 
				starte - 1. No caso o comando e' JMP
				para a instrucao ao final da execucao dos
				comandos */
				ins[yyvsp[-1]-1] |= pc;
				yyval = yyvsp[-1];
			 }
break;
case 91:
#line 1411 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tSTV\t%s\n",
					pc,variavel[yyvsp[-2]].nome);
#endif
				/*
				** Armazena o numero que se encontra no topo
				** da pilha de dados na variavel cujo indice
				** e' o retornado por $1
				*/

				ins[pc] = STV | yyvsp[-2];
				IncrementaPC(&pc);
				yyval = yyvsp[-2];
			}
break;
case 92:
#line 1432 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tLDV\t%s\n",pc,
					variavel[yyvsp[0]].nome);
#endif
				/*
				** Armazena o valor da ultima variavel na pilha
				** de dados para proceder as atribuicoes.
				*/

				ins[pc] = LDV | yyvsp[0];
				IncrementaPC(&pc);
#ifdef DEBUG
				D16print("\t%d\tSTV\t%s\n", pc,
					variavel[yyvsp[-2]].nome);
#endif
				/*
				** Armazena o numero que se encontra no topo
				** da pilha de dados na variavel cujo indice
				** e' o retornado por $1
				*/

				ins[pc] = STV | yyvsp[-2];
				IncrementaPC(&pc);
				yyval = yyvsp[-2];
			}
break;
case 93:
#line 1466 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tSTS\t%s\t%d\n", pc,
					variavel[yyvsp[-2]].nome, yyvsp[-2]);
#endif
				/* manda armazenar a string que se encontra
				no topo da pilha de dados na var. cujo indice 
				e' o retornado por $1 */
				ins[pc] = STS | yyvsp[-2];
				IncrementaPC(&pc);
				yyval = yyvsp[-2];
			}
break;
case 94:
#line 1479 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tLDS\t%s\t%d\n",pc,
					variavel[yyvsp[0]].nome, yyvsp[0]);
#endif
				/* manda armazenar a string resultante na pilha
				de dados  */

				ins[pc] = LDS | yyvsp[0];
				IncrementaPC(&pc);
#ifdef DEBUG
				D16print("\t%d\tSTS\t%s\t%d\n", pc,
					variavel[yyvsp[-2]].nome, yyvsp[-2]);
#endif
				/* manda armazenar a string que se encontra
				no topo da pilha de dados na var. cujo indice
				e' o retornado por $1 */
				ins[pc] = STS | yyvsp[-2];
				IncrementaPC(&pc);
				yyval = yyvsp[-2];
			}
break;
case 95:
#line 1508 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tSTV\t%s\n",
					pc,variavel[yyvsp[-2]].nome);
#endif
				/* manda armazenar a data que se encontra
				no topo da pilha de dados na var. cujo indice
				e' o retornado por $1 */
				ins[pc] = STV | yyvsp[-2];
				IncrementaPC(&pc);
				yyval = yyvsp[-2];
			}
break;
case 96:
#line 1521 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tSTV\t%s\n",
					pc,variavel[yyvsp[-2]].nome);
#endif
				ins[pc] = STV | yyvsp[-2];
				IncrementaPC(&pc);
				yyval = yyvsp[-2];
			}
break;
case 97:
#line 1531 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tLDV\t%s\n",pc,
					variavel[yyvsp[0]].nome);
#endif
				/* manda armazenar valor nulo na pilha de dados
				para proceder as atribuicoes */
				ins[pc] = LDV | yyvsp[0];
				IncrementaPC(&pc);
#ifdef DEBUG
				D16print("\t%d\tSTV\t%s\n", pc,
					variavel[yyvsp[-2]].nome);
#endif
				/* manda armazenar a data resultante da pilha
				de dados  na variavel de indice $1 */
				ins[pc] = STV | yyvsp[-2];
				IncrementaPC(&pc);
				yyval = yyvsp[-2];
			}
break;
case 98:
#line 1556 "genparse.y"
{
				yyval = pc;
#ifdef DEBUG
				D16print("\t%d\tJF\t0\n",pc);
#endif
				ins[pc] = JF;
				IncrementaPC(&pc);
			}
break;
case 99:
#line 1570 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tJMP\t0\n",pc);
#endif
				ins[pc] = JMP;
				IncrementaPC(&pc);
				yyval = pc;
			}
break;
case 101:
#line 1588 "genparse.y"
{ 
				if ( num_while ) 
					end_break[ct_break++] = 0 - num_while;
				num_while++;
				yyval = pc;
			}
break;
case 102:
#line 1598 "genparse.y"
{
#ifdef DEBUG
				if (variavel[yyvsp[0]].ptrval.ptrf >= MISSING) {
					D16print("\t%d\tLDN\t.\n", pc);
				}
				else {
					D16print("\t%d\tLDN\t%lg\n", pc,
						variavel[yyvsp[0]].ptrval.ptrf);
				}
#endif
			/* Manda carregar o valor data na pilha de dados  */
				ins[pc] = LDV | yyvsp[0];
				IncrementaPC(&pc);
			}
break;
case 103:
#line 1613 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tLDV\t%s\n",pc, variavel[yyvsp[0]].nome);
#endif
			/* Manda carregar o indice da variavel data na 
			pilha de dados  */
				ins[pc] = LDV | yyvsp[0];
				IncrementaPC(&pc);
			}
break;
case 104:
#line 1623 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tLDV\tnulo\n",pc);
#endif
			/* Manda carregar variavel nula na pilha de dados, para 
			proceder as atribuicoes */
				ins[pc] = LDV | VARNULL;
				IncrementaPC(&pc);
			}
break;
case 105:
#line 1633 "genparse.y"
{
				nparam[npr++] = 0;
				if (npr > 99 || npr < 0)
				  {
					sprintf (tmpbuf, PegaMsg (3160), 99 );
					execerror( tmpbuf, "");
				  }
			}
break;
case 106:
#line 1642 "genparse.y"
{
				/* verifica se o no. de parms. da funcao esta'
				certo  */
				i = funcdwords[yyvsp[-4]].nparm;
				if (i != nparam[npr-1]) {
				    if (i % 10 != nparam[npr-1] && (i/100) != nparam[npr-1])
				     {		
					sprintf (tmpbuf, PegaMsg (3165), 
					         funcdwords[yyvsp[-4]].name);
					execerror( tmpbuf, "");
				     }
				}
				npr--;

				/* Verifica se os tipos de parametros estao corretos */

				for(j=i-1; j >= 0;	j--) {

				    if ( funcdwords[yyvsp[-4]].tipo_par[j] != P_Top(TipoParametro) ) {
					/*Tipo de Parametro Incorreto*/ 
					sprintf(tmpbuf,PegaMsg(3251));
					execerror(tmpbuf,"");
				    }
				    (void) P_Pop(TipoParametro);
				}

#ifdef DEBUG
				D16print("\t%d\tFUNC\t%s\n", pc,
					funcdwords[yyvsp[-4]].name);
#endif
				/* manda executar a funcao */
				ins[pc] = FUNC | funcdwords[yyvsp[-4]].kval;
				IncrementaPC(&pc);
			}
break;
case 107:
#line 1678 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tATOD\n", pc);
#endif
				ins[pc] = FUNCS | OATOD;
				IncrementaPC(&pc);
			}
break;
case 108:
#line 1686 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tFUNC\tFTOD\n", pc);
#endif
				ins[pc] = FUNC | OFTOD;
				IncrementaPC(&pc);
			}
break;
case 110:
#line 1699 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tLDS\t%s\t%d\n", pc, 
					variavel[yyvsp[0]].ptrval.ptrs, yyvsp[0]);
#endif
				/* Manda carregar valor string na pilha de 
				dados */
				ins[pc] = LDS | yyvsp[0];
				IncrementaPC(&pc);
			}
break;
case 111:
#line 1710 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tLDS\t%s\t%d\n", pc,
					variavel[yyvsp[0]].nome, yyvsp[0]);
#endif
				/* Manda carregar indice da variavel string 
				na pilha de dados */
				ins[pc] = LDS | yyvsp[0];
				IncrementaPC(&pc);
			}
break;
case 112:
#line 1721 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tLDS\t%s\t%d\n",pc,
					variavel[yyvsp[-1]].nome, yyvsp[-1]);
#endif
				/* Manda carregar a string resultante da 
				atribuicao  na pilha de dados */
				ins[pc] = LDS | yyvsp[-1];
				IncrementaPC(&pc);
			}
break;
case 113:
#line 1732 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tSTRCAT\n", pc);
#endif
				ins[pc] = FUNCS | OSTRCAT;
				IncrementaPC(&pc);
			}
break;
case 114:
#line 1740 "genparse.y"
{
				nparam[npr++] = 0;
				if (npr > 99 || npr < 0)
				  {
					sprintf (tmpbuf, PegaMsg (3160), 99 );
					execerror( tmpbuf, "");
				  }
			}
break;
case 115:
#line 1749 "genparse.y"
{
				/* verifica se o no. de parms. da funcao esta'
				certo  */
				i = funcswords[yyvsp[-4]].nparm;
				if (i != nparam[npr-1]) {
				    if (i % 10 != nparam[npr-1] && (i/100) != nparam[npr-1])
				      {
					sprintf (tmpbuf, PegaMsg (3165),  
						  funcswords[yyvsp[-4]].name);
					execerror( tmpbuf, "");
				      }
				}
				npr--;

				/* Verifica se os tipos de parametros estao corretos */

				for(j=i-1; j >= 0;	j--) {

				    if ( funcswords[yyvsp[-4]].tipo_par[j] !=  P_Top(TipoParametro) ) {
					/*Tipo de Parametro Incorreto*/ 
					sprintf(tmpbuf,PegaMsg(3251));
					execerror(tmpbuf,"");
				    }
				    (void) P_Pop(TipoParametro);
				}


#ifdef DEBUG
				D16print("\t%d\tFUNCS\t%s\n", pc,
					funcswords[yyvsp[-4]].name);
#endif
				/* Manda executar a funcao  */
				ins[pc] = FUNCS | funcswords[yyvsp[-4]].kval;
				IncrementaPC(&pc);
			}
break;
case 116:
#line 1785 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tFUNC\tFTOA\n", pc);
#endif
				 /* Manda executar a funcao  */
				ins[pc] = FUNC | OFTOA;
				IncrementaPC(&pc);
			}
break;
case 117:
#line 1794 "genparse.y"
{
#ifdef DEBUG
				 D16print("\t%d\tFUNC\tDTOA\n", pc);
#endif
				  /* Manda executar a funcao  */
				  ins[pc] = FUNC | ODTOA;
				  IncrementaPC(&pc);
			  }
break;
case 118:
#line 1803 "genparse.y"
{
#ifdef DEBUG
				 D16print("\t%d\tFUNC\tMNT\n", pc);
#endif
				  /* Manda executar a funcao  */
				  ins[pc] = FUNC | OMNT;
				  IncrementaPC(&pc);
			  }
break;
case 120:
#line 1816 "genparse.y"
{
#ifdef DEBUG
				if (variavel[yyvsp[0]].ptrval.ptrf >= MISSING) {
					D16print("\t%d\tLDN\t.\n", pc);
				}
				else {
					D16print("\t%d\tLDN\t%lg\n", pc,
						variavel[yyvsp[0]].ptrval.ptrf);
				}
#endif
				/* coloca na pilha o valor do numero  */
				ins[pc] = LDV | yyvsp[0];
				IncrementaPC(&pc);
			}
break;
case 121:
#line 1831 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tCONST\t%s\n", pc,
					cnstwords[yyvsp[0]].name);
#endif
				/* coloca na pilha o valor da constante */
				ins[pc] = CNST | cnstwords[yyvsp[0]].kval;
				IncrementaPC(&pc);

				/* testa se e' constante de fim de arquivo */
				if (strcmp(cnstwords[yyvsp[0]].name, "_eof") == 0 ||
					strcmp(cnstwords[yyvsp[0]].name, "_fda") == 0)
						pareeof = 0;
			}
break;
case 122:
#line 1846 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tLDV\t%s\n",pc, variavel[yyvsp[0]].nome);
#endif
				/* coloca na pilha o indice da variavel  */
				ins[pc] = LDV | yyvsp[0];
				IncrementaPC(&pc);
			}
break;
case 124:
#line 1856 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tLDV\t%s\n",pc,
					variavel[yyvsp[-1]].nome);
#endif
				/* Manda carregar variavel nula na pilha de 
				dados, para proceder as atribuicoes */
				ins[pc] = LDV | yyvsp[-1];
				IncrementaPC(&pc);
			}
break;
case 125:
#line 1867 "genparse.y"
{
				nparam[npr++] = 0;
				if (npr > 99 || npr < 0)
				  {
					sprintf (tmpbuf, PegaMsg (3160), 99 );
					execerror( tmpbuf, "");
				  }
			}
break;
case 126:
#line 1876 "genparse.y"
{
				/* verifica se o no. de parms. da funcao esta'
				certo  */

				i = funcwords[yyvsp[-4]].nparm;

				if (i != nparam[npr-1]) {
					if ((funcwords[yyvsp[-4]].kval == ORAND ||
						funcwords[yyvsp[-4]].kval == OSRAND)
						&& nparam[npr-1] == 0) {
#ifdef DEBUG
						D16print("\t%d\tLDV\tnulo\n",
							pc);
#endif
						ins[pc] = LDV | VARNULL;
						IncrementaPC(&pc);
					}

					else if (i % 10 != nparam[npr-1] &&
						(i/100) != nparam[npr-1])
					       {
						sprintf (tmpbuf, PegaMsg (3165),
							 funcwords[yyvsp[-4]].name);
						execerror( tmpbuf, "");
					       }
				}

				npr--;

				/* Verifica se os tipos de parametros estao corretos */

				for(j=i-1; j >= 0;	j--) {

				    if ( funcwords[yyvsp[-4]].tipo_par[j] !=  P_Top(TipoParametro) ) {
					/*Tipo de Parametro Incorreto*/ 
					sprintf(tmpbuf,PegaMsg(3251));
					execerror(tmpbuf,"");
				    }
				    (void) P_Pop(TipoParametro);
				}

#ifdef DEBUG
				D16print("\t%d\tFUNC\t%s\n", pc,
					funcwords[yyvsp[-4]].name);
#endif
				/* manda executar a funcao  */	
				ins[pc] = FUNC | funcwords[yyvsp[-4]].kval;
				IncrementaPC(&pc);
			}
break;
case 128:
#line 1927 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tATOF\n", pc);
#endif
				ins[pc] = FUNCS | OATOF;
				IncrementaPC(&pc);
			}
break;
case 129:
#line 1935 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tDTOF\n", pc);
#endif
				ins[pc] = FUNC | ODTOF;
				IncrementaPC(&pc);
			}
break;
case 130:
#line 1943 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tADD\n", pc);
#endif
				ins[pc] = OPER | OADD;
				IncrementaPC(&pc);
			}
break;
case 131:
#line 1951 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tSUB\n", pc);
#endif
				ins[pc] = OPER | OSUB;
				IncrementaPC(&pc);
			}
break;
case 132:
#line 1959 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tMINUS\n", pc);
#endif
				ins[pc] = OPER | OMINUS;
				IncrementaPC(&pc);
			}
break;
case 133:
#line 1967 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tMUL\n", pc);
#endif
				ins[pc] = OPER | OMUL;
				IncrementaPC(&pc);
			}
break;
case 134:
#line 1975 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tDIV\n", pc);
#endif
				ins[pc] = OPER | ODIV;
				IncrementaPC(&pc);
			}
break;
case 135:
#line 1983 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tMOD\n", pc);
#endif
				ins[pc] = OPER | OMOD;
				IncrementaPC(&pc);
			}
break;
case 136:
#line 1991 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tPOW\n", pc);
#endif
				ins[pc] = OPER | OPOW;
				IncrementaPC(&pc);
			}
break;
case 137:
#line 1999 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tEQ\n", pc);
#endif
				ins[pc] = LOGICA | OEQ;
				IncrementaPC(&pc);
			}
break;
case 138:
#line 2007 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tNEQ\n", pc);
#endif
				ins[pc] = LOGICA | ONEQ;
				IncrementaPC(&pc);
			}
break;
case 139:
#line 2015 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tLT\n", pc);
#endif
				ins[pc] = LOGICA | OLT;
				IncrementaPC(&pc);
			}
break;
case 140:
#line 2023 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tLE\n", pc);
#endif
				ins[pc] = LOGICA | OLE;
				IncrementaPC(&pc);
			}
break;
case 141:
#line 2031 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tGT\n", pc);
#endif
				ins[pc] = LOGICA | OGT;
				IncrementaPC(&pc);
			}
break;
case 142:
#line 2039 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tGE\n", pc);
#endif
				ins[pc] = LOGICA | OGE;
				IncrementaPC(&pc);
			}
break;
case 143:
#line 2047 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tAND\n", pc);
#endif
				ins[pc] = LOGICA | OAND;
				IncrementaPC(&pc);
			}
break;
case 144:
#line 2055 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tOR\n", pc);
#endif
				ins[pc] = LOGICA | OOR;
				IncrementaPC(&pc);
			}
break;
case 145:
#line 2063 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tNOT\n", pc);
#endif
				ins[pc] = LOGICA | ONOT;
				IncrementaPC(&pc);
			}
break;
case 147:
#line 2072 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tEQ\n", pc);
#endif
				ins[pc] = LOGICA | OEQ;
				IncrementaPC(&pc);
			}
break;
case 148:
#line 2081 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tEQ\n", pc);
#endif
				ins[pc] = LOGICA | OEQ;
				IncrementaPC(&pc);
			}
break;
case 149:
#line 2090 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tEQ\n", pc);
#endif
				ins[pc] = LOGICA | OEQ;
				IncrementaPC(&pc);
			}
break;
case 150:
#line 2098 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tNEQ\n", pc);
#endif
				ins[pc] = LOGICA | ONEQ;
				IncrementaPC(&pc);
			}
break;
case 151:
#line 2107 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tNEQ\n", pc);
#endif
				ins[pc] = LOGICA | ONEQ;
				IncrementaPC(&pc);
			}
break;
case 152:
#line 2116 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tNEQ\n", pc);
#endif
				ins[pc] = LOGICA | ONEQ;
				IncrementaPC(&pc);
			}
break;
case 153:
#line 2124 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tLT\n", pc);
#endif
				ins[pc] = LOGICA | OLT;
				IncrementaPC(&pc);
			}
break;
case 154:
#line 2132 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tLE\n", pc);
#endif
				ins[pc] = LOGICA | OLE;
				IncrementaPC(&pc);
			}
break;
case 155:
#line 2140 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tGT\n", pc);
#endif
				ins[pc] = LOGICA | OGT;
				IncrementaPC(&pc);
			}
break;
case 156:
#line 2148 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tOPER\tGE\n", pc);
#endif
				ins[pc] = LOGICA | OGE;
				IncrementaPC(&pc);
			}
break;
case 157:
#line 2156 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tEQ\n", pc);
#endif
				ins[pc] = FUNCS | OEQ;
				IncrementaPC(&pc);
			}
break;
case 158:
#line 2164 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tNEQ\n", pc);
#endif
				ins[pc] = FUNCS | ONEQ;
				IncrementaPC(&pc);
			}
break;
case 159:
#line 2172 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tLT\n", pc);
#endif
				ins[pc] = FUNCS | OLT;
				IncrementaPC(&pc);
			}
break;
case 160:
#line 2180 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tLE\n", pc);
#endif
				ins[pc] = FUNCS | OLE;
				IncrementaPC(&pc);
			}
break;
case 161:
#line 2188 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tGT\n", pc);
#endif
				ins[pc] = FUNCS | OGT;
				IncrementaPC(&pc);
			}
break;
case 162:
#line 2196 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tGE\n", pc);
#endif
				ins[pc] = FUNCS | OGE;
				IncrementaPC(&pc);
			}
break;
case 163:
#line 2204 "genparse.y"
{

/* *** Padroniz. msg erro - Adriana 09/01/95
				execerror("Expressao invalida","");
*** */

				execerror( PegaMsg (3166),"");
			}
break;
case 164:
#line 2215 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tLDN\t.\n", pc);
#endif
				ins[pc] = LDV | yyvsp[0];
				IncrementaPC(&pc);
			}
break;
case 166:
#line 2239 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\tdata\n", pc);
#endif
				/* manda imprimir */
				ins[pc] = PRT | PDAT;
				IncrementaPC(&pc);
				tabpos = 1;
				formnum = 0;
			}
break;
case 167:
#line 2251 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\tstring\n", pc);
#endif
				/* manda imprimir  */
				ins[pc] = PRT | PALF;
				IncrementaPC(&pc);
				tabpos = 1;
				formnum = 0;
			}
break;
case 168:
#line 2263 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\tvalor\n", pc);
#endif
				/* manda imprimir  */
				ins[pc] = PRT | PNUM;
				IncrementaPC(&pc);
				tabpos = 1;
				formnum = 0;
			}
break;
case 170:
#line 2275 "genparse.y"
{
				if (tabpos) {
#ifdef DEBUG
					D16print("\t%d\tPRT\ttab\n",pc);
#endif
					ins[pc] = PRT | PTAB;
					IncrementaPC(&pc);
				}
#ifdef DEBUG
				D16print("\t%d\tPRT\tdata\n", pc);
#endif
				ins[pc] = PRT | PDAT;
				IncrementaPC(&pc);
				tabpos = 1;
				formnum = 0;
			}
break;
case 171:
#line 2292 "genparse.y"
{
				if (tabpos) {
#ifdef DEBUG
					D16print("\t%d\tPRT\ttab\n",pc);
#endif
					ins[pc] = PRT | PTAB;
					IncrementaPC(&pc);
				}
#ifdef DEBUG
				D16print("\t%d\tPRT\tstring\n", pc);
#endif
				ins[pc] = PRT | PALF;
				IncrementaPC(&pc);
				tabpos = 1;
				formnum = 0;
			}
break;
case 172:
#line 2309 "genparse.y"
{
				if (tabpos) {
#ifdef DEBUG
						D16print("\t%d\tPRT\ttab\n",pc);
#endif
						ins[pc] = PRT | PTAB;
						IncrementaPC(&pc);
				}
#ifdef DEBUG
				D16print("\t%d\tPRT\tvalor\n", pc);
#endif
				ins[pc] = PRT | PNUM;
				IncrementaPC(&pc);
				tabpos = 1;
				formnum = 0;
			}
break;
case 173:
#line 2330 "genparse.y"
{
				formnum = 1;
			}
break;
case 174:
#line 2342 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\t%d brancos\n", pc, yyvsp[0]);
#endif
				ins[pc] = PRT | (yyvsp[0] << 3 | PBRC);
				IncrementaPC(&pc);
				tabpos = 0;
				posnum = 0;
			}
break;
case 175:
#line 2353 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\tcoluna %d\n", pc, yyvsp[0]);
#endif
				ins[pc] = PRT | (yyvsp[0] << 3 | PCOL);
				IncrementaPC(&pc);
				tabpos = 0;
				posnum = 0;
			}
break;
case 176:
#line 2363 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\tnl\n", pc);
				D16print("\t%d\tPRT\tlinha\n", pc+1);
#endif
				ins[pc] = PRT | PNL;
				IncrementaPC(&pc);
				ins[pc] = PRT | PLIN;
				IncrementaPC(&pc);
				prtvar = 0;
				tabpos = 0;
			}
break;
case 177:
#line 2376 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\tnl\n", pc);
				D16print("\t%d\tPRT\tlinha\n", pc+1);
#endif
				ins[pc] = PRT | PNL;
				IncrementaPC(&pc);
				ins[pc] = PRT | PLIN;
				IncrementaPC(&pc);
				prtvar = 0;
				tabpos = 0;
			}
break;
case 178:
#line 2389 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\ttab\n", pc);
#endif
				ins[pc] = PRT | PTAB;
				IncrementaPC(&pc);
				prtvar = 0;
			}
break;
case 179:
#line 2398 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\ttab\n", pc);
#endif
				ins[pc] = PRT | PTAB;
				IncrementaPC(&pc);
				prtvar = 0;
			}
break;
case 180:
#line 2407 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\tpag\n", pc);
				D16print("\t%d\tPRT\tlinha\n", pc+1);
#endif
				ins[pc] = PRT | PFF;
				IncrementaPC(&pc);
				ins[pc] = PRT | PLIN;
				IncrementaPC(&pc);
				prtvar = 0;
				tabpos = 0;
			}
break;
case 181:
#line 2420 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\tpag\n", pc);
				D16print("\t%d\tPRT\tlinha\n", pc+1);
#endif
				ins[pc] = PRT | PFF;
				IncrementaPC(&pc);
				ins[pc] = PRT | PLIN;
				IncrementaPC(&pc);
				prtvar = 0;
				tabpos = 0;
			}
break;
case 183:
#line 2439 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\tcoluna %d\n", pc, yyvsp[-4]);
				D16print("\t%d\tPRT\tcampo %d\n", pc+1, yyvsp[-2]-yyvsp[-4]+1);
#endif
				if (yyvsp[-2] - yyvsp[-4] + 1 > RDRBUF)
				  {
					sprintf (tmpbuf, PegaMsg (3031), "", (RDRBUF -1) );
					execerror( tmpbuf, "");
				  }
				ins[pc] = PRT | (yyvsp[-4] << 3 | PCOL);
				IncrementaPC(&pc);
				ins[pc] = PRT | ((yyvsp[-2]-yyvsp[-4]+1) << 3 | PTAM);
				IncrementaPC(&pc);
				tabpos = 0;
			}
break;
case 184:
#line 2456 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\tcampo %d\n", pc, yyvsp[-2]);
#endif
				if (yyvsp[-2] > RDRBUF)
				  {
					sprintf (tmpbuf, PegaMsg (3031), (RDRBUF - 1) );
					execerror( tmpbuf, "");
				  }
				ins[pc] = PRT | (yyvsp[-2] << 3 | PTAM);
				IncrementaPC(&pc);
				tabpos = 0;
			}
break;
case 186:
#line 2474 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\talinhamento esquerda\n", pc);
#endif
				ins[pc] = PRT | PESQ;
				IncrementaPC(&pc);
			}
break;
case 187:
#line 2485 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\tdecimais %d\n", pc, 0);
#endif
				ins[pc] = PRT | PDEC;
				IncrementaPC(&pc);
			}
break;
case 188:
#line 2493 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\tdecimais %d\n", pc, yyvsp[0]);
#endif
				ins[pc] = PRT | (yyvsp[0] << 3 | PDEC);
				IncrementaPC(&pc);
			}
break;
case 189:
#line 2504 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\tdecimais %d\n", pc, 0);
#endif
				ins[pc] = PRT | PDEC;
				IncrementaPC(&pc);
			}
break;
case 190:
#line 2512 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tPRT\tdecimais %d\n", pc, yyvsp[0]);
#endif
				ins[pc] = PRT | (yyvsp[0] << 3 | PDEC);
				IncrementaPC(&pc);
			}
break;
case 191:
#line 2524 "genparse.y"
{
				prtvar = 1;
			}
break;
case 192:
#line 2532 "genparse.y"
{
				posnum = 1;
			}
break;
case 194:
#line 2542 "genparse.y"
{
				nparam[npr-1]++;
				(void) P_Push(TipoParametro, 'd');
			}
break;
case 195:
#line 2547 "genparse.y"
{
				nparam[npr-1]++;
				(void) P_Push(TipoParametro, 'a');
			}
break;
case 196:
#line 2552 "genparse.y"
{
				nparam[npr-1]++;
				(void) P_Push(TipoParametro, 'n');
			}
break;
case 197:
#line 2557 "genparse.y"
{
				nparam[npr-1]++;
				(void) P_Push(TipoParametro, 'd');
			}
break;
case 198:
#line 2562 "genparse.y"
{
				nparam[npr-1]++;
				(void) P_Push(TipoParametro, 'a');
			}
break;
case 199:
#line 2567 "genparse.y"
{
				nparam[npr-1]++;
				(void) P_Push(TipoParametro, 'n');
			}
break;
case 200:
#line 2577 "genparse.y"
{
				/* procura a variavel de arquivo */
				for (i = 1; i < narqs; ++i) {
					if (varfil[i] == yyvsp[-1])
						break;
				}	
				if (i >= narqs)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Variavel referencia de arquivo nao definida", "");
*** */

					execerror( PegaMsg (3163), "");

				/* testa o tipo do arquivo  */
				if (tipofil[i] == 2)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror(
					"Arquivo aberto como 'EXTERNO'. Utilize 'LEIAF'", "");
*** */

					execerror( PegaMsg (3167), "");

				/* obtem o indice do arquivo na tabela de arqs.
				e verifica seu modo  */
				arq = variavel[yyvsp[-1]].ptrval.ptra;
				if (arquivos[arq].modo != ENTRADA)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Leitura nao permitida. Arquivo aberto para gravacao", "");
*** */

					execerror( PegaMsg (3168), "");
#ifdef DEBUG
				D16print("\t%d\tSRD\t%s\n", pc,
					variavel[yyvsp[-1]].nome);
#endif
				/* manda ler o arquivo, guardando pc no 
				momento da leitura */
				pcread = pc;
				ins[pc] = SRD | arq;
				IncrementaPC(&pc);

			}
break;
case 202:
#line 2624 "genparse.y"
{
				/* testa o modo do arquivo */
				if (arquivos[arq].modo != ENTRADA)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Leitura nao permitida. Arquivo foi aberto para gravacao", "");
*** */

					execerror( PegaMsg (3168), "");
#ifdef DEBUG
				D16print("\t%d\tFRD\t%s\n", pc,
					variavel[yyvsp[-1]].nome);
#endif
				/* manda ler o arquivo  */
				ins[pc] = FRD | (arq << 4);
				IncrementaPC(&pc);
			}
break;
case 203:
#line 2643 "genparse.y"
{
				/* testa se e' formatado  */
				if (indfmt == 0)
					eform = 0;
				else
					/* testa se o no. de formatacoes e' 
					o mesmo do no. de vars. declaradas  */
					if (nformv == indvar)
						eform = 1;
					else {

/* *** Padroniz. msg erro - Adriana 09/01/95
						execerror("Falta especificar formato",
							"");
*** */

						execerror( PegaMsg (3169), "");
					}
				/* testa modo do arquivo  */
				if (arquivos[arq].modo != ENTRADA)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Leitura nao permitida. Arquivo aberto para gravacao", "");
*** */

					execerror( PegaMsg (3168), "");
#ifdef DEBUG
				D16print("\t%d\tFRD\tformato %d\n",pc, nform);
				D16print("\t%d\tFRD\t%s\n", pc+1,
					variavel[yyvsp[-2]].nome);
#endif
				/* arq. formatado */	
				if (eform) {
					/* aloca area para o formato do arq. */
					printbuf[indfmt++] = '\0';
					ubytes = (unsigned) indfmt;
					pp = (char *) malloc(ubytes);
					if (pp == (char *) NULL)

/* *** Padroniz. msg erro - Adriana 09/01/95
						execerror("Memoria disponivel esgotada", "");
*** */

						execerror( PegaMsg (1039), "");
					for (i = 0; i < indfmt; ++i)
						pp[i] = printbuf[i];
					formatos[nform] = pp;
				}
				else
					formatos[nform] = (char *) NULL;

				/* aloca area para os indices das vars  */
				ubytes = (unsigned) (indvar * sizeof(int));
				pv = (int *) malloc(ubytes);
				if (pv == (int *) NULL) {

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Memoria disponivel esgotada",
					"");
*** */

					execerror( PegaMsg (1039), "");
				}
				for (i = 0; i < indvar; ++i)
					pv[i] = vars[i];
				listas[nform] = pv;
				numvar[nform] = indvar;

				/* manda ler o arquivo  */
				ins[pc] = FRD | (nform << 4 | 1);
				IncrementaPC(&pc);
				ins[pc] = FRD | (arq << 4);
				IncrementaPC(&pc);
				pervar = 0;
				formnum = 0;
				++nform;
			}
break;
case 204:
#line 2721 "genparse.y"
{
#ifdef DEBUG
				D16print("\t%d\tSWR\n", pc);
#endif
				ins[pc] = SWR;
				IncrementaPC(&pc);
				output = 0;
			}
break;
case 205:
#line 2730 "genparse.y"
{
				/* procura o indice do arquivo na tabela de 
				indices e verifica se e' arq. externo  */
				for (i = 1; i < narqs; ++i) {
					if (varfil[i] == yyvsp[-1])
						if (tipofil[i] != 1)

/* *** Padroniz. msg erro - Adriana 09/01/95
							execerror(
							"Comando 'GRAVE' apenas para criacao arquivo_ntia. Utilize comando 'LISTE'", "");
*** */

							execerror( PegaMsg (3170), "");
						else
							break;
				}	
				if (i >= narqs)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Variavel referencia de arquivo nao definida", "");
*** */

					execerror( PegaMsg (3163), "");
				/* testa o modo do arquivo  */
				arq = variavel[yyvsp[-1]].ptrval.ptra;
				if (arquivos[arq].modo != SAIDA)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Gravacao nao permitida. Arquivo aberto para leitura", "");
*** */

					execerror( PegaMsg (3164), "");
#ifdef DEBUG
				D16print("\t%d\tSWR\t%s\n", pc,
					variavel[yyvsp[-1]].nome);
#endif
				/* manda gravar o  arquivo  */
				ins[pc] = SWR | arq;
				IncrementaPC(&pc);
				output = 0;
			}
break;
case 207:
#line 2776 "genparse.y"
{
				yyval = pc;
#ifdef DEBUG
				D16print("\t%d\tJFDA\t 0\n",pc);
#endif
				ins [pc] = JFDA | 0;	
				IncrementaPC(&pc);
			      }
break;
case 208:
#line 2785 "genparse.y"
{
				/* caso a condicao de leitura nao tenha sido 
				satisfeita, le uma nova observacao  */
				/***
#ifdef DEBUG
				D16print("\t%d\tJF\t%d\n",pc,pcread);
#endif
				**** ins[pc] = JF | pcread;
				IncrementaPC(&pc);
				****/

				/***
				**** testa o resultado da expressao e, se falso,
				**** desvia para um bloco auxiliar, que retira 
				**** da pilha o numero da ultima observacao 
				**** lida
				***/
#ifdef DEBUG
				D16print("\t%d\tJF\t%d\n",pc,pc + 2);
#endif
				ins [pc] = JF | (pc + 2); 
				IncrementaPC(&pc);

				/***
				**** Se o resultado da expressao e' verdadeiro,
				**** desvia para a proxima instrucao apos a
				**** expressao 
				***/
#ifdef DEBUG
				D16print("\t%d\tJMP\t%d\n",pc,pc + 3);
#endif
				ins [pc] = JMP | (pc + 3);
				IncrementaPC(&pc);

				/***
				**** Este e' o bloco auxiliar (acima citado).
				***/
#ifdef DEBUG
				D16print("\t%d\tPOP\n",pc);
#endif
				ins [pc] = FSPC | POP;
				IncrementaPC(&pc);
#ifdef DEBUG
				D16print("\t%d\tJMP\t%d\n",pc,pcread);
#endif
				ins [pc] = JMP | pcread;
				IncrementaPC(&pc);


				/***
				**** atualiza o JFDA do WHERE 
				***/
#ifdef DEBUG
				D16print("\tatualizar em %d para %d\n",
					 yyvsp[-3], pc);
#endif
				ins [yyvsp[-3]] |= pc; 

			}
break;
case 209:
#line 2848 "genparse.y"
{
				for (i = 1; i < narqs; ++i) {
					if (varfil[i] == yyvsp[0])
						if (tipofil[i] != 2)

/* *** Padroniz. msg erro - Adriana 09/01/95
							execerror(
							"Arquivo aberto como arquivo_ntia. Utilize comando 'LEIAS'", "");
*** */

							execerror(
							PegaMsg (3171), "");
						else
							break;
				}	
				if (i >= narqs)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Variavel referencia de arquivo nao definida","");
*** */

					execerror( PegaMsg (3163),"");
				arq = variavel[yyvsp[0]].ptrval.ptra;
				indfmt = 0;
				indvar = 0;
				nformv = 0;
				pervar = 7;
			}
break;
case 214:
#line 2885 "genparse.y"
{

/* *** Padroniz. msg erro - Adriana 09/01/95
				execerror("Formato errado ou ausente", "");
*** */

				execerror( PegaMsg (3169), "");
			}
break;
case 215:
#line 2897 "genparse.y"
{
				formnum = 1;
			}
break;
case 216:
#line 2908 "genparse.y"
{
				printbuf[indfmt++] = '#';
				itoa(yyvsp[0], &printbuf[indfmt], 10);
				indfmt += (strlen(&printbuf[indfmt]) + 1);
				posnum = 0;
			}
break;
case 217:
#line 2916 "genparse.y"
{
				printbuf[indfmt++] = '@';
				itoa(yyvsp[0], &printbuf[indfmt], 10);
				indfmt += (strlen(&printbuf[indfmt]) + 1);
				posnum = 0;
			}
break;
case 218:
#line 2923 "genparse.y"
{
				printbuf[indfmt++] = 'L';
				printbuf[indfmt++] = '\0';
				prtvar = 0;
			}
break;
case 219:
#line 2929 "genparse.y"
{
				printbuf[indfmt++] = 'L';
				printbuf[indfmt++] = '\0';
				prtvar = 0;
			}
break;
case 220:
#line 2939 "genparse.y"
{
				if (yyvsp[-2] - yyvsp[-4] +1 > RDRBUF)
				  {
					sprintf (tmpbuf, PegaMsg (3031), (RDRBUF -1) );
					execerror( tmpbuf, "");
				  }
				printbuf[indfmt++] = '@';
				itoa(yyvsp[-4], &printbuf[indfmt], 10);
				indfmt += (strlen(&printbuf[indfmt]) + 1);
				itoa(yyvsp[-2]-yyvsp[-4]+1, &printbuf[indfmt], 10);
				indfmt += (strlen(&printbuf[indfmt]) + 1);
				itoa(yyvsp[-1], &printbuf[indfmt], 10);
				indfmt += (strlen(&printbuf[indfmt]) + 1);
				++nformv;
			}
break;
case 221:
#line 2955 "genparse.y"
{
				if (yyvsp[-2] > RDRBUF)
				  {
					sprintf (tmpbuf, PegaMsg (3031), (RDRBUF - 1) );
					execerror( tmpbuf, "");
				  }
				itoa(yyvsp[-2], &printbuf[indfmt], 10);
				indfmt += (strlen(&printbuf[indfmt]) + 1);
				itoa(yyvsp[-1], &printbuf[indfmt], 10);
				indfmt += (strlen(&printbuf[indfmt]) + 1);
				++nformv;
			}
break;
case 222:
#line 2971 "genparse.y"
{
				yyval = 0;
			}
break;
case 223:
#line 2975 "genparse.y"
{
				yyval = yyvsp[0];
			}
break;
case 224:
#line 2982 "genparse.y"
{
				yyval = 0;
			}
break;
case 225:
#line 2986 "genparse.y"
{
				yyval = yyvsp[0];
			}
break;
#line 4437 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
