%{
/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Arquivo que a gramtica da linguagem GENESE

 Desenvolvido por:

      Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
      Carla Geovana do N. Macario
	Maria Fernanda Moura

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <string.h>
#ifdef MSDOS
# include <stdlib.h>
# include "y_tab.h"
#else
#ifdef VAXVMS
#include <stdlib.h>
#include "ytab.h"
#else
#include <malloc.h>
# include "y.tab.h"
#endif
#endif

#ifdef	MEM_DEBUG
#include "mshell.h"
#endif

#include "socasm.h"
#include "pcsgbd.h"
#include "genese.h"
#include "pilha.h"

#ifdef DEBUG
#define	YYDEBUG			1
#endif

/* ----------------------------------------------------------------------------
**
**	
**
** Define a gramatica do modulo genese
**
**
** Programado por:
**
**		Oscar Ivan Palma Pacheco
**		Carlos Fernando Assis Paniago
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**		Oscar Ivan Palma Pacheco
**
**
** Data da ultima alteracao:
**
**		97/02/28 15:44:02
**
** ----------------------------------------------------------------------------
*/


#ifdef DEBUG
extern	int	f_16;
#endif

#define YYMAXDEPTH 500

extern struct funcwords funcwords[]; 	/* Informacoes de funcoes matematicas e
					   funcoes que tratam datas numericas.*/

extern struct funcwords funcswords[]; 	/* Informcaoes de funcoes que tratam
					   strings.  */

extern struct funcwords funcdwords[]; 	/* Informacoes de funcoes de datas. */

extern struct funcwords funcvwords[];	/* informacoes de funcoes void */

extern struct keywords cnstwords[]; 	/* Informacoes de constantes. */

extern struct variavel variavel[];	/* Informacoes das vars. do genese. */

extern struct arquivos arquivos[];	/* Informacoes dos arqs. do genese. */

extern	int	pc;		/* Contador do programa. */
extern	int	output;		/* Flag - e' arquivo de saida. */
extern	int	pervar;		/* Contem o tipo da variavel. */
extern	int	iskeep;		/* Flag - variavel a ser mantida. */
extern	int	isdrop;		/* Flag - variavel a ser excluida. */
extern	int	narqs;		/* Numero de arquivos existentes. */
extern	int	prtvar;		/* Caracter especial de formatacao:
				   \L, \T ou \P */
extern	int	nform;		/* Numero de arquivos externos com formatos. */
extern	int	indvar;		/* Indice de variaveis de um arquivo. */
extern	int	posnum;		/* Numero de coluna a partir da qual deve ser
				   Iniciada a leitura formatada. */
extern	int	formnum;	/* Indice de variavel com formato numerico
				   para sua leitura. */
extern	unsigned int	ins[];	/* Vetor de instrucoes do programa. */
extern	int	nomeflag;	/* Flag - e' nome de arquivo. */
extern	int	debflag;	/* Flag - permite a depuracao do programa. */
extern	int	setmodo;	/* Flag - modo. */
extern	char	printbuf[];	/* Armazena a formatacao do arq. */
extern	char	*formatos[];	/* Formatacao de cada arquivo formatado. */
extern	int	*listas[];	/* Lista de vars. de cada arquivo externo. */
extern	int	numvar[];	/* Numero de vars. de cada arquivo externo. */
extern	int	pareeof;	/* Constante de final de arquivo. */

/*
** Variaveis globais neste arquivo.
*/

int	arq;
char	tabpos;			/* Tabulacao da posicao de impressao. */
char	*pp;			/* Buffer com a formatacao do arquivo. */
int	i, j, ct_break = 0;	/* indices auxiliares */
int	pcread;			/* variavel auxiliar para guardar o valor de 
				   pc */
int	indfmt;			/* Indice de formatacao de arquivo formatado. */
int	*pv;			/* Apontador para os indices das vars do
				   arquivo. */
int	eform;			/* Flag - e' formatado. */
int	nformv;			/* Numero de formatacoes. */
int	tarqs;			/* Total de arquivos lidos sem considerar os
				   que serao utilizados para concatenacao. */
int	varfil[MAXGENARQ];	/* Indice das variaveis arquivo. */
char	tipofil[MAXGENARQ];	/* Tipo do arquivo:
					1 - Arquivo do sistema
					2 - Arquivo externo
					3 - Arquivo para concatenacao vertical
					4 - Arquivo para concatenacao horizontal
				*/
int	yynch;
int	vetchave[MAXCHAVES];	
int	vars[MAXVAR];		/* Indices das variaveis de arquivo externo. */
int	flag_dcls = 0;		/* Flag de declaracao. */
char	tipordenacao;		/* Tipo de ordenacao. */
int	flagord=0;		/* Flag de ordenacao. */
int	end_break[200];		/* contem os enderecos dos breaks de cada 
				   while */
int	num_while = 0;		/* contem o no. do while que o parse esta' 
				   analisando  */
static	int	*vet;
int	nparam[100];		/* Indices dos parametros. */
int	npr = 0;	
unsigned ubytes;


T_Pilha		TipoParametro;			/* Tipo de parametros recebidos em listas de 
							argumentos de funcoes */
char	tmpbuf [128]; 

/*
** Mensagens de ERRO.
*/


static int Msg[] = {
	3182, /* Nao se pode usar MANTER e EXCLUIR no mesmo programa */
	3183, /* Estourado o numero maximo de arquivos */
	3184, /* ABRES(SOPEN): Lista de variaveis so' para criacao de arquivo */
	1039, /* Memoria disponivel esgotada */
	3185, /* ABREF(EOPEN): Lista de variaveis so' para leitura de arquivo */
	1039, /* Memoria disponivel esgotada */
	3186, /* Declaracao do nome e/ou tipo do arquivo incorreta */
	3183, /* Estourado o numero maximo de arquivos */
	3187, /* Especificacao da lista de arquivos incorreta */
	9999  /* (char *) NULL */
};


%}

%token	KEEP DROP NUMBER IF WHILE ELSE SREAD EREAD FUNCAO FTOA ATOF STOP MNT
%token	MYFILE SOPEN EOPEN VALSTR FLOAT PRINT VARSTR VARNUM DATE VARFIL RDEBUG
%token	EQ NEQ LT LE GT GE NOT AND OR STRING NOMEARQ CONTINUE OUTPUT CONST
%token	FUNCAOS MODO ABORT CONCV CONCH CHAVE ORD ASC DESC VARDATA VALDATA
%token	FUNCAOD FUNCAOV MISSNUM REWIND BREAK DTOA ATOD DTOF FTOD WHERE PAUSE
%token	'(' '{' ')' '}' ';' ',' '#' '@' '\\'
%left	OR
%left	AND
%left	GT GE LT LE EQ NEQ
%left	'+' '-'
%left	'*' '/' '%'
%left	UNARYMINUS NOT
%right	'^'
%%

/*
** Estrutura geral de um programa Genese.
*/

			/*
			** Incluindo declaracoes.
			*/

pgm		:	dcls dclsend inicia bloco
			{
				/*
				** Fim do programa genese.
				*/

				pgm();
				return 0;
			}

			/*
			** Apenas comandos.
			*/

		|	{
				flag_dcls = 1;
			}

			inicia bloco

			{
#ifdef DEBUG
				D16print("\t%d\tJMP\t1\n", pc);
#endif
				/*
				** Instrucao para parar a execucao do programa.
				*/

				ins[pc] = PARE;
				IncrementaPC(&pc);
				return 0;
			}

		|	error
			{
				execerror( PegaMsg (3159), "");
			}
		;

inicia:	/* nada a nao ser inicializar variaveis globais */
		{

			TipoParametro = Pil_Create(128);
		}


/*
** Conjunto de declaracoes .
*/

dcls		:	dcl ';'
		|	dcls dcl ';'
		;


/*
** Declaracoes.
*/

			/*
			** Declara  variaveis a serem mantidas.
			*/

dcl		:	KEEP inikd lista_de_var
			{
				if (isdrop)
					execerror(PegaMsg (Msg[0]), "");
				iskeep = 1;
			}

			/*
			** Declara variaveis a serem excluidas.
			*/

		|	DROP inikd lista_de_var
			{
				if (iskeep)
					execerror(PegaMsg (Msg[0]), "");
				isdrop = 1;
			}

			/*
			** Declara variaveis numericas.
			*/

		|	FLOAT perf lista_de_var_n
			{
				pervar = 0;	/* reseta pervar */
			}

			/*
			** Declara variaveis tipo data.
			*/

		|	DATE perd lista_de_var_d
			{
				pervar = 0;	/* reseta pervar */
			}

			/*
			** Declara variaveis tipo string.
			*/

		|	STRING pers lista_de_var_s
			{
				pervar = 0;	/* reseta pervar */
			}

			/*
			** Declara arquivos.
			*/

		|	MYFILE defil VARFIL '=' opcao
			{
				/*
				** Testa o numero de arquivos.
				*/

				if (narqs >= MAXGENARQ - 1)
					execerror(PegaMsg (Msg[1]), "");

				/*
				** Seta o indice deste arq. no vetor de vars. 
				** do arquivo.
				*/

				varfil[narqs] = $3; 

				/* tipo do arq. */

				tipofil[narqs] = (char) ($5); 

				/*
				** Arquivo do sistema ou externo: tipo da
				** variavel e' "a" e indica o indice deste
				** arquivo na tabela de arquivos.
				*/

				if ($5==1 || $5==2) {
					variavel[$3].tipo = 'a';
					variavel[$3].ptrval.ptra = narqs++;
				}
				else {

					/*
					** Arquivo p/ concatenacao: variavel
					** do tipo v ou h.
					*/

					if ($5==3)
						variavel[$3].tipo = 'v';
					else
						variavel[$3].tipo = 'h';

					/*
					** Indica o indice deste arquivo na
					** tabela de variaveis.
					*/

					variavel[$3].ptrval.ptra = tarqs;

					/*
					** Indica que os arquivos com indices
					** de tarqs ate (narqs-tarqs) serao
					** usados na concatenacao do arquivo $3
					** e define o tipo de concatenacao
					** (v ou h).
					*/

					for(; tarqs<narqs ; tarqs++) {
						varfil[tarqs] = $3;
						tipofil[tarqs] = (char) ($5);
					}
				}

				pervar = 0;	/* reseta pervar */
			}

			/*
			** Debuga durante execucao. Normalmente disponivel
			** somente em versoes internas do CNPTIA.
			*/

		|	RDEBUG xdeb NUMBER
			{
				debug($3);
			}
		;


xdeb		:	/* nada */
			{
				debflag = -1;
			}
		;


/*
** Indica que espera o nome de uma variavel.
*/

inikd		:	/* nada */
			{
				pervar = 5;
			}
		;


/*
** Indica que espera o nome de um arquivo.
*/

defil		:	/* nada */
			{
				pervar = 3;
				tarqs  = narqs;
				yynch  = 0;
			}
		;


/*
** Fim das declaracoes.
*/

dclsend		:	/* nada */ 
			{
				/*
				** Termina bloco de declaracoes.
				** Prepara para iniciar comandos.
				*/

				dclsend();
				flag_dcls = 1;
			}
		;


/*
** Indica que espera o nome de uma variavel numerica.
*/

perf		:	/* nada */
			{
				pervar = 1;
			}
		;


/*
** Indica que espera o nome de uma variavel tipo data.
*/

perd		:	/* nada */
			{
				pervar = 4;
			}
		;


/*
** Indica que espera o nome de uma variavel tipo string.
*/

pers		:	/* nada */
			{
				pervar = 2;
			}
		;


/*
** Trata lista de variaveis na abertura de arquivos.
** Pode ser vazia.
*/

lista_de_var_op	:	/* nada */
			{
				$$ = 0;
			}

		|	lista_de_var
			{
				$$ = -1;
			}
		;


/*
** Trata lista de variaveis em geral.
** Nao pode ser vazia.
*/

lista_de_var	:	variavel
		|	lista_de_var variavel

		|	error
			{

/* *** Padroniz. msg erro - Adriana 09/01/95
				execerror(
				"Lista de variaveis nao especificada","");
*** */

				execerror( PegaMsg (3027), "");
			}
		;

/*
** Coloca informacoes da variavel na lista. 
*/

variavel	:	VARNUM
			{
				listadevar($1);
			}

		|	VARSTR
			{
				listadevar($1);
			}

		|	VARDATA
			{
				listadevar($1);
			}
		;


/*
** Trata lista de variaveis tipo data.
*/

lista_de_var_d	:	VARDATA
			{
				listadevar($1);
			}

		|	lista_de_var_d VARDATA
			{
				listadevar($2);
			}
		;


/*
** Trata lista de variaveis numericas.
*/

lista_de_var_n	:	VARNUM
			{
				listadevar($1);
			}

		|	lista_de_var_n VARNUM
			{
				listadevar($2);
			}
		;


/*
** Trata lista de variaveis tipo string.
*/

lista_de_var_s	:	VARSTR
			{
				listadevar($1);
			}

		|	lista_de_var_s VARSTR
			{
				listadevar($2);
			}
		;


/*
** Trata as opcoes associadas aos arquivos.
*/

			/*
			** Abertura de arquivos no formato NTIA.
			*/

opcao		:	SOPEN nomarq '(' nome_do_arq ')' lvar lista_de_var_op
			{
				/*
				** Verifica as variaveis, se tiver.
				*/

				if (indvar) {
					arquivos[narqs].nvar = indvar;
					ubytes=(unsigned)(indvar*sizeof(int));

					/*
					** Aloca area para os indices das
					** variaveis.
					*/

					pv = (int *) malloc(ubytes);

					if (pv == (int *) NULL)
						execerror( PegaMsg (Msg[3]), "");

					/*
					** Coloca em pv os indices das
					** variaveis.
					*/

					for (i = 0; i < indvar; ++i)
						pv[i] = vars[i];

					/*
					** Coloca na estrutura de arquivos o
					** apontador para os indices das
					** variaveis.
					*/

					arquivos[narqs].pos = pv;
				}

				/*
				** Verifica se tem variaveis declaradas.
				*/

				if ($7) {
					/*
					** Tem variaveis declaradas.
					** Verifica se e' arquivo de saida.
					*/

					if ($4 != SAIDA)
						execerror(PegaMsg (Msg[2]), "");

					ssopen(SAIDA);
				}

				else {
					/*
					** Nao tem variaveis declaradas.
					** Verifica modo (entrada ou saida).
					** O default e' ENTRADA.
					*/

					if ($4 == -1)
						ssopen(ENTRADA);
					else
						ssopen($4);
				}

				/*
				** Nao e' arquivo a ser concatenado, logo 
				** os campos abaixo sao NULL ou 0.
				*/

				arquivos[narqs].fim = 0;
				arquivos[narqs].nch = 0;
				arquivos[narqs].ch  = NULL;
				arquivos[narqs].qarea.pch = NULL;

				$$ = 1;
			}

			/*
			** Abertura de arquivos esterno.
			*/

		|	EOPEN nomarq '(' nome_do_arq ')' lvar lista_de_var_op
			{
				/*
				** Verifica as variaveis, se tiver.
				*/

				if (indvar) {
					arquivos[narqs].nvar = indvar;
					ubytes=(unsigned)(indvar*sizeof(int));

					/*
					** Aloca area para os indices das
					** variaveis.
					*/

					pv = (int *) malloc(ubytes);

					if (pv == (int *) NULL) {

/* *** Padroniz. msg erro - Adriana 09/01/95
						execerror(
						"Memoria disponivel esgotada",
						"");
*** */

						execerror( PegaMsg (1039), "");
					}

					/*
					** Coloca em pv os indices das
					** variaveis.
					*/

					for (i = 0; i < indvar; ++i)
						pv[i] = vars[i];

					/*
					** Coloca na estrutura de arquivos o
					** apontador para os indices das
					** variaveis.
					*/

					arquivos[narqs].pos = pv;
				}

				/*
				** Verifica se tem variaveis declaradas.
				*/

				if ($7) {
					/*
					** Tem variaveis declaradas.
					** Verifica se e' arquivo de saida.
					*/

					if ($4 == SAIDA)
						execerror(PegaMsg (Msg[4]), "");

					ffopen(ENTRADA);
				}

				else {
					/*
					** Nao tem variaveis declaradas.
					** Verifica modo (entrada ou saida).
					** O default e' ENTRADA.
					*/

					if ($4 == -1)
						ffopen(ENTRADA);
					else
						ffopen($4);
				}

				/*
				** Nao e' arquivo a ser concatenado, logo 
				** os campos abaixo sao NULL ou 0.
				*/

				arquivos[narqs].fim = 0;
				arquivos[narqs].nch = 0;
				arquivos[narqs].ch  = NULL;
				arquivos[narqs].qarea.pch = NULL;

				$$ = 2;
			}

			/*
			** Concatenacao vertical de arquivos.
			*/

		|	CONCV nomarq '(' lista_arq { nomeflag = 0;} ')' chave 
			{
				/*
				** Indica o indice do ultimo arquivo a ser
				** concatenado.
				*/

				arquivos[tarqs].fim = narqs-1;
				arquivos[tarqs].nch  = yynch;

				if (yynch == 0)
					/*
					** Nao tem chaves p/ concatencao.
					*/ 

					arquivos[tarqs].ch = NULL;

				else {
					/*
					** Tem chaves p/ concatenacao.
					*/

					ubytes = (unsigned) (yynch*sizeof(int));

					/*
					** Aloca area para os inds. das chaves.
					*/

					vet = (int *) malloc(ubytes);

					if (vet == (int *) NULL) {

/* *** Padroniz. msg erro - Adriana 09/01/95
						execerror(
						"Memoria disponivel esgotada",
						"");
*** */

						execerror( PegaMsg (1039), "");
					}

					/*
					** Coloca em vet os indices das vars.
					*/

					for (i=0; i < yynch; i++)
						vet[i] = vetchave[i];

					/*
					** Coloca na estrutura arquivos o vetor
					** de indices das chaves.
					*/

					arquivos[tarqs].ch = vet;
				}

				/*
				** Aloca memoria para a area de trabalho da 
				** concatencao vertical.
				*/

				ubytes = (unsigned) sizeof(struct WorkArea);
				arquivos[tarqs].qarea.pcv =
					(struct WorkArea *) malloc(ubytes);

				if (arquivos[tarqs].qarea.pcv == WNULL)
					execerror(PegaMsg (Msg[5]), "");

				arquivos[tarqs].qarea.pcv->mestre = 0;
				arquivos[tarqs].qarea.pcv->tip_ord =
						tipordenacao;
				$$ = 3;
			}

			/*
			** Concatenacao horizontal de arquivos.
			*/

		|	CONCH nomarq '(' lista_arq { nomeflag = 0;} ')' chave 
			{
				/*
				** Indica o indice do ultimo arquivo a ser
				** concatenado.
				*/

				arquivos[tarqs].fim = narqs-1;
				arquivos[tarqs].nch  = yynch;

				if ( yynch == 0 )
					/*
					** Nao tem chaves p/ concatencao.
					*/

					arquivos[tarqs].ch = NULL;
				else {
					/*
					** Tem chaves p/ concatenacao.
					*/

					ubytes = (unsigned) (yynch*sizeof(int));

					/*
					** Aloca area para os inds. das chaves.
					*/

					vet = (int *) malloc(ubytes);

					if (vet == (int *) NULL)
						execerror(PegaMsg (Msg[5]), "");

					/*
					** Coloca em vet os indices das vars.
					*/

					for (i = 0; i < yynch; i++)
						vet[i] = vetchave[i];

					/*
					** Coloca na estrutura arquivos o
					** vetor de indices das chaves.
					*/

					arquivos[tarqs].ch = vet;
				}

				/*
				** Aloca memoria para a area de trabalho da
				** concatencao horizontal.
				*/

				ubytes = (unsigned) sizeof(struct Ch_Area);
				arquivos[tarqs].qarea.pch =
					(struct Ch_Area *) malloc(ubytes);

				if (arquivos[tarqs].qarea.pch == ChNULL)
					execerror( PegaMsg (Msg[5]), "");

				arquivos[tarqs].qarea.pch->mestre = 0;
				arquivos[tarqs].qarea.pch->tip_ord =
						tipordenacao;
				$$ = 4;
			}
		;


/*
** Seta flag indicando que espera um nome de arquibvo.
*/

nomarq		:	/* nada */
			{
				nomeflag = -1;
			}
		;


/*
** Indica que espera uma lista de variaveis.
*/

lvar		:	/* nada */
			{
				pervar = 6;
				indvar = 0;
			}
		;


/*
** Tratamento de nome e/ou tipo de arquivo.
*/

nome_do_arq	:	NOMEARQ
			{
				$$ = -1;
				nomeflag = 0;
			}

		|	NOMEARQ { nomeflag = 0; } ',' { setmodo = 1;} MODO
			{
				$$ = $5;
				setmodo = 0;
			}

		|	error
			{
				execerror( PegaMsg (Msg[6]), "");
			}
		;

/*
** Define a lista de arquivos que serao usados na concatenacao  
*/

lista_arq	: NOMEARQ
		  {
			if ( narqs >= MAXGENARQ - 1)
				execerror( PegaMsg (Msg[7]), "");

			ssopen(ENTRADA);
			arquivos[narqs].fim = 0;
			arquivos[narqs].nch = 0;
			arquivos[narqs].ch  = NULL;
			arquivos[narqs].qarea.pch = NULL;
			++narqs;
		  }

		| lista_arq NOMEARQ
		  {
			if ( narqs >= MAXGENARQ - 1)
				execerror(PegaMsg (Msg[7]), "");

			ssopen(ENTRADA);
			arquivos[narqs].fim = 0;
			arquivos[narqs].nch = 0;
			arquivos[narqs].ch  = NULL;
			arquivos[narqs].qarea.pch = NULL;
			++narqs;
		  }

		| error
		  {
			execerror( PegaMsg (Msg[8]), "");
		  }
		;


/*
** Define as chaves para concatenacao dos arquivos
*/

chave		: /* nao tem chave */
		|	CHAVE { pervar = 8; }  lista_de_var  {pervar = 0;} ord
			{
				tipordenacao = (char) $5;
			}

		|	error 
			{

/* *** Padroniz. msg erro - Adriana 09/01/95
			execerror("Especificacao de chave incorreta","");
*** */

			execerror( PegaMsg (3155),"");
			}	
		;

ord		: /* nada */	{ flagord = 0; $$ = 'a'; }

		|	ORD { flagord = 1;}	'='	tipoOrd
			{
				$$ = $4;
			}

		|	error 
			{
			flagord = 0; 

/* *** Padroniz. msg erro - Adriana 09/01/95
			execerror("Especificacao de ordenacao incorreta","");
*** */

			execerror( PegaMsg (3156), "");
			}	
		;

tipoOrd		:	ASC	
			{
				flagord = 0;
				$$ = (int) 'a';
			}

		|	DESC	
			{
				flagord = 0;
				$$ = (int) 'd';
			}

		|	error 
			{
			flagord = 0; 

/* *** Padroniz. msg erro - Adriana 09/01/95
			execerror("Especificacao de ordenacao incorreta","");
*** */

			execerror( PegaMsg (3156),"");
			}	
		;	
			

bloco		:	'{' cmds '}'
		;


cmds		: 	cmd
		|	cmds cmd
		;


cmd		:	atribnum ';' 	/* atribuicao numerica  */
		|	atribstr ';'	/* atribuicao de strings */
		|	atribdat ';'	/* atribuicao de datas  */
		|	IF cond start cmd else
			{
#ifdef DEBUG
				D16print("\tatualizar em %d para %d\n", $3,$5);
#endif
				/* Coloca o valor retornado por else como
				parametro da instrucao cujo indice no vetor de 
				instrucoes e' o valor retornado por start. No
				caso, a instrucao e' um JF e o parametro e'
				o endereco (pc) do comeco do else.*/
				ins[$3] |= $5;
			}
		|	WHILE end cond start cmd
			{
#ifdef DEBUG
				D16print("\t%d\tJMP\t%d\n",pc, $2);
				D16print("\tatualizar em %d para %d\n",
					$4, pc+1);
#endif
				/* Ao final dos comandos, realiza um JMP para
				a posicao retornada por end. No caso, faz a
				execucao retornar para o comando inicial do 
				WHILE, que e' a condicao.  */

				ins[pc] = JMP | $2;
				IncrementaPC(&pc);

				/* Coloca o pc apos a execucao dos comandos  
				como parametro da instrucao cujo indice no 
				vetor de instrucoes e' o valor retornado por 
				start. No caso, a instrucao e' um JF e o 
				parametro e' o endereco (pc) ao final da 
				execucao dos comandos */

				ins[$4] |= pc;

				/* Verifica a existencia de algum break dentro
				do while, atualizando o parametro da instrucao 
				correspondente ao break, no caso o comando JMP.
				O endereco do JMP passa a ser o endereco do 
				fim do while . Feito isso, decrementa o no. 
				de while's ja' tratados */

				if ( ct_break > 0 )
					--ct_break;
				while ( end_break[ct_break] > 0 && 
							ct_break >= 0 ) {
#ifdef DEBUG
					D16print("\tatualizar em %d para %d\n",
						end_break[ct_break], pc);
#endif
						ins[end_break[ct_break]] |= pc;
						--ct_break;
				}
				if ( end_break[ct_break] < 0 && ct_break > 0 )
					--ct_break;
				num_while--;
			}
		|	BREAK ';'	
			{ 
#ifdef DEBUG
				D16print("\t%d\tJMP\t0\n",pc);
#endif
				if (!num_while )

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Comando BREAK usado fora do WHILE", "");
*** */

					execerror( PegaMsg (3157), "");
				else if ( ct_break == 200 )
				      {	
					sprintf (tmpbuf, PegaMsg (3161), 200);
					execerror( tmpbuf, "");
				      }
				else {

				/* Atualiza o no. de breaks referentes a esse
				while. Coloca o endereco da instrucao 
				correspondente ao break no vetor de enderecos 
				de breaks deste while. Coloca a instrucao para 
				desvio da execucao do programa
				no vetor de instrucoes */

					end_break[ct_break++] = pc;
					ins[pc] = JMP;
					IncrementaPC(&pc);
				}
			}
		|	entsai ';' /* comandos de E/S (read e write)  */
			{
#ifdef DEBUG
				D16print("\t%d\tSTV\tnulo\n",pc);
#endif
				ins[pc] = STV | VARNULL;
				IncrementaPC(&pc);
			}
		|	PRINT unidadep { tabpos = 0; } itens ';' 
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\tnl\n",pc);
				D16print("\t%d\tPRT\tlinha\n",pc+1);
#endif
				ins[pc] = PRT | PNL;
				IncrementaPC(&pc);
				ins[pc] = PRT | PLIN;
				IncrementaPC(&pc);
			}
		|	PAUSE '(' VALSTR ')' ';'  /* rewind de arquivo */
			{
#ifdef DEBUG
				D16print("\t%d\tLDS\t%s\t%d\n", pc, 
					variavel[$3].ptrval.ptrs, $3);
				D16print("\t%d\tFSPC\tPSE\t\n",pc+1);
#endif
				/* Manda carregar valor string na pilha de 
				dados e executar a funcao especial PSE */
				ins[pc] = LDS | $3;
				IncrementaPC(&pc);
				ins[pc] = FSPC | PSE;
				IncrementaPC(&pc);
			}
		|	REWIND '(' VARFIL ')' ';'  /* rewind de arquivo */
			{
#ifdef DEBUG
				D16print("\t%d\tLDI\t%s\t%d\n",pc,
					variavel[$3].nome, $3);
				D16print("\t%d\tFSPC\tRWND\t\n",pc+1);
#endif
				/* pega o indice do arquivo na tabela manda
				colocar na pilha. Manda executar a funcao 
				especial rewind  */
				arq = variavel[$3].ptrval.ptra;
				ins[pc] = LDI | arq;
				IncrementaPC(&pc);
				ins[pc] = FSPC | RWND;
				IncrementaPC(&pc);
			}
		|	CONTINUE ';'
			{
#ifdef DEBUG
				D16print("\t%d\tJMP\t%d\n",pc, 0);
#endif
				ins[pc] = JMP;
				IncrementaPC(&pc);
			}
		|	STOP ';'  /* termina a execucao do programa genese */
			{
#ifdef DEBUG
				D16print("\t%d\tSTOP\n",pc);
#endif
				ins[pc] = PARE;
				IncrementaPC(&pc);
			}
		|	ABORT ';' /* aborta a execucao do programa genese */
			{
#ifdef DEBUG
				D16print("\t%d\tABORT\n",pc);
#endif
				ins[pc] = PARE | 255;
				IncrementaPC(&pc);
			}
		|	FUNCAOV
			{
				nparam[npr++] = 0;
				if (npr > 99 || npr < 0)
				  {
					sprintf (tmpbuf, PegaMsg (3160), 99 );
					execerror( tmpbuf, "");
				  }
			}
			'(' lista_de_exprs ')'	/* lista de parametros  */
			{
				/* verifica se o no. de parms. da funcao esta'
				certo  */

				i = funcvwords[$1].nparm;

				if (i != nparam[npr-1]) {
					if (funcvwords[$1].kval == OSRAND
						&& nparam[npr-1] == 0) {
#ifdef DEBUG
						D16print("\t%d\tLDV\tnulo\n",
							pc);
#endif
						ins[pc] = LDV | VARNULL;
						IncrementaPC(&pc);
					}

					else if (i % 10 != nparam[npr-1] &&
						(i/100) != nparam[npr-1])
					       {
						sprintf (tmpbuf, PegaMsg (3165), funcwords[$1].name);
						execerror( tmpbuf, "");
					       }
				}

				npr--;

				/* Verifica se os tipos de parametros estao corretos */

				for(j=i-1; j >= 0;	j--) {

				    if ( funcvwords[$1].tipo_par[j] !=  P_Top(TipoParametro) ) {
					/*Tipo de Parametro Incorreto*/ 
					sprintf(tmpbuf,PegaMsg(3251));
					execerror(tmpbuf,"");
				    }
				    (void) P_Pop(TipoParametro);
				}

#ifdef DEBUG
				D16print("\t%d\tFUNC\t%s\n", pc,
					funcvwords[$1].name);
#endif
				/* manda executar a funcao  */	
				ins[pc] = FUNC | funcvwords[$1].kval;
				IncrementaPC(&pc);
			}
		|	bloco
		|	RDEBUG xdeb NUMBER ';'
			{
				debug($3);
			}
		|	';'
		|	error
			{

/* *** Padroniz. msg erro - Adriana 09/01/95
				execerror("Comando invalido ou fora de ordem","");
*** */

				execerror( PegaMsg (3005),"");
			}
		;


unidadep	:	/* nada */
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\tunidade padrao\n", pc);
#endif
				ins[pc]=PRT | (100 << 3 | PUNI);
				IncrementaPC(&pc);
			}
		|	'(' VARFIL ')' /* define arquivo a ser impresso  */
			{
				for (i = 1; i < narqs; ++i) {
					if (varfil[i] == $2)
						if (tipofil[i] != 2)

/* *** Padroniz. msg erro - Adriana 09/01/95
							execerror(
							"Utilizar 'grave'", "");
*** */

							execerror(
							 PegaMsg (3162), "");
						else
							break;
				}	
				if (i >= narqs)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Variavel referencia de arquivo nao definida", "");
*** */

					execerror( PegaMsg (3163), "");
				arq = variavel[$2].ptrval.ptra;
				if (arquivos[arq].modo != SAIDA)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Gravacao nao permitida. Arquivo foi aberto para leitura", "");
*** */

					execerror( PegaMsg (3164), "");
#ifdef DEBUG
				D16print("\t%d\tPRT\tunidade %s\n", pc,
				arquivos[variavel[$2].ptrval.ptra].nome);
#endif
				/* Manda imprimir arquivo  */
				ins[pc] = PRT | ( arq << 3 | PUNI);
				IncrementaPC(&pc);
			}
		;


else		:	/* nenhum comando . Retorna pc */	
			{
				$$ = pc;
			}
		|	ELSE starte cmd /* else com comandos  */
			{
#ifdef DEBUG
				D16print("\tatualizar em %d para %d\n",
					$2-1, pc);
#endif
				/* Coloca o valor de pc como parametro 
				da instrucao cujo indice no vetor de
				instrucoes e' o valor retornado por 
				starte - 1. No caso o comando e' JMP
				para a instrucao ao final da execucao dos
				comandos */
				ins[$2-1] |= pc;
				$$ = $2;
			 }
		;


/*
** Atribuicao numerica. Retorna o valor resultante da atribuicao.
*/

			/*
			** Atribuicao de um numero a uma variavel.
			*/

atribnum	:	VARNUM '=' expr
			{
#ifdef DEBUG
				D16print("\t%d\tSTV\t%s\n",
					pc,variavel[$1].nome);
#endif
				/*
				** Armazena o numero que se encontra no topo
				** da pilha de dados na variavel cujo indice
				** e' o retornado por $1
				*/

				ins[pc] = STV | $1;
				IncrementaPC(&pc);
				$$ = $1;
			}

			/*
			** Sequencia de atribuicoes.
			*/

		|	VARNUM '=' atribnum
			{
#ifdef DEBUG
				D16print("\t%d\tLDV\t%s\n",pc,
					variavel[$3].nome);
#endif
				/*
				** Armazena o valor da ultima variavel na pilha
				** de dados para proceder as atribuicoes.
				*/

				ins[pc] = LDV | $3;
				IncrementaPC(&pc);
#ifdef DEBUG
				D16print("\t%d\tSTV\t%s\n", pc,
					variavel[$1].nome);
#endif
				/*
				** Armazena o numero que se encontra no topo
				** da pilha de dados na variavel cujo indice
				** e' o retornado por $1
				*/

				ins[pc] = STV | $1;
				IncrementaPC(&pc);
				$$ = $1;
			}
		;


/*
** Atribuicao de strings. Retorna o valor resultante da atribuicao
*/
atribstr	:	VARSTR '=' exprs  /* atribuicao de um string a uma
					   variavel  */	
			{
#ifdef DEBUG
				D16print("\t%d\tSTS\t%s\t%d\n", pc,
					variavel[$1].nome, $1);
#endif
				/* manda armazenar a string que se encontra
				no topo da pilha de dados na var. cujo indice 
				e' o retornado por $1 */
				ins[pc] = STS | $1;
				IncrementaPC(&pc);
				$$ = $1;
			}
		|	VARSTR '=' atribstr /* sequencia de atribuicoes */
			{
#ifdef DEBUG
				D16print("\t%d\tLDS\t%s\t%d\n",pc,
					variavel[$3].nome, $3);
#endif
				/* manda armazenar a string resultante na pilha
				de dados  */

				ins[pc] = LDS | $3;
				IncrementaPC(&pc);
#ifdef DEBUG
				D16print("\t%d\tSTS\t%s\t%d\n", pc,
					variavel[$1].nome, $1);
#endif
				/* manda armazenar a string que se encontra
				no topo da pilha de dados na var. cujo indice
				e' o retornado por $1 */
				ins[pc] = STS | $1;
				IncrementaPC(&pc);
				$$ = $1;
			}
		;


/*
** Atribuicao de datas. Retorna o valor resultante da atribuicao
*/
atribdat	:	VARDATA '=' exprd  /* atribuicao de uma data a uma
					   variavel  */
			{
#ifdef DEBUG
				D16print("\t%d\tSTV\t%s\n",
					pc,variavel[$1].nome);
#endif
				/* manda armazenar a data que se encontra
				no topo da pilha de dados na var. cujo indice
				e' o retornado por $1 */
				ins[pc] = STV | $1;
				IncrementaPC(&pc);
				$$ = $1;
			}
		|	VARDATA '=' missval	/* atribuicao de valor nulo */
			{
#ifdef DEBUG
				D16print("\t%d\tSTV\t%s\n",
					pc,variavel[$1].nome);
#endif
				ins[pc] = STV | $1;
				IncrementaPC(&pc);
				$$ = $1;
			}
		|	VARDATA '=' atribdat	 /* sequencia de atribuicoes */
			{
#ifdef DEBUG
				D16print("\t%d\tLDV\t%s\n",pc,
					variavel[$3].nome);
#endif
				/* manda armazenar valor nulo na pilha de dados
				para proceder as atribuicoes */
				ins[pc] = LDV | $3;
				IncrementaPC(&pc);
#ifdef DEBUG
				D16print("\t%d\tSTV\t%s\n", pc,
					variavel[$1].nome);
#endif
				/* manda armazenar a data resultante da pilha
				de dados  na variavel de indice $1 */
				ins[pc] = STV | $1;
				IncrementaPC(&pc);
				$$ = $1;
			}
		;



start		:	/* nada, apenas armazena o comando a ser executado apos
			   a condicao: JF  */
			{
				$$ = pc;
#ifdef DEBUG
				D16print("\t%d\tJF\t0\n",pc);
#endif
				ins[pc] = JF;
				IncrementaPC(&pc);
			}
		;


starte		:	/* nada, apenas armazena o comando a ser caso o nao va' 
			   executar o ELSE : JMP  */

			{
#ifdef DEBUG
				D16print("\t%d\tJMP\t0\n",pc);
#endif
				ins[pc] = JMP;
				IncrementaPC(&pc);
				$$ = pc;
			}
		;


cond		:	'(' expr ')'
		;


end		:	/* Incrementa o no. de while e coloca a marca de 
			   fim de while no vetor de enderecos de breaks. 
			   Retorna pc do inicio do while */
			{ 
				if ( num_while ) 
					end_break[ct_break++] = 0 - num_while;
				num_while++;
				$$ = pc;
			}
		;


exprd		:	VALDATA /* valor data  */
			{
#ifdef DEBUG
				if (variavel[$1].ptrval.ptrf >= MISSING) {
					D16print("\t%d\tLDN\t.\n", pc);
				}
				else {
					D16print("\t%d\tLDN\t%lg\n", pc,
						variavel[$1].ptrval.ptrf);
				}
#endif
			/* Manda carregar o valor data na pilha de dados  */
				ins[pc] = LDV | $1;
				IncrementaPC(&pc);
			}
		|	VARDATA	/* variavel data  */
			{
#ifdef DEBUG
				D16print("\t%d\tLDV\t%s\n",pc, variavel[$1].nome);
#endif
			/* Manda carregar o indice da variavel data na 
			pilha de dados  */
				ins[pc] = LDV | $1;
				IncrementaPC(&pc);
			}
		|	'(' atribdat ')'  /* varias atribuicoes de data  */
			{
#ifdef DEBUG
				D16print("\t%d\tLDV\tnulo\n",pc);
#endif
			/* Manda carregar variavel nula na pilha de dados, para 
			proceder as atribuicoes */
				ins[pc] = LDV | VARNULL;
				IncrementaPC(&pc);
			}
		|	FUNCAOD	/* funcao de data  */
			{
				nparam[npr++] = 0;
				if (npr > 99 || npr < 0)
				  {
					sprintf (tmpbuf, PegaMsg (3160), 99 );
					execerror( tmpbuf, "");
				  }
			}
			'(' lista_de_exprs ')'	/* lista de parametros */
			{
				/* verifica se o no. de parms. da funcao esta'
				certo  */
				i = funcdwords[$1].nparm;
				if (i != nparam[npr-1]) {
				    if (i % 10 != nparam[npr-1] && (i/100) != nparam[npr-1])
				     {		
					sprintf (tmpbuf, PegaMsg (3165), 
					         funcdwords[$1].name);
					execerror( tmpbuf, "");
				     }
				}
				npr--;

				/* Verifica se os tipos de parametros estao corretos */

				for(j=i-1; j >= 0;	j--) {

				    if ( funcdwords[$1].tipo_par[j] != P_Top(TipoParametro) ) {
					/*Tipo de Parametro Incorreto*/ 
					sprintf(tmpbuf,PegaMsg(3251));
					execerror(tmpbuf,"");
				    }
				    (void) P_Pop(TipoParametro);
				}

#ifdef DEBUG
				D16print("\t%d\tFUNC\t%s\n", pc,
					funcdwords[$1].name);
#endif
				/* manda executar a funcao */
				ins[pc] = FUNC | funcdwords[$1].kval;
				IncrementaPC(&pc);
			}

		|	ATOD '(' exprs ')'   /* converte um string para data. */
			{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tATOD\n", pc);
#endif
				ins[pc] = FUNCS | OATOD;
				IncrementaPC(&pc);
			}
		|	FTOD '(' expr ')'   /* converte um numero para data. */
			{
#ifdef DEBUG
				D16print("\t%d\tFUNC\tFTOD\n", pc);
#endif
				ins[pc] = FUNC | OFTOD;
				IncrementaPC(&pc);
			}
		|	'(' exprd ')' /* expressao de data  */

		;


exprs		:	VALSTR	/* valor string */
			{
#ifdef DEBUG
				D16print("\t%d\tLDS\t%s\t%d\n", pc, 
					variavel[$1].ptrval.ptrs, $1);
#endif
				/* Manda carregar valor string na pilha de 
				dados */
				ins[pc] = LDS | $1;
				IncrementaPC(&pc);
			}
		|	VARSTR	 /* variavel string */
			{
#ifdef DEBUG
				D16print("\t%d\tLDS\t%s\t%d\n", pc,
					variavel[$1].nome, $1);
#endif
				/* Manda carregar indice da variavel string 
				na pilha de dados */
				ins[pc] = LDS | $1;
				IncrementaPC(&pc);
			}
		|	'(' atribstr ')' /* varias atribuicoes de string  */
			{
#ifdef DEBUG
				D16print("\t%d\tLDS\t%s\t%d\n",pc,
					variavel[$2].nome, $2);
#endif
				/* Manda carregar a string resultante da 
				atribuicao  na pilha de dados */
				ins[pc] = LDS | $2;
				IncrementaPC(&pc);
			}
		|	exprs '+' exprs	/* concatenacao de strings  */
			{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tSTRCAT\n", pc);
#endif
				ins[pc] = FUNCS | OSTRCAT;
				IncrementaPC(&pc);
			}
		|	FUNCAOS	/* funcao de manipulacao de strings */
			{
				nparam[npr++] = 0;
				if (npr > 99 || npr < 0)
				  {
					sprintf (tmpbuf, PegaMsg (3160), 99 );
					execerror( tmpbuf, "");
				  }
			}
			'(' lista_de_exprs ')' /* lista de parametros */
			{
				/* verifica se o no. de parms. da funcao esta'
				certo  */
				i = funcswords[$1].nparm;
				if (i != nparam[npr-1]) {
				    if (i % 10 != nparam[npr-1] && (i/100) != nparam[npr-1])
				      {
					sprintf (tmpbuf, PegaMsg (3165),  
						  funcswords[$1].name);
					execerror( tmpbuf, "");
				      }
				}
				npr--;

				/* Verifica se os tipos de parametros estao corretos */

				for(j=i-1; j >= 0;	j--) {

				    if ( funcswords[$1].tipo_par[j] !=  P_Top(TipoParametro) ) {
					/*Tipo de Parametro Incorreto*/ 
					sprintf(tmpbuf,PegaMsg(3251));
					execerror(tmpbuf,"");
				    }
				    (void) P_Pop(TipoParametro);
				}


#ifdef DEBUG
				D16print("\t%d\tFUNCS\t%s\n", pc,
					funcswords[$1].name);
#endif
				/* Manda executar a funcao  */
				ins[pc] = FUNCS | funcswords[$1].kval;
				IncrementaPC(&pc);
			}
		|	FTOA '(' expr ')' /* transforma um numero em string */
			{
#ifdef DEBUG
				D16print("\t%d\tFUNC\tFTOA\n", pc);
#endif
				 /* Manda executar a funcao  */
				ins[pc] = FUNC | OFTOA;
				IncrementaPC(&pc);
			}
		 |       DTOA '(' exprd ')' /* transforma uma data em string */
			 {
#ifdef DEBUG
				 D16print("\t%d\tFUNC\tDTOA\n", pc);
#endif
				  /* Manda executar a funcao  */
				  ins[pc] = FUNC | ODTOA;
				  IncrementaPC(&pc);
			  }
		 |       MNT '(' expr ')' /* transforma um no. em string no formato monetario */
			 {
#ifdef DEBUG
				 D16print("\t%d\tFUNC\tMNT\n", pc);
#endif
				  /* Manda executar a funcao  */
				  ins[pc] = FUNC | OMNT;
				  IncrementaPC(&pc);
			  }
		|	'(' exprs ')'
		;


expr		:	NUMBER	/* numero  */
			{
#ifdef DEBUG
				if (variavel[$1].ptrval.ptrf >= MISSING) {
					D16print("\t%d\tLDN\t.\n", pc);
				}
				else {
					D16print("\t%d\tLDN\t%lg\n", pc,
						variavel[$1].ptrval.ptrf);
				}
#endif
				/* coloca na pilha o valor do numero  */
				ins[pc] = LDV | $1;
				IncrementaPC(&pc);
			}
		|	CONST	/* constante  */
			{
#ifdef DEBUG
				D16print("\t%d\tCONST\t%s\n", pc,
					cnstwords[$1].name);
#endif
				/* coloca na pilha o valor da constante */
				ins[pc] = CNST | cnstwords[$1].kval;
				IncrementaPC(&pc);

				/* testa se e' constante de fim de arquivo */
				if (strcmp(cnstwords[$1].name, "_eof") == 0 ||
					strcmp(cnstwords[$1].name, "_fda") == 0)
						pareeof = 0;
			}
		|	VARNUM 	/*var. numerica  */
			{
#ifdef DEBUG
				D16print("\t%d\tLDV\t%s\n",pc, variavel[$1].nome);
#endif
				/* coloca na pilha o indice da variavel  */
				ins[pc] = LDV | $1;
				IncrementaPC(&pc);
			}
		|	missval
		|	'(' atribnum ')'
			{
#ifdef DEBUG
				D16print("\t%d\tLDV\t%s\n",pc,
					variavel[$2].nome);
#endif
				/* Manda carregar variavel nula na pilha de 
				dados, para proceder as atribuicoes */
				ins[pc] = LDV | $2;
				IncrementaPC(&pc);
			}
		|	FUNCAO  /* funcao */
			{
				nparam[npr++] = 0;
				if (npr > 99 || npr < 0)
				  {
					sprintf (tmpbuf, PegaMsg (3160), 99 );
					execerror( tmpbuf, "");
				  }
			}
			'(' lista_de_exprs ')'	/* lista de parametros  */
			{
				/* verifica se o no. de parms. da funcao esta'
				certo  */

				i = funcwords[$1].nparm;

				if (i != nparam[npr-1]) {
					if ((funcwords[$1].kval == ORAND ||
						funcwords[$1].kval == OSRAND)
						&& nparam[npr-1] == 0) {
#ifdef DEBUG
						D16print("\t%d\tLDV\tnulo\n",
							pc);
#endif
						ins[pc] = LDV | VARNULL;
						IncrementaPC(&pc);
					}

					else if (i % 10 != nparam[npr-1] &&
						(i/100) != nparam[npr-1])
					       {
						sprintf (tmpbuf, PegaMsg (3165),
							 funcwords[$1].name);
						execerror( tmpbuf, "");
					       }
				}

				npr--;

				/* Verifica se os tipos de parametros estao corretos */

				for(j=i-1; j >= 0;	j--) {

				    if ( funcwords[$1].tipo_par[j] !=  P_Top(TipoParametro) ) {
					/*Tipo de Parametro Incorreto*/ 
					sprintf(tmpbuf,PegaMsg(3251));
					execerror(tmpbuf,"");
				    }
				    (void) P_Pop(TipoParametro);
				}

#ifdef DEBUG
				D16print("\t%d\tFUNC\t%s\n", pc,
					funcwords[$1].name);
#endif
				/* manda executar a funcao  */	
				ins[pc] = FUNC | funcwords[$1].kval;
				IncrementaPC(&pc);
			}
		|	entsai	/* comandos de E/S (read e write)  */
		|	ATOF '(' exprs ')'   /* converte um string para no. */
			{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tATOF\n", pc);
#endif
				ins[pc] = FUNCS | OATOF;
				IncrementaPC(&pc);
			}
		|	DTOF '(' exprd ')'   /* converte uma data para no. */
			{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tDTOF\n", pc);
#endif
				ins[pc] = FUNC | ODTOF;
				IncrementaPC(&pc);
			}
		|	expr '+' expr	/* soma */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tADD\n", pc);
#endif
				ins[pc] = OPER | OADD;
				IncrementaPC(&pc);
			}
		|	expr '-' expr	/* subtracao  */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tSUB\n", pc);
#endif
				ins[pc] = OPER | OSUB;
				IncrementaPC(&pc);
			}
		|	'-' expr %prec UNARYMINUS	/* no. negativo */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tMINUS\n", pc);
#endif
				ins[pc] = OPER | OMINUS;
				IncrementaPC(&pc);
			}
		|	expr '*' expr	/* multiplicacao  */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tMUL\n", pc);
#endif
				ins[pc] = OPER | OMUL;
				IncrementaPC(&pc);
			}
		|	expr '/' expr	/* divisao  */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tDIV\n", pc);
#endif
				ins[pc] = OPER | ODIV;
				IncrementaPC(&pc);
			}
		|	expr '%' expr /* divisao inteira */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tMOD\n", pc);
#endif
				ins[pc] = OPER | OMOD;
				IncrementaPC(&pc);
			}
		|	expr '^' expr	/* exponenciacao  */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tPOW\n", pc);
#endif
				ins[pc] = OPER | OPOW;
				IncrementaPC(&pc);
			}
		|	expr EQ expr	/* operador logico == */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tEQ\n", pc);
#endif
				ins[pc] = LOGICA | OEQ;
				IncrementaPC(&pc);
			}
		|	expr NEQ expr	/* operador logico !=  */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tNEQ\n", pc);
#endif
				ins[pc] = LOGICA | ONEQ;
				IncrementaPC(&pc);
			}
		|	expr LT expr	/* operador logico < */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tLT\n", pc);
#endif
				ins[pc] = LOGICA | OLT;
				IncrementaPC(&pc);
			}
		|	expr LE expr	/* operador logico <= */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tLE\n", pc);
#endif
				ins[pc] = LOGICA | OLE;
				IncrementaPC(&pc);
			}
		|	expr GT expr	/* operador logico > */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tGT\n", pc);
#endif
				ins[pc] = LOGICA | OGT;
				IncrementaPC(&pc);
			}
		|	expr GE expr	/* operador logico >= */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tGE\n", pc);
#endif
				ins[pc] = LOGICA | OGE;
				IncrementaPC(&pc);
			}
		|	expr AND expr	/* operador logico && */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tAND\n", pc);
#endif
				ins[pc] = LOGICA | OAND;
				IncrementaPC(&pc);
			}
		|	expr OR expr	 /* operador logico || */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tOR\n", pc);
#endif
				ins[pc] = LOGICA | OOR;
				IncrementaPC(&pc);
			}
		|	NOT expr %prec NOT  /* operador logico ! */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tNOT\n", pc);
#endif
				ins[pc] = LOGICA | ONOT;
				IncrementaPC(&pc);
			}
		|	'(' expr ')'
		|	exprd EQ exprd	/* operador logico == para datas */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tEQ\n", pc);
#endif
				ins[pc] = LOGICA | OEQ;
				IncrementaPC(&pc);
			}
		|	exprd EQ missval /* operador logico == para datas, com 
					    um valor nulo */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tEQ\n", pc);
#endif
				ins[pc] = LOGICA | OEQ;
				IncrementaPC(&pc);
			}
		|	missval EQ exprd  /* operador logico == para datas com
					     um valor nulo */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tEQ\n", pc);
#endif
				ins[pc] = LOGICA | OEQ;
				IncrementaPC(&pc);
			}
		|	exprd NEQ exprd	/* operador logico != para datas */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tNEQ\n", pc);
#endif
				ins[pc] = LOGICA | ONEQ;
				IncrementaPC(&pc);
			}
		|	exprd NEQ missval /* operador logico == para datas, com
					    um valor nulo */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tNEQ\n", pc);
#endif
				ins[pc] = LOGICA | ONEQ;
				IncrementaPC(&pc);
			}
		|	missval NEQ exprd /* operador logico == para datas, com
					    um valor nulo */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tNEQ\n", pc);
#endif
				ins[pc] = LOGICA | ONEQ;
				IncrementaPC(&pc);
			}
		|	exprd LT exprd	/* operador logico < para datas */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tLT\n", pc);
#endif
				ins[pc] = LOGICA | OLT;
				IncrementaPC(&pc);
			}
		|	exprd LE exprd	/* operador logico <= para datas */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tLE\n", pc);
#endif
				ins[pc] = LOGICA | OLE;
				IncrementaPC(&pc);
			}
		|	exprd GT exprd	/* operador logico > para datas */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tGT\n", pc);
#endif
				ins[pc] = LOGICA | OGT;
				IncrementaPC(&pc);
			}
		|	exprd GE exprd	/* operador logico >= para datas */
			{
#ifdef DEBUG
				D16print("\t%d\tOPER\tGE\n", pc);
#endif
				ins[pc] = LOGICA | OGE;
				IncrementaPC(&pc);
			}
		|	exprs EQ exprs	/* operador logico == para strings */
			{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tEQ\n", pc);
#endif
				ins[pc] = FUNCS | OEQ;
				IncrementaPC(&pc);
			}
		|	exprs NEQ exprs	/* operador logico != para strings */
			{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tNEQ\n", pc);
#endif
				ins[pc] = FUNCS | ONEQ;
				IncrementaPC(&pc);
			}
		|	exprs LT exprs	/* operador logico < para strings */
			{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tLT\n", pc);
#endif
				ins[pc] = FUNCS | OLT;
				IncrementaPC(&pc);
			}
		|	exprs LE exprs	/* operador logico <= para strings */
			{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tLE\n", pc);
#endif
				ins[pc] = FUNCS | OLE;
				IncrementaPC(&pc);
			}
		|	exprs GT exprs	/* operador logico > para strings */
			{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tGT\n", pc);
#endif
				ins[pc] = FUNCS | OGT;
				IncrementaPC(&pc);
			}
		|	exprs GE exprs	/* operador logico >= para strings */
			{
#ifdef DEBUG
				D16print("\t%d\tFUNCS\tGE\n", pc);
#endif
				ins[pc] = FUNCS | OGE;
				IncrementaPC(&pc);
			}
		|	error
			{

/* *** Padroniz. msg erro - Adriana 09/01/95
				execerror("Expressao invalida","");
*** */

				execerror( PegaMsg (3166),"");
			}
		;

missval		:	MISSNUM		/*  valor nulo  */	
			{
#ifdef DEBUG
				D16print("\t%d\tLDN\t.\n", pc);
#endif
				ins[pc] = LDV | $1;
				IncrementaPC(&pc);
			}
		;


/*
lista_de_expr	:	nada +++++++++++++++++++++++++++
		|	expr
		|	lista_de_expr ',' expr
		;
*/


/*
** Itens para impressao
*/
itens		:	controle /* itens de controle do formato */
		|	exprd formnum formato	/* variavel data com formato
						para impressao  */
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\tdata\n", pc);
#endif
				/* manda imprimir */
				ins[pc] = PRT | PDAT;
				IncrementaPC(&pc);
				tabpos = 1;
				formnum = 0;
			}
		|	exprs formnum formato	/* variavel string com 
						formato para impressao  */
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\tstring\n", pc);
#endif
				/* manda imprimir  */
				ins[pc] = PRT | PALF;
				IncrementaPC(&pc);
				tabpos = 1;
				formnum = 0;
			}
		|	expr formnum formato	/* variavel numerica com
						formato para impressao  */
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\tvalor\n", pc);
#endif
				/* manda imprimir  */
				ins[pc] = PRT | PNUM;
				IncrementaPC(&pc);
				tabpos = 1;
				formnum = 0;
			}
		|	itens controle	
		|	itens exprd formnum formato
			{
				if (tabpos) {
#ifdef DEBUG
					D16print("\t%d\tPRT\ttab\n",pc);
#endif
					ins[pc] = PRT | PTAB;
					IncrementaPC(&pc);
				}
#ifdef DEBUG
				D16print("\t%d\tPRT\tdata\n", pc);
#endif
				ins[pc] = PRT | PDAT;
				IncrementaPC(&pc);
				tabpos = 1;
				formnum = 0;
			}
		|	itens exprs formnum formato
			{
				if (tabpos) {
#ifdef DEBUG
					D16print("\t%d\tPRT\ttab\n",pc);
#endif
					ins[pc] = PRT | PTAB;
					IncrementaPC(&pc);
				}
#ifdef DEBUG
				D16print("\t%d\tPRT\tstring\n", pc);
#endif
				ins[pc] = PRT | PALF;
				IncrementaPC(&pc);
				tabpos = 1;
				formnum = 0;
			}
		|	itens expr formnum formato
			{
				if (tabpos) {
#ifdef DEBUG
						D16print("\t%d\tPRT\ttab\n",pc);
#endif
						ins[pc] = PRT | PTAB;
						IncrementaPC(&pc);
				}
#ifdef DEBUG
				D16print("\t%d\tPRT\tvalor\n", pc);
#endif
				ins[pc] = PRT | PNUM;
				IncrementaPC(&pc);
				tabpos = 1;
				formnum = 0;
			}
		;


formnum		:	/* nada, apenas seta o indice da var. a ser 
			   impressa com formato numerico  */
			{
				formnum = 1;
			}
		;


/*
** Define itens de controle na impressao
*/
controle	:	'#' numero NUMBER  /* inicializa a leitura de dados na
					      coluna NUMBER  depois da ultima
					      leitura */
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\t%d brancos\n", pc, $3);
#endif
				ins[pc] = PRT | ($3 << 3 | PBRC);
				IncrementaPC(&pc);
				tabpos = 0;
				posnum = 0;
			}
		|	'@' numero NUMBER  /* inicializa a leitura de dados na
					      coluna NUMBER */
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\tcoluna %d\n", pc, $3);
#endif
				ins[pc] = PRT | ($3 << 3 | PCOL);
				IncrementaPC(&pc);
				tabpos = 0;
				posnum = 0;
			}
			|	'\\' prtchar 'L'	/* pular linha  */
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\tnl\n", pc);
				D16print("\t%d\tPRT\tlinha\n", pc+1);
#endif
				ins[pc] = PRT | PNL;
				IncrementaPC(&pc);
				ins[pc] = PRT | PLIN;
				IncrementaPC(&pc);
				prtvar = 0;
				tabpos = 0;
			}
		|	'\\' prtchar 'l'	/* pular linha  */
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\tnl\n", pc);
				D16print("\t%d\tPRT\tlinha\n", pc+1);
#endif
				ins[pc] = PRT | PNL;
				IncrementaPC(&pc);
				ins[pc] = PRT | PLIN;
				IncrementaPC(&pc);
				prtvar = 0;
				tabpos = 0;
			}
		|	'\\' prtchar 'T'	/* tabulacao */
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\ttab\n", pc);
#endif
				ins[pc] = PRT | PTAB;
				IncrementaPC(&pc);
				prtvar = 0;
			}
		|	'\\' prtchar 't'	/* tabulacao  */
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\ttab\n", pc);
#endif
				ins[pc] = PRT | PTAB;
				IncrementaPC(&pc);
				prtvar = 0;
			}
		|	'\\' prtchar 'P'	/* mudar de pagina  */
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\tpag\n", pc);
				D16print("\t%d\tPRT\tlinha\n", pc+1);
#endif
				ins[pc] = PRT | PFF;
				IncrementaPC(&pc);
				ins[pc] = PRT | PLIN;
				IncrementaPC(&pc);
				prtvar = 0;
				tabpos = 0;
			}
		|	'\\' prtchar 'p'	/* mudar de pagina  */
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\tpag\n", pc);
				D16print("\t%d\tPRT\tlinha\n", pc+1);
#endif
				ins[pc] = PRT | PFF;
				IncrementaPC(&pc);
				ins[pc] = PRT | PLIN;
				IncrementaPC(&pc);
				prtvar = 0;
				tabpos = 0;
			}
		;

/*
** Formato de impressao de valores numericos
*/
formato		:	/* nada */
		|	'{' alinhamento NUMBER ':' NUMBER numdec '}'
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\tcoluna %d\n", pc, $3);
				D16print("\t%d\tPRT\tcampo %d\n", pc+1, $5-$3+1);
#endif
				if ($5 - $3 + 1 > RDRBUF)
				  {
					sprintf (tmpbuf, PegaMsg (3031), "", (RDRBUF -1) );
					execerror( tmpbuf, "");
				  }
				ins[pc] = PRT | ($3 << 3 | PCOL);
				IncrementaPC(&pc);
				ins[pc] = PRT | (($5-$3+1) << 3 | PTAM);
				IncrementaPC(&pc);
				tabpos = 0;
			}
		|	'{' alinhamento NUMBER decs '}'
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\tcampo %d\n", pc, $3);
#endif
				if ($3 > RDRBUF)
				  {
					sprintf (tmpbuf, PegaMsg (3031), (RDRBUF - 1) );
					execerror( tmpbuf, "");
				  }
				ins[pc] = PRT | ($3 << 3 | PTAM);
				IncrementaPC(&pc);
				tabpos = 0;
			}
		;


alinhamento	:	/* nada */
		|	'-' 		/* alinhamento a esquerda  */	
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\talinhamento esquerda\n", pc);
#endif
				ins[pc] = PRT | PESQ;
				IncrementaPC(&pc);
			}
		;


decs		:	/* nada */
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\tdecimais %d\n", pc, 0);
#endif
				ins[pc] = PRT | PDEC;
				IncrementaPC(&pc);
			}
		|	'.' NUMBER	/* casas decimais a serem impressas  */
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\tdecimais %d\n", pc, $2);
#endif
				ins[pc] = PRT | ($2 << 3 | PDEC);
				IncrementaPC(&pc);
			}
		;


numdec		:	/* nada */
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\tdecimais %d\n", pc, 0);
#endif
				ins[pc] = PRT | PDEC;
				IncrementaPC(&pc);
			}
		|	NUMBER	/* nos. decimais a serem impressos  */
			{
#ifdef DEBUG
				D16print("\t%d\tPRT\tdecimais %d\n", pc, $1);
#endif
				ins[pc] = PRT | ($1 << 3 | PDEC);
				IncrementaPC(&pc);
			}
		;


prtchar		:	/* nada, apenas indica que existe itens de 
			   formatacao  */
			{
				prtvar = 1;
			}
		;


numero		:	/* nada, apenas indica que a impressao deve ser
			   feita a partir de determinada coluna  */
			{
				posnum = 1;
			}
		;

/*
** Lista de parametros das funcoes
*/
lista_de_exprs	:	/* nada */
		|	exprd
			{
				nparam[npr-1]++;
				(void) P_Push(TipoParametro, 'd');
			}
		|	exprs
			{
				nparam[npr-1]++;
				(void) P_Push(TipoParametro, 'a');
			}
		|	expr
			{
				nparam[npr-1]++;
				(void) P_Push(TipoParametro, 'n');
			}
		|	lista_de_exprs ',' exprd
			{
				nparam[npr-1]++;
				(void) P_Push(TipoParametro, 'd');
			}
		|	lista_de_exprs ',' exprs
			{
				nparam[npr-1]++;
				(void) P_Push(TipoParametro, 'a');
			}
		|	lista_de_exprs ',' expr
			{
				nparam[npr-1]++;
				(void) P_Push(TipoParametro, 'n');
			}
		;

/*
** Funcoes de entrada e saida
*/
entsai		:	SREAD '(' VARFIL ')'	/* ler arq. do sistema  */
			{
				/* procura a variavel de arquivo */
				for (i = 1; i < narqs; ++i) {
					if (varfil[i] == $3)
						break;
				}	
				if (i >= narqs)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Variavel referencia de arquivo nao definida", "");
*** */

					execerror( PegaMsg (3163), "");

				/* testa o tipo do arquivo  */
				if (tipofil[i] == 2)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror(
					"Arquivo aberto como 'EXTERNO'. Utilize 'LEIAF'", "");
*** */

					execerror( PegaMsg (3167), "");

				/* obtem o indice do arquivo na tabela de arqs.
				e verifica seu modo  */
				arq = variavel[$3].ptrval.ptra;
				if (arquivos[arq].modo != ENTRADA)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Leitura nao permitida. Arquivo aberto para gravacao", "");
*** */

					execerror( PegaMsg (3168), "");
#ifdef DEBUG
				D16print("\t%d\tSRD\t%s\n", pc,
					variavel[$3].nome);
#endif
				/* manda ler o arquivo, guardando pc no 
				momento da leitura */
				pcread = pc;
				ins[pc] = SRD | arq;
				IncrementaPC(&pc);

			}
			whereblk
		|	EREAD '(' setarq ')'	/* ler arq. externo */
			{
				/* testa o modo do arquivo */
				if (arquivos[arq].modo != ENTRADA)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Leitura nao permitida. Arquivo foi aberto para gravacao", "");
*** */

					execerror( PegaMsg (3168), "");
#ifdef DEBUG
				D16print("\t%d\tFRD\t%s\n", pc,
					variavel[$3].nome);
#endif
				/* manda ler o arquivo  */
				ins[pc] = FRD | (arq << 4);
				IncrementaPC(&pc);
			}
		|	EREAD '(' setarq ')' itensr  /* ler arq. externo algum 
							tipo de controle */
			{
				/* testa se e' formatado  */
				if (indfmt == 0)
					eform = 0;
				else
					/* testa se o no. de formatacoes e' 
					o mesmo do no. de vars. declaradas  */
					if (nformv == indvar)
						eform = 1;
					else {

/* *** Padroniz. msg erro - Adriana 09/01/95
						execerror("Falta especificar formato",
							"");
*** */

						execerror( PegaMsg (3169), "");
					}
				/* testa modo do arquivo  */
				if (arquivos[arq].modo != ENTRADA)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Leitura nao permitida. Arquivo aberto para gravacao", "");
*** */

					execerror( PegaMsg (3168), "");
#ifdef DEBUG
				D16print("\t%d\tFRD\tformato %d\n",pc, nform);
				D16print("\t%d\tFRD\t%s\n", pc+1,
					variavel[$3].nome);
#endif
				/* arq. formatado */	
				if (eform) {
					/* aloca area para o formato do arq. */
					printbuf[indfmt++] = '\0';
					ubytes = (unsigned) indfmt;
					pp = (char *) malloc(ubytes);
					if (pp == (char *) NULL)

/* *** Padroniz. msg erro - Adriana 09/01/95
						execerror("Memoria disponivel esgotada", "");
*** */

						execerror( PegaMsg (1039), "");
					for (i = 0; i < indfmt; ++i)
						pp[i] = printbuf[i];
					formatos[nform] = pp;
				}
				else
					formatos[nform] = (char *) NULL;

				/* aloca area para os indices das vars  */
				ubytes = (unsigned) (indvar * sizeof(int));
				pv = (int *) malloc(ubytes);
				if (pv == (int *) NULL) {

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Memoria disponivel esgotada",
					"");
*** */

					execerror( PegaMsg (1039), "");
				}
				for (i = 0; i < indvar; ++i)
					pv[i] = vars[i];
				listas[nform] = pv;
				numvar[nform] = indvar;

				/* manda ler o arquivo  */
				ins[pc] = FRD | (nform << 4 | 1);
				IncrementaPC(&pc);
				ins[pc] = FRD | (arq << 4);
				IncrementaPC(&pc);
				pervar = 0;
				formnum = 0;
				++nform;
			}
		|	OUTPUT	/* manda gravar todos os arquivos de saida  */
			{
#ifdef DEBUG
				D16print("\t%d\tSWR\n", pc);
#endif
				ins[pc] = SWR;
				IncrementaPC(&pc);
				output = 0;
			}
		|	OUTPUT '(' VARFIL ')'	/* manda gravar um arquivo  */
			{
				/* procura o indice do arquivo na tabela de 
				indices e verifica se e' arq. externo  */
				for (i = 1; i < narqs; ++i) {
					if (varfil[i] == $3)
						if (tipofil[i] != 1)

/* *** Padroniz. msg erro - Adriana 09/01/95
							execerror(
							"Comando 'GRAVE' apenas para criacao arquivo_ntia. Utilize comando 'LISTE'", "");
*** */

							execerror( PegaMsg (3170), "");
						else
							break;
				}	
				if (i >= narqs)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Variavel referencia de arquivo nao definida", "");
*** */

					execerror( PegaMsg (3163), "");
				/* testa o modo do arquivo  */
				arq = variavel[$3].ptrval.ptra;
				if (arquivos[arq].modo != SAIDA)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Gravacao nao permitida. Arquivo aberto para leitura", "");
*** */

					execerror( PegaMsg (3164), "");
#ifdef DEBUG
				D16print("\t%d\tSWR\t%s\n", pc,
					variavel[$3].nome);
#endif
				/* manda gravar o  arquivo  */
				ins[pc] = SWR | arq;
				IncrementaPC(&pc);
				output = 0;
			}
		;


whereblk	:	/* nada. Comando sem WHERE */	
		/*  leitura de arquivo interno com condicao  */
		|	WHERE {
				$$ = pc;
#ifdef DEBUG
				D16print("\t%d\tJFDA\t 0\n",pc);
#endif
				ins [pc] = JFDA | 0;	
				IncrementaPC(&pc);
			      }
			'(' expr ')' 
				{
				/* caso a condicao de leitura nao tenha sido 
				satisfeita, le uma nova observacao  */
				/***
#ifdef DEBUG
				D16print("\t%d\tJF\t%d\n",pc,pcread);
#endif
				**** ins[pc] = JF | pcread;
				IncrementaPC(&pc);
				****/

				/***
				**** testa o resultado da expressao e, se falso,
				**** desvia para um bloco auxiliar, que retira 
				**** da pilha o numero da ultima observacao 
				**** lida
				***/
#ifdef DEBUG
				D16print("\t%d\tJF\t%d\n",pc,pc + 2);
#endif
				ins [pc] = JF | (pc + 2); 
				IncrementaPC(&pc);

				/***
				**** Se o resultado da expressao e' verdadeiro,
				**** desvia para a proxima instrucao apos a
				**** expressao 
				***/
#ifdef DEBUG
				D16print("\t%d\tJMP\t%d\n",pc,pc + 3);
#endif
				ins [pc] = JMP | (pc + 3);
				IncrementaPC(&pc);

				/***
				**** Este e' o bloco auxiliar (acima citado).
				***/
#ifdef DEBUG
				D16print("\t%d\tPOP\n",pc);
#endif
				ins [pc] = FSPC | POP;
				IncrementaPC(&pc);
#ifdef DEBUG
				D16print("\t%d\tJMP\t%d\n",pc,pcread);
#endif
				ins [pc] = JMP | pcread;
				IncrementaPC(&pc);


				/***
				**** atualiza o JFDA do WHERE 
				***/
#ifdef DEBUG
				D16print("\tatualizar em %d para %d\n",
					 $2, pc);
#endif
				ins [$2] |= pc; 

			}
		;


setarq		:	VARFIL	/* nome de arquivo externo  */
			{
				for (i = 1; i < narqs; ++i) {
					if (varfil[i] == $1)
						if (tipofil[i] != 2)

/* *** Padroniz. msg erro - Adriana 09/01/95
							execerror(
							"Arquivo aberto como arquivo_ntia. Utilize comando 'LEIAS'", "");
*** */

							execerror(
							PegaMsg (3171), "");
						else
							break;
				}	
				if (i >= narqs)

/* *** Padroniz. msg erro - Adriana 09/01/95
					execerror("Variavel referencia de arquivo nao definida","");
*** */

					execerror( PegaMsg (3163),"");
				arq = variavel[$1].ptrval.ptra;
				indfmt = 0;
				indvar = 0;
				nformv = 0;
				pervar = 7;
			}
		;

itensr		:	controler	/* itens de controle do formato de 
					   leitura  */
		|	variavel formnumr formator /* variavel com formato 
						      numerico de leitura  */
		|	itensr controler
		|	itensr variavel formnumr formator
		|	error
			{

/* *** Padroniz. msg erro - Adriana 09/01/95
				execerror("Formato errado ou ausente", "");
*** */

				execerror( PegaMsg (3169), "");
			}
		;


formnumr	:	'{'	/* inicio do formato  */
			{
				formnum = 1;
			}
		;

/*
** Formatos numericos para leitura
*/
controler	:	'#' numero NUMBER  /* inicializa a leitura de dados na
					      coluna NUMBER  depois da ultima
					      leitura */
			{
				printbuf[indfmt++] = '#';
				itoa($3, &printbuf[indfmt], 10);
				indfmt += (strlen(&printbuf[indfmt]) + 1);
				posnum = 0;
			}
		|	'@' numero NUMBER  /* inicializa a leitura de dados na
					      coluna NUMBER */
			{
				printbuf[indfmt++] = '@';
				itoa($3, &printbuf[indfmt], 10);
				indfmt += (strlen(&printbuf[indfmt]) + 1);
				posnum = 0;
			}
		|	'\\' prtchar 'L'	/* pular linha  */
			{
				printbuf[indfmt++] = 'L';
				printbuf[indfmt++] = '\0';
				prtvar = 0;
			}
		|	'\\' prtchar 'l'	/* pular linha  */
			{
				printbuf[indfmt++] = 'L';
				printbuf[indfmt++] = '\0';
				prtvar = 0;
			}
		;


formator	:	NUMBER ':' NUMBER numdecr '}' /* define o formato de 
							 var. numerica  */
			{
				if ($3 - $1 +1 > RDRBUF)
				  {
					sprintf (tmpbuf, PegaMsg (3031), (RDRBUF -1) );
					execerror( tmpbuf, "");
				  }
				printbuf[indfmt++] = '@';
				itoa($1, &printbuf[indfmt], 10);
				indfmt += (strlen(&printbuf[indfmt]) + 1);
				itoa($3-$1+1, &printbuf[indfmt], 10);
				indfmt += (strlen(&printbuf[indfmt]) + 1);
				itoa($4, &printbuf[indfmt], 10);
				indfmt += (strlen(&printbuf[indfmt]) + 1);
				++nformv;
			}
		|	NUMBER decsr '}'  /* no. com decimais p/ leitura  */ 
			{
				if ($1 > RDRBUF)
				  {
					sprintf (tmpbuf, PegaMsg (3031), (RDRBUF - 1) );
					execerror( tmpbuf, "");
				  }
				itoa($1, &printbuf[indfmt], 10);
				indfmt += (strlen(&printbuf[indfmt]) + 1);
				itoa($2, &printbuf[indfmt], 10);
				indfmt += (strlen(&printbuf[indfmt]) + 1);
				++nformv;
			}
		;


decsr		:	/* nada */
			{
				$$ = 0;
			}
		|	'.' NUMBER  	/* tem casas decimais  */
			{
				$$ = $2;
			}
		;


numdecr		:	/* nada */
			{
				$$ = 0;
			}
		|	NUMBER  	/* tem casas decimais  */
			{
				$$ = $1;
			}
		;


%% 	/* end of grammar */

int			VerificaTipoParametro(estrutura,ind,n_par)
struct funcwords 	*estrutura;
int			ind;
int			n_par;
{
}

int 	IncrementaPC(pc)
int	*pc;
{

#if defined(MSDOS) & !defined(DJGPP)
	if ( (*pc) >= 2047 ) {
	    execerror (PegaMsg (1160), "");
	}
#endif

	return((*pc)++);
}

/* End of genparse.y */

