/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Contem a funcao grvint para gravao de arquivo do sistema

 Desenvolvido por:

      Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
      Carla Geovana do N. Macario
	Adriana Delfino dos Santos
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <string.h>
#include "pcsgbd.h"
#include "genese.h"

/* ----------------------------------------------------------------------------
**
**	
**
** Funcao para gravar arquivo do sistema
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
**
** Data da ultima alteracao:
**
**		95/04/28 13:45:18
**
** Alteracao da Versao 4.1b :
**
**      Se o tamanho da observacao nao for suficiente para todos os campos, em lugar
**      de trunca-la, completa-se a observacao com MISSING VALUES, o que resulta em
**      uma advertencia.
** -----------------------------------------------------------------------------
*/

#ifdef DEBUG
	extern int	f_1;
	extern int	f_4;
#endif


extern struct variavel variavel[];  	/* informacoes dos arquivos existentes */

extern struct arquivos arquivos[];  	/* informacpes das vars existentes */

extern double pilha[];			/* pilha de dados  */
extern int idpilha;			/* indice da pilha de dados  */

extern char *obs[];			/* observacao  */

void grvint(i)
int i;
{
	int 	k;
	char 	*qp;
	int 	j;
	int 	m;
	int 	tamobs, tamaux;
	int	quanto_falta;		/* quanto falta pra completar a observacao */


#ifdef DEBUG
	D1print("Gravar arquivo interno\n");
#endif


	k = arquivos[i].nvar;
	qp = (char *) &obs[MAXVAR];
	tamobs = (OBSSIZE - (MAXVAR + 1)) * sizeof(char *);

	/* coloca em obs[] a observacao do arquivo, var. a var.   */

	for ( j=0 ; j < k ; ++j ) {
		m = arquivos[i].pos[j];
		obs[j] = qp;
		tamaux = tamobs;
		quanto_falta = 2*(k-j-1) /* MISSING + "\0" */;
		if (variavel[m].tipo == 'c') {
			tamobs -= (strlen(variavel[m].ptrval.ptrs) + 1);
			if ( tamobs >= quanto_falta ) {
				strcpy(qp, variavel[m].ptrval.ptrs);
			}
			else {
				*qp = '\0';
			}
		}
		else {
			ftoa(variavel[m].ptrval.ptrf, 15, qp);
			tamobs -= (strlen(qp) + 1);
			if ( tamobs < quanto_falta ) {
				strcpy(qp,".");
			}
		}

		if ( tamobs < quanto_falta ) {
			/* completa com missing values */
			qp += (strlen(qp) + 1);
			++j;
			for (; j < k ; ++j ) {
				m = arquivos[i].pos[j];
				obs[j] = qp;
				if (variavel[m].tipo == 'c') {
					*qp = '\0';
				}
				else {
					strcpy(qp,".");
				}
				qp += (strlen(qp) + 1);
			}
			
			fprintf(stderr, "\n\n\n\n\tADVERTENCIA!!!\n");
			fprintf(stderr, "\t\tAtingido o tamanho maximo da observacao.\n");
			fprintf(stderr, "\t\tSeu conteudo foi completado com MISSINGS.\n");
			fprintf(stderr, "\t\tArquivo <%s>, observacao <%d>.\n\n",
					arquivos [i].nome,
					arquivos[i].obs+1);
			Pausa_de_Advertencia ();


			break;
		}
		else  {
			qp += (strlen(qp) + 1);
		}
	}

	/* grava a observacao */
		
	grav_obs(arquivos[i].arq.ptraa, obs);

	/* posiciona na proxima obervacao do arquivo e coloca seu no. na
	pilha de dados  */

	++arquivos[i].obs;
	pilha[idpilha++] = (double) arquivos[i].obs;

#ifdef DEBUG

	if (f_4) {
		for (j=0; j<k; ++j)
			printf("\t<%s>", obs[j]);
		printf("\n");
	}
#endif

}
