/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Contm funcao lerextf para leitura de arquivo externo formatado e funcao number que 
	calcula o valor de um numero


 Desenvolvido por:

      	Carlos Eduardo Assis Paniago
		Oscar Ivan Palma Pacheco
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <string.h>

# include <stdlib.h>

#ifndef VAXVMS
# include <malloc.h>
#endif

#include <math.h>
#include <ctype.h>

#ifdef MSDOS
# include <stdlib.h>
#endif

#include "pcsgbd.h"
#include "socasm.h"
#include "genese.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif


/* ----------------------------------------------------------------------------
**	
**
** Funcao para ler arquivo externo formatado e funcao number que calcula o 
** valor de um numero
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
**
** Data da ultima alteracao:
**
**		95/01/11 11:30:38
**
** ----------------------------------------------------------------------------
*/

#ifdef DEBUG
extern int	f_1;
extern int	f_4;
#endif

extern struct variavel variavel[];   /* informacoes das vars. existentes  */

extern struct arquivos arquivos[];   /* informacoes dos arqs. existentes  */

extern double pilha[];	/* pilha de dados */
extern int idpilha;	/* indice da pilha de dados */
extern int fim;		/* flag - indica fim do programa genese  */ 
extern int pareeof;	/* constante de fim de arquivo  */
extern int flagW;

extern char buffer[];

extern char printbuf[];	/* armazena a formatacao do arquivo  */

extern char *frdform;	/* armazena o formato do arq. ext. formatado  */

void lerextf(i)
int i;
{
	int k;
	int j;
	int m;
	int colind;
	int campo;
	int decim;
	int miss;	/* no. missing  */
	int ponto;
	int ne;		/* no. exponencial  */
	double aux;
	double dx;
	int tambuf;
	int reg;
	int comentario;
	char *qp;
	char *fp;
#ifdef EDIX
	double *dp;
#endif

#ifdef DEBUG
	D1print("Ler arquivo externo com formato\n");
#endif

	if (arquivos[i].obs)
		comentario = 0;
	else
		comentario = 1;

	while (1) {
		/* Arquivo nulo  */
		if (fgets(printbuf, PRTBUF, arquivos[i].arq.ptraf) ==
				 (char *) NULL) {
			/* comentario apenas com marca de inicio  */
			if (comentario == 2)

/* *** Padroniz. msg erro - Adriana 06/01/95
				execerror("Comentario incompleto", "");
*** */

				execerror( PegaMsg (3048), "");

			pilha[idpilha++] = (double) EOF;
			arquivos[i].obs = (long) EOF;
			for (j = 0; j < arquivos[i].nvar; ++j) {
				m = arquivos[i].pos[j];
				if (variavel[m].tipo == 'c') {
					free(variavel[m].ptrval.ptrs);
					variavel[m].ptrval.ptrs = (char *) NULL;
					if((qp=(char *)malloc(1))==(char *)NULL)

/* *** Padroniz. msg erro - Adriana 06/01/95
						execerror("Falta memoria", "");
*** */

						execerror( PegaMsg (1039), "");

					*qp = '\0';
					variavel[m].ptrval.ptrs = qp;
				}
				else  {
#ifdef EDIX
					dp = &(variavel[m].ptrval.ptrf);
					*dp = MISSING;
#else
					variavel[m].ptrval.ptrf = MISSING;
#endif
				}
			}
			if (pareeof)
				if (veriarq())
					fim = 0;
			return;
		}

		j = 0;
		reg = 1;
		tambuf = strlen(printbuf);
		if (printbuf[tambuf-1] == '\n') {
			printbuf[tambuf-1] = '\0';
			tambuf -= 1;
		}

		if (comentario == 0)
			break;

		/* tem comentario  */
		if (comentario == 1) {
			/* ignora os tabs e brancos  */
			while (printbuf[j]) {
				if (printbuf[j] != ' ' && printbuf[j] != '\t')
					break;
				++j;
			}
			/* verifica se e' comentario  */
			if (printbuf[j++] == '/' && printbuf[j++] == '*') {
				comentario = 2;
			}
			/* nao e' comentario  */
			else {
				comentario = 0;
#ifdef MSDOS
				if (strcmpi(arquivos[i].nome, "con") == 0)
#else
				if (strcmpi(arquivos[i].nome, "/dev/tty") == 0)
#endif
					break;
				else {
					/* posiciona no inicio do arq.  */
					fseek(arquivos[i].arq.ptraf, 0L, 0);
					continue;
				}
			}
		}

		/* procura o final do comentario  */
		if (comentario == 2) {
			while (printbuf[j]) {
				if (printbuf[j] == '*' && printbuf[j+1] == '/'){
					comentario = 0;
					break;
				}
				++j;
			}
		}

	}

	colind = 0;
	fp = frdform; /* fd apontar para o formato do arquivo  */
	for (j = 0; j < arquivos[i].nvar; ++j) {
		/* enquanto for um item especial de formatacao  */
		while (*fp == '@' || *fp == '#' || *fp == 'L') {
			if (*fp == 'L') {	/* pular linha  */
				if (fgets(printbuf, PRTBUF,
					arquivos[i].arq.ptraf)==(char *) NULL)
					tambuf = 0;
				else {
					tambuf = strlen(printbuf);
					if (printbuf[tambuf-1] == '\n') {
						printbuf[tambuf-1] = '\0';
						tambuf -= 1;
					}
				}
				colind = 0;
				++reg;
			}
			else
				if (*fp == '@')	/* posiciona em uma coluna  */
					colind = atoi(++fp) - 1;
				else
					/* posiciona em uma coluna x a partir 
					da ultima coluna lida */
					if (*fp == '#')	
						colind += atoi(++fp);
			fp += (strlen(fp) + 1);
		}
		/* pega o tamanho do campo  */
		campo = atoi(fp);
		fp += (strlen(fp) + 1);
		/* pega os decimais  */
		decim = atoi(fp);
		fp += (strlen(fp) + 1);
		/* pega o indice da variavel  */
		m = arquivos[i].pos[j];
		for (k = 0; k < campo; ++k) {
			if (colind + k >= tambuf) {
				break;
			}
			/* pega o dado a partir da coluna especificada  */
			buffer[k] = printbuf[colind + k];
		}
		if (k == 0 && flagW) {
			fprintf (stderr, "Advertencia: ");
			fprintf(stderr,
				"Valor perdido [Obs %ld Reg %d Campo %d:%d]\n",
				arquivos[i].obs+1L,reg,colind+1,colind+campo);
		}
		buffer[k] = '\0';

		remblk(buffer);	/* Remover brancos a esquerda e a direita */

		colind += campo;
		miss = 1;
		ponto = 0;
		ne = 0;		
		k = 0;
		while (buffer[k]) {
			if (buffer[k] != ' ' && buffer[k] != '.' &&
					To_Lower(buffer[k]) != 'e')
				miss = 0;
			else
				/* no. com decimal  */
				if (buffer[k] == '.') {
					if (ne && variavel[m].tipo == 'n')

/* *** Padroniz. msg erro - Adriana 06/01/95
						execerror("Ponto invalido", "");
*** */

						execerror( PegaMsg (3172), "");
					else
						++ponto;
				}
				else	/* no. exponencial  */
					if (To_Lower(buffer[k]) == 'e')
						++ne;
			++k;
		}
		if (variavel[m].tipo == 'c') {
			if (ponto > 1)
				miss = 0;
			free(variavel[m].ptrval.ptrs);
			variavel[m].ptrval.ptrs = (char *) NULL;
			if ((qp = (char *) malloc((unsigned)(strlen(buffer)+1)))
					== (char *) NULL)

/* *** Padroniz. msg erro - Adriana 06/01/95
				execerror("Falta memoria", "");
*** */

				execerror( PegaMsg (1039), "");
			strcpy(qp, buffer);

			variavel[m].ptrval.ptrs = qp;
		}
		else if (variavel[m].tipo == 'd') {
			if (miss) {
#ifdef EDIX
				dp = &(variavel[m].ptrval.ptrf);
				*dp = MISSING;
#else
				variavel[m].ptrval.ptrf = MISSING;
#endif
			}
			else {
#ifdef EDIX
				dp = &(variavel[m].ptrval.ptrf);
				if ((dx = atod(buffer)) < (double) 0)
					*dp = MISSING;
				else
					*dp = dx;
#else
				if ((dx = atod(buffer)) < (double) 0)
					variavel[m].ptrval.ptrf = MISSING;
				else
					variavel[m].ptrval.ptrf = dx;
#endif
			}
		}
		else  {
			if (ponto > 1 || ne > 1)

/* *** Padroniz. msg erro - Adriana 06/01/95
				execerror("Campo nao numerico", "");
*** */

				execerror( PegaMsg (3148), "");

			if (miss) {
#ifdef EDIX
				dp = &(variavel[m].ptrval.ptrf);
				*dp = MISSING;
#else
				variavel[m].ptrval.ptrf = MISSING;
#endif
			}
			else {
				/* calcula o no.  */
				if (number(buffer,arquivos[i].obs+1L)) {
					aux = atof(buffer);
#ifdef EDIX
					if (!ponto && !ne)
						aux=aux/pow(10.,(double) decim);
					dp = &(variavel[m].ptrval.ptrf);
					*dp = aux;
#else
					if (!ponto && !ne)
						aux /= pow(10., (double) decim);
					variavel[m].ptrval.ptrf = aux;
#endif
				}
				else {
#ifdef EDIX
					dp = &(variavel[m].ptrval.ptrf);
					*dp = MISSING;
#else
					variavel[m].ptrval.ptrf = MISSING;
#endif
				}
			}
		}
	}

	/* caracteres especiais de formatacao  */
	while (*fp == '@' || *fp == '#' || *fp == 'L') {
		if (*fp == 'L') {
			if (fgets(printbuf, PRTBUF,
				arquivos[i].arq.ptraf)==(char *) NULL)
				tambuf = 0;
			else {
				tambuf = strlen(printbuf);
				if (printbuf[tambuf-1] == '\n') {
					printbuf[tambuf-1] = '\0';
					tambuf -= 1;
				}
			}
			colind = 0;
			++reg;
		}
		else
			if (*fp == '@')
				colind = atoi(++fp) - 1;
			else
				if (*fp == '#')
					colind += atoi(++fp);
		fp += (strlen(fp) + 1);
	}

	if (*fp != '\0')

/* *** Padroniz. msg erro - Adriana 06/01/95
		execerror("Erro no formato (lerextf)", "");
*** */

		execerror( PegaMsg (3169), "");

	++arquivos[i].obs;

	/* coloca na pilha de dados o no. da observacao lida */
	pilha[idpilha++] = (double) arquivos[i].obs;
#ifdef DEBUG
	if (f_4) {
		printabela();
	}
#endif
}

number(num, obs)
char *num;
long   obs;
{
	int i;
	int ce, cp, cplus, cminus, flag;
	int pe;
	int err;

	cplus  = 0;
	cminus = 0;
	ce     = 0;
	cp     = 0;
	flag   = 0;
	pe     = 0;
	err    = 0;

	for (i=0; i < (int) strlen(num);++i) {
		switch (num[i]) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			flag = 1;
			break;
		case '.':
			cp++;
			break;
		case '+':
			if (i == 0 || (pe && pe+1 == i)) {
				cplus++;
			}
			else
				err = 1;
			break;
		case '-':
			if (i == 0 || (pe && pe+1 == i)) {
				cminus++;
			}
			else
				err = 1;
			break;
		case 'E':
		case 'e':
			pe = i;
			ce++;
			cplus--;
			cminus--;
			break;
		default:
			err = 1;
		}

		if (err) {

/* *** Padroniz. msg erro - Adriana 06/01/95
			fprintf(stderr,
				"Numero invalido: <%s> na observacao <%ld>\n",
				num, obs);
*** */

			fprintf(stderr, PegaMsg (3192), num, obs );

			return(0);
		}
	}

	if (ce > 1 || cp > 1 || cplus > 1 || cminus > 1 || flag == 0) {

/* *** Padroniz. msg erro - Adriana 06/01/95
		fprintf(stderr,"Numero invalido: <%s> na observacao <%ld>\n",
			num, obs);
*** */

		fprintf(stderr, PegaMsg (3192), num, obs);

		return(0);
	}

	return(1);
}

