/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Contm funo lerextnf para leitura de arquivo externo no formatado

 Desenvolvido por:

      	Carlos Eduardo Assis Paniago
		Oscar Ivan Palma Pacheco
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>
#include <string.h>
#include <math.h>

#include <stdlib.h>

#ifndef VAXVMS
#include <malloc.h>
#endif

#include "pcsgbd.h"
#include "socasm.h"
#include "genese.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

/* ----------------------------------------------------------------------------
**
**	
**
** Funcao para leitura de arquivo externo nao formatado
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
**
** Data da ultima alteracao:
**
**		95/01/11 11:30:41
**
** ----------------------------------------------------------------------------
*/

#ifdef DEBUG
extern int	f_1;
extern int	f_4;
#endif

extern struct variavel variavel[];	/* informacoes das vars. existentes  */

extern struct arquivos arquivos[];	/* informacoes dos arqs. existentes  */

extern double pilha[];	/* pilha de dados  */
extern int idpilha;	/* indice da pilha de dados  */
extern int fim;		/* flag de fim do programa genese  */
extern int pareeof;	/* constante que indica fim de arquivo  */

extern char buffer[];	/* buffer utilizado para armazenar o conteudo de cada 
			campo lido  */

void lerextnf(i)
int i;
{
	int k;
	int j;
	int ret;
	int m;
	char *qp;
	double dx;
#ifdef EDIX
	double *dp;
#endif

#ifdef DEBUG
	D1print("Ler arquivo externo em formato livre\n");
#endif
	k = arquivos[i].nvar;
	for (j=0; j<k; ++j) {
		/* le um campo do arquivo  */
		ret = lerumcampo(buffer, RDRBUF, arquivos[i].arq.ptraf);
		/* pega o indice da variavel */
		m = arquivos[i].pos[j];
		if (ret == EOF) {
			if (j == 0)
				break;

/* *** Padroniz. msg erro - Adriana 06/01/95
			fprintf(stderr, "Campo inexistente ** Valor perdido\n");
*** */

			fprintf(stderr, PegaMsg (1009), arquivos [i].nome);

			if (variavel[m].tipo == 'c')
				strcpy(buffer, "");
			else
				strcpy(buffer, ".");
		}
		if (variavel[m].tipo == 'c') { /* var. string  */
			free(variavel[m].ptrval.ptrs);
			variavel[m].ptrval.ptrs = (char *) NULL;
			/* aloca area para a variavel string */
			if ((qp=(char *)malloc((unsigned) (strlen(buffer)+1)))
					== (char *)NULL)

/* *** Padroniz. msg erro - Adriana 06/01/95
				execerror("Falta memoria", "");
*** */

				execerror(PegaMsg (1039), "");
			strcpy(qp, buffer);
			variavel[m].ptrval.ptrs = qp;
		}
		else if (variavel[m].tipo == 'd') {	/* var. data  */
			if (strcmp(buffer, ".") == 0) {
#ifdef EDIX
				dp = &(variavel[m].ptrval.ptrf);
				*dp = MISSING;
#else
				variavel[m].ptrval.ptrf = MISSING;
#endif
			}
			else {
#ifdef EDIX
				dp = &(variavel[m].ptrval.ptrf);
				if ((dx = atod(buffer)) < (double) 0)
					*dp = MISSING;
				else
					*dp = dx;
#else
				if ((dx = atod(buffer)) < (double) 0)
					variavel[m].ptrval.ptrf = MISSING;
				else
					variavel[m].ptrval.ptrf = dx;
#endif
			}
		}
		else  { 	/* var. numerica  */
			if (strcmp(buffer, ".") == 0) {
#ifdef EDIX
				dp = &(variavel[m].ptrval.ptrf);
				*dp = MISSING;
#else
				variavel[m].ptrval.ptrf = MISSING;
#endif
			}
			else {
				if (number(buffer,arquivos[i].obs+1L)) {
#ifdef EDIX
					dp = &(variavel[m].ptrval.ptrf);
					*dp = atof(buffer);
#else
					variavel[m].ptrval.ptrf = atof(buffer);
#endif
				}
				else {
#ifdef EDIX
					dp = &(variavel[m].ptrval.ptrf);
					*dp = MISSING;
#else
					variavel[m].ptrval.ptrf = MISSING;
#endif
				}
			}
		}
	}
	/* verifica se nao tem mais observacoes a serem lidas. Se ainda houver
	   incrementa o no. da observacao corrente  */
	if (ret == EOF && j == 0) {
		arquivos[i].obs = (long) ret;
		/* testa se e' o fim da execucao do programa genese  */
		if (pareeof)
			if (veriarq())
				fim = 0;
	}
	else
		++arquivos[i].obs;
	/* coloca na pilha o no. da observacao  */
	pilha[idpilha++] = (double) arquivos[i].obs;
#ifdef DEBUG
	if (f_4) {
		printabela();
	}
#endif
}

