/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Contm a funo lerint para a leitura de arquivo interno (arquivo genese)

 Desenvolvido por:

      Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
	Maria Fernanda Moura
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#ifdef VAXVMS
#include <stdlib.h>
#else
#include <malloc.h>
#endif

#include "pcsgbd.h"
#include "socasm.h"
#include "genese.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif


/* ----------------------------------------------------------------------------
**
**	
**
** Funcao para ler um arquivo do sistema 
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
**
** Data da ultima alteracao:
**
**		95/05/23 14:50:34
**
** ----------------------------------------------------------------------------
*/

#ifdef DEBUG
extern int	f_1;
extern int	f_4;
#endif

extern struct variavel variavel[];   /* informacoes das vars. existentes  */

extern struct arquivos arquivos[];   /* informacoes dos arqs. existentes  */

extern int varfil[];	/* vetor com os indices das vars. arquivo  */

extern double pilha[];	/* pilha de dados  */
extern int idpilha;	/* indice da pilha de dados  */
extern int fim;		/* flag que indica fim do programa genese  */
extern int pareeof;	/* constante de fim de arquivo  */

extern char *obs[];	/* buffer da observacao lida  */

void lerint(i)
int i;
{
	long ret;
	int k;
	int j;
	int m;
	char *qp;
#ifdef EDIX
	double *dp;
#endif

	/* 
	** testa se e' arquivo a ser concatenado  
	*/

	if ( arquivos[i].fim != 0 ) {
		/* 
		** conc. vertical  
		*/

		if (variavel[varfil[i]].tipo == 'v' ) { 
#ifdef DEBUG
		D1print("Operacao CONCVER\n");
#endif
			concv(i,arquivos[i].fim,arquivos[i].ch,arquivos[i].nch,
				arquivos[i].qarea.pcv);
		}

		/* 
		** conc. horizontal  
		*/

		else {
#ifdef DEBUG
		D1print("Operacao CONCHOR \n");
#endif
			conch(i,arquivos[i].fim,arquivos[i].ch,arquivos[i].nch,
				arquivos[i].qarea.pch);
		}

		k = 0;

		return;
	}

#ifdef DEBUG
	D1print("Ler arquivo interno\n");
#endif

	/* 
	** le uma observacao  
	*/

	ret = ler_obs(arquivos[i].arq.ptraa, obs);
	arquivos[i].obs = ret;

	/* 
	** coloca na pilha o no. da observacao lida  
	*/

	pilha[idpilha++] = (double) ((ret==-1L)?ret:ret+1L);
	k = arquivos[i].nvar;

	/* 
	** atribui o valor de cada campo da observacao 'as respectivas vars. 
	*/

	for (j=0; j<k; ++j) {
		m = arquivos[i].pos[j];

		/* 
		** var. tipo string
		*/

		if (variavel[m].tipo == 'c') {
			free(variavel[m].ptrval.ptrs);
			variavel[m].ptrval.ptrs = (char *) NULL;

			if (ret == (long) EOF) {
			    if ((qp=malloc((unsigned)(2))) == NULL) {
				execerror( PegaMsg (1039), "");
				termina(2);
			    }
				*qp = '\0';
			}
			else {

			    if ((qp=malloc((unsigned)(strlen(obs[j])+1))) == NULL) {
				execerror( PegaMsg (1039), "");
				termina(2);
			    }
			    strcpy(qp, obs[j]);
			}
			variavel[m].ptrval.ptrs = qp;
		}

		/* 
		** var. tipo data ou numerica  
		*/

		else {	
			if (ret == (long) EOF || strcmpi(obs[j], ".") == 0) {
#ifdef EDIX
				dp = &(variavel[m].ptrval.ptrf);
				*dp = MISSING;
#else
				variavel[m].ptrval.ptrf = MISSING;
#endif
			}

			else {
#ifdef EDIX
				dp = &(variavel[m].ptrval.ptrf);
				*dp = atof(obs[j]);
#else
				variavel[m].ptrval.ptrf = atof(obs[j]);
#endif
			}
		}
	}

#ifdef DEBUG
	if (f_4)
		printabela();
#endif

	if (ret == (long) EOF && pareeof)
		if (veriarq())
			fim = 0;

	k = 0;
}

