/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Contm a funo operlog para a execuo de operacoes logicas


 Desenvolvido por:

	Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>
#include "socasm.h"
#include "pcsgbd.h"
#include "genese.h"


/* ----------------------------------------------------------------------------
**
**	
**
** Funcao para executar operacoes logicas
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
**
** Data da ultima alteracao:
**
**		94/10/17 12:51:26
**
** ----------------------------------------------------------------------------
*/


#ifdef DEBUG
extern int	f_1;
#endif

extern	double	pilha[];	/* pilha de dados  */
extern	int	idpilha;	/* indice da pilha de dados  */
extern unsigned int inst;	/* instrucao a ser executada  */

extern	double	op1, op2, op3;
extern	char	*ops1, *ops2, *ops3;

void operlog()
{
	/* 
	** Pega o operador 2  na pilha  
	*/
	op2 = pilha[--idpilha];
	if(OPER1 == ONOT) { 	/* verifica se tipo de operacao e' NOT  */
#ifdef DEBUG
		D1print("NOT\n");
#endif
	
		/* faz um NOT do operador obtido na pilha , colocando nela 
		   o resultado ( V ou F ) */
		pilha[idpilha++] = (double) (! op2);
	}
	else {
		/*
		** Obtem o operador 1 e verifica o tipo de operacao, 
		** executando-a e colocando o resultado na pilha ( V ou F )
		*/
		op1 = pilha[--idpilha];
		switch (OPER1) {
			case OAND:
#ifdef DEBUG
				D1print("AND\n");
#endif
				pilha[idpilha++] = (double) (op1 && op2);
				break;
			case OOR:
#ifdef DEBUG
				D1print("OR\n");
#endif
				pilha[idpilha++] = (double) (op1 || op2);
				break;
			case OXOR:
#ifdef DEBUG
				D1print("XOR\n");
#endif
				pilha[idpilha++] = (double) ((op1||op2) &&
					!(op1&&op2));
				break;
			case ONEQ:
#ifdef DEBUG
				D1print("NEQ\n");
#endif
				pilha[idpilha++] = (double) (op1 != op2);
				break;
			case OEQ:
#ifdef DEBUG
				D1print("EQ\n");
#endif
				pilha[idpilha++] = (double) (op1 == op2);
				break;
			case OLT:
#ifdef DEBUG
				D1print("LT\n");
#endif
				pilha[idpilha++] = (double) (op1 < op2);
				break;
			case OLE:
#ifdef DEBUG
				D1print("LE\n");
#endif
				pilha[idpilha++] = (double) (op1 <= op2);
				break;
			case OGT:
#ifdef DEBUG
				D1print("GT\n");
#endif
				pilha[idpilha++] = (double) (op1 > op2);
				break;
			case OGE:
#ifdef DEBUG
				D1print("GE\n");
#endif
				pilha[idpilha++] = (double) (op1 >= op2);
				break;
		}
	}
}
