/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Contm a funo pgm a ser executada no fim do programa genese. Executa o Loop 
	automatico e acoes de fim de programa

 Desenvolvido por:

	Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
	Carla Geovana do N. Macario
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>
#include "socasm.h"
#include "pcsgbd.h"
#include "genese.h"

/* ----------------------------------------------------------------------------
**
**	
**
** Funcao a ser executada no fim do programa genese. Executa o Loop 
** automatico e acoes de fim de programa
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
**
** Data da ultima alteracao:
**
**		94/12/09 09:16:52
**
** ----------------------------------------------------------------------------
*/


#ifdef DEBUG
extern	int	f_16;
#endif

extern	int	pc;		/* contador do programa  */
extern	unsigned int	ins[];	/* vetor de instrucoes a serem executadas */
extern	int	output;		/* flag - tem arquivos de saida  */

void pgm()
{
	if (output) {		/* tem arquivos de saida  */
#ifdef DEBUG
		D16print("\t%d\tVFA\n", pc);
		D16print("\t%d\tSWR\n", pc+1);
		D16print("\t%d\tSTV\tnulo\n", pc+2);
		D16print("\t%d\tJMP\t1\n", pc+3);
#endif
		/* 
		** Verifica se todos os arquivos de entrada chegaram ate' o fim.
		** Grava os arquivos de saida. Limpa a pilha de dados e Volta 
		** para a 1a. instrucao, executando o loop automatico  
		*/
		ins[pc++] = FSPC | VFA;
		ins[pc++] = SWR;
		ins[pc++] = STV | VARNULL;
		ins[pc++] = JMP | 1;
	}
	else {	/* Nao tem arquivos de saida. Apenas manda voltar para a 1a.
		   instrucao, executando o loop automatico */
#ifdef DEBUG
		D16print("\t%d\tJMP\t0\n", pc);
#endif
		ins[pc++] = JMP;
	}
}
