/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Contm a funo verivar para verificao se uma dada variavel existe. Retorna o
	tipo da variavel caso ela exista e 0 caso contrrio


 Desenvolvido por:

	Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <string.h>
#ifdef MSDOS
# include "y_tab.h"
#else
#ifdef VAXVMS
#include "ytab.h"
#else
# include "y.tab.h"
#endif
#endif
#include "pcsgbd.h"
#include "genese.h"


/* ----------------------------------------------------------------------------
**
**	
**
** Funcao que verifica se a variavel ja existe.
**
**
** Valor retornado:
**
**			O tipo da variavel ou 0 caso ela nao exista
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
**
** Data da ultima alteracao:
**
**		97/02/28 15:46:50
**
** ----------------------------------------------------------------------------
*/


extern struct variavel variavel[];   /* informacoes das vars. existentes */

extern	int	nvarc;		/* no. de vars. corrente  */
extern	int	varveris;	/* indice da variavel  */

int verivar(s)
char *s;
{
	int i;

	/* verifica se variavel existe e retorna seu tipo */
	for (i=0; i<nvarc; ++i) {
		if (variavel[i].nome && !strcmpi(variavel[i].nome, s)) {
			varveris = i;

			if (variavel[i].tipo == 'n')
				return VARNUM;

			if (variavel[i].tipo == 'c')
				return VARSTR;

			if (variavel[i].tipo == 'd')
				return VARDATA;

			return VARFIL;
		}
	}
	
	/* variavel nao existe */
	varveris = 0;

	return 0;
}
