/***********************************************************************************
 LIBSOC - Biblioteca padro para o SOftware Cientfico

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob 
 os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free 
 Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio) 
 qualquer verso posterior.

 Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA 
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais 
 detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com 
 esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no 
 endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Contem todas as funcoes necessarias para manipulacao da base de referencias

 Desenvolvido por:

 	      Antonio L. Peloso
		Carla Geovana do Nascimento Macrio
 		Oscar Ivan Palma Pacheco
		Roberto Hiroshi Higa
		Adriana Delfino dos Santos
		Luciana Alvim
 
 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
/*
 * Funcao:
 *	Contem todas as funcoes necessarias para
 *	manipulacao da base de referencias
 *
 * ------------------------------------------------------------------
*/

#include	<stdio.h>

#ifndef DIGIX
#include	<string.h>
#endif

#ifdef VAXVMS
#include	<ctype.h>
#include	<unixio.h>
#include	<file.h>
#include	<types.h>
#include	<stat.h>
#include	<stdlib.h>
#endif

#include	<fcntl.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<stdlib.h>

long            F_TERMOS;

#ifdef  MSDOS
#include        <io.h>
#endif

#ifdef SUN
#include	<stdlib.h>
#include	<unistd.h>
#endif

#include	"atomic.h"
#include	"memoria.h"

#ifdef MEM_DEBUG
#define M_Aloca(a,b,c) 		calloc(a,b)
#define M_Libera(a,b)		free(a)
#define M_Realoca(a,b,c,d)	realloc(a,b*c)
#include <mshell.h>
#endif

#include	"erro.h"

#include	"btree.h"
#include	"pilha.h"
#include	"lista.h"
#include	"classif.h"
#include	"campo.h"
#include	"word.h"
#include	"termo.h"
#include	"guia.h"
#include	"stop.h"
#include	"invert.h"
#include	"braco.h"
#include	"symbol.h"
#include	"index.h"
#include	"fixo.h"
#include	"base.h"
#include	"search.h"
#include	"parser.h"
#include	"seqnum.h"
#include	"merge.h"
#include	"getword.h"
#include	"mostra.h"
#include	"pcsgbd.h"
#include	"substr.h"
#include	"oper.h"
#include	"relacao.h"
#include	"filectl.h"
#include	"reindex.h"
#include	"copia.h"

#define MAXBUF		2048
#define ESC		''     /* delimitador de campo utilizado pelo sort */

#define ACCREAD         04
#define ACCWRITE        02
#define ACCRDWRT        06
#define ACCEXIST        00

#ifndef SUN
# define	S_IRUSR	00400		/*  permissao de leitura,	*/
# define	S_IWUSR	00200		/*  gravacao e 			*/
# define	S_IXUSR	00100		/*  execucao para user		*/
# define	S_IRGRP	00040		/*  permissao de leitura,	*/
# define	S_IWGRP	00020		/*  gravacao e 			*/
# define	S_IXGRP	00010		/*  execucao para grupo		*/
# define	S_IROTH	00004		/*  permissao para leitura,	*/
# define	S_IWOTH	00002		/*  gravacao e			*/
# define	S_IXOTH	00001		/*  execucao para outros	*/
# define	S_ENFMT 02000           /*  execucao para outros        */
#endif

#ifdef VAXVMS
#define O_RDBIN     O_RDONLY, 0, "rfm=stmlf"
#define RECACC      , "rfm=stmlf"
#define CREATFLAG   (S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP | S_IROTH), "rfm=stmlf"
#define unlink      delete
#else
#ifdef MSDOS
#define O_RDBIN     (O_RDONLY | O_BINARY | O_EXCL)
#define O_WRBIN     (O_WRONLY | O_BINARY | O_EXCL)
#define O_RDTXT     (O_RDWR   | O_TEXT   | O_EXCL)
#else
#define O_RDBIN     (O_RDONLY | O_EXCL)
#define O_WRBIN     (O_RDWR   | O_EXCL)
#define O_RDTXT     (O_RDONLY | O_EXCL)
#endif
#define RECACC
#define CREATFLAG   (S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP | S_IROTH | S_ENFMT)
#endif

#ifdef  DEBUG
static  int     debug = 1;
#endif

#ifndef VAXVMS
extern  char    *getenv();
extern  char    *mktemp();
#endif

#ifdef MSDOS
# define COPY		"copy"
# define DEL		"del"
# define NULO		"nul"
#else
# define COPY		"cp"
# define DEL		"rm"
# define NULO		"/dev/null"
#endif

static char *sccsid = "@(#)base.c	3.5	(NTIA/recinfo)	94/12/16";

static  char    *F_No = (char *) NULL;

extern  long    registro(void);
extern  long    LBas_Max;
extern  int     LReg_Max;

extern  char    basenom[];

#ifdef MSDOS
#include        <dos.h>

extern char *M_Realoca();

long    dizmemd()
{
	union REGS regs;

	regs.x.bx = 0xffff;
	regs.x.ax = 0x4800;
	int86(0x21, &regs, &regs);

	return((long) regs.x.bx * 16L);

}

int     dizmem()
{
	union REGS regs;
	return(int86(0x12, &regs, &regs));
}
#endif

Base    F_Create(nome)
char    *nome;
{
	int     i;
	int     len;
	char    *bname;
	char    *pdir;
	char    *sp;
	char    *fileaux;
	Base    B;
	char	*ult_chr;

	if (nome == (char *) NULL) {
		execerror("Erro Interno.", "[F_Create] Comunique ao NTIA.");
	}

	if (!F_No) {
		F_No = (char *) M_Aloca(TAMSTR, sizeof(char), "F_Create");
		if (F_No == (char *) NULL)
			errormem();
	}

	B = (Base) M_Aloca(1, sizeof(_Base), "F_Create");
	if (B == (Base) NULL)
		errormem();
	B -> C  = C_Create();
	B -> G  = Gi_Create(TAMGIA);
	B -> Bt = T_Create();
	B -> St = S_Create();
	
	if ((pdir = getenv("NTIABASES")) != (char *)NULL) {
		B -> Dir = (char *) M_Aloca((unsigned) (strlen(pdir) + 2),
			sizeof(char), "F_Create");
		if (B -> Dir == (char *) NULL)
			errormem();
		strcpy(B -> Dir, pdir);
#ifndef VAXVMS
#ifdef MSDOS
		strcat(B -> Dir, "\\");
#else
		strcat(B -> Dir, "/");
#endif
#endif
	}
	else {
		B -> Dir = (char *) M_Aloca(1, sizeof(char), "F_Create");
		if (B -> Dir == (char *) NULL)
			errormem();
		strcpy(B -> Dir,  "");
	}

	strcpy(basenom, nome);

	fileaux = (char *) M_Aloca(TAMSTR, sizeof(char), "F_Create");
	if (fileaux == (char *) NULL)
		fprintf(stderr,"Memoria insuficiente para arquivo temporario.",
			"");

	strcpy(fileaux, nome);
	strcat(fileaux, ".hdr");

	if (!(access(fileaux,0))) 
		strcpy(B -> Dir,  "");

	M_Libera((char *) fileaux, "F_Create");

	len = strlen(nome) + 6;

	for (i = 0; i < F_MAX; ++i) {
		B -> nome[i] = (char *) M_Aloca((unsigned) len, sizeof(char),
			"F_Create");
		if (B -> nome[i] == (char *) NULL)
			errormem();
	}

	bname = (char *) M_Aloca(TAMSTR, sizeof(char), "F_Create");

	if (bname == (char *) NULL)
		errormem();

	strcpy(bname, nome);

	for (sp = bname; *sp; sp++)
		if (*sp == '.') *sp = '\0';

	strncpy(B -> nome[F_RECINFO], bname, len);
	strncpy(B -> nome[F_DFX], bname, len);
	strncpy(B -> nome[F_INV], bname, len);
	strncpy(B -> nome[F_IFX], bname, len);
	strncpy(B -> nome[F_GIA], bname, len);
	strncpy(B -> nome[F_HDR], bname, len);
	strncpy(B -> nome[F_CMP], bname, len);
	strncpy(B -> nome[F_CTL], bname, len);


#ifdef VAXVMS
	strcat(B -> nome[F_RECINFO], ".dat;1");
	strcat(B -> nome[F_DFX], ".dfx;1");
	strcat(B -> nome[F_INV], ".inv;1");
	strcat(B -> nome[F_IFX], ".ifx;1");
	strcat(B -> nome[F_GIA], ".gia;1");
	strcat(B -> nome[F_HDR], ".hdr;1");
	strcat(B -> nome[F_CMP], ".cmp;1");
	strcat(B -> nome[F_CTL], ".ctl;1");
#else
	strcat(B -> nome[F_RECINFO], ".dat");
	strcat(B -> nome[F_DFX], ".dfx");
	strcat(B -> nome[F_INV], ".inv");
	strcat(B -> nome[F_IFX], ".ifx");
	strcat(B -> nome[F_GIA], ".gia");
	strcat(B -> nome[F_HDR], ".hdr");
	strcat(B -> nome[F_CMP], ".cmp");
	strcat(B -> nome[F_CTL], ".ctl");
#endif

	strcat(bname, ".stp");
	F_Nome(B, F_No, bname);
	if (fopen(F_No, "r" RECACC) == (FILE *)NULL)
	{
#ifndef VAXVMS
#ifdef MSDOS
		ult_chr = strrchr(basenom, '\\');
#else
		ult_chr = strrchr(basenom, '/');
#endif
#endif
		if (ult_chr != (char *) NULL)
		{
			strncpy(B->nome[F_STP],basenom,
				((int) ( ult_chr - basenom )) + 1);
			strcat(B -> nome[F_STP], "stopw");
		}
		else
			strcpy(B->nome[F_STP], "stopw");
	}
	else {
		strncpy(B -> nome[F_STP], bname, len);
#ifdef VAXVMS
		strcat(B -> nome[F_STP], ";1");
#endif
	}

	B -> fd[F_INV] = -1;
	B -> fd[F_IFX] = -1;

#ifdef DEBUG
	if (debug) {
		int	i;
		printf("F_Create:\n");
		for (i = 0; i < F_MAX; ++i) {
			printf("Base = [%s]\n", B -> nome[i]);
		}
	}
#endif
	M_Libera((char *) bname, "F_Create");

	return (B);
}

void	F_Destroy(B)
Base	B;
{
	int	i;

	if (!B)
		execerror("Erro Interno:", "[F_Destroy] Comunique ao NTIA");

	else {
		M_Libera(B -> Dir, "F_Destroy");
		Gi_Destroy(B -> G);
		C_Destroy (B -> C);
		T_Destroy (B -> Bt, (Funcao) X_Destroy);
		S_Destroy(B -> St);

		for (i = 0; i < F_MAX; ++i)
			M_Libera((char *)B -> nome[i], "F_Destroy");

		M_Libera((char *)B, "F_Destroy");
	}
}

/*
 * Indexa a base de dados especificada
*/
 
void 	F_Inverte(termos)
int     termos;
{
	extern	Base	G_Base[20];
	extern	int	B_Uso;

	ARQ	*Farq;
	Symbol	*V, *h_aux;
	Symbol	aux;
	Symbol  S;
	int	i;

	if (termos > 1) {
		V = (Symbol *) M_Aloca((unsigned) termos, sizeof(Symbol),
			"F_Inverte");
		if (V == (Symbol *) NULL)
			errormem();
		h_aux = V;
		for (i = 0; i < (termos - 1); ++i, ++V) {
			*V = (Symbol) Pop();
		}
	}
	
	if ((S = (Symbol) Pop()) == (Symbol) NULL) { 
			execerror("Erro: Parametro invalido para o comando ",
				"<indexe nome_de_base>");
	}
	if (!(Sy_Var(S) == VARI && Sy_Tipo(S) == VARI)) {
			execerror("Erro: Parametro invalido para o comando ",
				"<indexe nome_de_base>");
	}

	F_Verify(Sy_Dado(S));

	G_Base[B_Uso] = F_Create(Sy_Dado(S));

	strcpy(F_No, G_Base[B_Uso] -> Dir);
	strcat(F_No, Sy_Dado(S));

	/*
	** ?????????? Qual e' o objetivo das tres linha seguintes?
	** Agora esta' proposta a linha seguinte.
	** if ((Farq = abre_arq(F_No, 0)) != NULL)
	*/

	Farq = abre_arq(F_No, 0);
	if (!((long) Farq < 0L && (long) Farq > -5L))
		fech_arq(Farq);

	strcpy(F_No, G_Base[B_Uso] -> nome[F_RECINFO]);
	if (access(F_No, ACCEXIST) == -1) {
		strcpy(F_No, G_Base[B_Uso] -> Dir);
		strcat(F_No, G_Base[B_Uso] -> nome[F_RECINFO]);
	}

	F_DefRead(G_Base[B_Uso]);

	if (termos > 1) {
		V = h_aux;
		for (i = 0; i < (termos-1); ++i, ++V) {
			if (C_LookUp(G_Base[B_Uso] -> C, Sy_Nome(*V)) == -1) {
				aux = *V;
				V = h_aux;
				M_Libera((char *) V, "F_Inverte");
				execerror("Erro: Campo inexistente:",
					Sy_Nome(aux));
			}
		}
		V = h_aux;
		C_IndSN(G_Base[B_Uso] -> C, 'n');
		for (i = 0; i < (termos-1); ++i, ++V) {
			C_IndCmp(G_Base[B_Uso] -> C, Sy_Nome(*V));
		}
		V = h_aux;
		M_Libera((char *) V, "F_Inverte");
	}
	else {
		C_IndSN(G_Base[B_Uso] -> C, 's');
	}

	F_Index(G_Base[B_Uso]);

	F_Grava(G_Base[B_Uso], G_Base[B_Uso] -> C);

	G_Base[B_Uso] = F_Reopen(G_Base[B_Uso]); 
}

/*
 * Le a definicao da base de referencias
*/

void	F_DefRead(B)
Base	B;
{
	FILE	*Fd;

	F_Nome(B, F_No, B -> nome[F_HDR]);

	if ((Fd = fopen(F_No, "r" RECACC)) == (FILE *)NULL) {
		errorarq(F_No);
	}

	C_Read(B -> C, Fd);
	fclose(Fd);
}

void	F_DefRCmp(B)
Base	B;
{
	FILE	*Fd;
 	char	*buf;

	F_Nome(B, F_No, B -> nome[F_CMP]);
	if ((Fd = fopen(F_No, "rb" RECACC)) == (FILE *)NULL) {
		errorarq(F_No);
	}
	buf = (char *) M_Aloca(MAXCAMPO, sizeof(char), "F_DefRCmp");
	if (buf == (char *) NULL)
		errormem();
	C_IndSN(B -> C, 'n');
	while (fscanf(Fd, "%s", buf) != EOF)
		C_IndCmp(B -> C, buf);
	fclose(Fd);
}

/*
 * Constroi o arquivo GUIA 
*/

void	F_Gmake(B)
Base	B;
{
	int	fin;
	int	fout;

	
	F_Nome(B, F_No, B -> nome[F_INV]);
	if ((fin = open(F_No, O_RDBIN)) < 0) {
		errorarq(F_No);
	}

	F_Nome(B, F_No, B -> nome[F_GIA]);
#ifdef VAXVMS
	unlink(F_No);
#endif
	if ((fout = creat(F_No, CREATFLAG)) < 0) {
		errorarq(F_No);
	}
	close(fout);
	fout = open(F_No, O_WRBIN);
	Gi_Make(fin, fout);
	close(fin);
	close(fout);
}

/*
 * Le o arquivo guia do arquivo invertido
*/

void	F_GiRead(B)
Base	B;
{
	int	fin;

	if (B) {
		F_Nome(B, F_No, B -> nome[F_GIA]);
		if ((fin = open(F_No, O_RDBIN)) < 0) {
			errorarq(F_No);
		}
		Gi_Read(B -> G, fin);
		close(fin);
	}
	else
		execerror("Erro Interno:", "[F_GuiaRead] Avise ao NTIA");
}

/*
 * Cria o arquivo invertido de uma base de referencias
*/

unsigned	char	*Buffer_Le;	/* buffer usado para leitura buferizada */

Campo 	campo_get = (Campo) NULL;

void	F_Index(Bs)
Base	Bs;
{
	extern  int     F_Re;

	Btree   T;
	Stop    S;
	Braco   B;
	Word    W;
	Invert  In;
	Campo   C;
	long    total = 0l;
	long    i;
	int     fin;
	int     ind;
	int     tipo;
	int     r;
	int     cmp;
	int     fd0, fd1, fd2, fd3;
	char    *arq0, *arq1, *arq2;
	FILE    *fctl;

	char    cmd_line[TAMSTR];

	int Lim_Ref;

	if (Bs == (Base) NULL)
		execerror("Erro Interno:", "[F_Index] Comunique ao NTIA");
	Buffer_Le = (unsigned char *) M_Aloca((unsigned) (BUF_SIZE + 1),
					sizeof(char), "F_Index");
	if (Buffer_Le == (unsigned char *) NULL)
		errormem();

	if(!F_Re)
	{
		F_Nome(Bs, F_No, Bs->nome[F_CTL]);
		if(!(access(F_No,0))) {
			sprintf(cmd_line, "%s %s > %s", DEL, F_No, NULO);
			system(cmd_line);
		}

		printf("\n\rVerificando arquivo de StopWords ...\r");
		fflush(stdout);
	}

	F_Nome(Bs, F_No, Bs -> nome[F_STP]);

	S = S_Make(F_No);

	F_Nome(Bs, F_No, Bs -> nome[F_RECINFO]);

	arq0 = F_Template("STXXXXXX");

	if ((r = creat(arq0, CREATFLAG)) < 0)
		errorarq(arq0);

	close(r);

	arq1 = F_Template("STXXXXXX");

	if ((r = creat(arq1, CREATFLAG)) < 0)
		errorarq(arq1);

	close(r);

	arq2 = F_Template("STXXXXXX");

	if ((r = creat(arq2, CREATFLAG)) < 0)
		errorarq(arq2);

	close(r);

	unlink(arq0);
	unlink(arq2);

/*
	Fixa a base de dados
*/
	if(!F_Re) {
		printf(
		"Verificado arquivo de StopWords                     \n");
		printf(
		"\r        registros na Base de Dados.                \r");
		fflush(stdout);
	}
	F_Nome(Bs, F_No, Bs -> nome[F_RECINFO]);
	if ((fin = open(F_No, O_RDBIN)) < 0) {
		errorarq(F_No);
	}
	F_Nome(Bs, F_No, Bs -> nome[F_DFX]);
#ifdef VAXVMS
	unlink(F_No);
#endif
	if ((fd1 = creat(F_No, CREATFLAG)) < 0) {
		errorarq(F_No);
	}
	close(fd1);
	fd1 = open(F_No, O_WRBIN);
	if (Fx_Make(fin, fd1) == 0) {
		execerror("Base de dados incorreta. Verifique!", "");
	}
	close(fin);
	close(fd1);

	if(!F_Re)
		F_Total(Bs);

#ifdef  MSDOS

	Lim_Ref = (int) ((dizmemd() - 40960) / 44);
	F_TERMOS = 2000;

#else

# ifdef IRIX

	Lim_Ref  = 20000; 
	F_TERMOS = 30000;

# else
#  ifdef SCO

	Lim_Ref  = 20000; 
	F_TERMOS = 5000;

#  else

	Lim_Ref  = 20000; 
	F_TERMOS = 100000;

#  endif
# endif
#endif

	/* Acho que uma otimizacao possivel seria considerar que :
	**
	** se uma palavra ocorre um numero de vezes igual ou maior que o
	** numero de registros da base entao a palavra e' uma stopword e
	** nao precisa ser indexada porque a leitura sequencial a recupera.
	**
	** A implicacao disto seria que:
	**
	** o tamanho maximo de um braco da base = numero de registros
	** portanto o braco poderia ser estatico para cada base o que
	** evitaria a alocacao/desalocacao de memoria.
	*/

	Buffer_Le = (unsigned char *) M_Realoca(Buffer_Le, 1, F_LReg(Bs)+2, "F_Index"); 

	if(!F_Re) {
	  printf("\n\nIndexando a base:                                 \r");
	  fflush(stdout);
	}
	campo_get = C = Bs -> C;

	F_Nome(Bs, F_No, Bs -> nome[F_RECINFO]);
	if ((fin = open(F_No, O_RDBIN)) < 0) {
		errorarq(F_No);
	}
	
	B  = B_Create();
	W  = B_Word(B);
	In = B_Inv(B);

	T = T_Create();

	do {
		for (i = 0; i < F_TERMOS ; ) {
			if ((r = R_GetWord(fin, B)) == 0)
				break;
			cmp = In -> campo;
			ind = (cmp < C->total) ? ((C -> index[cmp]) & 0x7f) : 0;
			if (ind != 's' && ind != 'S') {
					continue;
			}
			if ((tipo = C_Tipo(C, cmp)) == 'c' || tipo == 'C') {
				W -> Tipo = 'C';
			}
			else {
				W -> Tipo = 'N';
			}

			if (S_LookUp(S, W_Key(W))) continue;
			
			T = X_Insert(T, B, S);
			
			++i;

			if (!(i % 200)) {
			   if(!F_Re) {
			       printf("Indexando a base:  %07ld registros.                 \r"
						, registro());
			       fflush(stdout);
			    }
			}
		}

		if(!F_Re)
		printf("Indexando a base:  %07ld registros.                 \r",
				registro());
		fflush(stdout);

		if (total == 0l) {
#ifdef VAXVMS
			unlink(arq1);
#endif
			if ((fd1 = creat(arq1, CREATFLAG)) < 0) {
				errorarq(arq1);
			}
			close(fd1);
			fd1 = open(arq1, O_WRBIN);
			X_Write(fd1, T);
			close(fd1);
			T_Destroy(T, (Funcao) X_Destroy);
		}
		else {
			if ((fd0 = creat(arq0, CREATFLAG)) < 0) {
				errorarq(arq0);
			}
			close(fd0);
			fd0 = open(arq0, O_WRBIN);
			X_Write(fd0, T);
			close(fd0);
			T_Destroy(T, (Funcao) X_Destroy);
			if ((fd0 = open(arq0, O_RDBIN)) < 0) {
				errorarq(arq0);
			}
			if ((fd1 = open(arq1, O_RDBIN)) < 0) {
				errorarq(arq1);
			}
			if ((fd2 = creat(arq2, CREATFLAG)) < 0) {
				errorarq(arq2);
			}
			close(fd2);
			fd2 = open(arq2, O_WRBIN);
			if ( !F_Merge(fd0, fd1, fd2, (long) 0) )
			{
				close(fd0); close(fd1); close(fd2);
				unlink(arq0); unlink(arq1); unlink(arq2);
				errordisk();	
			}
			close(fd0); close(fd1); close(fd2);
			unlink(arq0); unlink(arq1);
			rename(arq2, arq1); /* ambos arquivos sao temporarios
					       e estarao sempre no mesmo file
					       system, podendo ser usado o re
					       name neste caso. */
		}
		T = T_Create();
		total += i;
	} while (r);

	T_Destroy (T, (Funcao) X_Destroy);

	B_Destroy(B);

	S_Destroy(S);

	close(fin);

	F_Nome(Bs, F_No, Bs -> nome[F_INV]);

	unlink(F_No);

	if(rename(arq1, F_No)) {
		F_Copy(arq1, F_No);
		unlink(arq1);
	}

	M_Libera((char*) arq2, "F_Index");
	M_Libera((char*) arq1, "F_Index");
	M_Libera((char*) arq0, "F_Index");

	if(!F_Re) 
	    printf("Total de Palavras Indexadas: [%09ld]\n\n", total);

	/* 
	** Fixa o arquivo invertido
	*/

	F_Nome(Bs, F_No, Bs -> nome[F_INV]);
	if ((fd0 = open(F_No, O_RDBIN)) < 0) {
		errorarq(F_No);
	}
	F_Nome(Bs, F_No, Bs -> nome[F_IFX]);

#ifdef VAXVMS
	unlink(F_No);
#endif

	if ((fd1 = creat(F_No, CREATFLAG)) < 0) {
		errorarq(F_No);
	}
	close(fd1);
	fd1 = open(F_No, O_WRBIN);
	Fx_Inv(fd0, fd1);	/* Cria arquivo fixo do invertido */
	close(fd0);
	close(fd1);

	F_Gmake(Bs);		/* Cria o guia para a base fixada */

	M_Libera((char *) Buffer_Le, "F_Index");

	/* forma a composicao dir/nome/extensao */

	F_Nome(Bs, F_No, Bs->nome[F_CTL]);

	unlink(F_No);                  /* remove o arquivo */
	fd3 = creat(F_No, CREATFLAG);  
	close(fd3);

	/* abre o arquivo CTL para gravacao de Tamanho da Base,
	   base toda indexada e quantidade de registros na base */

	fctl = fopen(F_No, "w+");
	fprintf(fctl, "%ld;%ld;%ld\n",
		Bs->Tamanho, Bs->Tamanho, F_Length(Bs));
	fclose(fctl);

}

/*
 * Cria templates para arquivos temporarios
*/

char	*F_Template(s)
char	s[];
{
	char	*tmp;
	char	*str;
	char	*nome;

	nome = (char *) M_Aloca(TAMSTR, sizeof(char), "F_Teamplate");
	if (nome == (char *) NULL)
		errormem();

	if (!(tmp = getenv("NTIATMP")))
		tmp = getenv("TMP");

	if (tmp)
#ifdef VAXVMS
		sprintf(nome, "%s%s;1", tmp, s);
	else
		sprintf(nome, "%s;1", s);
#else
#ifdef MSDOS
		sprintf(nome, "%s\\%s", tmp, s);
#else
		sprintf(nome, "%s/%s", tmp, s);
#endif
	else
		sprintf(nome, "%s", s);
#endif

	if ((str = mktemp(nome)) == (char *)NULL) {
		errorarq(nome);
	}

	return (str);
}

/*
 * Le  um arquivo invertido e devolve um Braco
*/

void	F_Iread(Bs, n, Br)
Base	Bs;
long	n;
Braco	Br;
{
	int	fin;
	int	fix;

	if (Bs) {
		fin = Bs -> fd[F_INV];
		fix = Bs -> fd[F_IFX];
#ifdef DEBUG
		if (debug)
			printf("Registro a ser lido [%ld]\n", n);
#endif
		B_Seek(fix, fin, n);
		B_Read(fin, Br);
	}
	else
		execerror("Erro Interno:", "[F_Iread] Comunique ao NTIA");
}

void	F_Open(B)
Base	B;
{
	if (B) {
		if (B -> fd[F_INV] != -1)
			return;
		F_Nome(B, F_No, B -> nome[F_INV]);
		if ((B -> fd[F_INV] = open(F_No, O_RDBIN)) < 0) {
			errorarq(F_No);
		}
		F_Nome(B, F_No, B -> nome[F_IFX]);
		if ((B -> fd[F_IFX] = open(F_No, O_RDBIN))< 0) {
			errorarq(F_No);
		}
	}
	else
		execerror("Erro Interno:", "[F_Open] Comunique ao NTIA");
}

void	F_Close(B)
Base	B;
{
	if (B) {
		if (B -> fd[F_INV] == -1)
			return;
		if (close(B -> fd[F_IFX]) < 0)
			execerror("Erro: Nao consegiu fechar o arquivo ", 
							B -> nome[F_IFX]);
		if (close(B -> fd[F_INV]) < 0)
			execerror("Erro: Nao consegiu fechar o arquivo ",
							B -> nome[F_INV]);
		B -> fd[F_INV] = -1;
		B -> fd[F_IFX] = -1;
	}
	else
		execerror("Erro Interno:", "[F_Open] Comunique ao NTIA");
}

long	F_Tamanho(B)
Base	B;
{
	return (B -> Tamanho);
}

void	F_Total(B)
Base	B;
{
	int	fd;

	F_Nome(B, F_No, B -> nome[F_DFX]);
	if ((fd = open(F_No, O_RDBIN)) < 0)
		B -> Tamanho = 0l;
	else {
		B -> Tamanho = (lseek(fd, 0l, 2) / (long) sizeof(_Fixo));
		close(fd);
	}
	LBas_Max = B->Tamanho;
}

/*
** Observe que apesar do tamanho de um registro na base ser definido como
** long, o maximo que se aloca para sua leitura e 32k (MSDOS) . ???
*/

int     F_LReg(B)
Base    B;
{
	int      fd;
	int      lth = 0;
	Fixo     F;

	if(LReg_Max > 0 )
		return(LReg_Max);

	F_Nome(B, F_No, B -> nome[F_DFX]);
	if ((fd = open(F_No, O_RDBIN)) < 0)
		lth = (int) BUF_SIZE;
	else {
		while( read(fd, (Fixo)F, sizeof(Fixo)) == sizeof(Fixo)) {
			if(Fx_Tamanho(F) > lth)
				lth = Fx_Tamanho(F);
		}
		close(fd);
	}
	LReg_Max = lth;
	return(lth);
}

long  F_Tambytes(Bs)
Base    Bs;
{

	int     fd;
	long    Tambytes;

	F_Nome(Bs, F_No, Bs -> nome[F_RECINFO]);
	fd = open(F_No, O_RDBIN);
	Tambytes = (long) lseek(fd, 0l, 2) ;
	close(fd);
	return((long) Tambytes);
}

void    F_Nome(B, nome, s)
Base    B;
char    *nome;
char    s[];
{

	strcpy(nome, B -> Dir);

	strcat(nome, s);
}

/*
#define MAX_MEM		(30 * 1024)
#define MAX_TAM		(30 * 1024 - 1)

int	F_GetRef(B)
Base	B;
{
	char	*Bp;
	int	tam;

	if (B -> Buffer) {
		M_Libera ((char *) B -> Buffer, "F_GetRef");
		B -> Buffer = (char *) NULL;
	}
	Bp = (char *) M_Aloca((unsigned) F_LReg(B), sizeof(char), "F_GetRef");
	if (Bp == (char *) NULL)
		errormem();
	if ((fgets(Bp, (unsigned)F_LReg(B)-1, B -> FP)) == (char *) NULL) {
		M_Libera((char *) Bp, "F_GetRef");
		return(0);
	}
	if ((tam = strlen(Bp)) > MAX_TAM) {
		execerror("Erro: linha muito longa.","");
	}
	B -> Buffer = (char *) M_Aloca((unsigned) (tam + 1), sizeof(char),
			"F_GetRef");
	if (B -> Buffer == (char *) NULL)
		errormem();
	Bp[tam - 1] = '\0';
	strcpy(B -> Buffer, Bp);
	M_Libera((char *) Bp, "F_GetRef");
	return(1);
}
*/
 
/*
** Grava os campos de indexacao.
** Porque gravar um arquivo igual ao HDR, sem indicacao nenhuma?
*/

static	int	fgra = -1;

void    F_Grava(Bs, C)
Base    Bs;
Campo   C; 
{
	Lista  L1;
	char	*buf;
	int    cmp;

	L1 = L_Create();
	for (cmp = 0; cmp < C -> total; ++cmp) {
		if (C -> index[cmp] == 's' || C -> index[cmp] == 'S') {
			buf = (char *) M_Aloca((unsigned)
					(strlen(C ->nome[cmp]) + 1),
					sizeof(char), "F_Grava");
			if (buf == (char *) NULL)
				errormem();
			strcpy(buf, C -> nome[cmp]);
			L1 = L_Insert(L1, (Dado) buf);
		}
	}

	F_Nome(Bs, F_No, Bs->nome[F_CMP]);
	unlink(F_No);
	if ((fgra = creat(F_No, CREATFLAG)) < 0)
		errorarq(F_No);
	close(fgra);
	fgra = open(F_No, O_WRBIN);
	L_Print(L1, (Funcao) _grava);
	close(fgra);
	L_Destroy(L1, _fdel);
}

/*
 *	Esta funcao classifica o resultado de pesquisa que esta no Braco
*/

void	F_Sorte(B, Br)
Base	B;
Braco	Br;
{
#ifdef	MSDOS
	extern	void Srt_Sort(int, char **);
	extern	int Srt_Mwrite(char *, int, long, short, short, short,
						FILE *, int *);
#else
	extern	void	Srt_Sort();
	extern	int	Srt_Mwrite();
#endif
	FILE	*fd;
	Campo	C;
	Invert	I;
	char	**argvs;
	char	*arq0, *arq1;
	char	*ptbuf;
	char	*buf;
	char	*nbuf;
	int	*cmps;
	long	r;
	int	args;
	int	farq;
	int	j;
	long	n, total;

	if (!B || !Br) {
		execerror("Erro Interno:", "[F_Sorte] Comunique ao NTIA");
	}
	arq0 = F_Template("STXXXXXX");
	if ((farq = creat(arq0, CREATFLAG)) < 0)
		errorarq(arq0);
	close (farq);
	arq1 = F_Template("STXXXXXX");
	if ((farq = creat(arq1, CREATFLAG)) < 0)
		errorarq(arq1);
	close (farq);

	C = B -> C;
	I = B_Inv(Br);
	total = B_Qtd(Br);

	cmps = (int *) M_Aloca((unsigned int) C -> total, sizeof(int),
								"F_Sorte");
	if (cmps == (int *) NULL)
		errormem();

	argvs = Cl_Argum(C -> Srt, C -> total, cmps, &args, arq0, arq1);

	F_Mopen(B);
	if ((fd = fopen(arq0, "wb" RECACC)) == (FILE *) NULL) {
		errorarq(arq0);
	}
	for (n = 1L; n <= total; ++n, ++I) {
		printf("\r%5d", n);
		fflush(stdout);
		r = I_Ref(I);
		F_Mread(B, r);
		if ( Srt_Mwrite(B -> Buffer, C -> total, I -> referencia,
				I -> campo, I -> posicao, I -> selecionado,
				fd, cmps) == -1)
		{
			unlink(arq0); free(arq0);
			unlink(arq1); free(arq1);
			errordisk();
		}
	}
	printf("\n");
	fflush(stdout);
	if (putc('\0', fd) == EOF)
	{
		unlink(arq0); free(arq0);
		unlink(arq1); free(arq1);
		errordisk();
	}
	F_Mclose(B);
	fclose(fd);

	Srt_Sort(args, argvs);

	unlink(arq0);
	M_Libera((char *) cmps, "F_Sorte");
	M_Libera((char *) argvs, "F_Sorte");


	if ((fd = fopen(arq1, "rb" RECACC)) == (FILE *) NULL) {
		errorarq(arq1);
	}
	I = B_Inv(Br);
	buf = (char *) M_Aloca(MAXBUF, sizeof(char), "F_Sorte");
	if (buf == (char *) NULL)
		errormem();
	nbuf = (char *) M_Aloca(16, sizeof(char), "F_Sorte");
	if (nbuf == (char *) NULL)
		errormem();
	while(fgets(buf, MAXBUF, fd)) {
		ptbuf = buf;
		ptbuf += strlen(buf);
		for (j = 0; j < 4; ++j)
			while(*ptbuf-- != ESC);
		++ptbuf;
		for (j = 0; j < 4; ++j) {
			n = 0;
			while(*++ptbuf != ESC && *ptbuf != '\n')
				nbuf[n++] = *ptbuf;
			nbuf[n] = '\0';
			if (j == 0)
				I -> referencia = atoi(nbuf);
			if (j == 1)
				I -> campo = atoi(nbuf);
			if (j == 2)
				I -> posicao = atoi(nbuf);
			if (j == 3)
				I -> selecionado = (char) atoi(nbuf);
		}
		++I;
	}
	unlink(arq1);
	M_Libera((char *) nbuf, "F_Sorte");
	M_Libera((char *) buf, "F_Sorte");
}


void    _grava(nome)
char	*nome;
{
 	char	*buf;
 	int	s;
 
	if (!nome)
		execerror("Erro Interno:","[G_Writ] Comunique ao Ntia.");
	buf = (char *) M_Aloca((unsigned) (strlen(nome) + 2), sizeof(char),
		"G_Writ");
	if (buf == (char *) NULL)
		errormem();
	strcpy(buf, nome);
	strcat(buf, "\n");
	s = strlen(buf);
	if (write(fgra, buf, s) != s) 
		execerror("Erro: Nao gravou corretamente ", F_No);
	M_Libera((char *) buf, "G_Writ");
}
 
int     _fdel(pt)
char     *pt;
{
	M_Libera((char*)pt, "_fdel");
	return(1);
}

#ifdef DEBUG
int	_bprint(B)
Braco	B;
{
	Word	W;
	
	W = B -> W;
	printf("[%s]  [%d] [%c]\n", W -> Key, W -> Qtd, W -> Tipo);
	return(1);
}
#endif

void    F_Fixa(B)
Base    B;
{
	int f0, f1;

	if(!F_No)
		F_No = M_Aloca(1, 128, "F_Fixa");

	F_Nome(B, F_No, B -> nome[F_INV]);
	if ((f0 = open(F_No, O_RDBIN)) < 0) {
		errorarq(F_No);
	}
	F_Nome(B, F_No, B -> nome[F_IFX]);
#ifdef VAXVMS
	unlink(F_No);
#endif
	if ((f1 = creat(F_No, CREATFLAG)) < 0) {
		errorarq(F_No);
	}
	close(f1);
	f1 = open(F_No, O_WRBIN);
	Fx_Inv(f0, f1); /* Cria arquivo fixo do invertido */
	close(f0);
	close(f1);

	F_Gmake(B);             /* Cria o guia para a base fixada */
}

void    F_MakeFx(B)
Base    B;
{
	int f0, f1;

	F_Nome(B, F_No, B -> nome[F_RECINFO]);
	if ((f0 = open(F_No, O_RDBIN)) < 0) {
		errorarq(F_No);
	}
	F_Nome(B, F_No, B -> nome[F_DFX]);
#ifdef VAXVMS
	unlink(F_No);
#endif
	if ((f1 = creat(F_No, CREATFLAG)) < 0) {
		errorarq(F_No);
	}

	/* Tento evitar que o DFX possa ser aberto como texto no MSDOS */

	close(f1);
	f1 = open(F_No, O_WRBIN);

	if (Fx_Make(f0, f1) == 0) {
		execerror("Base de dados incorreta. Verifique!", "");
	}
	close(f0);
	close(f1);
}

int    F_Merge(fd0, fd1, fd2, fptr)
int     fd0, fd1, fd2;
long    fptr;
{

	extern  int   F_Re;
	extern  long  LBas_Max;
	extern  Word  Wrd0, Wrd1, Wrd2;

	int     ior0, ior1;
	int     state = 1;
	int     r;
	
	char    fg;

	/* Se uma word se repete por mais de x registros
	   entao ela eh uma stopword para a base */

	while (1) {
		switch (state) {
		case 1:
			ior0 = Word_Read(fd0, Wrd0);
			ior1 = Word_Read(fd1, Wrd1);
			state = 2;
			break;
		case 2:
			if (ior0 == 0 && ior1 == 0)
				return(1);
			if (ior0 == 0 && ior1 != 0)
				{ state = 3; break; }
			if (ior1 == 0 && ior0 != 0)
				{ state = 4; break; }
			if ((r = W_Cmp(Wrd0 , Wrd1)) < 0 ) 
				{ state = 5; break; }
			else if ( r > 0)
				{ state = 6; break; }
			else if (r == 0)
				{ state = 7; break; }
			else {
				execerror( "Erro Interno:", 
					"[MergeFile] Comunique ao NTIA");
			}
			break;
		case 3:
			if (F_Re) fg = 'R';
			else      fg = ' ';

			do {
				if( !Word_Write(fd1, fd2, Wrd1,fg,fptr) )
					return(0);
			} while (Word_Read(fd1, Wrd1));

			return(1);
		case 4:
			if (F_Re) fg = 'I';
			else      fg = ' ';

			do {
				if( !Word_Write(fd0, fd2, Wrd0,fg,fptr) )
					return(0);
			} while (Word_Read(fd0, Wrd0));

			return(1);
		case 5:
			if (F_Re) fg = 'I';
			else      fg = ' ';
			if( !Word_Write(fd0, fd2, Wrd0, fg, fptr) )
				return(0);
			ior0 = Word_Read(fd0, Wrd0);
			state = 2;
			break;
		case 6:
			if (F_Re) fg = 'R';
			else      fg = ' ';
			if ( !Word_Write(fd1, fd2, Wrd1, fg, fptr) )
				return(0);
			ior1 = Word_Read(fd1, Wrd1);
			state = 2;
			break;
		case 7:
			if ( !F_Junta(fd0, fd1, fd2, Wrd0, Wrd1, fptr) )
				return(0); 
			state = 1;
			break;
		}
	}
}

/*      O conjunto de rotinas abaixo deve ser otimizado para ler
	32k de referencias de cada vez.
	
	Chicherchio             NTIA                    27/03/93
*/

int     Word_Read(inv, W)
int     inv;
Word    W;
{
	if (read(inv, (Word) W, sizeof(_Word))<sizeof(_Word))
		return(0);
	return(1);      
}

int     Word_Write(inv, out, W, fg, ref)
int     inv;
int     out;
Word    W;
char    fg;
long    ref;
{
	extern  Invert  Inv0;
	long    Q;

	if (write(out, W, sizeof(_Word)) != sizeof(_Word))
		return(0);

	for(Q = 0; Q < W->Qtd; ++Q) {
		read (inv, Inv0, sizeof(_Invert));
		if(fg=='R') {
			if(Inv0->referencia == 0L)
				Inv0->referencia = ref;
		}
		else {
			if(fg=='I')
				if(Inv0->referencia>=ref)
					Inv0->referencia++;
		}
		if (write(out, Inv0, sizeof(_Invert)) != sizeof(_Invert))
			return(0);
	}
	return(1);
}

long    C_Length(B)
Base    B;
{
	int     fd;
	long    ls;

	F_Nome(B, F_No, B-> nome[F_CTL]);
	if ((fd = open(F_No, O_RDTXT)) < 0)
		ls = 0l;
	else 
		ls = lseek(fd, (long) 0, 2);  
		close(fd);
	return((long) ls); } 

void trim(s,s1)
char    *s;
char    *s1;
{
	int     i;
	int     k;

	k = 0;
	for(i=0; i < (int) strlen (s); i++) {
		if (s[i] != ' ')
			s1[k++] = s[i];
	}
	s1[k] = '\0';
}

int     F_Junta(inv1, inv2, out, W1, W2, ref)
int     inv1;
int     inv2;
int     out;
Word    W1;
Word    W2;
long    ref;
{
	extern  Word    Wrd2;
	extern  Invert  Inv0, Inv1;
	extern  int     F_Re;
	long    q1, q2, maior;
	long    i;

	q1 = W1->Qtd;
	q2 = W2->Qtd;

	maior = q1 + q2;

	W_Set(Wrd2, W_Key(W1), maior, W_Tipo(W1));
	
	if (write(out, Wrd2, sizeof(_Word)) != sizeof(_Word))
		return(0);

	for(i = 0; i < W1->Qtd; ++i) {
		read (inv1,Inv0, sizeof(_Invert));
		if(F_Re) {
			if(Inv0->referencia>=ref)
				Inv0->referencia++;
		}
		if(write(out, Inv0, sizeof(_Invert)) != sizeof(_Invert))
			return(0);
	}
	for(i = 0; i < W2->Qtd; ++i) {
		read (inv2,Inv1, sizeof(_Invert));
		if(F_Re) {
			if(Inv1->referencia==0L)
				Inv1->referencia=ref;
		}
		if(write(out, Inv1, sizeof(_Invert)) != sizeof(_Invert))
			return(0);
	}
	return(1);
}

void	F_Verify(Nome)
char	*Nome;
{
	char	Area[128], Brea[128];

	sprintf(Brea, "%s.dat",Nome);
	sprintf(Area, "%s/%s", getenv("NTIABASES"), Brea);

	if(access(Brea, ACCEXIST)==-1) {
		if(access(Area, ACCEXIST)==-1)
			execerror("Base Nao Existe: ",Brea);
	}
}

