/***********************************************************************************
 LIBSOC - Biblioteca padro para o SOftware Cientfico

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob 
 os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free 
 Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio) 
 qualquer verso posterior.

 Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA 
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais 
 detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com 
 esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no 
 endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Rotina para criar arquivos de dados.

 Desenvolvido por:

		Oscar Ivan Palma Pacheco


 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
/*
** --------------------------------------------------------------------------
**
** Rotina para criar arquivos de dados.
**
** Forma de usar:
**
**		fdind = cria_arq(nome);
**
** Variaveis envolvidas:
**
**		ARQ	*fdind;	ponteiro de referencia da base de dados
**		char	*nome;	nome da base de dados
**
** Valor retornado:
**
**			parq : Ponteiro de referencia da base de dados
**			  -1 : Nao conseguiu alocar memoria
**			  -2 : Erro na criacao do arquivo ".dat"
**			  -3 : Erro na criacao do arquivo ".hdr"
**
** -------------------------------------------------------------------------
*/

#include <stdio.h>

#ifndef VAXVMS
# include <string.h>
# include <malloc.h>
#endif

#include "pcsgbd.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

#ifdef MSDOS
# define MODO_2			"wb+"
#else
# define MODO_2			"w+"
#endif

ARQ *
cria_arq(nome)
char	*nome;
{
	char	nomearq[128];
	ARQ	*parq;
	VAR	*pvar;

	/*
	** Aloca area na memoria para arquivos.
	*/

	if ((parq = (ARQ *) malloc((PATIPO) sizeof (ARQ))) == (ARQ *) NULL)
		return ((ARQ *) -1);
	if ((pvar = (VAR *) malloc((PATIPO) (sizeof (VAR) * MAXVAR)))
			== (VAR *) NULL) {
		free((ALTIPO) parq);
		return ((ARQ *) -1);
	}
	parq -> pvar = pvar;

	/*
	** Criar arquivos.
	*/

	strcpy(nomearq, nome);
	strcat(nomearq, ".dat");
	if ((parq -> fddat = fopen(nomearq, MODO_2)) == (FILE *) NULL) {
		free((ALTIPO) parq);
		free((ALTIPO) pvar);
		return ((ARQ *) -2);
	}

	strcpy(nomearq, nome);
	strcat(nomearq, ".hdr");
	if ((parq -> fdhdr = fopen(nomearq, MODO_2)) == (FILE *) NULL) {
		fclose(parq -> fddat);
		free((ALTIPO) parq);
		free((ALTIPO) pvar);
		return ((ARQ *) -3);
	}

	/*
	** Atualizar estrutura de informacoes da base.
	*/

	strcpy(parq -> nome, nome);
	parq -> novo = 1;
	parq -> nvar = 0;
	parq -> proxobs = 0L;

	Set_Buff(parq -> fddat, (unsigned) TAMFILEBUF);

	return parq;
}
