/***********************************************************************************
 LIBSOC - Biblioteca padro para o SOftware Cientfico

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob 
 os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free 
 Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio) 
 qualquer verso posterior.

 Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA 
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais 
 detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com 
 esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no 
 endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Rotina para definir variaveis.

 Desenvolvido por:

		Oscar Ivan Palma Pacheco
		Carlos Fernando Assis Paniago

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#ifndef VAXVMS
#include <string.h>
#endif
#include "pcsgbd.h"



/* --------------------------------------------------------------------------
**
** Rotina para definir variaveis.
**
** Forma de usar:
**
**		numvar = def_var(parq, nome, tipo);
**
** Variaveis envolvidas:
**
**		ARQ	*parq;	ponteiro de referencia da base de dados
**		char	*nome;	nome da variavel
**		char	tipo;	tipo da variavel
**
** Valor retornado:
**
**			num : Numero de variaveis definidas
**			 -1 : Excedido o numero maximo de variaveis
**			 -2 : Variavel ja existe
**
** ------------------------------------------------------------------------- */

def_var(parq, nome, tipo)
ARQ	*parq;
char	*nome;
char	tipo;
{
	VAR	*pvar;
	int	i;

	/*
	** Verificar numero de variaveis.
	*/

	if (parq -> nvar == MAXVAR - 1)
		return -1;

	/*
	** Verificar se a variavel ja existe.
	*/

	for (i = 0; i < parq -> nvar; i++)
		if (strcmpi((parq -> pvar + i) -> nome, nome) == 0)
			return -2;

	/*
	** Atualizar definicoes.
	*/

	pvar = parq -> pvar + parq -> nvar++;
	strcpy(pvar -> nome, nome);
	pvar -> tipo = tipo;

	if (tipo == 'c') {
		pvar -> mmin.len = MAX_INT;
#ifdef VAXVMS
		pvar -> mmax.len = MININT;
#else
		pvar -> mmax.len = (int) MININT;
#endif
	}
	else {
		pvar -> mmin.valor = MAXREAL;
		pvar -> mmax.valor = MINREAL;
	}
	return (parq -> nvar);
}
