/***********************************************************************************
 LIBSOC - Biblioteca padro para o SOftware Cientfico

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob 
 os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free 
 Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio) 
 qualquer verso posterior.

 Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA 
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais 
 detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com 
 esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no 
 endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Funcao para executar outro processo entrando em WAIT

 Desenvolvido por:

		Oscar Ivan Palma Pacheco

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#ifndef MSDOS

#include <stdio.h>
#include <string.h>
#include <errno.h>

#ifdef ULTRIX
# include <sys/wait.h>
#endif

#ifdef SUN
# include <stdlib.h>
# include <unistd.h>
# include <sys/types.h>
# include <sys/wait.h>
#endif

#ifdef VAXVMS
# include <processes.h>
# include <signal.h>
#else
# include <fcntl.h>
#endif

#include "pcsgbd.h" /* Adriana */


/* ----------------------------------------------------------------------------
**
** Funcao para executar outro processo entrando em WAIT
**
** Forma de usar:
**
**		execfil(nome, parm)
**		char *nome;
**		char *parm[];
**
** Valor retornado:
**
**		Codigo de execucao do processo (exit)
**
** ----------------------------------------------------------------------------
*/


extern int errno;

#ifdef VAXVMS
int _exfwait = 0;

int execfil(nome, parm)
char *nome;
char *parm[];
{
	int i;
	int rc;
	int pid;
	int c;
	int pipes[2];
	char buffer[512];
	char arquivo[256];
	char lixo[256];
	char exnome[20];
	int estado;
	int nchar;
	int tam;
	char *pbuf;
	int nrec;
	int instd;
	int outstd;

	pbuf = buffer;
	fgetname(stdin, arquivo);
	instd = 1;
	if (strcmp(arquivo, "SYS$INPUT:.;") == 0)
		instd = 0;
	strcpy(pbuf, arquivo);
	pbuf += (strlen(pbuf) + 1);
	fgetname(stdout, arquivo);
	outstd = 1;
	if (strcmp(arquivo, "SYS$OUTPUT:.;") == 0)
		outstd = 0;
	strcpy(pbuf, arquivo);
	pbuf += (strlen(pbuf) + 1);

	fflush(stdout);

	if (instd) {
		nchar = 0;
		c = getc(stdin);
		nrec = ftell(stdin);
		while (c != '\n') {
			c = getc(stdin);
			--nchar;     
		}

		fseek(stdin, nrec, 0);

		c = xgetc(stdin);
		while (c != '\n') {
			c = xgetc(stdin);
			++nchar;
		}

		itoa(nrec, pbuf, 10);
		pbuf += (strlen(pbuf) + 1);
		itoa(nchar, pbuf, 10);
		pbuf += (strlen(pbuf) + 1);
	}
	*pbuf = '\n';
	++pbuf;
	*pbuf = '\0';
	tam = pbuf - buffer + 1;

	if (outstd) {
		strcpy(lixo, "lixo");
		itoa(getpid(), &lixo[strlen(lixo)], 10);
		strcat(lixo, ".nti;1");
		if (freopen(lixo, "w", stdout) == (FILE *) NULL) {

/* *** Padroniz. msg erro - Adriana 30/11/94
			fprintf(stderr, "Nao consegui abrir <%s>\n", lixo);
*** */

			fprintf(stderr, PegaMsg (5020), lixo);
			exit(2);
		}
	}

	if (pipe(pipes) == -1) {

/* *** Padroniz. msg erro - Adriana 30/11/94
		fprintf(stderr, "Erro: Pipe nao completado\n");
*** */

		fprintf(stderr,  PegaMsg (5023));
		exit(2);
	}
	i = 0;
	pbuf = parm[i];
	while (parm[++i])
		pbuf = parm[i];
	pbuf += (strlen(pbuf) + 1);
	itoa(pipes[0], pbuf, 10);
	parm[i++] = pbuf;
	pbuf += (strlen(pbuf) + 1);
	itoa(pipes[1], pbuf, 10);
	parm[i++] = pbuf;
	parm[i] = '\0';

	if (write (pipes[1], buffer, tam) == -1) {

/* *** Padroniz. msg erro - Adriana 30/11/94
		fprintf(stderr, "Erro: Pipe nao gravado\n");
*** */

		fprintf(stderr,  PegaMsg (5023));
		exit(2);
	}

	if ((pid = vfork()) == 0) {
		strcpy(exnome, "ntia$path:");
		strcat(exnome, nome);
     		rc = execv(exnome, parm);	/* processo filho */
		if (rc == -1)

/* *** Padroniz. msg erro - Adriana 30/11/94
			fprintf(stderr, "Erro: programa nao executado.%d\n",
*** */

			fprintf(stderr,  PegaMsg (5024));
				
		exit(errno);
	}
	else {					/* processo pai */
		void (*func)();

		func = signal(SIGINT, SIG_IGN);
		_exfwait = 1;
  		while (wait(&estado) != pid)
			;			/* espera o filho acabar */
		_exfwait = 0;
  		signal(SIGINT, func);

		if (instd) {
			tam = read(pipes[0], buffer, 512);
			pbuf = buffer;
			nrec = atoi(pbuf);
			pbuf += (strlen(pbuf) + 1);
			nchar = atoi(pbuf);
			fseek(stdin, nrec, 0);
			for (i = 0; i < nchar; ++i)
				xgetc(stdin);
		}

		if (outstd) {
			freopen(arquivo, "a", stdout);
			delete(lixo);
		}

		rc = estado;
		close(pipes[0]);
		close(pipes[1]);
	}

	return rc;
}
#else
int execfil(nome, parm)
char *nome;
char *parm[];
{
	int set;
	int rc;
	int pid;
#ifdef ULTRIX
	union wait estado;
#else
	int estado;
#endif

	set = fcntl(fileno(stdin), F_GETFD, 0) & 1;
	fcntl(fileno(stdin), F_SETFD, 0);   /* deixa stdin aberto no execve */
	fflush(stdout);

	if ((pid = fork()) == 0) {
		rc = execvp(nome, parm);	/* processo filho */
		if (rc == -1)

/* *** Padroniz. msg erro - Adriana 30/11/94
			fprintf(stderr, "Erro: modulo nao executado.%d\n",
				errno);
*** */

			fprintf(stderr,  PegaMsg (5024));

		exit(errno);
	}
	else {					/* processo pai */
		while (wait(&estado) != pid)
			;			/* espera o filho acabar */
#ifdef ULTRIX
		rc = (int) estado.w_status;	/* retorna "return code" filho*/
#else
#if defined(SUN) | defined(RS6000)
		rc = estado >> 8;
#else
		rc = estado;			/* retorna "return code" filho*/
#endif
#endif
	}

	fcntl(fileno(stdin), F_SETFD, set);/* stdin igual a entrada no execve */

	return rc;
}
#endif
#endif

