/***********************************************************************************
 LIBSOC - Biblioteca padro para o SOftware Cientfico

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob 
 os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free 
 Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio) 
 qualquer verso posterior.

 Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA 
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais 
 detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com 
 esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no 
 endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Calcula a probabilidade acumlada em uma distribuio F 

Desenvolvido por: 
		Dalton Francisco Andrade
		Maria Fernanda Moura 		
		Oscar Ivan Palma Pacheco
		Slvio Roberto Medeiros Evangelista 		
		Snia Ternes

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <math.h>
#include "pcsgbd.h"


/*---------------------------------------------------------------------*/
/*                 fprob  -- Significance of F distribution            */
/*---------------------------------------------------------------------*/
/*                                                                     */
/*       Purpose:   Evaluates F distribution probability               */
/*                                                                     */
/*       Calling Sequence:                                             */
/*                                                                     */
/*            P     := fprob( F , Dfn , Dfd );                         */
/*                                                                     */
/*                 F      --- F-value                                  */
/*                 Dfn    --- Numerator degrees of freedom             */
/*                 Dfd    --- Denominator degrees of freedom           */
/*                                                                     */
/*                 P      --- Resultant probability                    */
/*                                                                     */
/*       Calls:                                                        */
/*                                                                     */
/*            CdBeta                                                   */
/*                                                                     */
/*       Method:                                                       */
/*                                                                     */
/*            The input values are transformed to match the            */
/*            requirements of the Beta distribution.  Function CDBeta  */
/*            provides the corresponding cumulative Beta distribution  */
/*            probability.                                             */
/*                                                                     */
/*            An error in the input arguments results in a returned    */
/*            probability of -1.                                       */
/*								       */
/* ------------------------------------------------------------------- */

double fprob( F , Dfn , Dfd )
double F;
double Dfn;
double Dfd;
{
	int Dprec = 12;
	int MaxIter = 200;

	int 	Iter;
	double  Cprec;
	int 	Ifault;
	double  Pval;

	/* Inicio fprob */

	if ( F == 0.0 )		return(1.0);

	if ( Dfn > 150.0 )
		Dfn = 150.0;
	else {
		if ( Dfn < .00001 )
			Dfn = 0.00001;
	}

	if ( Dfd > 150.0 )
		Dfd = 150.0;
	else {
		if ( Dfd < .00001 )
			Dfd = 0.00001;
	}

	if ( F < 0.00000001 )
		F = 0.00000001;
	else {
		if ( F > 1000000.0 )	/* um milhao */
			F = 1000000.0;
	}

	Pval = -1.0;

	if (( Dfn > 0.0 ) && ( Dfd > 0.0 )) {
	      Pval = CDBeta( Dfd / ( Dfd + F * Dfn ), Dfd / 2.0, Dfn / 2.0,
			      Dprec, MaxIter, &Cprec, &Iter, &Ifault );
	      if (Ifault != 0) 
			Pval = -1.0;
	}

	return(Pval);
}
