/***********************************************************************************
 LIBSOC - Biblioteca padro para o SOftware Cientfico

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob 
 os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free 
 Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio) 
 qualquer verso posterior.

 Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA 
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais 
 detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com 
 esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no 
 endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Funcao para obter "tokens"

 Desenvolvido por:

		Carlos Fernando Assis Paniago
		Silvio Evangelista
		Oscar Ivan Palma Pacheco

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <ctype.h>

#ifdef MSDOS
#include <stdlib.h>
#endif

#ifdef SUN
#include <stdlib.h>
#endif

#include "pcsgbd.h"
#include "getoken.h"


/* ----------------------------------------------------------------------------
**
** Funcao para obter "tokens"
**
** Forma de usar:
**
**		gtoken1(token)
**		char *token;
**		FILE *faux;
**
** Valor retornado:
**
**		Inteiro correspondente ao caracter separador
**
** ----------------------------------------------------------------------------
*/

int gtoken1(token, faux)
char *token;
FILE *faux;
{
	char *q;
	int c;
	int cc;
	int tok;


	while ((c = xgetc(faux)) == ' ' || c == '\t' || c == '\n' 
			|| c == '/' || c == '\r') {
		if (c == '/') {
			if ((cc = xgetc(faux)) == '*') {
				c = xgetc(faux);
				while ((cc = xgetc(faux)) != '/' || c != '*') {
					c = cc;
				}
			}
			else {
				unxgetc(cc, faux);
				break;
			}
		}
	}
	q = token;
	*q++ = (char) c;
	*q='\0';
	switch (c) {
		case EOF:
			setOSstdin();
			exit(1);
		case ',':
			return VG;
		case ';':
			return PTVG;
		case '*':
			return STAR;
		case '#':
			return POUND;
		case '{':
			return LB;
		case '}':
			return RB;
		case '[':
			return LC;
		case ']':
			return RC;
		case '(':
			return LP;
		case ')':
			return RP;
		case '<':
			return LA;
		case '>':
			return RA;
		case '=':
			return IGUAL;
		case '"':
			return ASPAS;
		case '!':
			return EXCLA;
	}

	tok = NUMBER;
	q = token;
	*q='\0';
	for (;;) {
		switch (c) {
			case EOF:
				*q = '\0';
				return tok;
			case ' ':
			case '\t':
			case '\n':
			case '\r':
			case ',':
			case ';':
			case '*':
			case '#':
			case '{':
			case '}':
			case '[':
			case ']':
			case '(':
			case ')':
			case '<':
			case '>':
			case '=':
			case '"':
			case '!':
				unxgetc(c, faux);
				*q = '\0';
				return tok;
		}
		if (c == ':' || c == '\\')
			tok = ARQUIVO;

		if (!isdigit(c) && c != '.' && c != '-' || c == '_')
			tok = VARIAV;

		if (!isdigit(c) && !isalpha(c) && c != '.' && c != '-' &&
				c != ':' && c != '\\' && c != '_') {
			*q = '\0';
			return ERRO;
		}
		*q++ = (char) c;
		c = xgetc(faux);
	}
}
