/***********************************************************************************
 LIBSOC - Biblioteca padro para o SOftware Cientfico

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob 
 os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free 
 Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio) 
 qualquer verso posterior.

 Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA 
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais 
 detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com 
 esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no 
 endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Contm funcoes para transformar dados como:
    - itoa: inteiro para string;
    - ltoa: longo para string;
    - dtoa: data para string;
    - atod: string para data


 Desenvolvido por:

 			Oscar Ivan Palma Pacheco


 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <string.h>

/*
#ifdef SUN
#include <stdlib.h>
#endif
*/

#ifdef MSDOS
#include <stdlib.h>
#endif

#include "pcsgbd.h"


/* ----------------------------------------------------------------------------
**
** Funcoes para transformar dados
**
** Forma de usar:
**
**		char *itoa(n, s, base)	inteiro para string
**		char *ltoa(m, s, base)	longo para string
**		char *dtoa(d, s)	data para string
**		long atod(s)		string para data
**		int	n;
**		long	m;
**		double	d;
**		char	*s;
**		int	base;
**
** Valor retornado:
**
**		Ponteiro da cadeia de caracteres
**
** ----------------------------------------------------------------------------
*/

static	char	digito[16] = {	'0', '1', '2', '3', '4', '5', '6', '7',
				'8', '9', 'A', 'B', 'C', 'D', 'E', 'F' };

static char rdbuffer[320];

#ifndef MSDOS

char *itoa(n, s, base)
int	n;
char	s[];
int	base;
{
	int	i, sign;

	if ((sign = n) < 0)
		n = -n;
	i = 0;
	do {
		s[i++] = digito[n % base];

	} while ((n /= base) > 0);
	if (sign < 0)
		s[i++] = '-';
	s[i] = '\0';
	reverse(s);
	return s;
}

char *ltoa(n, s, b)
long	n;
char	s[];
int	b;
{
	long	i, sign, base;

	base = (long) b;

	if ((sign = n) < 0L)
		n = -n;
	i = 0L;
	do {
		s[i++] = digito[n % base];

	} while ((n /= base) > 0L);
	if (sign < 0L)
		s[i++] = '-';
	s[i] = '\0';
	reverse(s);
	return s;
}

#endif

char *dtoa(n, s)
double	n;
char	s[];
{
	int	ano;
	int	mes, dia;

	if (n >= MISSING) {
		strcpy(s, ".");
		return s;
	}

	dia = (int) ((long) n % 100L);

	n /= 100L;
	mes = (int) ((long) n % 100L);

	ano =(int) ((long) n / 100L);

	sprintf(s, "%02d/%02d/%04d", dia, mes, ano);

	return s;
}

double atod(s)
char	s[];
{
	long n;
	char *p;
	int i;
	int j;
	int k;

	i = 0;
	j = 0;

	if (strcmp(s, ".") == 0)
		return MISSING;

	while (s[i]) {
		if (s[i] == '/') {
			s[i] = '\0';
			++j;
		}

		++i;
	}

	if (j != 2)
		return (double) -2;

	p = s;

	k = atoi(p);

	if (k < 1 || k > 31)
		return (double) -3;

	n = (long) k;

	p += (strlen(p) + 1);

	k = atoi(p);

	if (k < 1 || k > 12)
		return (double) -4;

	n = n + (100L * (long) k);

	p += (strlen(p) + 1);

	n = n + (10000L * (long) atoi(p));

	return (double) n;
}

char *rounddec(val, tam, dec)
double val;
int tam;
int dec;
{
	extern double fabs();

	static char *buff = rdbuffer;
	char *p;

	/* Ajuste do tam e dec para pedidos acima da precisao da maquina */

	if (tam > 15) {
		if (dec > 15)
			dec = dec - (tam - 15); 
		tam = 15;
	}

	/* 
	** Teste para garantir a nao ocorrencia de violacao no tamanho
	** de rdbuffer e o limite de numeros representativos nos
	** diversos tipos de hardware
	*/

	if ( (fabs(val) > 1.0e37 && tam < 7) || (fabs(val) > 1.0e99 && tam < 8)) {

	    sprintf(buff, "%*.*e", tam,  0 , val);

	    p = buff;

	    buff += (strlen(buff) + 1);

	    if (buff - rdbuffer > 200)
		    buff = rdbuffer;

	    return p;
	}

	sprintf(buff, "%*.*f", tam+4, dec+4, val);

	p = strchr(buff, '.') + dec + 1;

	if (*p > '4') {
		*p = '\0';

		--p;

		if (*p == '.')
			--p;
		++*p;

		while (*p - '0' == 10) {
			*p = '0';

			--p;

			if (*p == '.')
				--p;

			if (*p == ' ') {
				*p = '1';
				break;
			}

			++*p;
		}
	}
	else
		*p = '\0';

	if (dec == 0) {
		p = strchr(buff, '.');
		*p = '\0';
	}

	if (strlen(buff) > 3) {
		p = buff;

		while (*p) {
			if (!strncmp(p, " -.0", 4)) {
				*p = '-';
				*(p+1) = '0';
				break;
			}
			else if (!strncmp(p, " +.0", 4)) {
				*p = '+';
				*(p+1) = '0';
				break;
			}

			++p;
		}
	}

	/*
	if (strlen(buff) > 1) {
		p = buff;

		while (*p) {
			if (!strncmp(p, "-0", 2)) {
				if (atof(p) >= (double) 0.)
					*p = ' ';

				break;
			}

			++p;
		}
	}
	*/

	if ((int) strlen(buff) > tam) {
		/*
		sprintf(buff, "%*.*e", tam, (tam<7 ? 0 : tam-7), val);
		*/
                if (fabs(val) >= 1.e100 || fabs(val) <= 1.e-100)
                        sprintf(buff, "%*.*e", tam, (dec<5 ? 0 : dec-5), val);

                else
                        if (fabs(val) >= 1.e10 || fabs(val) <= 1.e-10)
                                sprintf(buff, "%*.*e", tam, (dec<4 ? 0 : dec-4), val);

                        else
                                sprintf(buff, "%*.*e", tam, (dec<4 ? 0 : dec-4), val);
	}

	p = buff;

	buff += (strlen(buff) + 1);

	if (buff - rdbuffer > 200)
		buff = rdbuffer;

	return p;
}

