/***********************************************************************************
LIBSOC - Biblioteca padro para o SOftware Cientfico

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob
os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free
Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio)
qualquer verso posterior.

Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com
esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no
endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    mshell.h provides the interface definitions for the dynamic
    memory handler.

 Implantado por :

        Moacir Pedroso Junior
 Atualizado por:
 
                Snia Ternes
		Carla Geovana do Nascimento Macrio

 
 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
/*----------------------------------------------------------------------
 *++
 *
 *  mshell.h -- Dynamic memory handler interface
 *  Description: mshell.h provides the interface definitions for the dynamic
 *  memory handler.
 *  See mshell.c for complete documentation.
 *
 *+-
 *  $Log$
 *--
 */

/* Compilation options */
#define MEM_LIST		/* Build internal list */
#define MEM_WHERE		/* Keep track of memory block source */

/* Interface functions */
unsigned long	Mem_Used(void) ;
void		Mem_Display(FILE *) ;
void		Mem_Store(char *) ;

/* Interface functions to access only through macros */
#if defined(MEM_WHERE)
void		*mem_alloc(size_t, char *, int) ;
void		*mem_calloc(size_t, size_t, char *, int) ;
void		*mem_realloc(void *, size_t, char *, int) ;
void		mem_free(void *, char *, int) ;
char		*mem_strdup(char *, char *, int) ;
#else
void		*mem_alloc(size_t) ;
void		*mem_calloc(size_t, size_t) ;
void		*mem_realloc(void *, size_t) ;
void		mem_free(void *) ;
char		*mem_strdup(char *) ;
#endif

/* Interface macros */
#if !defined(__MSHELL__)
#if defined(MEM_WHERE)
#define malloc(a)	mem_alloc((a),__FILE__,__LINE__)
#define calloc(a,b)	mem_calloc((a), (b),__FILE__,__LINE__)
#define realloc(a,b)	mem_realloc((a),(b),__FILE__,__LINE__)
#define free(a)		mem_free((a),__FILE__,__LINE__)
#define strdup(a)	mem_strdup((a),__FILE__,__LINE__)
#else
#define malloc(a)	mem_alloc(a)
#define calloc(a, b)	mem_calloc((a),(b))
#define realloc(a, b)	mem_realloc((a),(b))
#define free(a)		mem_free(a)
#define strdup(a)	mem_strdup(a)
#endif
#endif

/*----------------------------------------------------------------------*/
