/***********************************************************************************
LIBSOC - Biblioteca padro para o SOftware Cientfico

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob
os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free
Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio)
qualquer verso posterior.

Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com
esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no
endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    nprob  -- calcula a probabilidade acumulada em uma Normal. 

Desenvolvido por:


		Dalton Francisco Andrade
		Maria Fernanda Moura
		Oscar Ivan Palma Pacheco
		Slvio Roberto Medeiros Evangelista
		Snia Ternes

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <math.h>
#include "const.h"
#include "pcsgbd.h"


/*--------------------------------------------------------------*/
/*        nprob  -- Significance of normal distribution         */
/*--------------------------------------------------------------*/
/*                                                              */
/* Function:  nprob                                             */
/*                                                              */
/* Purpose:   Evaluates normal distribution probability         */
/*                                                              */
/* Calling Sequence:                                            */
/*                                                              */
/*      P     := nprob( X );                                    */
/*                                                              */
/*           X      --- ordinate of normal distribution         */
/*                                                              */
/*           P      --- Resultant tail probability              */
/*                                                              */
/* Calls:                                                       */
/*                                                              */
/*      Erf                                                     */
/*                                                              */
/* Method:                                                      */
/*                                                              */
/* The simple relationship between the error function and the   */
/*      normal distribution is used.                            */
/*                                                              */
/*--------------------------------------------------------------*/

double nprob( X ) 
double X;
{
	/* Inicio SigNorm */

	if ( X >=  8.21 )	return(0.0);
	if ( X <= -8.21 )	return(1.0);

	if (X >= 0.0) 
	   return(1.0 - ( 1.0 + Erf(  X / Sqrt2 ) ) / 2.0);
	else
	   return(1.0 - ( 1.0 - Erf( -X / Sqrt2 ) ) / 2.0);

}      /* Fim SigNorm */
	
