/***********************************************************************************
LIBSOC - Biblioteca padro para o SOftware Cientfico

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob
os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free
Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio)
qualquer verso posterior.

Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com
esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no
endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Encontra o caminho de um arquivo, a partir do valor da varivel de ambiente PATH.

Desenvolvido por:

                	Antonio Luiz Peloso
			Oscar Ivan Palma Pacheco

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
/* ----------------------------------------------------------------------------
**
** Function:
**
**	Finds out if a file name is on any directory listed on the PATH
**	environment variable
**
** ----------------------------------------------------------------------------
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<sys/types.h>
#include	<sys/stat.h>

#define	FOREVER	for (;;)

static	char	PathEnvBuffer[1024];
static	int	indx = 0;

#ifdef MSDOS
void	PathGetNextName(char *);
#else
void	PathGetNextName();
#endif

void	PathGetEnv()
{
	char	*getenv();
	char	*ptr;

	ptr = getenv("PATH");
	indx = 0;

	if (ptr)
		strcpy(PathEnvBuffer, ptr);
}

void	PathGetNextName(dir)
char	*dir;
{
	static	int	ch;
	static	int	nindx;

	dir[0] = '\0';
	nindx = 0;

	FOREVER {
		ch = PathEnvBuffer[indx];

		if (ch != ' ')
			break;

		++indx;
	}
		
	FOREVER {
		ch = PathEnvBuffer[indx];
		++indx;

		if (ch == '\0' || ch == ' ' || ch == ':') {
			dir[nindx] = '\0';
			break;
		}

		dir[nindx] = (char) ch;
		++nindx;
	}
}

void PathGetDir(arv, path)
char	*arv;
char	*path;
{

	char	name[256];
	char	dir[256];
	int	rc;
	unsigned int	mode;
	struct	stat	st;

	path[0] = '\0';

	if (strchr(arv, '/')) {
		rc = stat(arv, &st);
		mode = st.st_mode;

/*		if (rc == 0 && !(mode & S_IFDIR) )
			strcpy(path, arv);  Carla */
	}

	else {

		PathGetEnv();

		FOREVER {
			PathGetNextName(dir);

			if (strlen(dir) == 0)
				break;

			sprintf(name, "%s/%s", dir, arv);

			rc = stat(name, &st);
			mode = st.st_mode;

/* 			if (rc == 0 && !(mode & S_IFDIR) ) {
				strcpy(path, name);
				break;
			}  Carla */
		}
	}
}

