/***********************************************************************************
LIBSOC - Biblioteca padro para o SOftware Cientfico

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob
os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free
Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio)
qualquer verso posterior.

Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com
esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no
endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Rotina obter definicao de variaveis.

 Desenvolvido por:

		Oscar Ivan Palma Pacheco

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>
#ifndef VAXVMS
#include <string.h>
#endif
#include "pcsgbd.h"


/* --------------------------------------------------------------------------
**
** Rotina obter definicao de variaveis.
**
** Forma de usar:
**
**		cod = pega_var(parq, numvar,  nome, &tipo, &mmin, &mmax);
**
** Variaveis envolvidas:
**
**		int	cod;	Codigo de retorno.
**		ARQ	*parq;	ponteiro de referencia da base de dados
**		int	numvar; Numero da variavel
**		char	nome[];	nome da variavel (retorno)
**		char	tipo;	tipo da variavel (retorno)
**		MINVAL	mmin;	menor valor ou menor comprimento (retorno)
**		MAXVAL	mmax;	maior valor ou maior comprimento (retorno)
**
** Valor retornado:
**
**			  0 : Retorno normal
**			 -1 : Variavel inexistente
**
** ------------------------------------------------------------------------- */

pega_var(parq, numvar, nome, tipo, mmin, mmax)
ARQ	*parq;
int	numvar;
char	*nome;
char	*tipo;
MINVAL	*mmin;
MAXVAL	*mmax;
{
	VAR	*pvar;

	/*
	** Verificar se a variavel existe.
	*/

	if (numvar >= parq -> nvar)
		return -1;

	/*
	** Pegar definicoes.
	*/

	pvar = parq -> pvar + numvar;
	strcpy(nome, pvar -> nome);
	*tipo = pvar -> tipo;

	if (*tipo == 'c') {
		mmin -> len = pvar -> mmin.len;
		mmax -> len = pvar -> mmax.len;
	}
	else {
		mmin -> valor = pvar -> mmin.valor;
		mmax -> valor = pvar -> mmax.valor;
	}

	return 0;

}
