/***********************************************************************************
LIBSOC - Biblioteca padro para o SOftware Cientfico

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob
os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free
Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio)
qualquer verso posterior.

Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com
esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no
endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Calcula a probabilidade em um t de Student bicaudal. 

 Desenvolvido por:

		Dalton Francisco Andrade
		Maria Fernanda Moura
		Oscar Ivan Palma Pacheco
		Slvio Roberto Medeiros Evangelista
            Snia Ternes

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>
#include <math.h>
#include "const.h"
#include "pcsgbd.h"

/*--------------------------------------------------------------*/
/*           tprob  -- Significance of t distribution           */
/*--------------------------------------------------------------*/
/*                                                              */
/* Function:  tprob                                             */
/*                                                              */
/* Purpose:   Evaluates t distribution probability ( 2 - tailed)*/
/*                                                              */
/* Calling Sequence:                                            */
/*                                                              */
/*      P     := tprob( F , Df );                               */
/*                                                              */
/*           t      --- t-value                                 */
/*           Df     --- degrees of freedom                      */
/*                                                              */
/*           P      --- Resultant probability (two-tailed)      */
/*			foi dividido por 2.0 ) 			*/
/*                                                              */
/* Calls:                                                       */
/*                                                              */
/*      CdBeta                                                  */
/*                                                              */
/* Method:                                                      */
/*                                                              */
/*      The input values are transformed to match the           */
/*      requirements of the Beta distribution.  Function CDBeta */
/*      provides the corresponding cumulative Beta distribution */
/*      probability.                                            */
/*                                                              */
/*      An error in the input arguments results in a returned   */
/*      probability of -1.                                      */
/*                                                              */
/*--------------------------------------------------------------*/

double tprob( t , Df ) 
double t;
double Df;
{
	int Dprec = 12;
	int MaxIter = 200;
	
	int 	Iter;
	double  Cprec;
	int 	Ifault;
	double  Pval;

	/* Inicio Sigt */

	if ( t == 0.0 )			return(0.5);

	if ( Df >= 10.0 ) {
		if ( t <= -8.21 )	return(1.0);
		if ( t >=  8.21 )	return(0.0);
	}

	if ( ( Df >= 1.0 ) && ( Df < 10.0 ) ) {
		if ( t <= -40000.0 )	return(1.0);
		if ( t >=  40000.0 )	return(0.0);
	}

	if ( t >= 400000.0) {
		t  = 400000.0;
		if ( Df <= 0.00001 ) 
			Df = 0.00001;
	}

	if ( t <= -400000.0) { 
		t  = -400000.0;
		if ( Df <= 0.00001 ) 
			Df = 0.00001;
	}

	Pval = -1.0;

	if( Df > 0.0 ) {
	      Pval   = CDBeta( Df / ( Df + t * t ), Df / 2.0, 0.5,
				Dprec, MaxIter, &Cprec, &Iter, &Ifault );
	      if (Ifault != 0) {
			if ( Ifault == 4 )	Pval =  0.0;
		 	else			Pval = -1.0;
	      }
	      else	Pval = Pval / 2.0;
	}

	if ( t <  0.0 )	Pval = 1.0 - Pval;

	return(Pval);
}
