/***********************************************************************************
LIBSOC - Biblioteca padro para o SOftware Cientfico

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob
os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free
Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio)
qualquer verso posterior.

Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com
esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no
endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Rotina para verificar se um nome dado corresponde a uma
    variavel existente na base de dados especificada.

 Desenvolvido por:

		Oscar Ivan Palma Pacheco


 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#ifndef VAXVMS
#include <string.h>
#endif
#include "pcsgbd.h"


/* --------------------------------------------------------------------------
**
** Rotina para verificar se um nome dado corresponde a uma
** variavel existente na base de dados especificada.
**
** Forma de usar:
**
**		cod = veri_var(parq, nome);
**
** Variaveis envolvidas:
**
**		int	cod;	Codigo de retorno
**		ARQ	*parq;	ponteiro de referencia da base de dados
**		char	*nome;	nome de variavel a ser testado
**
** Valor retornado:
**
**			numvar : Numero da variavel verificada
**			    -1 : O nome dado nao corresponde a uma variavel
**
** ------------------------------------------------------------------------- */

int veri_var(parq, nome)
ARQ	*parq;
char	*nome;
{
	VAR	*pvar;
	int	i;

	pvar = parq -> pvar;

	/*
	** Procurar variavel.
	*/

	for (i = 0; i < parq -> nvar; i++) {
		if (strcmpi(nome, pvar -> nome) == 0)
			break;
		pvar++;
	}

	/*
	** Verificar se existe.
	*/

	if (i == parq -> nvar)
		return -1;
	return i;
}

