/***********************************************************************************
LIBSOC - Biblioteca padro para o SOftware Cientfico

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob
os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free
Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio)
qualquer verso posterior.

Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com
esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no
endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    xprob -- calcula a significncia da qui-quadrado: 1 - p (p=acumulada at o ponto).

    
 Desenvolvido por:

		Dalton Francisco Andrade
		Maria Fernanda Moura
		Oscar Ivan Palma Pacheco
		Slvio Roberto Medeiros Evangelista
            Snia Ternes

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>
#include <math.h>
#include "pcsgbd.h"

#ifdef MSDOS
#define PRECISAO 1.e-15
#else
#define PRECISAO 1.e-08
#endif

/*-------------------------------------------------------------------*/
/*          xprob -- Significance of Chi-Square distribution         */
/*-------------------------------------------------------------------*/
/*                                                                   */
/* Purpose:   Evaluates Chi-Square distribution probability          */
/*                                                                   */
/* Calling Sequence:                                                 */
/*                                                                   */
/*      P    = xprob( Chisq , Df );                                  */
/*                                                                   */
/*           Chisq  --- Chi-square value                             */
/*           Df     --- Degrees of freedom                           */
/*                                                                   */
/*           P      --- Resultant probability                        */
/*                                                                   */
/* Calls:                                                            */
/*                                                                   */
/*      GammaIn                                                      */
/*                                                                   */
/* Method:                                                           */
/*                                                                   */
/*      The input values are transformed to match the                */
/*      requirements of the Gamma distribution.  Function GammaIn    */
/*      provides the corresponding cumulative incomplete gamma       */
/*      probability.                                                 */
/*                                                                   */
/*      An error in the input arguments results in a returned        */
/*      probability of -1.                                           */
/*                                                                   */
/*-------------------------------------------------------------------*/

double xprob( Chisq , Df )
double Chisq;
double Df;
{
	static int MaxIter = 200;
	static int Dprec   = 12;

	int 	Ierr,Iter;
	double  Cprec,g;

	/* Inicio Sigchi */

	if ( (Chisq / Df ) <=  PRECISAO )	return(1.0);
	if ( ((int) (Chisq / Df )) >= 20)	return(0.0);

	g = GammaIn( Chisq/2.0 , Df/2.0 , Dprec, MaxIter, &Cprec, &Iter, &Ierr);

	if (Ierr == 13 ) {
		if ( Chisq < Df )	return(1.0);
		else			return(0.0);
	}

	if (Ierr != 0)
		return(-1.0);
	else 
		return(1.0 - g);
} 

