/***********************************************************************************
 ORDENA - Ferramenta para Ordenao de Arquivos SOC

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Este  o mdulo principal da ferramenta de ordenao de arquivos SOC; que 
	utiliza o mtodo "quicksort". A ferramenta deve ser usada da seguinte forma:

	Ordena [-opcoes] <arquivo_entrada> [<arquivo_saida>]
	class <lista-variaveis>;
	}

	Onde:
		Opcoes:
			-f  Considera maiuscula != minuscula
			-d  Ordena na ordem descendente
			-o<parametros> Ordena mais de um campo 
				parmetros:
					-a	ordem ascendente
					-d 	ordem descendente	
	<lista-variaveis>: lista de variveis a serem consideradas
			chaves de ordenao, segundo especificao.

		**	Exemplo:
		**		ordena -oa,d,d blocos blocos_o
		**		class bloco trat rep;}
		**		Ser considerado:
		**		- trat em ordem ascendente.
		**		- bloco em ordem descendente.
		**		- rep em ordem descendente.

 Desenvolvido por:

	  Dalton Francisco Andrade
	  Joo Camargo Neto
	  Maurcio Noronha Festa

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <setjmp.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

#ifndef VAXVMS
#include <sys/types.h>
#include <sys/stat.h>
#endif

#include "getoken.h"
#include "pcsgbd.h"
#include "ordena.h"

char *obs[OBSSIZE];
char *q;
ARQ *parq;
VAR *ivar;
int aponta[20];			/* aponta para a lista de variaveis */
int naponta;
int rflag = 0;
int fflag = 1;
int kflag = 0;
int pflag = 0;
int flagX = 0;
int flagP = 0;
char ord[20];
char filein[128];
char fileout[128];
char cmd1[128];
char cmd2[128];
int arquivo = 0;
int dois = -1;
char token[128];
char buffer[128];
jmp_buf env;

#ifdef MSDOS
int nlins = 25;
#else
int nlins = 24;
#endif
int ncols = 80;

int descarq[2];			/* descritor de arquivo para funcoes de bloqueio */

main(argc, argv)
int argc;
char *argv[];
{
    int c;
    int i, j, l;
    int ret;

#ifdef VAXVMS
    argc = prepvax(argc, argv);
#endif

    descarq[0] = -1;
    descarq[1] = -1;

    getarg(argc, argv);

    setjmp(env);
    naponta = 0;
    c = getoken(token);
    if (c != VARIAV)
	erromod(2);
    if (strcmpi(token, "class") != 0 && strcmpi(token, "classif") != 0)
	erromod(2);
    c = getoken(token);
    do {
	if (c != VARIAV)
	    erromod(0);
	i = veri_var(parq, token);
	if (i < 0)
	    erromod(1);
	aponta[naponta++] = i;
	if (naponta > MAXCLASS)
	    erromod(3);
    } while ((c = getoken(token)) != PTVG);

    if ((c = getoken(token)) != RB)
	erromod(4);

    j = 0;
    q = (char *) &obs[MAXVAR];
    obs[j++] = q;
    strcpy(q, "ntiasort");	/* coloca nome do programa */
    q += (strlen(q) + 1);
    obs[j++] = q;
    strcpy(q, filein);
    q += (strlen(q) + 1);
    obs[j++] = q;
    strcpy(q, fileout);
    ivar = parq->pvar;
    for (i = 0; i < naponta; ++i) {
	l = aponta[i];
	strcpy(token, "-k");
	if ((ivar + l)->tipo == 'c')
	    strcat(token, "s,");
	else
	    strcat(token, "f,");
	if (kflag) {
	    if (ord[i] == '\0') {
		printf(PegaMsg(3219));
		setOSstdin();
		exit(3);
	    }
	    if (ord[i] == 'd')
		strcat(token, "d,");
	    else
		strcat(token, "a,");
	} else if (rflag)
	    strcat(token, "d,");
	else
	    strcat(token, "a,");

	strcat(token, itoa(aponta[i], buffer, 10));
	q += (strlen(q) + 1);
	obs[j++] = q;
	strcpy(q, token);
    }
    ret = fech_arq(parq);
    if (ret < 0) {
	fprintf(stderr, PegaMsg(1011), "");
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("ordena");
	    exit(2);
	}
#endif

	exit(2);
    }

    obs[j] = (char *) NULL;
    if (pflag) {
	for (i = 0; i < j; ++i)
	    printf("%s ", obs[i]);
	printf("\n");
	if (arquivo)
	    printf("cp %s %s\n", cmd1, cmd2);
    }
    if (arquivo) {
	cp(cmd1, cmd2);
    }
    ntiasort(j, obs);
    setOSstdin();

    exit(0);
}
