/***********************************************************************************
 ORDENA - Ferramenta para Ordenao de Arquivos SOC

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Mdulo sortio2 da ferramenta de ordenao de arquivos SOC.

 Desenvolvido por:

	  Dalton Francisco Andrade
	  Joo Camargo Neto
	  Maurcio Noronha Festa

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef MSDOS
#include <io.h>
#endif

#include "pcsgbd.h"
#include "ordena.h"
#include "sortspec.h"

extern SORTSPEC sspec;

extern char fileout[];
extern int arquivo;

void exit_ord();

FILE *do_open(fname, fmode)
char fname[];
char fmode[];
{
    FILE *fd;

    fd = fopen(fname, fmode);
    if (fd == (FILE *) NULL) {

/* *** Padroniz. msg erro - Luciana 03/01/95
		printf("ERRO(1480): Abertura do arquivo %s\n",fname);
*** */
	printf(PegaMsg(1034), fname);

	setOSstdin();
	exit_ord(8);
    }
    return (fd);
}

void do_close(fd, fname)
FILE *fd;
char fname[];
{
    if (fclose(fd) == EOF) {

/* *** Padroniz. msg erro - Luciana 03/01/95
		printf("ERRO(1212): Fechamento do arquivo %s\n",fname);
*** */
	printf(PegaMsg(1011), fname);

	setOSstdin();
	exit_ord(10);
    }
}


char *get_rec(p, s, n)
char *p;
char s[];
int n;
{
    int i;
    char c;

    for (i = 0; i < n; i++) {
	while ((c = *p++) != ';') {
	    if (c == '\\')
		p++;
	}
    }

    i = 0;

    while (*p != ';' && *p != '\n') {
	c = s[i++] = *p++;

	if (c == '\\')
	    s[i++] = *p++;

    }

    s[i] = '\0';

    return (s);
}


int getrec(rec, maxr, fd)
char rec[];
int maxr;
FILE *fd;
{
    return ((*sspec.pget) (rec, maxr, fd));
}

int putrec(rec, fd)
char rec[];
FILE *fd;
{
    return ((*sspec.pput) (rec, fd));

}

int getl(s, maxs, fd)
char s[];
int maxs;
FILE *fd;
{
    int i;
    if (fgets(s, maxs - 1, fd) == NULL)
	return (-1);
    i = strlen(s);
    if (s[i - 1] != '\n') {
	s[i] = '\n';
	s[i + 1] = '\0';
	i = i + 1;
    }
    return (i + 1);
}

int putl(s, fd)
char s[];
FILE *fd;
{
    if (fputs(s, fd) == EOF) {

/* *** Padroniz. msg erro - Luciana 03/01/95
		printf("ERRO (1211): Espaco em disco insuficiente ou diretorio cheio\n");
*** */
	printf(PegaMsg(1010));

	setOSstdin();
	exit_ord(1);
    }

    return 0;
}

/*
** Monta os prefixos dos nomes dos arquivos intermediarios no UNIX
*/
void apag_unix()
{
    void apag();

    int pid;

    char cpid[24];
    char buf[24];
    char prefix[64];

    pid = getpid();
    strcpy(cpid, itoa(pid, buf, 10));

    strcpy(prefix, "scra");
    strcat(prefix, cpid);
    apag(prefix);

    strcpy(prefix, "scrb");
    strcat(prefix, cpid);
    apag(prefix);
}

/*
** Monta os prefixos dos nomes dos arquivos intermediarios no DOS
*/
void apag_dos()
{
    void apag();

    apag("scra");
    apag("scrb");
}

/*
** Apaga arquivos intermediarios de nome prefix
*/
void apag(prefix)
char prefix[];
{
    int i, ult;

    char file_name[64];

    ult = 0;
    for (i = 0; !ult; i++) {

	sprintf(file_name, "%s.%03d", prefix, i);

	if (access(file_name, 0) != -1)
	    unlink(file_name);
	else
	    ult = 1;
    }
}

/*
** Apaga arquivo_saida anteriormente criado
*/
void apag_hdr()
{
    char file_hdr[TAMSTR];
    char *pont;
    int pos;

    /* Apaga .dat */
    if (access(fileout, 0) != -1)
	unlink(fileout);

    /* Apaga .hdr */
    strcpy(file_hdr, fileout);

    pont = strchr(file_hdr, '.');

    if (pont != NULL) {
	pos = pont - file_hdr + 1;
	file_hdr[pos] = '\0';
	strcat(file_hdr, "hdr");

	if (access(file_hdr, 0) != -1)
	    unlink(file_hdr);
    }
}

/*
** Apaga arquivos intermediarios gravados em disco, antes de chamar exit()
*/
void exit_ord(n)
int n;
{
#ifndef MSDOS
    apag_unix();		/* apaga arquivos temporarios no UNIX */
#else
    apag_dos();			/* apaga arquivos temporarios no DOS */
#endif

    if (arquivo == -1)
	apag_hdr();		/* apaga arquivo_saida criado */


    setOSstdin();
    exit(n);
}
