
/***********************************************************************************
 REGRESS - Anlise de Regresso Linear Univariada

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    O mdulo getarg  responsvel pela leitura das opes de execuo e consequente 
	inicializao de flags e criao/abertura de arquivos. 

 Desenvolvido por:

	  Dalton Francisco Andrade
	  Maria Fernanda Moura
	  Maurcio Noronha Festa
        Slvio Roberto Medeiros Evangelista
	  Snia Ternes Frassetto

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#ifdef MSDOS
#include <io.h>
#endif

#ifdef RS6000
#include <sys/io.h>
#endif

#include "regress.h"
#include "getoken.h"
#include "pcsgbd.h" /* Luciana */
/* #include "lockfile.h" */

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)getarg.c	3.13	(NTIA/regress)	95/09/21";

extern int flagX;
extern int nlins;
extern int ncols;
extern ARQ* fd;
static int flag_exec = 0;
extern void controlC();

extern char exretstd[]; /* Contem nome do arquivo exretstd */
extern int flagstd;

extern int descarq[3];

void getarg(argc, argv)
int	argc;
char	*argv[];
{
	       int	i;
	       double 	t;
	extern double 	confianca;
	extern int 	g_eflag;
	extern int 	fl_dw;
	extern int 	fl_dg;
	extern int 	fl_dg1;
	extern int	fl_freq;
	extern int 	fl_imp;
	extern int 	fl_correl;
	extern int 	fl_padrao;
	extern int 	iterativo;
	       char	*pdir;
	       long	ret;
 	       /* char 	namelock[30]; */
		int	flag_vazio;

	flagX = 1;	/* default: executar fora do ambiente NTIA */
	++argv;		/* aponta para o primeiro parametro */
	--argc;		/* decrementa o apontador */
	flag_vazio = 1; /* habilita teste arq. vazio */
	while (argc--) {
		if (argv[0][0] == '-') {
			for (i=1; argv[0][i]; ++i) {
				switch (argv[0][i]) {
				case 's':
					++fl_padrao;
					break;
				case 'b':
					++bflag;
					break;
				case 'm':
					fl_correl = 0;
					break;
				case 'i':
					fl_int = 0;
					break;
				case 'P':
					fl_imp = 1;
					break;
				case 'A':
					flag_exec = 1;
#ifdef RS6000
					flagstd = 1;

					if(*strchr(&argv[0][i+1], '|'))
						*strchr(&argv[0][i+1], '|') = '\0';

					if (freopen(&argv[0][i+1], "r", stdin)==
							(FILE *) NULL) {

/* *** Padroniz. msg erro - Luciana 20/12/94
						fprintf(stderr,
						"Arquivo stdin nao abre.\n");
*** */
						i += (strlen(&argv[0][i+1]) + 1);
						*strchr(&argv[0][i+1], '|') = '\0';
						i += (strlen(&argv[0][i+1]) + 1);
						strcpy(exretstd, &argv[0][i+1]);

						fprintf(stderr,PegaMsg(1034),"stdin");
						setOSstdin();
#ifdef  MEM_DEBUG
						if (Mem_Used() != 0) {
							printf("*** Lista de memoria nao esta' vazia ***\n");
							Mem_Store("regress");
							exit(5);
						}
#endif

						exit(5);
					}
					i += (strlen(&argv[0][i+1]) + 1);
					*strchr(&argv[0][i+1], '|') = '\0';
					fseek(stdin, atol(&argv[0][i+1]), 0);
					i += (strlen(&argv[0][i+1]) + 1);
					strcpy(exretstd, &argv[0][i+1]);
					i += strlen(&argv[0][i+1]);
#endif
					setbuf(stdin, (char *) NULL);
					iterativo = 0;
					break;
				case 'X':
					if (strcmp(&argv[0][i+1],"ntia") == 0) {
						flagX = 1;
						i += 4;
					}
					break;
				case 'd':
					if (strcmp(&argv[0][i+1], "w") == 0) {
						fl_dw = 1;
						i++;
					}
					else {
						if (strcmp(&argv[0][i+1],
							 "g") == 0) {
							fl_dg = 1;
							i++;
						}
						else {
							if(strcmp(&argv[0][i+1],
								 "g1") == 0) {
								fl_dg1 = 1;
								fl_dg = 1;
								i += 2;
							}
						}
					}
					break;
				case 'r':
					rflag=1;
					break;
				case 'l': 
					if (isdigit(argv[0][i+1])) {
						nlins = atoi(&argv[0][i+1]);
						i += strlen(&argv[0][i+1]);
					}
					else
						++lflag;
					break;
				case 'c':
					number(&t,argv,&i);
					if ((t == 95.0) || (t == 90.0) || ( t == 99.0)) 
						confianca = t;
					else
						ncols = (int) t;
					--i;
					break;
				case 'x':
					++xflag;
					break;

				/*
				** Habilita impressao de mensagens
				*/

				case 'M':

					break;

				/*
				** Habilita impressao de tempo
				*/


				case 't':
					break;

				case 'p':
					++pflag;
					break;

				case 'k':
					flag_vazio = 0;
					break;

				default:

/* *** Padroniz. msg erro - Luciana 20/12/94
					fprintf(stderr, "Flag <%c> ilegal\n", argv[0][1]);
*** */
					fprintf(stderr, PegaMsg(3086),argv[0][1]); 

					setOSstdin();
#ifdef  MEM_DEBUG
					if (Mem_Used() != 0) {
						printf("*** Lista de memoria nao esta' vazia ***\n");
						Mem_Store("regress");
						exit(1);
					}
#endif
					exit(1);
				}
			}
		}
		else
			break;
		++argv;
	}

	if (!flagX) {

/* *** Padroniz. msg erro - Luciana 20/12/94
		fprintf(stderr, "Execucao nao permitida\n");
*** */
		fprintf(stderr, PegaMsg(1000));
		setOSstdin();
#ifdef  MEM_DEBUG
		if (Mem_Used() != 0) {
			printf("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("regress");
			exit(1);
		}
#endif
		exit(1);
	}

	if (argc < 0)
		usage();

	pdir = pega_env(argv[0], ".hdr");


        /* Abertura do arquivo de entrada */
	if ((ret = (long) (fd = abre_arq(pdir, 0, flag_vazio))) < 0L && ret > -5L) {
		if (flag_vazio) {

/* *** Padroniz. msg erro - Luciana 20/12/94
		    fprintf(stderr, "Nao consegui abrir <%s> %ld\n", pdir,
			    ret);
*** */
		    fprintf(stderr, PegaMsg(1034),pdir);
		    setOSstdin();
#ifdef  MEM_DEBUG
		    if (Mem_Used() != 0) {
			    printf("*** Lista de memoria nao esta' vazia ***\n");
			    Mem_Store("regress");
			    exit(2);
		    }
#endif

		    exit(2);
	    }
	}

	if (argc >= 1 ) {


                /* Abertura do arquivo de saida */
		if ((ret = (long) (fe = cria_arq(argv[1]))) < 0L && ret > -5L) {

/* *** Padroniz. msg erro - Luciana 20/12/94
			fprintf(stderr, "Nao consegui criar <%s> %ld\n", 
				argv[1], ret);
*** */
			fprintf(stderr, PegaMsg(5006),argv[1]);
			setOSstdin();
#ifdef  MEM_DEBUG
			if (Mem_Used() != 0) {
				printf("*** Lista de memoria nao esta' vazia ***\n");
				Mem_Store("regress");
				exit(2);
			}
#endif

			exit(2);
		}

		g_eflag = 1;
	}

	if (bflag) {

                /* Abertura do arquivo de saida */
		if ((ret = (long) (fb = cria_arq("beta"))) < 0L && ret > -5L) {

/* *** Padroniz. msg erro - Luciana 20/12/94
			fprintf(stderr, "Nao consegui criar <%s> %ld\n", "beta",
				ret);
*** */
			fprintf(stderr, PegaMsg(5006),"beta");
			setOSstdin();
#ifdef  MEM_DEBUG
			if (Mem_Used() != 0) {
				printf("*** Lista de memoria nao esta' vazia ***\n");
				Mem_Store("regress");
				exit(2);
			}
#endif

			exit(2);
		}
	}
	signal(SIGINT,controlC);

}


void controlC(sig)
int sig;
{
	/*
	** Apagar, se necessario, arquivos temporarios
	*/
	
        if (!flag_exec)
                fprintf(stderr,"\n********  Interrompido pelo usuario\n");


	setOSstdin();

#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
		printf("***Lista de memoria nao esta vazia ***\n");
		Mem_Store("nome_modulo");
		exit(1);
	}
#endif
	exit(sig);
}

