/***********************************************************************************
 REGRESS - Anlise de Regresso Linear Univariada

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	O mdulo pivota, com base no algortimo SWEEP, pivota a matriz ZZ.
 
Desenvolvido por:

	  Dalton Francisco Andrade
	  Maurcio Noronha Festa
        Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include "regress.h"

static char *sccsid = "@(#)pivota.c	3.2	(NTIA/regress)	95/01/11";

void pivota()
{
	extern int nd;
	extern double squad1[MAXDEP];

	int i, j, k;

	for (i=0; i<ndim; ++i)
		v[i] = 1;

	sweep(0);			/* calculei a iteracao 0 */

	if (fl_int) { /* guarda soma de quadrados total c/ intercepto */
		for (i=0; i < nd; ++i)
			squad1[i] = xlx[idx(nxlx+i,nxlx+i)];
	}
	else {
		if (nef == 1) {
			for (i=0; i < nd; ++i)
				sse[i][nd] = xlx[idx(nxlx+i,nxlx+i)];
		}
	}


	for (i=0; i<ndim; ++i) {
		css[i] = xlx[idx(i,i)];	/* armazenei o css */
		if (fl_int)
			mean[i] = xlx[idx(i,0)];	/* media */
	}

	j = 1 + !fl_int;
	for (i=1; i<nxlx; ++i) {
		if (rflag) {
			printf("\nIteracao : %d", i-1);
			print_xlx();
		}

		if (fabs(css[i]) < 1.e-14) {
			zera_linha(i);
			--nv[j];
		}
		else {
			if ((fabs(xlx[idx(i,i)]) / css[i]) < 1.e-8) {
				zera_linha(i);
				--nv[j];
			}
			else 
				sweep(i);
		}

		for (k = 0; k < nd ; ++k ) {
			sse[k][j] = xlx[idx(nxlx+k, nxlx+k)];
		}
		++j;
	}
	if ((xflag & 2) || rflag) {
		printf("\nResultado final:\n");
		print_xlx();
	}
}
