/***********************************************************************************
 REGRESS - Anlise de Regresso Linear Univariada

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	O mdulo printanv imprime o quadro de anlise de varincia.  
 
Desenvolvido por:

	  Dalton Francisco Andrade
	  Maurcio Noronha Festa
        Slvio Roberto Medeiros Evangelista
	  Sonia Ternes

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include "regress.h"
#include <string.h>

static char *sccsid = "@(#)printanv.c	3.3	(NTIA/regress)	95/07/25";

printanv(k,nd1)
int k;
int nd1;
{
	extern int fl_wt;
	extern double squad;
	extern int fl_padrao;
	int i, j;
	int glm;
	char tit[32];
	double valorf;		/* valor de F */
	double x1,x2;		/* variavel auxiliar */

	for(i=1; i < nd+nef-!fl_int; ++i) {
		if (linhazerada[i] == 1) {
			for(j=0; j < (ndim+nd1-1); ++j) {
				if (sv[j] == i) {
					printf("\nA matriz X'X e' singular. A variavel %s e'uma combinacao linear\n", efts[j]);
					printf("de variaveis que a precedem no modelo. Neste caso a analise \n");
					printf("nao e' executada.\n\n");
					return -1;
				}
			}
		}
	}

	imp_titulo("Quadro de analise de variancia");

	strcpy(tit,"Variavel Dependente : ");
	strcat(tit,efts[fl_int+k]);
	imp_titulo(tit);

	if (fl_padrao)
		imp_titulo("Variaveis padronizadas");
	if (fl_wt)
		printf("\t\t\t Peso = %s",efts_wt);
	printf("\n");
	printf("Fonte de variacao     gl Soma de quadrados   Quadrado medio    Valor F  PR > F\n\n");

	j = 0;
	for (i=fl_int; i<=nef+nd1-!fl_int; ++i) {
		if (ef[i][0] == -1)
			j += nv[i];		/* calculo do gl do residuo */
	}
	glm = j;
	glr = (glt-fl_int) - j;			/* gl do residuo */

	for (i=0; i<=nef+nd1-!fl_int; ++i) {		/*quadrado medio*/
		if (ef[i][0] == -1 || (i == 0 && fl_int)) {
			j = sv[i];
			x1 = xlx[idx(nxlx,j)];
			x2 = xlx[idx(j,j)];
			if (fabs(x2) < 1.0e-14)
				saida[i] = 0.0;
			else
				saida[i] = x1 * x1 / xlx[idx(j,j)];
		}
		obs[i] = (nv[i]) ? saida[i] / (double) nv[i] : 0.0;
	}

	sse[k][nef+nd-1] = fabs(sse[k][nef+nd-1]);

	qmr = (glr) ? sse[k][nef+nd-1] / ((double) glr) : 0.0; /* qm residuo */
	
	x1 = (squad  - sse[k][nef+nd-1]);
	x2 = x1 / ((double) glm);
	valorf = (qmr) ? x2 / qmr : 9999.9999;
	if (valorf > 10000.)
		valorf = 9999.9999;

	printf("%-18s  %4d %17s %16s %10s %7.4f\n\n",
		"Modelo", glm, rounddec(x1,17,8), rounddec(x2,16,8), rounddec(valorf,10,4), fprob(valorf,(double) glm,(double) glr));
	printf("%-18s  %4d %17s %16s\n\n",
		"Residuo", glr, rounddec(sse[k][nef+nd-1],17,8), rounddec(qmr,16,8));
	printf("%-18s  %4d %17s\n",
		"Total", (glt-fl_int), rounddec(squad,17,8));
	printf("\n");
	printf("-------------------------------------------------------------------------------\n");
	return 0;
}
