/***********************************************************************************
 REGRESS - Anlise de Regresso Linear Univariada

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	O mdulo printtest imprime as estimativas para diagnstico.   
 
Desenvolvido por:

	  Dalton Francisco Andrade
	  Maurcio Noronha Festa
        Slvio Roberto Medeiros Evangelista
	  Sonia Ternes

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <string.h>
#include <stdlib.h>
#include "regress.h"

static char *sccsid = "@(#)printest.c	3.3	(NTIA/regress)	95/07/25";

static char *obs3[OBSSIZE];

void printest(m,ndim1,par,nd1,r)
int m;
int ndim1;
int par;
int nd1;
double *r;
{
	int i;
	int j;
	int k;
	int    a;
	double y;
	double yi;
	double ys;
	double var;
	double hi;
	double saida1[MAXMEM];
	long ret;

	extern char *obs1[];
	extern char obs2[MAXCLASS][80];
	extern double resdo;
	extern double resd2;
	extern double autocor;
	extern double dw;
	extern double tvalue;
	extern char *pchar;
	extern int g_eflag;
	extern int fl_padrao;
	extern double soma[MAXMEM];
	extern double varia[MAXMEM];
	
	y = 0.0;
	a = 0;

	if (g_eflag && (par==0)) {
		for(i=0; i<nby ; ++i) {
			obs3[i] = pchar;
			strcpy(pchar,obs2[i]);
			pchar += (strlen(pchar)+1);
		}
	}

	for(i=0; i <= nd1+nef-!fl_int; ++i) {
		if ((ef[i][0] == -1) || (i == 0 && fl_int)) {
			k = sv[i];
			if (fl_padrao && i > 0) {
				if ((fabs(varia[i])) > 0.0) {
					saida1[k] = (saida[k] - (soma[i]/glt))/
						       sqrt(fabs(varia[i]));	
				}
				else {
					printf("\nO desvio padrao de uma das variaveis independentes e zero\n\n");
					setOSstdin();
					exit(0);
				}
			} 
			else {
				saida1[k] = saida[k];
			}
			if (strcmp(obs1[ef[i][1]],".") != 0)
				y += saida1[k]*xlx[idx(nxlx,k)];
			else {
				a = 1;
				break;
			}
		}
	}
	if (strcmp(obs1[ef[fl_int+par][1]],".") == 0) {
		if (a == 0)
			a = 2;
		else
			a = 3;
	}
	else {
		if (a == 0) {
			(*r) = atof(obs1[ef[fl_int+par][1]]) - y;
			autocor += ((*r) * resdo);
			dw += (((*r) - resdo)*((*r) - resdo));
			resdo = (*r);
			resd2 += (*r)*(*r);
		}
	}
	for(i=0; i < nxlx; ++i) {
		obs[i] = 0.0;
		for(j=0; j < nxlx; ++j) {
			obs[i] += saida1[j]*xlx[idx(j,i)];
		}
	}
	hi = 0.0;
	for(i=0; i < nxlx; ++i) {
		hi += obs[i] * saida1[i];
	}
	var = sqrt(fabs(qmr*hi));
	yi = y - var*tvalue;
	ys = y + var*tvalue;
	
	
	if (lflag ) {
		switch(a) {
			case 0:
				printf("%5d %11.5g %11.5g %11.5g %11.5g %11.5g %11.5g\n",m,atof(obs1[ef[fl_int+par][1]]),y,(*r),var,yi,ys);
				break;
			case 1:
				printf("%5d %11.5g %11s %11s %11s %11s %11s\n",m,atof(obs1[ef[fl_int+par][1]]),".",".",".",".",".");
				break;
			case 2:
				printf("%5d %11s %11.5g %11s %11.5g %11.5g %11.5g\n",m,".",y,".",var,yi,ys);
				break;
			case 3:
				printf("%5d %11s %11s %11s %11s %11s %11s\n",m,".",".",".",".",".",".");
				break;
			default:
				break;
		}
	}
	if (g_eflag && (par==0)) {
		obs3[nby] = pchar;
		strcpy(pchar,obs1[ef[fl_int][1]]);
		pchar += (strlen(pchar) + 1);

		obs3[nby+1] = pchar;
	  	if (a==1 || a==3)
			strcpy(pchar,".");
		else
			gcvt(y,15,pchar);
		pchar += (strlen(pchar) + 1);

		obs3[nby+2] = pchar;
	  	if (a!=0)
			strcpy(pchar,".");
		else
			gcvt((*r),15,pchar);
		pchar += (strlen(pchar) + 1);

		obs3[nby+3] = pchar;
	  	if (a==1 || a==3)
			strcpy(pchar,".");
		else
			gcvt(var,15,pchar);
		pchar += (strlen(pchar) + 1);

		obs3[nby+4] = pchar;
	  	if (a==1 || a==3)
			strcpy(pchar,".");
		else
			gcvt(yi,15,pchar);
		pchar += (strlen(pchar) + 1);

		obs3[nby+5] = pchar;
	  	if (a==1 || a==3)
			strcpy(pchar,".");
		else
			gcvt(ys,15,pchar);
		pchar += (strlen(pchar) + 1);

		j = 0;
		for(i=0; i < ndim1; ++i) {
			if (ef[i][0] == -1) {
				obs3[nby+6+j] = pchar;
				strcpy(pchar,obs1[ef[i][1]]);
				pchar += (strlen(pchar) + 1);
				++j;
			}
		}

	}
	if (g_eflag && (par==0))
		if( (grav_obs(fe,obs3)) < 0L){
                fprintf(stderr, PegaMsg(5018), "");
#ifdef  MEM_DEBUG
                if (Mem_Used() != 0) {
                        printf("*** Lista de memoria nao esta' vazia ***\n");
                        Mem_Store("regress");
                        exit(2);
                }
#endif
                setOSstdin();
                exit(2);
        }
}

