
/***********************************************************************************
 REGRESS - Anlise de Regresso Linear Univariada

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Este  o mdulo principal do software de anlise de regresso linear univariada;
	cujo modelo  ajustado pelo mtodo de mnimos quadrados. Pode-se especificar 
	mais de uma varivel dependente; no entanto, o ajuste do modelo  feito para 
	cada varivel individualmente. Alm do ajuste do modelo, o software fornece a 
	matriz de correlaes e a tabela de anlise de varincia, e, ainda permite: 
		 - trabalhar com 	mnimos quadrados ponderados; 
		 - testes de comparaes dos parmetros estimados;
		 - diagnstico de regresso (Dcook, DFFits, pontos influentes); e,
		 - gerar arquivos de saida com os valores estimados. 

 Desenvolvido por:

	  Dalton Francisco Andrade
	  Maurcio Noronha Festa
        Slvio Roberto Medeiros Evangelista
	  Snia Ternes Frassetto

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#define EXTERN

#include "regress.h"
#include "getoken.h"
#include "pcsgbd.h" /* Luciana */
/* #include "lockfile.h" */

# include <stdlib.h>

#ifndef VAXVMS
# include <malloc.h>
#endif

#include <string.h>
#include <setjmp.h>

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)regress.c	3.9	(NTIA/regress)	95/09/15";

char	*p;		/* ponteiro para a area nao usada */
char	*pchar;		/* ponteiro para a area nao usada */

int	pflag = 0;	/* flag de impressao de leitura */
int	xflag = 0;	/* flag de impressao de x'x */
int	lflag = 0;	/* flag de impressao de dados originais */
int	rflag = 0;	/* flag de impressao de passos de calculo */
int	bflag = 0;	/* flag de impressao de beta */
int	g_eflag=0;	/* flag se vai imprimir estimativas */
int	fl_int=1;	/* flag se usa intercepto no modelo */
int	fl_freq=0;	/* flag se usa variavel peso como frequencia */
int	fl_wt=0;	/* flag se vai usar m.q.p */
int	fl_imp=0;	/* flag para pular pagina */
int	fl_dw=0;	/* nao imprime teste de Durbin-Watson */
int	fl_dg=0;	/* nao calcula diagnostico */
int	fl_dg1=0;	/* nao imprime valores parciais do diagnostico */
int	ordc=1;		/* tipo do ordenacao assumida no comando class */
int	fl_correl=1;
int	fl_padrao=0;
int	obs_freq=0;	/* numero de obs se opcao freq for usada */
int	linha;

jmp_buf env;
char	obs2[MAXCLASS][80];	  
char	*obs1[OBSSIZE];
char	area1[1024];
double resdo;
double resd2;
double autocor;
double dw;
double tvalue;
double confianca;
double squad1[MAXDEP];
double squad;
double soma[MAXMEM];
double varia[MAXMEM];
double media2[MAXDEP];	/* Variavel que armazena valor da media de Y */

/* ------- Variaveis para uso do contraste -----------*/
FILE	*fout;		/* ponteiro para arquivo com comandos do 'cp' */

int	med1[MAXMEM];
int	iterativo=1;
int	tem_comando;
FILE	*faux;
int     c,c1;
int	tem1_comando;
int	flagX = 0;
#ifdef MSDOS
int	nlins = 25;
#else
int	nlins = 24;
#endif

int	ncols = 80;
ARQ * fd;

/* --------------------------------------------------*/

int nv1[MAXMEM];	/* Variavel que guarda o numero de niveis */

int     descarq[3];     /* descritor de arquivo para funcoes de bloqueio */

#define MUDA_PAG 12

main(argc, argv, envp)
int argc;
char *argv[];
char *envp[];
{
	int i, m;
	int j;
	int n;
	TINT ii;
	long l;
	int ret;

        /* Inicializacao dos descritores */
        descarq[0] = -1;
        descarq[1] = -1;
	descarq[2] = -1;

#ifdef VAXVMS
	argc = prepvax(argc, argv);
#endif


	c1 	= 0;	
	c  	= 0;
	tem_comando = 0;
	tem1_comando = 0;

	confianca = 95.0;
	getarg(argc,argv);		/* le os argumentos e abre arquivo */

	p = area;
	pchar = area1;
	
	setjmp(env);
	ler_par();			/* le os parametros do modelo */

	l = ((long) ndim + 1l) * (long) ndim / 2l;
	if ((xlx = (double MY_HUGE *) HALLOC((TIPO) l, sizeof(double))) ==
		(double MY_HUGE *) NULL) {

/* *** Padroniz. msg erro - Luciana 20/12/94
		fprintf(stderr, "Nao consegui espaco para x'x\n");
*** */
		fprintf(stderr, PegaMsg(1042));
		setOSstdin();
#ifdef MEM_DEBUG
		if(Mem_Used() != 0){
			printf("***Lista de memoria nao esta vazia ***\n");
			Mem_Store("regress");
			exit(1);
		}
#endif
		exit(1);
	}

	m = 0;
	inicializa();
	
	m++;
	n=1;

	if (g_eflag)
		outhdr1();
	
	while (ler_obs(fd,obs1) != (long) EOF) {
		if ((m == 1) && (nby > 0))
			inicioby();
		if (class() == 0 ) {
			if (missing() == -1) {
				expand_mat(nd);

				for (i=fl_int; i <= (nd+nef-!fl_int); ++i) {
					j = sv[i];
					soma[j] += saida[j];
				}

				if (fl_wt)
					pondera(nd);
				cria_xlx();	
				m++;
			}
			++n;
			++linha;
		}
		else {
			executa(m,n);
			pchar = area1;
			inicioby();
			m = 1;
			inicializa();
			for(ii=0; ii < (unsigned) l; ++ii)
				xlx[ii] = 0.0;
			if (missing() == -1) {
				expand_mat(nd);

				for (i=fl_int; i <= (nd+nef-!fl_int); ++i) {
					j = sv[i];
					soma[j] += saida[j];
				}
	
				if (fl_wt)
					pondera(nd);
				cria_xlx();	
				m++;
			}
			++n;
			++linha;
		}

	}

 	executa(m,n);

	if (bflag){

/****
 ****  Retirado o tratamento: .dat vazio grava .hdr vazio.
 ****  18/07/95
 ****
		if ( NRO_OBS(fb) == 0L ) {
        		if( (ret= fech_vazio(fb)) < 0 ){
                		fprintf(stderr, PegaMsg(1011),"");      
#ifdef  MEM_DEBUG
                		if (Mem_Used() != 0) {
                        		printf("*** Lista de memoria nao esta' vazia ***\n");
                       	 		Mem_Store("regress");
                        		exit(2);
                		}
#endif

 		               setOSstdin();   
                		exit(2);        
            		}
		}
		else {
 ****
 ****  fim comentario
 ****/
        		if( (ret= fech_arq(fb)) < 0 && ret >= -2){
                		fprintf(stderr, PegaMsg(1011),"");      
#ifdef  MEM_DEBUG
                		if (Mem_Used() != 0) {
                        		printf("*** Lista de memoria nao esta' vazia ***\n");
                       	 		Mem_Store("regress");
                        		exit(2);
                		}
#endif

 		               setOSstdin();   
                		exit(2);        
            		}
/****
 **** 
		}
 ****
 ****/
	}
	if (g_eflag){
/****
 ****  Retirado o tratamento: .dat vazio grava .hdr vazio.
 ****  18/07/95
 ****
		if ( NRO_OBS(fe) == 0L ) {
        		if( (ret= fech_vazio(fe)) < 0 ){
                		fprintf(stderr, PegaMsg(1011),"");      
#ifdef  MEM_DEBUG
                		if (Mem_Used() != 0) {
                        		printf("*** Lista de memoria nao esta' vazia ***\n");
                       	 		Mem_Store("regress");
                        		exit(2);
                		}
#endif

 		               setOSstdin();   
                		exit(2);        
            		}
		}
		else {
 ****
 ****  fim comentario
 ****/
        		if( (ret= fech_arq(fe)) < 0 && ret >= -2){
                		fprintf(stderr, PegaMsg(1011),"");      
#ifdef  MEM_DEBUG
                		if (Mem_Used() != 0) {
                        		printf("*** Lista de memoria nao esta' vazia ***\n");
                        		Mem_Store("regress");
                        		exit(2);
                		}
#endif

 		               setOSstdin();   
                		exit(2);        
            		}
/****
 **** 
		}
 ****
 ****/
	}

        if( (ret= fech_arq(fd)) < 0 && ret >= -2){
                fprintf(stderr, PegaMsg(1011),"");      
#ifdef  MEM_DEBUG
                if (Mem_Used() != 0) {
                        printf("*** Lista de memoria nao esta' vazia ***\n");
                        Mem_Store("regress");
                        exit(2);
                }
#endif
	
                setOSstdin();   
                exit(2);        
        }
	if (tem_comando && !iterativo) {	
	     	unlink("regress.out");
	}

	HFREE((char MY_HUGE *) xlx); 
	libera();
	printf("\n");
	setOSstdin();
#ifdef MEM_DEBUG
        if(Mem_Used() != 0){
                 printf("***Lista de memoria nao esta vazia ***\n");
                 Mem_Store("regress");
                 exit(0);
         }
#endif
/* ----------------- Desbloqueio dos arquivos
        if (descarq[0] != -1) {
                UnlockAFile(descarq[0]);
        }
        if (descarq[1] != -1) {
                UnlockAFile(descarq[1]);
        }
	if (descarq[2] != -1) {
                UnlockAFile(descarq[2]);
        }
------------------- */
	exit(0);
}

void putchr1()
{
	int i,j;
	char pbuff[15];

	if (fl_imp)
		putchar(12);
	imp_titulo(titulo);
 	j = 0;
	if (nby > 0) {
		for(i=0; i < nby; ++i) {
			if (tip_by[i] == 2)
				j += 10;
			else
				j += strlen(obs2[i]);		

			j += strlen(efts_by[i]);		
		}

		for(i=0; i < ((80 - j - 2*nby - nby)/2);++i)
			printf("-");

		for(i=0; i < nby; ++i) {
			if (tip_by[i] == 2)
				printf(" %s=%s ", efts_by[i],
					dtoa(atof(obs2[i]), pbuff));
			else
				printf(" %s=%s ",efts_by[i],obs2[i]);
		}

		for(i=0; i < ((79 - j - 2*nby)/2);++i)
			printf("-");

		printf("\n\n");
	}
}

executa(m,n)
int m,n;
{
	int i;
	int j;
	int k;
	int nobs=1;
	int ndim1,nd1;
	char token[128];
	double res;
	double sd;

	glt = m - 1;

	j = 0;
	for (i = fl_int+nef; i < ndim ; ++i) {
		media2[j] = soma[i] / (double) glt;
		++j;
	}

	if ((m - 1) <= (nd+nef + !fl_int)) {
		printf("\n*** Num. de observacoes (%d) insuficiente para calculo da regressao. ***\n\n",(m-1));
		do {
			c1 = gtoken1(token, stdin);
		} while(c1 != RB && (strcmpi(token,"fim")));

		return 0;
	}
	putchr1();
	prtdes(linha-1);
	if (fl_correl) {
		if (nd+nef > 5 && !fl_wt) 
			putchr1();
		if (!fl_wt)
			prtcor();
	}
	if (fl_padrao) 
		padroniza();

	if (xflag & 1) {
		putchr1();
		printf("\nMatriz z'z\n");
		print_xlx();
	}

	if (!fl_int) { /* guarda soma de quadrados total s/ intercepto */
		for (k = 0; k < nd; ++k)
			squad1[k] = xlx[idx(nxlx+k,nxlx+k)];
	}

	ini_niveis();
	pivota();		/* pivota a mtriz x'x */

	ndim1 = ndim;
	ndim  = ndim - nd + 1;
	nd1   = nd;
	nd    = 1;

	for (k = 0; k < nd1; ++k ) { /* loop para cada var. dep */

		squad = squad1[k]; /* soma de quadrados total */

		if ( k > 0 ) {
			troca(k);
		}

		putchr1();
				/* imprime o quadro de analise de variancia */

		if (printanv(k,nd1) == -1) {
			do {
				c1 = gtoken1(token, stdin);
			} while(c1 != RB && (strcmpi(token,"fim")));

			return 0;
		}
		printcov(k,nd1);/* imprime covariaveis e varivel dependente */

		if (bflag) {
			if (k == 0)
				outhdr(nd1,ndim1); /* cria hdr */
			printbeta(k,ndim1);	/* imprime o vetor beta */
		}
	
		if (lflag || (g_eflag && (k==0)) || fl_dw ||
				fl_dg || fl_dg1 ) {

			int x,flag;	/* controle no calculo das estatis. */

			resdo  = 0.0;
			resd2  = 0.0;
			autocor  = 0.0;
			saida[0] = 1.0;
			dw 	 = 0.0;
			tvalue	 = sqrt(finv((1.0 - confianca/100.),1.0,(double) (glt-(nd+nef-1+fl_int))));

			rew_arq(fd);
			i = 1;
			if (lflag) {
				putchr1();
				printf("  Obs       Valor       Valor     Residuo      Desvio    Int. Inf    Int. Sup\n");
				printf("        Observado    Ajustado                  Padrao   %3.0f%1s        %3.0f%1s\n\n",confianca,"%",confianca,"%");
			}

			sd = 0.0;
			res = 0.0;
			if (nby > 0)
				flag = 0;
			else
				flag = 1;
			while (ler_obs(fd,obs1) != (long) EOF && i != n) {
				if (flag == 0) {
					for(j=0; j < nby; ++j) {
						x = ef_by[j];
						if(strcmpi(obs1[x],obs2[j])!=0)
							break;
					}
					if (j == nby)
						flag = 1;
				}
				if (flag) {
					expand_mat(nd1);
					if (fl_wt)
						pondera(nd1);
					printest(i++,ndim1,k,nd1,&res);
					pchar = area1;
					sd += res*res;
					nobs++;
				}
				else
					++i;
				
			}

			if (fl_dg || fl_dg1 ) {
					diagnostico(k,nd1,nobs,sd);
			}

			if (fl_dw) {
				printf("\n\n\nDurbin-Watson D                %14.8g",dw/resd2);
				printf("\nAutocorrelacao de prim. ordem  %14.8g\n",autocor/resd2);
				printf("\n\n");
			}
		}

		setjmp(env);

		if (tem_comando && !iterativo) {
			if ((fout = fopen("regress.out","r")) == NULL) {
				HFREE((char MY_HUGE *) xlx); 
				errocon(10,0);
			}
			faux = fout;
		}
		else
			faux = stdin;

		if (c1 != RB || (tem_comando && !iterativo))
			c1 = gtoken1(token, faux);

		while(c1 != RB && (strcmpi(token,"fim"))){
			if (!iterativo && !tem1_comando) {
				if ((fout = fopen("regress.out","w")) == NULL) {
					HFREE((char MY_HUGE *) xlx); 
					errocon(10,0);
				}
				tem1_comando = 1;
			}
			pchar  = area1; /* Inicializa ponteiro */
			if (strcmpi(token,"cp") == 0) {
				if (!iterativo && !tem_comando)
					fprintf(fout,"cp ");
				contraste(k, faux,nd1);
			}
			else {
				if (strcmpi(token,"fim") != 0) {
					errocon(11,0);
				}
			}
			c1 = gtoken1(token, faux);
		}
		if (strcmpi(token,"fim")==0) {
			c1 = gtoken1(token, faux);
			if (c1 != PTVG)
				errocon(3,0);
		}

		if (tem1_comando)
			tem_comando++;
		if (!iterativo && tem_comando )
			fprintf(fout,"\n%s",token);
		if (!iterativo && tem_comando ) {
			fclose(fout);
		}
	}	/* fim do loop para cada var. dep. */
	
	nd = nd1;
	ndim = ndim1;

	vol_niveis();

	return 0;
}

void inicializa()
{
	int i;
	for (i=0; i<ndim; ++i) {
		linhazerada[i] = 0; 
	}
        
	for(i=0; i <= nd+nef-!fl_int; ++i) {
		soma[i] = 0.0;
	}

	saida[0] = 1.0;
	mean[nxlx] = 0.0; 
	linha	= 1;

	for (i=0 ; i < nd; ++i)
		media2[i] = 0.0;
}

void inicioby()
{
	int i;

	for(i=0; i < nby; ++i) {  
		strcpy(obs2[i],obs1[ef_by[i]]);			
	}
}

void imp_titulo(titulo)
char *titulo;
{
	int i;
	int j;

	printf("\n");
	i = strlen(titulo);
	if (i<79)
		i = (80 - i) / 2;
	else
		i = 0;
	for (j=0; j<i; ++j)
		printf(" ");
	printf("%s\n\n", titulo);
}

void prtcor()
{
	int inic;	/* inicio de linha e coluna a imprimir */
	int fimc;	/* coluna final a imprimir */
	int ncor;	/* limite de linha e coluna a imprimir */
	int lim;	/* numero de colunas a serem impressas por linha */
	int i,j,k;	
	double correl;	/* valor da correlacao */
	double pv[5];	/* valor do p_value para cada correl na linha */

	inic = fl_int;
	ncor = nd + nef - !fl_int;
	lim  = (fl_int) ? 5 : 4;
	fimc = (ncor > lim) ? lim : ncor;

	printf("\n    Matriz de Correlacoes e Niveis Descritivos do Teste Ho:Correl=0\n\n");
	
	do {
		printf("%9.9s "," ");
		for (j = inic; j <= fimc; ++j)
			printf("%9.9s ",efts[j]);
		printf("\n\n");

		for (i = inic ; i <= ncor; ++i) {
			printf("%9.9s ",efts[i]);

			/* calcula p_value e correl */
			k = 0;
			for (j = inic ; j <= ((i < fimc) ? i : fimc); ++j) {
				if (i == j ) {
					correl = 1.0;
					pv[k++] = 0.0;
				}
				else {
					correl = calc_cor(i,j);
					if (fabs(correl) < EPS)
						pv[k++] = 1.0;
					else {
						if (fabs(correl-1.0) < EPS)
							pv[k++] = 0.0;
						else
							pv[k++]=calc_pv(correl);
					}
				}
				printf("%9.4g ",correl);
			}

			printf("\n%9s"," ");

			/* imprime p_value */
			k = 0;
			for (j = inic ; j <= ((i < fimc) ? i : fimc); ++j)
				printf("   (%5.3f)",pv[k++]);
			printf("\n\n");

		}
		inic = fimc + 1;
		fimc += lim;
		if ( (fimc >= ncor) && (inic <= ncor) ) {
			fimc = ncor;
			printf("\n\n");
		}
	} while ( fimc <= ncor );
}

double calc_pv(r)
double r;
{
	extern int glt;

	double t;

	t = r * sqrt((double) (glt) - 2.0) / sqrt(1.0 - r*r);
	return(2.0*tprob(fabs(t),(double) (glt-2))); 
}

double calc_cor(i,j)
int i,j;
{
	double correl;
	int k,l;
	double tmp, tmp1, tmp2;

	/* Observacao: O vetor soma e' usado como soma 
		       O vetor varia e' usado como variancia */
	k = sv[i];
	l = sv[j];
	tmp = sqrt(fabs(varia[i]));
	tmp1 = sqrt(fabs(varia[j]));
	tmp2 = ( ((double) glt ) * ((double) (glt - 1)) * tmp * tmp1);
	if (tmp == 0.0 && tmp1 == 0.0)
		return(1.0);
	if (tmp == 0.0 || tmp1 == 0.0 || tmp2 <= 1.e-77)
		return(0.0);

	correl = ( ((double) glt ) * xlx[idx(k,l)] - soma[k] * soma[l]) / tmp2;

	return(correl);
}

void prtdes(num)
int num;
{
	int i,j,tam;
	double tmp;
	int l;
	
	printf("\tDescricao das variaveis do modelo\n\n");

	l = 0;
	tam = 36;	/* controle dos nomes das var. a imprimir */
	for(i=fl_int; i <= (nef+nd-!fl_int); ++i) {
		if (ef[i][0] == -1) {
			if (l == 0) { 
				if (nd+nef > 2)
					printf("\n\tVariaveis independentes : ");
				else
					printf("\n\tVariavel independente   : ");
				printf("%s ", efts[i]);
				tam += (strlen(efts[i])+1);
			}
			else {
				if (tam >= 79 ) {
					printf("\n\t                          ");
					printf("%s",efts[i]);
					tam = (strlen(efts[i])+36);
				}
				else {
					printf(", %s ", efts[i]);
					tam += (strlen(efts[i])+3);
				}
			}
			++l;	
		}
	}

	if (nd > 1)
		printf("\n\n\tVariaveis dependentes   : ");
	else
		printf("\n\n\tVariavel dependente     : ");

	l = 0;
	for(i=fl_int; i <=nd+nef-!fl_int; ++i) {
		if (ef[i][0] == -2) {
			if (l == 0) {
				printf("%s", efts[i]);
			}
			else {
				printf(", %s ", efts[i]);
			}
			++l;
		}
	}

	printf("\n");
	printf("\n");
	printf("\tNumero de observacoes lidas     : %d\n",num);
	printf("\tNumero de observacoes utilizadas: %d\n",glt);

	if (!fl_wt) {
		putchr1();
		imp_titulo("Estatisticas Descritivas");
		printf("%-8s %18s %20s %20s\n","Variavel","Media","Variancia","Desvio");
		printf("       %20s %20s %20s\n"," "," ","Padrao");
		printf("\n");
	}

	for(i=fl_int; i <= (nd+nef-!fl_int); ++i) {
		j = sv[i];
		if (!fl_wt)
			printf("%-9s ",efts[i]); 
		tmp = (((double) glt) * xlx[idx(j,j)] - (soma[j]*soma[j]));
		varia[i] = tmp /(((double) glt) * ((double) (glt-1)));
		tmp = soma[j] / (double) glt;
		if (!fl_wt) {
			printf("%17s    %17s    %17s\n", 
				rounddec(soma[j] / (double) glt, 17, 8),
				rounddec(varia[i], 17, 8),
				rounddec(sqrt(fabs(varia[i])), 17, 8));
			printf("\n\n");
		}
	}
}

void padroniza()
{
	int i,j;
	int i1, j1;
	double x;
	double tmp[MAXMEM];
	TINT id;

	if (fl_int) {		/* Se tem intercepto */
		for(i=fl_int; i <= nd+nef; ++i) {
			if (ef[i][0] != -2) {
				i1 = sv[i]; 
				id = idx(0, i1);
				xlx[id] = 0.0;
			}
		}
	}
	j = 0;
	for(i=fl_int; i <= nd+nef-!fl_int; ++i) {
		if (ef[i][0] != -2) {
			i1 = sv[i]; 
			id = idx(i1, i1);
			xlx[id] = (double) (glt-1);
			tmp[j++]=((double)(glt - 1)) * sqrt(fabs(varia[fl_int]))
					  * calc_cor(i, fl_int );
		}
	}
	for(i=fl_int; i <= nd+nef-!fl_int; ++i) {
		if (ef[i][0] != -2) {
			i1 = sv[i];	
			for(j=fl_int; j <= i; ++j) {
				j1 = sv[j];
				if (i != j && ef[j][0] != -2) {
					x = calc_cor(i,j);
					id = idx(i1,j1);
					xlx[id]=((double)(glt-1))*x;
				}
			}
		}
	}
	j1 = sv[fl_int];
	j=0;
	for(i=fl_int; i <= nd+nef-!fl_int; ++i) {
		if (ef[i][0] != -2) {
			i1 = sv[i]; 
			id = idx(i1,j1);
			xlx[id]=tmp[j++];
		}
	}
}

void ini_niveis()
{
	int i;
	for(i=0; i <= nef+nd-!fl_int; ++i)
		nv1[i] = nv[i];
}

void vol_niveis()
{
	int i;
	for(i=0; i <= nef+nd-!fl_int; ++i)
		nv[i] = nv1[i];
}

void troca(k)
int k;
{
	int i;
	double temp;
	TINT id1, id2;
	
	for(i=0; i < nxlx; ++i) {
		id1 = idx(nxlx+k,i);
		id2 = idx(nxlx,i);
		temp = xlx[id1];
		xlx[id1] = xlx[id2];
		xlx[id2] = temp;

	}

	temp = css[nxlx];
	css[nxlx] = css[nxlx+k];
	css[nxlx+k] = temp;

	temp = mean[nxlx];
	mean[nxlx] = mean[nxlx+k];
	mean[nxlx+k] = temp;

	id1 = idx(nxlx+k,nxlx+k);
	id2 = idx(nxlx,nxlx);
	temp = xlx[id1];
	xlx[id1] = xlx[id2];
	xlx[id2] = temp;
}

