/***********************************************************************************
Video - Biblioteca padro para Recursos de Vdeo

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob
os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free
Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio)
qualquer verso posterior.

Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com
esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no
endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	**
		**		Desenhar uma tabela na tela.
		**
		**	Forma de uso:
		**
		**		faztab([, def, ..., def], (long) NULL);
		**
		**		def    : (Opcional) Lista de especificacoes (no maximo 97)
		**			 onde cada especificacao pode ter qualquer uma das
		**			 duas formas seguintes:
		**
		**			 VERT(col, de, ate) para especificar um traco na
		**				coluna "col", entre as linhas "de" e "ate".
		**			 HORZ(lin, de, ate) para especificar um traco na
		**				linha "lin", entre as colunas "de" e "ate".
		**
	Desenvolvido por: Oscar Ivan Palma Pacheco, NTIA/EMBRAPA, Campinas.
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/


#ifdef	ULTRIX
# include	<cursesX.h>
#else
# include	<stdio.h>

# ifdef i486
#   include 	<ncurses.h>
# else
#   include	<curses.h>
# endif

#endif
/*
#ifdef MSDOS
# include	<stdarg.h>
#else
# include	<varargs.h>
#endif
*/

#include	"video.h"

#ifdef MSDOS
# define MAXLINS			25
# define MAXCOLS			80
#else
# define MAXLINS			80
# define MAXCOLS			200
#endif

extern void	vdmsg();

#ifdef MSDOS
int	faztab(WINDOW *win, int fecha,...)
#else
int	faztab(win, fecha, va_alist)
WINDOW	*win;
int	 fecha;
/*
va_dcl
*/

#endif
{
	va_list arg;
	int	i;
	long	ft[25];

	/*
	** Lendo parametros que definem os tracos.
	*/
/*
#ifdef MSDOS
	va_start(arg, fecha);
#else
	va_start(arg);
#endif
*/

	i = 0;

	while ((ft[i++] = va_arg(arg, long)) != (long) NULL)
		;

	va_end(arg);

	return pfaztab(win, fecha, ft);
}

int	 pfaztab(win, fecha, ft)
WINDOW	*win;
int	 fecha;
long	 ft[];
{
	int	li[MAXLINS];
	int	hd[MAXLINS];
	int	ha[MAXLINS];
	int	co[MAXCOLS];
	int	vd[MAXCOLS];
	int	va[MAXCOLS];
	int	tipo;
	int	nv;
	int	nh;
	int	maxl;
	int	minl;
	int	i;
	int	j;
	int	ret;
	long	vararg;

	nv = 0;
	nh = 0;
	maxl = 0;
	minl = 127;

	i = 0;

	while ((vararg = ft[i++]) != (long) NULL) {

		tipo = (int) (vararg % 10L);
		vararg /= 10L;

		if (tipo != 1 && tipo != 2) {
			vdmsg(win, "Parametro deve ser v ou h");
			return -5;
		}

		if (tipo == 1) {
			ret = gettraco(win, vararg, &nv, co, vd, va,
				&maxl, &minl, tipo);
		}

		else {
			ret = gettraco(win, vararg, &nh, li, hd, ha,
				&maxl, &minl, tipo);
		}

		if (ret < 0)
			return ret;

	}

	/*
	** Ordenando tracos.
	*/

	ret = ordtraco(win, co, vd, va, nv);

	ret = ordtraco(win, li, hd, ha, nh);

	if (ret < 0)
		return ret;

	/*
	** Gerando tracos das tabelas.
	*/

	j = 0;

	for (i = minl; i <= maxl; ++i) {

		if ((j < nh && i < li[j]) || j >= nh)

			/*
			** Linha so de tracos verticais.
			*/

			travert(win, nv, i, co, vd, va);

		else {

			/*
			** Linha com tracos verticais e horizontais.
			*/

			trahorz(win, fecha, i, &j, nv, nh, li, hd, ha,
				co, vd, va);

		}

	}

	wrefresh(win);

	return 0;

}

