
/***********************************************************************************
Video - Biblioteca padro para Recursos de Vdeo

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob
os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free
Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio)
qualquer verso posterior.

Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com
esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no
endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
		Tratar da recuperacao da especificacao de um traco.

		Forma de uso:

		gettraco(traco, pn, lis, de, ate, pmax, pmin, tipo);

		long traco : Traco codificado.
		int pn     : Endereco do total de tracos.
		int lis[]  : Lista de posicoes dos tracos.
		int de[]   : Lista de inicios de traco.
		int ate[]  : Lista de terminos de traco.
		int pmax   : Endereco do maximo da posicao.
		int pmin   : Endereco do minimo da posicao.
		int tipo   : Tipo de traco.

Desenvolvido por: Oscar Ivan Palma Pacheco, NTIA/EMBRAPA, Campinas.
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

#ifdef	ULTRIX
# include	<cursesX.h>
#else 
# include	<stdio.h>

# ifdef i486
#   include 	<ncurses.h>
# else
#   include	<curses.h>
# endif

# ifdef MSDOS
#  include	<stdlib.h>
# endif
#endif

#include	<string.h>

#include	"video.h"

extern void	vdmsg();

int	 gettraco(win, traco, pn, lis, de, ate, pmax, pmin, tipo)
WINDOW	*win;
long	 traco;
int	*pn;
int	 lis[];
int	 de[];
int	 ate[];
int	*pmax;
int	*pmin;
int	 tipo;
{
	char	errobuf[128];
	int	max1;
	int	max2;
	char	colunae;
	char	tcol[10];
	char	tlin[10];

	colunae = 0;

	/*
	** Definir quantidade limites de tracos de acordo com o tipo.
	*/

	if (tipo == 1) {
		max1 = wcols(win);
		max2 = wlines(win);
		strcpy(tlin, "Coluna");
		strcpy(tcol, "Linha");
	}

	else {
		max1 = wlines(win);
		max2 = wcols(win);
		strcpy(tlin, "Linha");
		strcpy(tcol, "Coluna");
	}

	/*
	** Verificar quantidade limite de tracos.
	*/

	if (*pn >= max1) {
		sprintf(errobuf, "Maximo de %d tracos excedido", max1);
		vdmsg(win, errobuf);

		return -2;
	}

	/*
	** Pegar posicao do traco.
	*/

	lis[*pn] = (int) (traco % 1000L);

	if (lis[*pn] < colunae || lis[*pn] > max1) {
		sprintf(errobuf, "%s %d de traco fora da tela.",
			tlin, lis[*pn]);
		vdmsg(win, errobuf);

		return -3;
	}

	/*
	** Pegar inicio do traco.
	*/

	traco /= 1000L;

	de[*pn] = (int) (traco % 1000L);

	if (de[*pn] < colunae || de[*pn] > max2) {
		sprintf(errobuf, "%s %d de traco fora da tela.",
			tcol, lis[*pn]);
		vdmsg(win, errobuf);

		return -4;
	}

	/*
	** Pegar fim do traco.
	*/

	traco /= 1000L;

	ate[*pn] = (int) traco;

	if (ate[*pn] < colunae || ate[*pn] > max2) {
		sprintf(errobuf, "%s %d de traco fora da tela.",
			tcol, lis[*pn]);
		vdmsg(win, errobuf);

		return -4;
	}

	/*
	** Atualizar maximo e minimo da dimensao vertical.
	*/

	if (tipo == 1) {

		if (*pmax < de[*pn])
			*pmax = de[*pn];

		if (*pmin > de[*pn])
			*pmin = de[*pn];

		if (*pmax < ate[*pn])
			*pmax = ate[*pn];

		if (*pmin > ate[*pn])
			*pmin = ate[*pn];

	}
	else {

		if (*pmax < lis[*pn])
			*pmax = lis[*pn];

		if (*pmin > lis[*pn])
			*pmin = lis[*pn];

	}

	++*pn;

	return 0;

}

