
/***********************************************************************************
Video - Biblioteca padro para Recursos de Vdeo

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob
os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free
Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio)
qualquer verso posterior.

Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com
esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no
endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
		Pegar caracter digitado pelo usurio.

	Desenvolvido por:

		Oscar Ivan Palma Pacheco, NTIA/EMBRAPA, Campinas.
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

#ifdef ULTRIX
# include	<cursesX.h>
# include	<unistd.h>
#else
# include	<stdio.h>

# ifdef i486
#   include 	<ncurses.h>
# else
#   include	<curses.h>
# endif

#endif

#include	<string.h>

#include	"pcsgbd.h"
#include	"video.h"

/*
#define DEBUG
*/

/*

#ifdef ULTRIX
static struct	 kkpad {
	char	*str;
	char	 key;
	int 	 ret;
	char	*nome;
} kkpad[] = {
		(char *) NULL,	1,	KEY_BACKSPACE,	"KEY_BACKSPACE",
		(char *) NULL,	1,	KEY_CATAB,	"KEY_CATAB",
		(char *) NULL,	1,	KEY_CLEAR,	"KEY_CLEAR",
		(char *) NULL,	1,	KEY_CTAB,	"KEY_CTAB",
		(char *) NULL,	1,	KEY_DC,		"KEY_DC",
		(char *) NULL,	1,	KEY_DL,		"KEY_DL",
		(char *) NULL,	1,	KEY_DOWN,	"KEY_DOWN",
		(char *) NULL,	1,	KEY_EIC,	"KEY_EIC",
		(char *) NULL,	1,	KEY_EOL,	"KEY_EOL",
		(char *) NULL,	1,	KEY_EOS,	"KEY_EOS",
		(char *) NULL,	1,	KEY_F0,		"KEY_F0",
		(char *) NULL,	1,	KEY_F(1),	"KEY_F(1)",
		(char *) NULL,	1,	KEY_F(10),	"KEY_F(10)",
		(char *) NULL,	1,	KEY_F(2),	"KEY_F(2)",
		(char *) NULL,	1,	KEY_F(3),	"KEY_F(3)",
		(char *) NULL,	1,	KEY_F(4),	"KEY_F(4)",
		(char *) NULL,	1,	KEY_F(5),	"KEY_F(5)",
		(char *) NULL,	1,	KEY_F(6),	"KEY_F(6)",
		(char *) NULL,	1,	KEY_F(7),	"KEY_F(7)",
		(char *) NULL,	1,	KEY_F(8),	"KEY_F(8)",
		(char *) NULL,	1,	KEY_F(9),	"KEY_F(9)",
		(char *) NULL,	1,	KEY_HOME,	"KEY_HOME",
		(char *) NULL,	1,	KEY_IC,		"KEY_IC",
		(char *) NULL,	1,	KEY_IL,		"KEY_IL",
		(char *) NULL,	1,	KEY_LEFT,	"KEY_LEFT",
		(char *) NULL,	1,	KEY_LL,		"KEY_LL",
		(char *) NULL,	1,	KEY_NPAGE,	"KEY_NPAGE",
		(char *) NULL,	1,	KEY_PPAGE,	"KEY_PPAGE",
		(char *) NULL,	1,	KEY_RIGHT,	"KEY_RIGHT",
		(char *) NULL,	1,	KEY_SF,		"KEY_SF",
		(char *) NULL,	1,	KEY_SR,		"KEY_SR",
		(char *) NULL,	1,	KEY_STAB,	"KEY_STAB",
		(char *) NULL,	1,	KEY_UP,		"KEY_UP",

		(char *) NULL,	1,	KEY_BREAK,	"KEY_BREAK",
		(char *) NULL,	1,	KEY_ENTER,	"KEY_ENTER",
		(char *) NULL,	1,	KEY_SRESET,	"KEY_SRESET",
		(char *) NULL,	1,	KEY_RESET,	"KEY_RESET",
		(char *) NULL,	1,	KEY_PRINT,	"KEY_PRINT",
		(char *) NULL,	1,	KEY_A1,		"KEY_A1",
		(char *) NULL,	1,	KEY_A3,		"KEY_A3",
		(char *) NULL,	1,	KEY_B2,		"KEY_B2",
		(char *) NULL,	1,	KEY_C1,		"KEY_C1",
		(char *) NULL,	1,	KEY_C3,		"KEY_C3",

		(char *) NULL,	0,	0,		(char *) NULL
};

void ini_key()
{
	kkpad[0].str = key_backspace;
	kkpad[1].str = key_catab;
	kkpad[2].str = key_clear;
	kkpad[3].str = key_ctab;
	kkpad[4].str = key_dc;
	kkpad[5].str = key_dl;
	kkpad[6].str = key_down;
	kkpad[7].str = key_eic;
	kkpad[8].str = key_eol;
	kkpad[9].str = key_eos;
	kkpad[10].str = key_f0;
	kkpad[11].str = key_f1;
	kkpad[12].str = key_f10;
	kkpad[13].str = key_f2;
	kkpad[14].str = key_f3;
	kkpad[15].str = key_f4;
	kkpad[16].str = key_f5;
	kkpad[17].str = key_f6;
	kkpad[18].str = key_f7;
	kkpad[19].str = key_f8;
	kkpad[20].str = key_f9;
	kkpad[21].str = key_home;
	kkpad[22].str = key_ic;
	kkpad[23].str = key_il;
	kkpad[24].str = key_left;
	kkpad[25].str = key_ll;
	kkpad[26].str = key_npage;
	kkpad[27].str = key_ppage;
	kkpad[28].str = key_right;
	kkpad[29].str = key_sf;
	kkpad[30].str = key_sr;
	kkpad[31].str = key_stab;
	kkpad[32].str = key_up;
}

*/

#ifdef DEBUG
WINDOW	*debwin = (WINDOW *) NULL;
#endif

/*
int	 kpgetch(win)
WINDOW	*win;
{
	int	c1 = 0;
	int	c2 = 0;
	int	c3 = 0;
	int	i;
	int	lasti;
	int	sel;
	int	level;

	c1 = pgetch(win);

#ifdef ULTRIX
	if (strcmpi(getenv("TERM"), "vt100p"))
		return c1;
#endif

	sel = level = 0;

	i = -1;

	while (kkpad[++i].ret) {
		if (c1 == kkpad[i].str[level]) {
			kkpad[i].key = 1;
			++sel;
		}

		else
			kkpad[i].key = 0;
	}

	if (sel == 0) {
#ifdef DEBUG
		wprintw(debwin, "<%d> ", sel);
		wrefresh(debwin);
#endif

		return c1;
	}

	++level;

	while (1) {
		c1 = pgetch(win);

		i = -1;

		while (kkpad[++i].ret) {
			if (kkpad[i].key) {
				if(c1 != kkpad[i].str[level]) {
					kkpad[i].key = 0;
					--sel;
				}

				else
					lasti = i;
			}
		}

		if (sel == 0) {
#ifdef DEBUG
			wprintw(debwin, "<%d> ", sel);
			wrefresh(debwin);
#endif

			return c1;
		}

		if (sel == 1) {
#ifdef DEBUG
			wprintw(debwin, "<%d> ", sel);
			wrefresh(debwin);
#endif

			return kkpad[lasti].ret;
		}

		++level;
	}

}
*/

static char	key_buff[20];
static int	key_ind = 0;

int	 xpgetch(win)
WINDOW	*win;
{
	int	c;

	if (key_ind)
		c = key_buff[--key_ind];
	else
		c = wgetch(win);

	return c;
}

void	 xpsetbuf(s)
char	*s;
{
	strcpy(key_buff, s);
	reverse(key_buff);
	key_ind = strlen(key_buff);
}

#ifdef DEBUG
int	 pgetch(win)
WINDOW	*win;
{
	static int	pos = 0;
	int		c1;

	if (debwin == (WINDOW *) NULL)
		debwin = newwin(1, COLS, LINES - 3, 0);

	if (pos > 10) {
		werase(debwin);
		pos = 0;
	}

	c1 = xpgetch(win);

	wprintw(debwin, "%02x ", c1);

	wrefresh(debwin);

	++pos;

	return c1;
}
#else
int	 pgetch(win)
WINDOW	*win;
{
	return xpgetch(win);
}
#endif

